angular.module("Flexikon.controllers").controller('Dc3dModelCtrl', ($scope, $sce, $q, $ionicScrollDelegate, $location, $timeout, $ionicModal, $http, FullscreenViewer, ToC) ->

  @IFRAME_URL = 'https://sketchfab.com/models/{{id}}/embed'

  @iframeParameters =
    autostart          : 1
    camera             : 0
    transparent        : 0
    ui_controls        : 0
    ui_infos           : 0
    ui_related         : 0
    annotations_visible: 1
    cardboard          : 0

  @models = []

  @current    = 0
  @fullscreen = false

  $scope.vm = @

  ###*
   * [init description]
   * @return {[type]} [description]
  ###
  @init = =>
    if !@id?
      return

    @ids = @id.split(',')

    if @ids.length == 0
      return

    @fetchModels().finally(=>
      @models = @models.filter((model) ->
        return model?
      )

      if @models.length > 0
        @render = true
    )

  ###*
   * [fetchModels]
   * @return {[type]} []
  ###
  @fetchModels = =>
    promises = []

    for i in [0..@ids.length - 1]
      id = @ids[i]

      promises.push(@fetchModelMetaData(id, i))

    return $q.allSettled(promises)

  ###*
   * [fetchModelMetaData]
   * @param  {[type]} id []
   * @return {[type]}    []
  ###
  @fetchModelMetaData = (id, index) =>
    return $http.get('https://api.sketchfab.com/v2/models/' + id, {
      headers: {
        Authorization: ''
      }
    })
    .then((response) =>
      if !(response?.data?)
        return

      model = {}
      model.id    = id
      model.thumb = {}
      model.thumb.small = response.data.thumbnails?.images?[1]?.url || ''
      model.thumb.medium = response.data.thumbnails?.images?[2]?.url || ''
      @models[index] = model

      @setUrl(index)

    ).catch((error) ->
      @error = true
    )

  ###*
   * [switchModel]
   * @param  {[type]} index []
   * @return {[type]}       []
  ###
  @switchModel = (index) =>
    if index == @current
      return

    @setUrl(index)

    @current = index
    return

  ###*
   * [toggleCardboard]
   * @return {[type]} []
  ###
  @toggleCardboard = =>
    @iframeParameters.cardboard = (@iframeParameters.cardboard + 1) % 2

    if ionic.Platform.isIOS()
      window.open(@getUrl(@models[@current].id) + @getParameters(), '_blank',
        'location=no,toolbar=yes'
      )
      @iframeParameters.cardboard = (@iframeParameters.cardboard + 1) % 2
      return

    @setUrl()
    return

  ###*
   * [getUrl]
   * @param  {[type]} id []
   * @return {[type]}    []
  ###
  @getUrl = (id) =>
    return @IFRAME_URL.replace(/\{\{id\}\}/g, id)

  ###*
   * [openModal]
   * @return {[type]} []
  ###
  @openModal = ($event) ->
    $event.preventDefault()
    $event.stopPropagation()

    FullscreenViewer.openModalFromUrl(
      'templates/3DModelModal.html'
      $scope
    )
    return

  ###*
   * [getParameters]
   * @return {[type]} []
  ###
  @getParameters = =>
    params = '?'

    angular.forEach(@iframeParameters, (value, key) ->
      params += key + '=' + value + '&'
    )

    return params.substr(0, params.length - 1)

  ###*
   * [setUrl]
   * @param {[type]} id []
  ###
  @setUrl = (index) =>
    index = index || @current
    model = @models[index]

    model.url = $sce.trustAsResourceUrl(@getUrl(model.id) + @getParameters())

  @init()

  return
)