angular.module("Flexikon.directives").directive('dcExpandable', ($rootScope, $ionicScrollDelegate, $timeout) ->
  restrict: 'E'
  require: ''
  scope:
    labelText: "@"
    open: "@"
    id : "@"
    action: "&"
    feedback: "@"
    onOpen: "&"
    onClose: "&"
    scrollable: '@'
    closable: '@'
    delegateHandle: '@'
  templateUrl: 'templates/DcExpandableTemplate.html'
  transclude: true
  link: (scope, element, attrs) ->
    ###*
     * [content description]
     * @type {[type]}
    ###
    scope.content =
      shown     : (scope.$eval(scope.open) || false)
      scrollable: (scope.$eval(scope.scrollable) || false)
      closable  : (scope.$eval(scope.closable))
    if !scope.content.closable? then scope.content.closable = true

    scope.timeouts  = []
    scope.listeners = []

    if scope.content.shown then element.addClass('shown')

    scope.ui =
      hasAction : scope.$eval(scope.feedback)

    ###*
     * [toggle - show/hide expandable contents]
     * @param  {[type]} triggered [description]
     * @return {[type]}           [description]
    ###
    scope.toggle = (triggered, data={}) ->
      if scope.content.shown && !scope.content.closable && !triggered
        return

      scope.action?()
      scope.content.shown = !scope.content.shown
      if scope.content.shown
        element.addClass('shown')
        if scope.content.scrollable
          scope.timeouts.push $timeout ->
            $ionicScrollDelegate.resize()
      else
        element.removeClass('shown')

      if !data.preventDefault
        if scope.content.shown
          scope.onOpen?()
        else
          scope.onClose?()

      scope.timeouts.push $timeout(->

        if !scope.$$phase
          scope.$apply()
        if scope.delegateHandle?
          $ionicScrollDelegate.$getByHandle(scope.delegateHandle).resize()
        else
          $ionicScrollDelegate.resize()

      , 250)

    ###*
     * [register listener for global events (open / close)]
     * @param  {[String]} n [new id]
     * @return
    ###
    scope.listeners.push attrs.$observe('id', (n) ->
      if n? && n != '{{id}}'
        scope.listeners.push $rootScope.$on('dcexpandable' + n + '-open', (event, data) ->
          if !scope.content.shown then scope.toggle(undefined, data)
        )
        scope.listeners.push $rootScope.$on('dcexpandable-close-all-but', (event, data) ->
          if data.id != n && scope.content.shown then scope.toggle(true)
        )
    )

    ###*
     * [remove registered listener and remaining timeouts]
     * @return
    ###
    scope.$on('$destroy', ->
      for listener in scope.listeners
        listener()
      for timeout in scope.timeouts
        $timeout.cancel(timeout)
    )
)