# DcFavoriteSegments Controller

angular.module("Flexikon.controllers").controller('DcFavoriteSegmentsCtrl', ($scope, $state, $q, $timeout, $ionicSlideBoxDelegate, $controller, Favorites, LastSeen, FlexikonApi, DcDateTime, GlobalSettings) ->

	$controller('BaseCtrl', {$scope: $scope});

	$scope.dot = $scope

	$scope.segment = 0;
	$scope.alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ#'

	$scope.init = ->
		$scope.getChannelListing()
		$scope.fetchLastSeen()
		$scope.fetchFavorites().then(->
			$ionicSlideBoxDelegate.update()	
		)
	$scope.$on('favs.beforeEnter', ->
		$scope.init()
	)
	
	$scope.setSegment = (index) ->
		$scope.segment = index;

	$scope.getAlphabetObject = ->
		temp = {}
		
		for letter in $scope.alphabet
			temp[letter] = []

		return angular.copy(temp)

	###*
	 * [fetchLastSeen - fetch last seen articles from local db]
	 * @return
	###
	$scope.fetchLastSeen = ->
		return $q((resolve, reject) ->
			LastSeen.getAll().then((result) ->
				$scope.lastSeen = result
				for ls in $scope.lastSeen
					ls.formattedDate = DcDateTime.getFormattedDate(ls.lastVisited)
				resolve()
			).catch((error) ->
				$scope.lastSeen = []
				reject()
			)
		)

	###*
	 * [getChannelListing - fetch articles of current user]
	 * @return 
	###
	$scope.getChannelListing = ->
		if !$scope.isAuthenticated()
			return

		FlexikonApi.getChannelListing()
		.success((result) ->
			document.removeEventListener("online", $scope.getChannelListing, false)

			$scope.contribs = []
			contribsTitle = []
			for c in result.query.usercontribs
				if c.title not in contribsTitle
					contribsTitle.push c.title
					c.formattedDate = DcDateTime.getFormattedDate(new Date(c.timestamp).getTime())
					$scope.contribs.push c
		).error((error) ->
			console.warn error

			document.removeEventListener("online", $scope.getChannelListing, false)
			document.addEventListener("online", $scope.getChannelListing, false)


			if $scope.contribs?.length > 0
				return 

			$scope.contribs = []			
		)

	$scope.sortFavorites = (favorites) ->
		sortedFavorites = $scope.getAlphabetObject()

		for favorite in favorites
			letter = favorite.article.title[0]
			if letter.toUpperCase() not in $scope.alphabet
				letter = '#'

			sortedFavorites[letter].push favorite

		return sortedFavorites

	###*
	 * [fetchFavorites - fetch favorites from local db]
	 * @return
	###
	$scope.fetchFavorites = ->
		return $q((resolve, reject) ->
			Favorites.getAll().then((result) ->
				$scope.favorites = $scope.sortFavorites(result)
				resolve()
			).catch((error) ->
				$scope.favorites = []
				reject()
			)
		)

	###*
	 * [openArticle - open article]
	 * @param  {[type]} page     [page title]
	 * @param  {[type]} language [article language]
	 * @return {[type]}          
	###
	$scope.openArticle = ($event, page, language) ->
		$event.preventDefault()
		$event.stopPropagation()
		if !language? then language = GlobalSettings.Language()
		page = page.replace(/&[^;]*;/g, '')
		$state.go('^.article', {page : ':' + language + ':' + window.decodeURIComponent(page)})	


	$scope.init()
	
)