angular.module("Flexikon.directives").directive('dcFlexikonArticle', ($timeout, GuidedTour, $ionicSideMenuDelegate, Favorites, Store, NavBar, DcDateTime) ->
  restrict: 'E'
  scope:
    id:   '@'
    page: '@'
  templateUrl: 'templates/DcFlexikonArticleTemplate.html'
  controller: 'DcFlexikonArticleCtrl as flex'
  bindToController: true
  link: (scope, element, attrs) ->

    scope.getSelf = ->
      return element

    scope.getHTMLWrapper = ->
      return element.find('.html-wrapper')

    scope.toggleBars = ->
      $timeout(->
        if window.innerHeight >= 768
          return

        if window.innerWidth < window.innerHeight
          scope.showBars()
        else
          scope.hideBars()
      , 300)

    scope.hideBars = (force) ->
      if (window.innerHeight >= 768 || window.innerWidth < window.innerHeight) && !force
        return

      scope.barsHidden = true

      $timeout(->
        angular.element('.tab-nav.tabs').css('-webkit-transform', 'translateY(49px)')
        angular.element('.tab-nav.tabs').css('transform', 'translateY(49px)')
        element.find('ion-header-bar').css('-webkit-transform', 'translateY(-44px)')
        element.find('ion-header-bar').css('transform', 'translateY(-44px)')
        element.find('ion-content').css('top', '0px')
        element.find('ion-content').css('bottom', '0px')
      , 500)

    scope.showBars = ->
      scope.barsHidden = false

      $timeout(->
        angular.element('.tab-nav.tabs').css('-webkit-transform', 'translateY(0px)')
        angular.element('.tab-nav.tabs').css('transform', 'translateY(0px)')
        element.find('ion-header-bar').css('-webkit-transform', 'translateY(0px)')
        element.find('ion-header-bar').css('transform', 'translateY(0px)')
        element.find('ion-content').css('top', '44px')
        element.find('ion-content').css('bottom', '49px')
      , 500)

    return

    scope.listeners.push scope.$on('$stateChangeStart', (event, toState) ->
      if toState.name.indexOf('article') < 0
        scope.showBars()
        NavBar.unhide()
        $ionicSideMenuDelegate.canDragContent(false)
      else
        $timeout ->
          NavBar.hide()
          $ionicSideMenuDelegate.canDragContent(true)
    )



    scope.$on('$destroy', ->
      scope.showBars()
    )

    scope.runOverlay = ->
      #stepsArray = GuidedTour.getSteps('articleSteps')
      if GuidedTour.isPassed('FlexikonArticleIntro')
        return

      GuidedTour.setRootElement(element)

      scope.showBars()

      GuidedTour.start(
        'FlexikonArticleIntro',
        [
          selector : [ # Step 1) Add to favorites
            name  : '.favorite-button'
            shape : 'round'
          ]
          hint : 'DC_TUTORIAL_OVERLAY_NEWBOOKMARK'
          endCallback : ->
            scope.hideBars()
        ,
          selector : [ # Step 2) Edit
            name  : '.fa.fa-pencil'
            shape : 'round'
          ]
          hint : 'DC_TUTORIAL_OVERLAY_EDIT'
          endCallback : ->
            scope.article.wiki.edit = scope.article.wiki.content
            scope.toggleEdit(undefined, true)
        ,
          selector : [ # Step 3) Preview
            name  : '.fa.fa-eye'
            shape : 'round'
          ]
          hint : 'DC_TUTORIAL_OVERLAY_PREVIEW'
          endCallback : ->
            scope.toggleEdit(undefined, true)
            scope.ui.unsaved = false
        ],
        false
      )

    return
)