angular.module("Flexikon.directives").directive('dcFlexikonHomeListing', ($timeout, $ionicScrollDelegate) ->
  restrict      : 'E'
  scope         : true
  templateUrl   : 'templates/DcFlexikonHomeListingTemplate.html'
  controller    : 'DcFlexikonHomeListingCtrl'
  link          : (scope, element, attrs) ->

    ###*
     * [cancelSnap - on tap prevent snap scroll]
     * @return
    ###
    scope.cancelSnap = ->
      $timeout.cancel(scope.scrollTimeout)

    ###*
     * [setDelta - determine scroll correction for snap scroll dependent on scroll direction]
     * @param {[Event]} $event [scroll event]
     * @return
    ###
    scope.setDelta = ($event) ->
      scope.ui.automaticScroll = true
      $timeout(->
        scope.ui.automaticScroll = false
      , 250, false)
      if $event.gesture.deltaY < 0 then scope.ui.delta = 1 else scope.ui.delta = 0

    ###*
     * [onScroll - determine scroll end]
     * @return
    ###
    scope.onScroll = ->
      # determine scroll complete by cancelling the timeout when scrolling and setting a new one
      $timeout.cancel(scope.scrollTimeout)
      # will be triggered as soon as scrolling has completed

      snapScrollTimeout = if ionic.Platform.isWebView() && ionic.Platform.isIOS() then 100 else 100

      scope.scrollTimeout = $timeout(->
        if scope.ui.automaticScroll
          scope.ui.automaticScroll = false
          return

        scope.snapScroll(false)
      , snapScrollTimeout)

    ###*
     * [snapScroll - snap to article on scroll end]
     * @return
    ###
    scope.snapScroll = (orientationChange=true) ->
      return
      scrollHeight = element.find('ion-content').height()

      # Portrait
      if window.innerHeight > window.innerWidth
        itemHeight = scrollHeight * 0.3333
        columns = 1
      # Landscape, tablet
      else if window.innerWidth >= 768
        itemHeight = scrollHeight * 0.5
        columns = 2
      # Landscape, phone
      else
        itemHeight = scrollHeight
        columns = 1

      scrollPosition = $ionicScrollDelegate.$getByHandle('HomeScroll').getScrollPosition().top
      if orientationChange && !scope.itemToScroll?
        return
      else if !orientationChange
        scope.itemToScroll = (parseInt(scrollPosition / itemHeight) + scope.ui.delta) * columns
      scope.ui.delta = 0

      # prevent scroll handler while scrolling automatically
      scope.ui.automaticScroll = true
      $ionicScrollDelegate.$getByHandle('HomeScroll').scrollTo(0, parseInt(scope.itemToScroll / columns) * itemHeight, true)
      return

)