angular.module("Flexikon.controllers").controller('DcFlexikonSectionCtrl', ($scope, $rootScope, $sce, $location, $ionicScrollDelegate, $timeout, WikiHTML, ToC) ->
    
  ###*
   * [ui - state variables]
  ###
  $scope.ui =
    edit    : $scope.$eval($scope.allowEdit)
    renderAd: false
    open    : parseInt($scope.sectionId) == 1

  ###*
   * if is section with title, process it accordingly
  ###
  $scope.title = $scope.section.match(/<h2.*>(.*)<\/h2>/g)
  if $scope.title?
    $scope.id = $scope.title[0].match(/id="(.*)"/)[1]
    $scope.title = $scope.title[0].replace(/<h2[^<]*>|<\/h2>/g, '')
    $scope.section = $scope.section.substr($scope.section.indexOf('</h2>') + ('</h2>').length)

  ###*
   * [editAction - set content of this section for editing]
   * @return
  ###
  $scope.editAction = ($event) ->
    $scope.sectionEditAction()($event, $scope.title, $scope.sectionId)

  ###*
   * [anchorScroll - scroll to this section when opened]
   * @return
  ###
  $scope.anchorScroll = ->
    $timeout(->
      scrollTo = angular.element('#' + $scope.id)

      if !scrollTo?
        return

      $ionicScrollDelegate.$getByHandle('ArticleScroll').scrollTo(0, scrollTo.closest('dc-flexikon-section').position().top + scrollTo.position().top - 12, true)
    , 300)
    $timeout(->
      ToC.setCurrentSection($scope.id)
    , 500)

  $scope.onOpen = ->
    $scope.anchorScroll()
    $scope.ui.open = true

  $scope.onClose = ->
    $scope.ui.open = false
)