angular.module("Flexikon.services").factory("GuidedTour", ($rootElement) ->

  ###*
   * [currentSteps]
   * @type {Array}
  ###
  currentSteps : []
  rootElement : $rootElement
  context : 'introduction'
  closable: true

  homeSteps : [
    # selector : undefined
    # hint : 'DC_TUTORIAL_OVERLAY_WELCOME'
    #,
      selector : [ # Step 1) Home
        name  : 'a[icon="fa fa-home"]'
        shape : 'round'
      ]
      hint : 'DC_TUTORIAL_OVERLAY_HOME'
    ,
      selector : [ # Step 2) Favorites
        name  : 'a[icon="fa fa-heart"]'
        shape : 'round'
      ]
      hint : 'DC_TUTORIAL_OVERLAY_BOOKMARK'
    ,
      selector : [ # Step 3) Search
        name  : 'a[icon="fa fa-search"]'
        shape : 'round'
      ]
      hint : 'DC_TUTORIAL_OVERLAY_SEARCH'
    ,
      selector : [ # Step 4) Settings
        name  : 'a[icon="fa fa-cog"]'
        shape : 'round'
      ]
      hint : 'DC_TUTORIAL_OVERLAY_SETTINGS'
    ]

  ###*
   * [registerShowCallback]
   * @param  {Function} callback []
   * @return
  ###
  registerShowCallback: (callback) ->
    @show = callback
    return

  ###*
   * [registerHideCallback]
   * @param  {Function} callback []
   * @return
  ###
  registerHideCallback: (callback) ->
    @hide = callback
    return

  ###*
   * [registerCancelCallback]
   * @param  {Function} callback []
   * @return
  ###
  registerCancelCallback: (callback) ->
    @cancel = callback
    return

  ###*
   * [setSteps]
   * @param {Array} steps []
   * @return
  ###
  setSteps: (steps) ->
    @currentSteps = steps

  ###*
   * [getSteps]
   * @param  {String} identifier []
   * @return {Array}  [prepared steps array]
  ###
  getSteps: (identifier) ->
    if identifier? && @[identifier]
      return @[identifier].slice()
    return @currentSteps

  setRootElement: (element) ->
    @rootElement = element || $rootElement

  getRootElement: ->
    return @rootElement

  ###*
   * [setContext description]
   * @param
  ###
  setContext: (context) ->
    @context = context
    return

  ###*
   * [getContext]
   * @return {String} [context]
  ###
  getContext: ->
    return @context

  ###*
   * [setClosable]
   * @param {Boolean} closable []
   * @return
  ###
  setClosable: (closable) ->
    @closable = closable
    return

  ###*
   * [isClosable]
   * @return {Boolean} []
  ###
  isClosable: ->
    return @closable

  ###*
   * [setPassed]
  ###
  setPassed: ->
    localStorage.setItem(@context, 'done')

  ###*
   * [isPassed]
   * @param  {String}  context=@context []
   * @return {Boolean}                  []
  ###
  isPassed: (context=@context) ->
    return (localStorage.getItem(context)?) && localStorage.getItem(context) == 'done'

  ###*
   * [cancel]
   * @return
  ###
  cancel: ->
    @cancel()
    return

  ###*
   * [stop]
   * @return
  ###
  stop: ->
    @hide()
    return

  ###*
   * [start]
   * @param  {[type]} context       [description]
   * @param  {[type]} steps         [description]
   * @param  {[type]} closable=true [description]
   * @return {[type]}               [description]
  ###
  start: (context, steps, closable=true) ->
    @setContext(context)
    @setSteps(steps)
    @setClosable(closable)

    if !@isPassed()
      @show()
    return
)