angular.module("Flexikon.directives").directive('dcPurchase', ($rootScope, $q, $timeout, Store) ->
	restrict: 'E'
	scope: true
	templateUrl: 'templates/DcPurchaseTemplate.html'
	controller: 'DcPurchaseCtrl'
	link: (scope, element, attrs) ->

		if Store.isOwned()
			element.addClass('hidden')

		###*
		 * [hide ads immediately when premium is purchased]
		 * @return 
		###
		$rootScope.$on('InAppPurchase-succeeded', ->
			scope.hide()
		)

		###*
		 * [show if not owned]
		 * @return 
		###
		$rootScope.$on('InAppPurchase-notowned', ->
			if !Store.isOwned()
				scope.show()
		)

		###*
		 * [hide - hide completely (in case of premium or no ad retrieved)]
		 * @return promise
		###
		scope.hide = ->
			element.addClass 'hiding'

			$timeout ->
				element.removeClass 'hiding'
				element.addClass 'hidden'
			, 350	
		
		###*
		 * [fade - fade out on hide]
		 * @return promise
		###
		scope.fade = ->
			return $q((resolve, reject) ->
				element.addClass 'hiding'			
				$timeout ->
					resolve()
				, 350
			)

		###*
		 * [show - show ad (when loaded)]
		 * @return
		###
		scope.show = ->
			element.removeClass 'hidden'
			element.removeClass 'hiding'
			element.addClass 'showing'

			$timeout ->
				element.removeClass 'showing'
			, 350		
)