angular.module("Flexikon.controllers").controller('DcQuickSearchCtrl', ($scope, $state, $ionicTabsDelegate, $timeout, QuickSearch, FlexikonApi) ->
  
  $scope.dot = $scope

  $scope.term =
    model : ''

  ###*
   * [submit - submit action for quick search]
   * @return
  ###
  $scope.submit = ->
    if $scope.term.model.length > 2
      QuickSearch.set($scope.term.model)
      $ionicTabsDelegate.select(2)
      $state.transitionTo('tabs.search.overview', {}, {reload: true, inherit: false, notify: true})
      $scope.term.model = ''
      if analytics? && $scope.term then analytics.trackEvent(
        'Article'
        'quicksearch'
        $scope.term.value
      )

  $scope.$watch("term.model", (n, o) ->
    $timeout.cancel($scope.suggestionTimeout)

    # if term too short or equals search term
    if n.length <= 2
      return

    #$scope.suggestions = []
    $scope.clearSuggestions = false

    $scope.suggestionTimeout = $timeout(->

      FlexikonApi.getSuggestions(n, 5).success((result) ->

        ###*
        $scope.form.newSuggestions = true
        $timeout(->
          $scope.form.newSuggestions = false
        , 1000)
        ###

        $scope.suggestions = result

      ).error((error) ->
        console.warn(error)
      )
      
    )
  )

  ###*
   * [openArticle - open article from listing]
   * @param  {[String]} page [title of page to open]
   * @return
  ###
  $scope.openArticle = (page) ->
    if !page?
      return

    if analytics? && $scope.term then analytics.trackEvent(
      'Article'
      'autosuggest'
      page
    )

    page = page.replace(/&[^;]*;/g, '').replace(/<(.*?)>/g, '')
    $state.go('^.article', page : window.decodeURIComponent(page))
    $scope.suggestions = []
    $scope.term.model = ''


)