angular.module("Flexikon.controllers").controller('DcSideMenuCtrl', ($scope, $rootScope, $ionicModal, $state, $ionicScrollDelegate, $ionicSideMenuDelegate, $location, $timeout, $ionicPopover, ToC, FontSize, Store, Api, Theme, LocalStorage, GuidedTour) ->

  $scope.ui =
    toc : false
    showToc : true
    tocContent : undefined
    activeSection : -1
    fontSize : FontSize.getCurrent()

  $scope.search =
    term : ''
    index : -1
    length : -1

  ionic.Platform.ready(->
    $scope.env =
      dev : Api.getEnv().indexOf('development') >= 0

    $ionicModal.fromTemplateUrl('templates/styleModal.html',
      scope   : $scope
    ).then((modal) ->
      $scope.modal = modal
    )


    $ionicPopover.fromTemplateUrl('stylePopover.html',
      scope: $scope
    ).then((popover) ->
      $scope.popover = popover
    )

    $scope.toggleToc = ->
      $scope.ui.showToc = !$scope.ui.showToc

    $scope.selectTheme = (theme) ->
      Theme.select(theme)

    $scope.openPopover = ($event) ->
      $rootScope.$broadcast('article:toggle-style-overlay')
      if $ionicSideMenuDelegate.isOpenRight() then $ionicSideMenuDelegate.toggleRight()

    $scope.closePopover = ->
      $scope.popover.hide()
      if $ionicSideMenuDelegate.isOpenRight() then $ionicSideMenuDelegate.toggleRight()
      return

    $scope.$on '$destroy', ->
      $scope.popover.remove()
      return
    
    $scope.$on 'popover.hidden', ->
      return

    $scope.$on 'popover.removed', ->
      return
  )

  $scope.$on('$stateChangeStart', (event, toState, fromState) ->
    $timeout(->
      $scope.ui.toc = false
    )
  )

  $scope.share = ->
    if !window.plugins?.socialsharing?
      console.debug 'Social sharing only available on device via plugin. However, this would be the text: \nhttp://flexikon.doccheck.com/' + window.encodeURIComponent(ToC.getTitle())
      return

    window.plugins.socialsharing.share('DocCheck Flexikon: ' + ToC.getTitle() + '\n', null, null, 'http://flexikon.doccheck.com/' + window.encodeURIComponent(ToC.getTitle()))

    if analytics? && ToC.getTitle() then analytics.trackEvent(
      'Article'
      'share'
      ToC.getTitle()
    )

  $rootScope.$on('new-toc-available', ->
    $timeout(->
      if $state.current.name.indexOf('article') > 0
        $timeout(->
          $scope.ui.tocContent = []
          $scope.ui.toc = false
          $timeout(->
            $scope.ui.toc = true
            $scope.ui.tocContent = ToC.get()
          )
        )
    )

  )

  $scope.anchorScroll = (id) ->
    expandId = angular.element('#' + id).closest('dc-expandable').attr('id')
    $rootScope.$broadcast('dcexpandable' + expandId + '-open')

    $timeout(->

      scrollTo = angular.element('#' + id)

      if !scrollTo?
        return

      $ionicScrollDelegate.$getByHandle('ArticleScroll').scrollTo(0, scrollTo.closest('dc-flexikon-section').position().top + scrollTo.position().top - 12, true)

      #$location.hash(id)
      $ionicSideMenuDelegate.toggleRight()
      #$ionicScrollDelegate.$getByHandle('ArticleScroll').anchorScroll(true)
      #$ionicScrollDelegate.scrollBy(0, -60, true);
      $timeout(->
        ToC.setCurrentSection(expandId)
        $scope.fetchActiveSection()
      , 500)

    )

  $scope.increaseFontSize = ($event) ->
    $event.preventDefault()
    $event.stopPropagation()
    $scope.ui.fontSize = FontSize.increase()

  $scope.decreaseFontSize = ($event) ->
    $event.preventDefault()
    $event.stopPropagation()
    $scope.ui.fontSize = FontSize.decrease()

  $scope.resetFontSize = ($event) ->
    $event.preventDefault()
    $event.stopPropagation()
    $scope.ui.fontSize = FontSize.reset()

  $scope.isOfflineVersion = ->
    return Store.isOwned('flexikon_offline')

  $scope.order = ->
    Store.order('flexikon_offline')

  $scope.fetchActiveSection = ->
    $scope.ui.activeSection = ToC.getCurrentSection()

  $scope.doNothing = ($event) ->
    $event.preventDefault()
    $event.stopPropagation()

  $scope.runArticleOverlay = ->
    $ionicSideMenuDelegate.toggleRight()
    
    GuidedTour.start(
      'FlexikonArticleIntro',
      [
        selector : undefined
        hint : 'DC_TUTORIAL_OVERLAY_FLEXIKON'
      ,
        selector : [
          name  : '.fa.fa-bars'
          shape : 'round'
        ]
        hint : 'DC_TUTORIAL_OVERLAY_TOC'
      ,
        selector : [
          name  : '.fa.fa-heart-o'
          shape : 'round'
        ]
        hint : 'DC_TUTORIAL_OVERLAY_NEWBOOKMARK'
      ,
        selector : [
          name  : 'dc-icon-button[action="editGlobal()"]'
          shape : 'round'
        ]
        hint : 'DC_TUTORIAL_OVERLAY_EDIT'
      ]
    )

  $scope.reloadActiveSection = $rootScope.$on('reloadActiveSection', ->
    $scope.fetchActiveSection()
  )

  $scope.clearFindInPage = $rootScope.$on('findInPage-termCleared', ->
    $scope.search.term = ''
  )

  $scope.$watch('ui.fontSize', (n, o) ->
    FontSize.set(n)
  )

  $scope.$on('$destroy', ->
    $scope.reloadActiveSection()
    $scope.clearFindInPage()
  )
)