angular.module("Flexikon.directives").directive('dcTable', ($timeout, $ionicScrollDelegate, $ionicGesture, $location, UniqueID, ToC, GlobalSettings) ->
	restrict: 'E'
	scope: true
	templateUrl: 'templates/DcTableTemplate.html'
	controller: 'DcTableCtrl'
	transclude: true
	link: (scope, element, attr) ->
		
		scope.table = element.find('table')
		scope.id = UniqueID.get()
		element.attr('id', scope.id);

		scope.ui = 
			full : false
			extends : false

		scope.style =
			maxHeight : 250
			marginBottom : 30

		scope.tableExtendsWrapper = ->
			scope.table = element.find('table')
			if element.height() <= 0
				return false

			if scope.table.height() <= 750
				scope.ui.extends = false
				scope.style.maxHeight = 764
				scope.style.marginBottom = 0
				return

			if element.height() < scope.table.height() 
				scope.ui.extends = true
			#if !scope.ui.extends 
				#scope.style.marginBottom = 0			
			return scope.ui.extends

		scope.extendHeight = ->
			scope.table = element.find('table')
			if !GlobalSettings.Stacktables() || scope.table.height() - scope.style.maxHeight < 750 
				scope.style.maxHeight = scope.table.height() + 14
				scope.style.marginBottom = 0
				scope.ui.full = true
			else				
				scope.style.marginBottom = 30
				scope.style.maxHeight += 500
				scope.ui.full = false
			$timeout ->
				if !scope.$$phase
					scope.$apply()
				$ionicScrollDelegate.$getByHandle('ArticleScroll').resize()
			, 550

		scope.resetHeight = ->
			scope.table = element.find('table')
			scope.style.maxHeight = 250
			scope.style.marginBottom = 30
			scope.ui.full = false
			scope.ui.extends = true
			scope.anchorScroll(scope.id)
			$timeout ->
				if !scope.$$phase
					scope.$apply()
				$ionicScrollDelegate.$getByHandle('ArticleScroll').resize()
			, 550

		scope.anchorScroll = (id) ->

			scrollTo = angular.element('#' + id)

			if !scrollTo?
				return

			$ionicScrollDelegate.$getByHandle('ArticleScroll').scrollTo(0, scrollTo.closest('dc-flexikon-section').position().top + scrollTo.position().top - 12, true)
			###
			$location.hash(id)
			$ionicScrollDelegate.$getByHandle('ArticleScroll').anchorScroll(true)	
			###

		scope.onElementClick = ($event) ->
			if $event.toElement.tagName.toUpperCase() == 'TABLE'
				return

			el = angular.element($event.toElement)

			offset 				= el.offset().top - el.offsetParent().offset().top
			elHeight 			= el.height()
			parentHeight 	= el.offsetParent().height()

			if elHeight + offset > parentHeight
				scope.style.maxHeight = elHeight + offset + 36

		scope.onDrag = ->
			event.preventDefault()
			event.stopPropagation()
			event.gesture.stopDetect()
			event.gesture.preventDefault()
			event.gesture.stopPropagation()
		scope.dragRightAction = $ionicGesture.on('dragright', scope.onDrag, element)
		scope.dragLeftAction = $ionicGesture.on('dragleft', scope.onDrag, element)

		scope.$on('$destroy', ->
			window.removeEventListener('orientationchange', scope.refresh)
			$ionicGesture.off(scope.dragLeftAction, 'dragleft', scope.onDrag)
			$ionicGesture.off(scope.dragRightAction, 'dragright', scope.onDrag)
		)

		# on click check target -> if video player then expand .. or expand always.. if target is not fully displayed ?
)