angular.module("Flexikon.controllers").controller('DcTvCtrl', ($scope, $http, $attrs, $sce, $timeout) ->
  $scope.ui =
    error : false
    loaded : false

  $scope.listeners = []
  
  detailUri = "http://tv.doccheck.com/de/service/movie/details/"

  if $attrs.key?
    detailUri += "identkey/?identkey=" + $attrs.key
  else if $attrs.id?
    detailUri += "id/?id=" + $attrs.id

  $http.get(detailUri).success((result) ->
    prv = result.data.previewImage
    if prv.indexOf('//') == 0 then prv = 'http:' + prv

    $scope.dcTvVideo =
      previewImage : prv
      url : $sce.trustAsResourceUrl(result.data.mp4HqUri || result.data.mp4Uri)

    $timeout(->
      $scope.bindFullscreenListener()
    )

    $scope.ui.loaded = true

  ).error((error) ->
    console.warn error
    $scope.ui.error = true
    $scope.ui.loaded = true
  )

  $scope.$on('$destroy', ->
    for listener in $scope.listeners
      listener()
  )


  $scope.getPreviewStyle = ->
    if $scope.dcTvVideo.previewImage?
      return {'background-image' : 'url(' + $scope.dcTvVideo.previewImage + ')'}
    return {'background-image' : 'url()'}

  $scope.getPreviewUrl = ->
    return $scope.dcTvVideo.previewImage || ''


  
)