angular.module("Flexikon.directives").directive('hideOnDrag', ($rootScope, $timeout) ->
  restrict: 'A'
  scope: false
  link: (scope, element, attrs) ->

    scope.ui =
      delta     : 0
      style     :
        '-webkit-transition': 'transform ease-in-out 300ms'
        'transition'        : 'transform ease-in-out 300ms'
        '-webkit-transform' : 'translateY(0)'
        'transform'         : 'translateY(0)'
      hidden    : false
      up        : attrs.up != "false"
      listening : false

    scope.pullElement = attrs.pullElement || ''
    scope.pushElement = attrs.pushElement || ''

    $rootScope.$on('hide-on-drag-touch', (event, data) ->
      scope.ui.listening = true
    )

    $rootScope.$on('hide-on-drag', (event, data) ->
      if !scope.ui.listening
        return

      scope.ui.delta = data.deltaY / 2
      if scope.ui.hidden then scope.ui.delta -= element.height()
      transform = scope.ui.delta

      if scope.ui.up
        if transform > 0 then transform = 0
        if transform < element.height() * -1 then transform = element.height() * -1
      else
        if transform < 0 then transform = 0
        if transform > element.height() then transform = element.height()

      scope.ui['-webkit-transform']          = 'translateY(' + transform + 'px)'
      scope.ui['transform']                  =  'translateY(' + transform + 'px)'
      scope.ui['-webkit-transform-inverted'] = 'translateY(' + (transform * -1) + 'px)'
      scope.ui['transform-inverted']         =  'translateY(' + (transform * -1) + 'px)'

      element.css('-webkit-transform', scope.ui['-webkit-transform'])
      element.css('transform', scope.ui['transform'])
      element.css('-webkit-transition-duration', '0ms')
      element.css('transition-duration', '0ms')

      pullElement = angular.element(scope.pullElement)
      if pullElement?.length > 0
        pullElement.css('-webkit-transform', scope.ui['-webkit-transform'])
        pullElement.css('transform', scope.ui['transform'])
        pullElement.css('-webkit-transition-duration', '0ms')
        pullElement.css('transition-duration', '0ms')

      pushElement = angular.element(scope.pushElement)
      if pushElement?.length > 0
        pushElement.css('-webkit-transform', scope.ui['-webkit-transform-inverted'])
        pushElement.css('transform', scope.ui['transform-inverted'])
        pushElement.css('-webkit-transition-duration', '0ms')
        pushElement.css('transition-duration', '0ms')
    )

    ###
    # Released
    ###
    $rootScope.$on('hide-on-drag-release', (event, data) ->
      scope.ui.listening = false

      element.css('-webkit-transition', scope.ui['-webkit-transition'])
      element.css('transition', scope.ui['transition'])
      element.css('-webkit-transition-duration', '300ms')
      element.css('transition-duration', '300ms')

      pullElement = angular.element(scope.pullElement)
      if pullElement?.length > 0
        pullElement.css('-webkit-transition', scope.ui['-webkit-transition'])
        pullElement.css('transition', scope.ui['transition'])
        pullElement.css('-webkit-transition-duration', '300ms')
        pullElement.css('transition-duration', '300ms')

      pushElement = angular.element(scope.pushElement)
      if pushElement?.length > 0
        pushElement.css('-webkit-transition', scope.ui['-webkit-transition'])
        pushElement.css('transition', scope.ui['transition'])
        pushElement.css('-webkit-transition-duration', '300ms')
        pushElement.css('transition-duration', '300ms')

      if scope.ui.delta < element.height() / 2 * -1 && scope.ui.up
        transform = element.height() * -1
        scope.ui.hidden = true
      else if scope.ui.delta < element.height() / 2 && !scope.ui.up
        transform = element.height()
        scope.ui.hidden = true
      else
        transform = 0
        scope.ui.hidden = false

      element.css('-webkit-transform', 'translateY(' + transform + 'px)')
      element.css('transform', 'translateY(' + transform + 'px)')

      if pullElement?.length > 0
        pullElement.css('-webkit-transform', 'translateY(' + transform + 'px)')
        pullElement.css('transform', 'translateY(' + transform + 'px)')

      if pushElement?.length > 0
        if transform != 0
          pushElement.css('-webkit-transform', 'translateY(100%)')
          pushElement.css('transform', 'translateY(100%)')
        else
          pushElement.css('-webkit-transform', 'translateY(0)')
          pushElement.css('transform', 'translateY(0)')

      scope.$on('$stateChangeStart', ->
        if scope.ui.hidden
          scope.ui.hidden = false
          scope.ui.delta  = 0
          $timeout(->
            angular.element('.tab-nav.tabs').css('-webkit-transform', 'translateY(0px)')
            angular.element('.tab-nav.tabs').css('transform', 'translateY(0px)')
          )
      )

      scope.$on('$destroy', ->
        if scope.ui.hidden
          scope.ui.hidden = false
          $timeout(->
            angular.element('.tab-nav.tabs').css('-webkit-transform', 'translateY(0px)')
            angular.element('.tab-nav.tabs').css('transform', 'translateY(0px)')
          )
      )
    )

    return
)