# Decorator for service $q
angular.module('Flexikon.services').config(($provide) ->

  ###*
   * []
   * @param  {[type]} $delegate []
   * @return {[type]}           []
  ###
  $provide.decorator('$q', ($delegate) ->

    $q = $delegate

    ###*
     * []
     * @param  {[type]} promises []
     * @return {[type]}          []
    ###
    $q.allSettled = $q.allSettled || (promises) ->

      deferred = $q.defer()

      # handle array of promises/values
      if angular.isArray(promises)

        states  = []
        results = []

        failedOnce = false

        # handle empty array
        if promises.length == 0
          deferred.resolve(results)
          return

        ###*
         * [Initialize states array to be ]
         * @param  {[type]} promise []
         * @param  {[type]} key     []
         * @return {[type]}         []
        ###
        angular.forEach promises, (promise, key) ->
          states[key] = false

        ###*
         * [checkPromiseStates]
         * @param  {[type]} states   []
         * @param  {[type]} results  []
         * @param  {[type]} deferred []
         * @param  {[type]} failed   []
         * @return {[type]}          []
        ###
        checkPromiseStates = (states, results, deferred, failed) ->
          allFinished = true

          angular.forEach states, (state, key) ->
            if !state
              allFinished = false

          if allFinished
            if failed
              deferred.reject(results)
            else
              deferred.resolve(results)

        ###*
         * [Run through the promises and check the overall state when a single one is resolved]
         * @param  {[type]} promise []
         * @param  {[type]} key     []
         * @return {[type]}         []
        ###
        angular.forEach promises, (promise, key) ->

          $q.when(promise)
          .then((result) ->
            states[key] = true
            results[key] = result

            checkPromiseStates(states, results, deferred, failedOnce)
          , (reason) ->
            failedOnce = true
            
            states[key] = true
            results[key] = reason

            checkPromiseStates(states, results, deferred, failedOnce)
          )

      else # expect parameter to be single promise or value and simply return it as promise
        return $q.when(promises)

      return deferred.promise

    return $q

  )

)