angular.module("Flexikon.services").factory("FontSize", ($rootScope, LocalStorage) ->
	baseFontSize 		: 17
	minFontSize	 		: 11
	maxFontSize  		: 25
	interval		 		: 2
	currentFontSize : parseInt(LocalStorage.get('fontSize')) || 17

	set: (value) ->
		if value < @minFontSize then value = @minFontSize
		if value > @maxFontSize then value = @maxFontSize
		@currentFontSize = value
		@persist()
		$rootScope.$broadcast("article:font-size-changed", {fontSize : @currentFontSize})	

	increase: ->
		if @currentFontSize < @maxFontSize 
			@currentFontSize += @interval
			@persist()
			$rootScope.$broadcast("article:font-size-changed", {fontSize : @currentFontSize})	
		return @currentFontSize
			

	decrease: ->
		if @currentFontSize > @minFontSize
			@currentFontSize -= @interval
			@persist()
			$rootScope.$broadcast("article:font-size-changed", {fontSize : @currentFontSize})	
		return @currentFontSize

	persist: ->
		LocalStorage.set('fontSize', @currentFontSize)

	reset: ->
		@currentFontSize = @baseFontSize
		@persist()
		$rootScope.$broadcast("article:font-size-changed", {fontSize : @currentFontSize})	
		return @currentFontSize

	getCurrent: ->
		return parseInt(LocalStorage.get('fontSize')) || @currentFontSize			

)