angular.module("Flexikon.services").factory("FlexikonMocking", ($httpBackend, Api) ->

	console.debug '#=-=Initializing Mocking...=#=-=#=-=#'		

	if Api.getEnv() == 'development_mocked'
		console.debug '# Mocking is currently enabled'
		console.debug '# Set environment in Api service to \"development\"'
		console.debug '# or \"production\" to disable it.'
		console.debug '#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n'

		generateMockArticle = (id, page) ->
			id = id || parseInt(Math.random() * 50000)
			article =
				query:
					pages:						
						"12345"	: 
							id 			: '' + id
							title 	: page || 'Mocked Article' + id
							revisions : [
								"*" :
									"''Synonym: Cor''<br />
									\n'''''Englisch''': [[:en:Heart|heart]]''
									\n
									\n==Definition==
									\nDas menschliche '''Herz''' ist das zentrale [[Organ]] des [[Blutkreislauf]]s. Es handelt sich um ein [[Muskel|muskuläres]] [[Hohlorgan]] und funktioniert als Druck- und Saugpumpe, die pro Minute etwa 5 bis 6 Liter [[Blut]] durch den menschlichen Körper pumpt. Es ist Teil des [[kardiovaskuläres System|kardiovaskulären System]]s. 
									\n
									\nDie Lehre von Struktur, Funktion und Erkrankungen des Herzens ist die [[Kardiologie]]. Die Zellen des Herzens werden als [[Kardiomyozyt]]en bezeichnet.
									\n
									\n==Anatomie==
									\n===Übersicht===
									\nDas Herz befindet sich im [[Mediastinum]] hinter dem [[Sternum]] und liegt im \"Herzbeutel\", der durch die beiden Blätter des [[Perikard]]s gebildet wird. Der größte Teil der [[kardial]]en Masse wird durch die Herzmuskulatur ([[Myokard]]) gebildet, die zum Lumen hin mit [[Endokard]] ausgekleidet ist, nach außen hin vom [[Epikard]] bedeckt wird.
									\n
									\nAnatomisch ist das Herz aus zwei Kammern (Ventrikel) und zwei Vorhöfen (Atrien), den so genannten [[Herzhöhle]]n, aufgebaut. Sie sind durch [[Herzklappe]]n voneinander getrennt und in den Körper- beziehungsweise Lungenkreislauf eingeschaltet. Die bindegewebige Trennschicht zwischen Vorhof- und Ventrikelmyokard in der Ventilebene des Herzens bezeichnet man als [[Herzskelett]]. Für die proprietäre Blutversorgung des Herzens sind die [[Koronararterie]]n verantwortlich. 
									\n
									\nDie nach [[kranial]] und [[dorsal]] weisende Fläche des Herzens, an der die großen Gefäßstämme münden, bezeichnet man als [[Herzbasis]] (Basis cordis), das ihr entgegen gesetzte Ende als [[Herzspitze]] (Apex cordis).
									\n
									\n<dcmedia id=\"Bw4096IOdN9DEP6H5Tmk1g\" view=\"max\" />
									\n
									\n===Dimensionen===
									\nDas Herz eines Erwachsenen ist etwa 12 cm lang, und misst im Querschnitt an der breitesten Stelle 8 bis 9 cm, an der tiefsten ca. 6 cm. Das Gewicht schwankt beim Mann zwischen 280 bis 340 Gramm, bei der Frau zwischen 230 bis 280 Gramm. Über den größten Teil des Lebens nimmt die Herzmasse kontinuierlich zu.
									\n
									\n===Einteilung===
									\nDas Herz ist durch [[Herzseptum|Septen]] vertikal in eine rechte und eine linke Hälfte geteilt, horizontal durch eine zirkuläre Einschnürung und die [[Segelklappe]]n in 2 [[Herzvorhof|Herzvorhöfe]] und 2 [[Herzkammer]]n. Damit ergeben sich insgesamt vier [[Herzhöhle]]n:
									\n
									\n* Rechter Vorhof (Atrium cordis dextrum)
									\n* Rechte Kammer (rechter Ventrikel, Ventriculus cordis dexter)
									\n* Linker Vorhof (Atrium cordis sinistrum)
									\n* Linke Kammer (linker Ventrikel, Ventriculus cordis sinister)
									\n
									\nDiese Aufteilung des Herzens ist auch von außen erkennbar. Zwischen den Vorhöfen und den Kammern verläuft als zirkuläre Einschnürung der [[Sulcus coronarius]]. Zwischen den Kammern finden sich als Einziehungen der Herzmuskulatur der [[Sulcus interventricularis anterior]] und der [[Sulcus interventricularis posterior]].
									\n
									\n===Außenflächen===
									\nMan unterscheidet anatomisch mehrere Außenflächen des Herzens:
									\n* ''Facies sternocostalis'': zum [[Brustbein]] (Sternum) und zu den [[Rippe]]n hin gelegene Fläche
									\n* ''Facies diaphragmatica'': zum [[Zwerchfell]] (Diaphragma) hin gelegene Fläche
									\n* ''Facies pulmonalis'': zur [[Lunge]] hin gelegene Fläche
									\n
									\n===Innenflächen===
									\nDie mit Endokard überzogene Innenfläche des Herzens ist nicht glatt und unstrukturiert, sondern im Bereich der Herzventrikel von vernetzen rundlichen Muskelbälkchen, den [[Trabeculae carneae]], überzogen. Ferner entspringen hier die [[Papillarmuskel]]n, welche über Sehnenfäden ([[Chordae tendineae]])  die Segelklappen verspannen.
									\n
									\n===Blutversorgung===
									\nDie Versorgung des Herzens mit arteriellem Blut erfolgt über zwei große  Koronargefäße, die [[Arteria coronaria dextra]] und die [[Arteria coronaria sinistra]]. Sie bilden untereinander zahlreiche [[Anastomose]]n. Diese Anastomosen reichen jedoch nicht aus, um einen vollständigen [[Kollateralkreislauf]] zu bilden. Man spricht deshalb von funktionellen [[Endarterie]]n. Bei Verschluss eines Astes kommt es zu einer [[Ischämie]] des Versorgungsgebiets. Bei lang andauernder Ischämie kommt es zur [[Nekrose]] des [[Herzmuskelgewebe]]s.
									\n
									\nDer Abtransport des venösen Blutes erfolgt über die [[Koronarvene]]n (u.a. die [[Vena cardiaca magna]]) und den [[Sinus coronarius]].
									\n
									\n''Weitere Einzelheiten siehe'': [[Koronararterie]]n
									\n
									\n===Innervation===
									\nDie [[vegetativ]]e [[Innervation]] des Herzens erfolgt über [[sympathisch]]e Nervenfasern der [[Halsganglion|Halsganglien]], die auch als [[Herznerv]]en (Nervi cardiaci) bezeichnet werden, und [[parasympathisch]]e Fasern des [[Nervus vagus]] (Nervus X). Sie strahlen in ein Nervengeflecht, den [[Plexus cardiacus]], an der Herzbasis ein. Die interne elektrische Steuerung der Herztätigkeit erfolgt über das Reizleitungssystem des Herzens.
									\n
									\n''Weitere Einzelheiten siehe'': [[Erregungsleitungssystem des Herzens]]
									\n
									\n===Topographie===
									\nDas Herz liegt innerhalb des [[Thorax]] im mittleren [[Mediastinum]], wobei sich seine Kontur auf die 2. bis 5. [[Rippe]] projiziert. Oben reicht die Herzbasis etwa zwei Zentimeter über den rechten [[Sternum|Sternalrand]] hinaus, unten grenzt die Herzspitze bis fast an die linke [[Medioklavikularlinie]]. Lateral wird das Herz jeweils von den beiden [[Pleura]]blättern des linken und rechten [[Lunge]]nflügels begrenzt. Der linke Vorhof steht [[dorsal]] in direktem Kontakt mit dem [[Ösophagus]]. [[Ventral]] des Herzens befindet sich die vordere Brustwand mit dem [[Sternum]] und dem dahinter liegenden [[Thymus]]. [[Kaudal]] sitzt das Herz dem Zwerchfell auf, das mit dem Perikard verwachsen ist.
									\n
									\n===Klinische Anatomie===
									\nFür die Lokalisation klinischer Befunde wird das [[AHA]]-System der [[kardiale Segmentierung|kardialen Segmentierung]] verwendet.
									\n
									\n==Embryologie==
									\nDie Herzanlage ([[kardiogene Platte]]) entwickelt sich um den 18. Tag in der Nähe der [[Membrana buccopharyngea]] aus dem Seitenplattenmesoderm ([[Herzschlauch]], [[Gefäß]]e, [[Epikard]], [[Perikard]]) und der [[Neuralleiste]] (Herzseptum in der Ausflussbahn).
									\nZunächst bilden [[Angioblast]]en Blutinseln, aus denen sich ein hufeisenförmiger [[Plexus|Gefäßplexus]] bildet. Die Zellen in seinem Inneren werden zu primitiven [[Blutzelle]]n, die peripheren Zellen zu [[Endothelzelle]]n.
									\n
									\nDer Gefäßplexus verschmilzt anschließend beidseitig zu je einem [[Endokardrohr]]. Durch die laterale Abfaltung verlagern sich die Endokardrohre nach [[medial]] und verschmelzen dort zum unpaaren Herzschlauch. Ihn umgebende [[Mesenchym]]zellen des [[viszeral]]en Blattes verdichten sich zum [[Myokard]]. Zwischen Endothel (Endokard) und dem Myokard liegt die [[Herzgallerte]], die [[extrazellulär]]es Material des Mesenchyms darstellt.
									\n
									\nDie kraniokaudale Abfaltung verursacht das Absteigen (''[[Descensus cordis]]'') dieser Strukturen und die Verlagerung in die Perikardhöhle (s.u.) des sich bildenden Herzens. Im [[Mesoderm]] entsteht durch Spaltbildung die primäre Perikardhöhle, worin der Herzschlauch über das dorsale Mesoderm befestigt ist. Der mittlere Teil des dorsalen Mesoderms [[Degeneration|degeneriert]], wodurch sich der [[Sinus transversus pericardii]] bildet.
									\n
									\nAusweitungen des primitiven Herzschlauchs sind: 
									\n* [[Truncus arteriosus]]
									\n* [[Bulbus cordis]]
									\n* [[Ventriculus cordis communis]]
									\n* [[Atrium commune]]
									\n* [[Sinus venosus]]
									\n
									\nAm 22. Tag beginnt das Myokard rhythmische Kontraktionen.
									\n
									\n''siehe Hauptartikel'': [[Embryonale Herzentwicklung]]
									\n
									\n==Physiologie==
									\nDie Hauptaufgabe des Herzens ist die Aufrechterhaltung des [[Blutkreislauf]]s. Neben der Pumpfunktion wird dem Herzen auch eine Aufgabe bei der [[Blutdruck]]regulation zugeschrieben, die spezielle endokrine Zellen vor allem in den Atrien wahrnehmen. In diesem Zusammenhang ist das atriale natriuretische Peptid ([[ANP]]) beschrieben. Das Herz ist ebenso in der Lage, auf eine Veränderung des [[Blutvolumen]]s zu reagieren. So steigt zum Beispiel bei erhöhtem Volumen die [[Herzfrequenz]] an ([[Bainbridge-Reflex]]). Ebenso wird die [[Kontraktilität]] der Herzmuskelzellen gesteigert ([[Frank-Starling-Mechanismus]]).
									\n
									\n==Klinik==
									\n===Klinische Untersuchung===
									\nDie klinische Untersuchung des Herzens basiert im Wesentlichen auf der [[Auskultation]] der [[Herzton|Herztöne]] und [[Herzgeräusch]]e sowie der [[Palpation]] des [[Puls]]es.
									\n{|
									\n! [http://tv.doccheck.com/de/movie/565/how-to-make-it-herzuntersuchung/ How to make it: Herzuntersuchung]
									\n|-
									\n| <dctv key=\"lkkndsgkselp\" preview=\"4\" duration=\"653\" />
									\n|}
									\n
									\n===Apparative Diagnostik===
									\nFür die Untersuchung des Herzens stehen zahlreiche Verfahren zur Verfügung, die [[invasiv]] oder [[nicht-invasiv]] sein können. Dazu zählen u.a.:
									\n* [[EKG]]
									\n* [[Echokardiografie]]
									\n* [[Kardio-CT]]
									\n* [[Kardio-MRT]]
									\n* [[Linksherzkatheteruntersuchung]]
									\n* [[Rechtsherzkatheteruntersuchung]]
									\n===Wichtige Erkrankungen===
									\nDie Erkrankungen des Herzens sind die Domäne der [[Kardiologie]]. Da das Herz funktionell eng mit dem Gefäßsystem im Zusammenhang steht, spricht man auch von [[Herz-Kreislauf-Erkrankung]]en. Wichtige Erkrankungen sind:
									\n* [[Koronare Herzkrankheit]] (KHK)
									\n* [[Herzinfarkt]]
									\n* [[Herzinsuffizienz]]
									\n* [[Herzklappenvitium|Herzklappenvitien]]
									\n* [[Herzrhythmusstörung]]en
									\n* [[Myokardiopathie]]n
									\n
									\n==Literatur==
									\nHerrmann-Lingen, C.: Depression und koronare Herzkrankheit. In: herzmedizin 26 (2009). H.2, S.76-81. [http://load.doccheck.com/de/load.php/sid/5e43f8831ace77fb455e2c30ae02fa90/cl/details/anid/9384a5c837ba80a10.82337569/listtype/search/searchparam/herzmedizin%202%202009| Volltext abrufen]
									\n
									\n==Weblinks==
									\n* [http://www.herz.hexal.de/grundwissen/herz/blutfluss.php 3D-Animation des schlagendes Herzens mit vielen Infos (Hexal)]
									\n* [http://www-medlib.med.utah.edu/kw/pharm/hyper_heart1.html 2D-Animation des schlagenden Herzens mit Diagrammen (engl.)]
									\n* [http://www.dgk-herzfuehrer.de Deutsche Gesellschaft für Kardiologie]
									\n* [http://www.gstcvs.org Deutsche Gesellschaft für Thorax-, Herz- und Gefäßchirurgie]
									\n
									\n[[en:Heart]]
									"
								]

		extractParam = (url, param, def) ->
			match = url.match(new RegExp(param + '=([^&]*)(&|$)'))
			if !match?
				return def
			return match[1] || def

		extractId = (url) ->
			match = url.match(/\/\d+(\?|$)/)
			if !match?
				return 
			return match[0].replace('/', '').replace('?', '')

		extractPage = (url) ->
			return url.match(/\/\d+(\?|$)/)[0].replace('/', '').replace('?', '')			
 
		###
		#	getArticle
		###		
		$httpBackend
		.when('GET', /^\/api.php\?/)
		#.when('GET', /^\/api\/flexikon_article\/[^\/\?]+\?(.*)/)
		.respond((method, url, data) ->
			console.debug 'Mocking Article Detail response..'

			id 	 = extractParam(url, 'id', '123456')
			page = extractParam(url, 'page', 'Mocked Heading')

			result = generateMockArticle(id, page)

			return [200, result, {}]
		)		

		###
		#	getListing
		###
		$httpBackend
		.when('GET', /^\/de\/api\/flexikon_article\/(\?.*)/)
		.respond((method, url, data) ->
			console.debug 'Mocking Article Listing response..'
			result = {}
			result.urls = []
			data = {}
			data.epp = parseInt(extractParam(url, 'epp', 20))
			data.page = parseInt(extractParam(url, 'page', 1))
			data.term = extractParam(url, 'term', 'Article')
			data.excellent = angular.fromJson(extractParam(url, 'excellent', false))			

			for i in [1..data.epp]
				mockedArticle = 
					id : '' + (i + data.epp * (data.page-1))
					title : 'Mocked ' + data.term + ' ' + (i + data.epp * (data.page-1)) #+ if data.excellent then '*' else ''
					content_highlight : 'Lorem ipsum Minim enim reprehenderit eu dolore id eu et amet dolore Duis quis eu esse minim officia Excepteur id ut ad ullamco Ut Duis. Lorem ipsum Minim enim reprehenderit eu dolore id eu et amet dolore Duis quis eu esse minim officia Excepteur id ut ad ullamco Ut Duis. '
					picture_url : './img/' + if i%3 == 0 then 'blinky.png' else if i%3 == 1 then 'clyde.jpg' else if i%3 == 2 then 'inky.png'

				result.urls.push mockedArticle

			return [200, result, {}]
		)
	else
		console.debug '# Mocking is currently disabled'
		console.debug '# Set environment in Api service to \"development_mocked\"'
		console.debug '#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n'
		return {}		

)