angular.module("Flexikon.services").factory("FullscreenViewer", ($ionicModal, $q) ->

  @modal = undefined

  ###*
   * [initModal ]
   * @param  {[type]} template []
   * @param  {[type]} scope    []
   * @return {[type]}          []
  ###
  @initModal = (template, scope) =>
    if @modal then @modal.remove()

    @modal = $ionicModal.fromTemplate(template,
      scope: scope,
      animation: 'slide-in-out-right fade'
    )

    scope.$on('$destroy', =>
      if @modal?
        @modal.remove()
        @modal = undefined
    )

  ###*
   * [initModalFromUrl]
   * @param  {[type]} url   []
   * @param  {[type]} scope []
   * @return {[type]}       []
  ###
  @initModalFromUrl = (url, scope, cssClass) =>
    if @modal then @modal.remove()

    $ionicModal.fromTemplateUrl(url,
      scope: scope,
      animation: 'slide-in-out-right fade'
      cssClass: 'BLUBB'
    ).then((modal) =>
      @modal = modal

      scope.$on('$destroy', =>
        if @modal?
          @modal.remove()
          @modal = undefined
      )
    )

  ###*
   * [openModal]
   * @param  {[type]} template []
   * @param  {[type]} scope    []
   * @return {[type]}          []
  ###
  @openModal = (template, scope) =>
    if template? then @initModal(template, scope)

    @modal.show()

  ###*
   * [openModalFromUrl]
   * @param  {[type]} url   []
   * @param  {[type]} scope []
   * @return {[type]}       []
  ###
  @openModalFromUrl = (url, scope, cssClass) =>
    if url? then @initModalFromUrl(url, scope).then(=>
      @modal.show()
    )
  
  ###*
   * [closeModal]
   * @return {[type]} []
  ###
  @closeModal = =>
    screen?.unlockOrientation?()
    if @modal?
      @modal.hide().finally(@modal.remove)
      @modal = undefined

  return {
    initModal       : @initModal
    initModalFromUrl: @initModalFromUrl
    openModal       : @openModal
    openModalFromUrl: @openModalFromUrl
    closeModal      : @closeModal
  }

)