angular.module("Flexikon.services").factory("GlobalSettings", (LocalStorage) ->

  settings : {
    privacy : undefined
    language : 'de'
    answerability : undefined
    stacktables : false
  }

  init : ->
    console.debug '#=-=Initializing GlobalSettings...-=#'

    if LocalStorage.isSet('flexikon_settings_save')
      @settings = JSON.parse(LocalStorage.get('flexikon_settings_save'))

    console.debug '# The currently set language is: ' + @settings.language
    console.debug '#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n'

    self = @

    if !@settings.language?
      if !navigator?.language?
        @settings.language = 'de'
      else
        @settings.language = navigator.language.substr(0, navigator.language.indexOf('-')).toLowerCase() || 'de'
      
    if !@settings.privacy?      then @settings.privacy  = 0
    if !@settings.answerability then @settings.answerability = 2

    @persist()

  persist : ->
    LocalStorage.set('flexikon_settings_save', JSON.stringify(@settings))

  Privacy : (value) ->
    if value == undefined
      return @settings.privacy
    else
      @settings.privacy = value
      @persist()

  Language : (value) ->
    if value == undefined
      return @settings.language || 'de'
    else
      @settings.language = value.toLowerCase()
      @persist()

  Answerability : (value) ->
    if value == undefined
      return @settings.answerability
    else
      @settings.answerability = value
      @persist()

  Stacktables : (value) ->
    if value == undefined
      return @settings.stacktables
    else
      @settings.stacktables = value
      @persist()

  getExtendedLanguage: ->
    return @settings.language + '_' + @settings.language.toUpperCase()

  getLanguageForURL: ->
    if @settings.language == 'en'
      return 'com'
    return @settings.language


)