angular.module("Flexikon.services").factory("Store", ($rootScope, Load, Api, InAppPurchase, ABTest) ->

  owned: []
  FREE_PREMIUM: false # just for beta purposes

  initialize: ->
    console.debug 'Initializing Store...'
    @owned = []
    self = @

    InAppPurchase.get('flexikon_offline')
    .then (doc) ->
      if ionic.Platform.isWebView()
        #console.debug 'DELETING'
        #InAppPurchase.delete(doc)
        self.owned.push('flexikon_offline')
      else
        #console.debug 'DELETING'
        InAppPurchase.delete(doc)
        #self.owned.push('flexikon_offline')
    .catch (error) ->
      console.debug 'Nothing found!'

    InAppPurchase.get('dc_flexikon_offline')
    .then (doc) ->
      if ionic.Platform.isWebView()
        #console.debug 'DELETING'
        #InAppPurchase.delete(doc)
        self.owned.push('dc_flexikon_offline')
      else
        console.debug 'DELETING'
        InAppPurchase.delete(doc)
        #self.owned.push('dc_flexikon_offline')
    .catch (error) ->
      console.debug 'Nothing found!'

    if !store?
      console.warn('store object is not available - currently testing in browser? Otherwise check the plugin!')
      return

    store.register
      id    : 'flexikon_offline'
      alias : 'Flexikon Offline'
      type  : store.NON_CONSUMABLE

    store.when('flexikon_offline').approved((product) ->
      if (self.owned.indexOf('flexikon_offline') < 0)
        self.owned.push('flexikon_offline')

        ABTest.trackEvent('approved')

        if product?.price?
          price = parseFloat(product.price.replace(',','.'))
        if isNaN(price)
          price = 2.99

        console.debug 'Price: ' + price

      console.debug('Approved offline usage')
      product.finish()
    )

    store.when('flexikon_offline').finished((product) ->
      console.debug('Finished offline usage')
      self.owned.push('flexikon_offline')
      InAppPurchase.insert('flexikon_offline',
        purchased : true
      )
      $rootScope.$broadcast('InAppPurchase-succeeded')
      Load.isBlocked(false)
    )

    store.when('flexikon_offline').cancelled((product) ->
      console.debug('Cancelled offline usage')
      Load.isBlocked(false)
    )

    store.when("flexikon_offline").updated((product) ->
      if product.owned && self.owned.indexOf('flexikon_offline') < 0
        self.owned.push('flexikon_offline')
        InAppPurchase.insert('flexikon_offline',
          purchased : true
        )
        $rootScope.$broadcast('InAppPurchase-succeeded')

      else if !product.owned
        InAppPurchase.get('flexikon_offline')
        .then (doc) ->
          InAppPurchase.delete(doc)
          $rootScope.$broadcast('InAppPurchase-notowned')
    )

    store.refresh()

    @initialized = true

  isOwned: (id) ->
    return (
      @FREE_PREMIUM && Api.getEnv().indexOf('dev') >= 0 ||
      @owned.indexOf(id)                           >= 0  ||
      @owned.indexOf('dc_' + id)                   >= 0
    )

  checkForOwnedDcProducts: ->




  removeDcProducts: ->




  ownedByDcUser: (id='flexikon_offline') ->
    @owned.push('dc_' + id)
    InAppPurchase.insert('dc_flexikon_offline',
      purchased : true
    )
    $rootScope.$broadcast('InAppPurchase-succeeded')

  dcUserLogout: (id='flexikon_offline') ->
    if @owned.indexOf('dc_' + id)
      @owned.splice(@owned.indexOf('dc_' + id))
      InAppPurchase.get('dc_' + id)
      .then (doc) ->
        InAppPurchase.delete(doc)
        $rootScope.$broadcast('InAppPurchase-notowned')

  restore: ->
    if !@initialized
      @initialize()

    if (!ionic.Platform.isWebView())
      console.warn('store object is not available - currently testing in browser? Otherwise check the plugin!')
      @owned.push('flexikon_offline')
      InAppPurchase.insert('flexikon_offline',
        purchased : true
      )
      $rootScope.$broadcast('InAppPurchase-succeeded')
      Load.isBlocked(false)
      return

    store.refresh()
    return

  order: (product) ->
    Load.isBlocked(true)

    # Debug because beta testing for Android is pain..!
    # Also added browser testing here
    # REMOVE as soon as testing with valid beta version
    if (!ionic.Platform.isWebView())
      console.warn('store object is not available - currently testing in browser? Otherwise check the plugin!')
      @owned.push('flexikon_offline')
      InAppPurchase.insert('flexikon_offline',
        purchased : true
      )
      $rootScope.$broadcast('InAppPurchase-succeeded')
      Load.isBlocked(false)
      return

    if !@initialized
      @initialize()
    store.order('flexikon_offline')
)