angular.module("Flexikon.services").factory("ToC", ($rootScope) ->

  currentTitle : ''
  currentToc : []
  currentSection : -1

  generate: (article, title) ->
    @currentTitle = title
    @currentToc = []
    @currentSection = -1
    regex = new RegExp('<h(.)>(.+?)<\/h.>', 'g')

    headings = article.match(regex) || []

    id = parseInt(Math.random()*100000)

    for h in headings

      heading = h.substr(h.indexOf('>')+1)
      heading = heading.substr(0, heading.indexOf('<'))

      if h[2]-1 <= 3
        @currentToc.push(
          level    : h[2]-1
          heading  : heading
          id       : id
          targetId : title.replace(/_| |'|"/g, '-') + id
        )
      if @currentSection < 0 then @currentSection = title.replace(/_| |'|"/g, '-') + id

      article = article.replace(h, '<h' + h[2] + ' id="' + title.replace(/_| |'|"/g, '-') + (id++) + '">' + heading + '</h' + h[2] + '>')

    x = {
      article : article
      toc : @currentToc.slice()
    }

    $rootScope.$broadcast('new-toc-available')

    return x

  setCurrentSection: (section) ->
    @currentSection = section
    $rootScope.$broadcast('reloadActiveSection')

  getCurrentSection: ->
    return @currentSection

  getTitle: ->
    return @currentTitle

  getSectionWithHeading: (heading) ->
    for section in @currentToc
      if section.heading == heading then return section
    return

  get: ->
    return @currentToc

  set: (toc) ->
    @currentToc = toc

    $rootScope.$broadcast('new-toc-available')

)