angular.module("Flexikon.translations").config(($translateProvider) ->

  $translateProvider.translations('en_EN', {
    ###
    #
    # 888888  88    88
    # 88      888   88
    # 88      8888  88
    # 88888   88 88 88
    # 88      88  8888
    # 88      88   888
    # 888888  88    88
    #
    ###
    
    ###
    # Globals
    ###
    'GLOB_DC_FLEXIKON'                  : 'DocCheck Flexikon'
    'GLOB_NO_CONNECTION'                : 'No connection!'

    ###
    # Views
    ###

    # Home
    'DC_HOME_ERROR'                     : 'Something went wrong.<br /><br />Please check your internet connection and try again!'

    # Favorites
    'FAVORITES_TITLE'                   : 'Favorites'
    
    'SAVED_ARTICLES'                    : 'Saved articles'
    'SAVED_ARTICLES_NOTHING'            : 'You haven\'t saved any articles yet.'

    'CONTRIBUTIONS'                     : 'My articles'
    'CONTRIBUTIONS_NOTHING'             : 'You haven\'t created or edited any articles yet.'
    'CONTRIBUTIONS_ERROR'               : 'Your articles couldn\'t be accessed.<br /Please check your internet connection and try again!'
    'CONTRIBUTIONS_SIGNIN'              : 'Log in to see your contributions to Flexikon.'
    'LAST_SEEN'                         : 'Last seen'
    'LAST_SEEN_NOTHING'                 : 'You haven\'t viewed any article yet.'

    # Search
    'SEARCH_TITLE'                      : 'Search'
    'SEARCH_ERROR'                      : 'Something went wrong.<br /><br />Please check your internet connection and try again!'
    'SEARCH_DEFINE'                     : 'No results? Be the first and write a definition.'

    # Settings
    'SETTINGS_HEADING'                  : 'Settings'
    'SETTINGS_SIGNOUT'                  : 'Sign out'
    'SETTINGS_PRIVACY'                  : ''
    'SETTINGS_HELP'                     : 'Help & tips'
    'SETTINGS_PROMOTION'                : 'More from DocCheck'
    'SETTINGS_DISCLAIMER'               : 'Disclaimer'
    'SETTINGS_PROFILE'                  : 'Set up profile'
    'SETTINGS_LANGUAGE'                 : 'Language'
    'SETTINGS_IMPORTANT'                : 'Important note'
    'SETTINGS_OFFLINE'                  : 'Save article offline'
    'SETTINGS_RESTORE_PURCHASE'         : 'Restore In-App-Purchase'

    'PROMOTION_HEADING'                 : 'More from DocCheck'
    'PROFILE_HEADING'                   : 'Set up profile'
    
    'HELP_HEADING'                      : 'Help & tips'
    'HELP_CONTENT'                      : '<b class="heading"> What can I use the DocCheck Flexikon App for? </b> <br />
        <ul>
             <li> Have access to more than 45,000 medical articles  </li>
             <li> Edit and write articles on topics of your choice  </li>
             <li> Mark especially relevant articles and save them offline  </li>
        </ul>
        <br />
        <b class="heading"> How can I edit existing articles?</b> <br />
        You can edit already existing articles in the Flexikon with the pen icon within the article. Within the edit mode you can first have a look at your changes or save them directly. <br />
        <br />
        <b class="heading"> How can I create a new article?</b> <br />
        When you don\'t find a term within the Flexikon search you can start with a definition yourself. As soon as you save the definition, a new article is created. You can then edit the article through the pen icon. <br />
        <br />
        <b class="heading"> How can I mark an article as favorite? </b> <br />
        First, you log in with your DocCheck account. When you have found an article which you would like to find again quickly later, you can mark it through the heart-icon in the upper bar. From now on it will be displayed in the navigation under "favorites". <br />
        <br />
        <b class="heading"> How can I save an article offline? </b> <br />
        In order to save articles locally, you can choose the chargeable option "Save article offline" within the table of contents. After that, all articles which you have marked as favorites will be available without internet connection. As soon as you reconnect your device to the internet, your articles will be updated to the newest version. Videos and media are only available online.<br />
        <br />
        <b class="heading">How can I customize the view of the app? </b> <br />
        The menu (or burger button) is available at the top of each article on the right. Click „view“ in order to change the font size and color scheme. By pressing „o“ you reset the size. In addition, you can navigate through individual sections of the article using the table of contents. Through this you can quickly jump to different chapters within an article.
            <br />
        <br />
        <b> Important note: </b> The DocCheck Flexikon is an open encyclopedia, which is meant exclusively for training and education. It is not a manual for self-therapy and no substitute for medical advice or treatment.</b>
        It is maintained by the participating authors in the best of their knowledge. The authors and operators of the DocCheck Flexikon assume no liability for any damage which is caused due to nonreflective or uncontrolled application of recommendations, contents or opinions that have been published in the DocCheck Flexikon for educational or demonstration purposes.<br />
        Articles which provide information on the use and dosage of drugs correspond to the personal opinion of the authors. They are no substitute for the recommendations of the manufacturer or the physician or pharmacist in charge.<br />
        <br />'

    'SIDEMENU_TOC'                      : 'Table of contents'
    'SIDEMENU_AUTHORS'                  : 'Authors of the article'
    'SIDEMENU_VERSIONS'                 : 'Versions'
    'SIDEMENU_SHARE'                    : 'Share article'
    'SIDEMENU_FONTSIZE'                 : 'View'

    'POPOVER_FONTSIZE'                  : 'Font Size'
    'POPOVER_THEME'                     : 'Color scheme'

    'IMPORTANT_HEADING'                 : 'Important note'
    'IMPORTANT_CONTENT'                 : ''

    'DISCLAIMER_CONTENT'                : 'The DocCheck Flexikon is an open encyclopedia, which is meant exclusively for training and education of healthcare professionals (e.g. physicians, pharmacists, veterinarians, dentists, medical students). It is not a manual for self-therapy and no substitute for medical advice or treatment.</b>

It is maintained by the participating authors in the best of their knowledge. The authors and operators of the DocCheck Flexikon assume no liability for any damage caused due to nonreflective or uncontrolled application of recommendations, contents or opinions that have been published in the DocCheck Flexikon for educational or demonstration purposes.<br />

Articles which provide information on the use and dosage of drugs correspond to the personal opinion of the authors. They are no substitute for the recommendations of the manufacturer or the physician or pharmacist in charge.<br />'
    'DISCLAIMER_IMPRESS'                : 'Imprint'
    'DISCLAIMER_HEADING'                : 'Disclaimer'

    # Article
    'ARTICLE_TITLE'                     : 'Article'

    ###
    # Directives
    ###

    'DC_DEFINITION_NO_RESULTS'          : 'There are no entries to your search term yet'
    'DC_DEFINITION_PLEASE_DEFINE'       : 'Make a start and define "{{title}}"'
    'DC_DEFINITION_SUBMIT'              : 'Submit'

    'DC_ARTICLE_HEADING'                : 'Article'
    'DC_ARTICLE_DEFINE'                 : 'This article doesn\'t exist yet.<br />Make a start!'
    'DC_ARTICLE_FINDINPAGE_PLACEHOLDER' : 'Search...'
    'DC_ARTICLE_SAVED'                  : 'Article saved successfully'
    'DC_ARTICLE_SAVED_ERROR'            : 'Article couldn\'t be saved. Please check your internet connection and try again!'
    'DC_ARTICLE_OFFLINE_HINT'           : '(last synchronized on {{date}})'
    'DC_ARTICLE_OFFLINE_BUY'            : 'The article couldn\'t be accessed. Please check your internet connection and try again later. <br /><br />
                                           In case you want to read Flexikon articles offline in the future - the full version of the App makes it possible!'
    'DC_ARTICLE_OFFLINE_BOUGHT'         : 'The article couldn\'t be accessed. Please check your internet connection and try again later. <br /><br />
                                           You always want to have this article on hand? Then add it to your favorites and read it offline!'
    'DC_ARTICLE_RETRY'                  : 'Try again'

    'DC_ARTICLE'                        :
      'SUMMERBREAK'                       :
        'POPOVER_HINT_PLAIN'                : '
          <div class="dc-bold">Summerbreak</div>
          <br />
          Flexikon\'s in summerbreak! For more information visit the website!
        '
        'POPOVER_HINT_DATE'                 : '
          <div class="dc-bold">Summerbreak</div>
          <br />
          Flexikon\'s in summerbreak from {{from}} to {{to}}!
        '
        'POPOVER_HINT_FAILURE'              : '
          A connection to DocCheck couldn\'t be established!<br />
          Check your connection or try again later!
        '
        'COME_BACK'                         : '
            After the summerbreak you\'ll be able to create & edit articles as usual!
        '

    'DC_TABLE_SHOW_MORE'                : 'More...'
    'DC_TABLE_SHOW_LESS'                : 'Less...'

    'DC_PUBLISH_NOT_ALLOWED'            : 'Either the document couldn\'t be accessed or the document can\'t be displayed due to its rights-settings.'

    'DC_3D_ERROR'                       : ''
    'DC_3D_CLOSE'                       : 'back to article'
    'DC_MEDIA_VIEWER_ERROR'             : ''
    'DC_PARSE_ERROR'                    : ''

    # Login
    'DC_LOGIN_USERNAME'                 : 'Username'
    'DC_LOGIN_PASSWORD'                 : 'Password'
    'DC_LOGIN_PASSWORDFORGOTTEN'        : 'Password forgotten?'
    'DC_LOGIN_REGISTER'                 : 'Register for free'
    'DC_LOGIN_SUBMIT'                   : 'Log in'
    'DC_LOGIN_REQ_USER'                 : 'Please enter your username.'
    'DC_LOGIN_REQ_PASSWORD'             : 'Please enter your password.'
    'DC_LOGIN_FAILED'                   : 'Wrong username or password.'
    'DC_LOGIN_SETTINGS'                 : 'Please log in with your DocCheck password in order to use all features.'

    'LANG_DE'                           : 'German'
    'LANG_EN'                           : 'English'

    ###
    # Neue Keys!
    ###

    ###
    'DC_PURCHASE_TEXT_VERSION1'         : 'Read all Flexikon articles <span class="white">free of ads</span> and <span class="white">favorites offline</span> for just <span class="white">2,99 €'
    ###
    'DC_PURCHASE_TEXT_VERSION1'         : 'You want to view your <span class="white">favorites offline</span><br />and enjoy <span class="white">ad-free</span> articles?'
    'DC_PURCHASE_TEXT_VERSION1b'        : '<ul><li>viewing <span class="white">Favorites offline</span></li><li><span class="white">ad-free</span> version</li></ul>'
    'DC_PURCHASE_TEXT_BUTTON'           : ' Get the Upgrade!'
    'DC_PURCHASE_TEXT_VERSION2'         : 'Read all Flexikon articles free of ads<br />and favorites offline for just 2,99 €'
    'DC_OPEN'                           : 'continue to article'
    'DC_ARTICLE_LEAVE_HINT'             : 'You haven\'t saved your changes yet. Are you sure you want to leave the article?'
    'DC_ARTICLE_LEAVE_WITH_SAVE'        : 'Save changes'
    'DC_ARTICLE_LEAVE_WITHOUT_SAVE'     : 'Delete changes'
    'DC_ARTICLE_CANCEL_LEAVE'           : 'Back to the article'
    'DC_ARTICLE_NOT_FOUND'              : 'This article doesn\'t exist yet. Start now with a definition!'
    'DC_ARTICLE_NO_CONNECTION_TITLE'    : 'No connection'
    'DC_ARTICLE_NO_CONNECTION'          : 'The article couldn\'t be accessed. Please check your internet connection and try again later!'
    'DC_ARTICLE_LOGIN'                  : 'Please log in with your DocCheck password in order to edit this article!'
    'DC_CREATE'                         : 'Create article'
    'DC_QUICKSEARCH_PLACEHOLDER'        : 'Search'
    'DC_SEARCH_SEARCHING_FAVS'          : 'Your device isn\'t connected to the internet. Restore your connection or search your favorites.'
    'DC_SEARCH_ONLINE_AGAIN'            : 'Internet connection is available again! Start a new search for more results.'

    ###
    # Neue Keys!
    ###
    'YOUTUBE_PREFIX'                    : 'Youtube Video'
    'YOUTUBE_TITLE_NOT_LOADED'          : 'Video title couldn\'t be retreived.'
    'MODEL_NOT_LOADED'                  : '3D model couldn\'t be retreived.'
    'SEARCH_LATEST'                     : 'Recently edited articles'
    'SETTINGS_OVERLAY_HOME_RERUN'       : 'Start the guided tour'

    'DC_TUTORIAL_OVERLAY_HOME'          : 'Discover current top articles'
    'DC_TUTORIAL_OVERLAY_BOOKMARK'      : 'Here you can find your favorite articles, which you can read also in offline mode'
    'DC_TUTORIAL_OVERLAY_SEARCH'        : 'Search for specific medical articles'
    'DC_TUTORIAL_OVERLAY_SETTINGS'      : 'Administer and customize the app according to your requirements'

    'DC_TUTORIAL_OVERLAY_NEWBOOKMARK'   : 'Mark this article as a favorite to save it under your personal items'
    'DC_TUTORIAL_OVERLAY_EDIT'          : 'Edit this article and...'
    'DC_TUTORIAL_OVERLAY_PREVIEW'       : '...preview the changes you\'ve made'
    'DC_TUTORIAL_OVERLAY_TOC'           : 'In the sidemenu you find the table of contents and additional functions.'
    'DC_TUTORIAL_OVERLAY_APPEARANCE'    : 'Choose font size and color scheme.'
    'DC_TUTORIAL_OVERLAY_SHARE'         : 'Recommend this article to friends or colleagues!'
    'DC_TUTORIAL_OVERLAY_PREMIUM'       : 'You cant read your favorites offline and ad-free!'

    'SEARCH_CREATE'                     : 'Not found what you were looking for? Be the first and write a <b>definition</b>.'

    # passt so
    'LANG_DE_FLAG'                      : '0px'
    'LANG_EN_FLAG'                      : '-40px'
  })
)