angular.module("Flexikon.services").factory("PictureSlider", ($ionicModal, $ionicScrollDelegate, $ionicSlideBoxDelegate, $ionicGesture, $timeout, $ImageCacheFactory, PicturesApi) ->

  modal = undefined
  scoperef = undefined

  init : ($scope, def) ->
    self = @

    self.scoperef = $scope

    $ionicModal.fromTemplateUrl('templates/PictureSliderModal.html', {
      scope: $scope,
      animation: 'slide-in-out-right fade'
    }).then((modal) ->
      self.modal = modal
      if def?
        def.resolve()
    )

    self.scoperef.modalapi = {}

    self.scoperef.modalapi.lockIfZoomed = () ->
      if($ionicScrollDelegate.$getByHandle('pictureSliderScroll')?.getScrollView()? && $ionicScrollDelegate.$getByHandle('pictureSliderScroll').getScrollView().__zoomLevel <= 1)
        $ionicSlideBoxDelegate.enableSlide(true)
      else
        $ionicSlideBoxDelegate.enableSlide(false)

    self.scoperef.modalapi.triggerZoom = (e) ->
      pos = e.gesture.srcEvent.changedTouches[0]

      if($ionicScrollDelegate.$getByHandle('pictureSliderScroll').getScrollView().__zoomLevel > 3.0)
        $ionicScrollDelegate.$getByHandle('pictureSliderScroll').zoomTo(1.0, true, pos.clientX, pos.clientY)
      else
        $ionicScrollDelegate.$getByHandle('pictureSliderScroll').zoomBy(3.0, true, pos.clientX, pos.clientY)

    self.scoperef.modalapi.getCurrentTitle = ->
      if $ionicSlideBoxDelegate.currentIndex()? && self.scoperef.pictureSliderModal?.pictures?.length > 0
        return self.scoperef.pictureSliderModal.pictures[$ionicSlideBoxDelegate.currentIndex()]?.title
      return ''

    self.scoperef.modalapi.openInPictures = ->
      if $ionicSlideBoxDelegate.currentIndex()? && self.scoperef.pictureSliderModal?.pictures?.length > 0
        window.open(PicturesApi.getLinkFor('photo') + self.scoperef.pictureSliderModal.pictures[$ionicSlideBoxDelegate.currentIndex()].id, "_system")
      return

    self.scoperef.modalapi.show = (pictures, title="", index=0) ->
      self.scoperef.pictureSliderModal = {
        index : index
        title : title
        pictures : pictures
        shown : false
        waiting : true
      }

      self.scoperef.pictureSliderModal.getPictureSize = () ->
        if window.innerWidth < window.innerHeight
          return {
            width: '100%'
            height: 'auto'
          }
        else
          return {
            height: '100%'
            width: 'auto'
          }

      self.modal.show()
      $ionicSlideBoxDelegate.update()

      purls = []
      for p in pictures
        purls.push(p.thumbnails.o)

      $ImageCacheFactory.Cache(purls).finally(->
        element = angular.element(document.querySelector('#pictureSliderScroll'))
        $ionicGesture.on('doubletap', self.scoperef.modalapi.triggerZoom, element)
        $ionicSlideBoxDelegate.update()
        $ionicSlideBoxDelegate.slide(self.scoperef.pictureSliderModal.index)
        self.scoperef.pictureSliderModal.shown = true
        $timeout(->
          self.scoperef.pictureSliderModal.waiting = false
        , 1000)
      )

    self.scoperef.modalapi.hide = ->
      self.scoperef.onSliderHide?($ionicSlideBoxDelegate.currentIndex())
      self.scoperef.pictureSliderModal.shown = true
      $ionicScrollDelegate.$getByHandle('pictureSliderScroll').zoomTo(1.0, true, 0, 0)
      self.modal.hide()

    self.scoperef.$on('$destroy', () ->
      if self.modal?.remove?
        self.modal.remove()
      self.modal = undefined
    )

  show : ($scope, pictures, title="") ->
    self = @

    $scope.pictureSliderModal = {
      title : title
      pictures : pictures
    }

    d = $.Deferred()

    d.then(->
      self.modal.show()
      element = angular.element(document.querySelector('#pictureSliderScroll'))
      $ionicGesture.on('doubletap', $scope.modalapi.triggerZoom, element)
    )

    if !@modal?
      @init($scope, d)
    else
      d.resolve()

  hide : ->
    if !@modal?
      @init()
    @modal.hide()

)