angular.module("Flexikon.controllers").controller('SettingsCtrl', ($scope, $rootScope, $controller, $ionicScrollDelegate, $ionicHistory, $timeout, $translate, $filter, GlobalSettings, Login, GuidedTour, Api, LocalStorage, Store, Load) ->

  $controller('TrackingCtrl', {$scope: $scope})

  $scope.selected =
    language : GlobalSettings.Language().toUpperCase() || 'DE'
  
  $scope.ui =
    renderContent: false
    restorable   : false
    flag         : $filter('translate')($scope.selected.language)
    loading      : false

  $scope.$on("$ionicView.beforeEnter", ->
    $scope.$broadcast("settings.beforeEnter", arguments)
    $timeout(->
      $scope.ui.restorable = !Store.isOwned('flexikon_offline')
    , 2000)
  )

  $scope.$on("$ionicView.afterEnter", ->
    $ionicScrollDelegate.resize()
  )

  ionic.DomUtil.ready(->
    $timeout(->
      $scope.ui.renderContent = true
      $scope.ui.restorable = !Store.isOwned('flexikon_offline')
    , 1000)
  )

  ionic.Platform.ready(->
    $scope.languages = [
      id      : 'DE'
      label   : $filter('translate')('LANG_DE')
    ,
      id      : 'EN'
      label   : $filter('translate')('LANG_EN')
    ]

    if Api.getEnv().indexOf('development') >= 0 then $scope.languages.push(
      id    : 'XYZ'
      label : 'DEBUG'
    )
  )

  $scope.$watch('selected.language', (n, o) ->
    if(n == o)
      return

    GlobalSettings.Language(n)
    $translate.use(n.toLowerCase() + '_' + n.toUpperCase())
    $ionicHistory.clearCache()
    $scope.ui.flag = $filter('translate')('LANG_' + $scope.selected.language + '_FLAG')

    #DEBUG
    if $scope.ui.flag.indexOf('XYZ') >= 0
      $scope.ui.flag = '40px'
  )

  $scope.isDev = ->
    return Api.getEnv() == 'development'

  $scope.getFlag = ->
    return $scope.ui.flag

  $scope.signOut = ->
    Login.signOut()
  
  $rootScope.$on 'event:auth-loginCancelled', ->
    $timeout ->
      $scope.resizeScroll()
    , 500
  $rootScope.$on 'event:auth-loginRequired', ->
    $timeout ->
      $scope.resizeScroll()
    , 500
  $rootScope.$on 'event:auth-loginConfirmed', ->
    $timeout ->
      $scope.resizeScroll()
    , 500
  $rootScope.$on 'event:auth-logout', ->
    $timeout ->
      $scope.resizeScroll()
    , 500

  ###*
   * [hide restore immediately when premium is purchased]
   * @return
  ###
  $rootScope.$on('InAppPurchase-succeeded', ->
    $timeout(->
      $scope.ui.restorable = false
    )
  )

  $scope.restorePurchase = ->
    Store.restore()

  $scope.resizeScroll = ->
    $ionicScrollDelegate.$getByHandle('SettingsScroll').resize()

  $scope.startOverlay = ->
    LocalStorage.unset('FlexikonHomeIntro')
    LocalStorage.unset('FlexikonArticleIntro')
    $timeout(->
      $scope.runHomeOverlay()
    )
    

)