angular.module('Flexikon', ['ionic', 'templates', 'ngIOS9UIWebViewPatch', 'ngCordova', 'ngCordova.plugins', 'ngCordova.plugins.vibration', 'ngMockE2E', 'ionic.ion.imageCacheFactory', 'Flexikon.controllers', 'Flexikon.services', 'Flexikon.directives', 'Flexikon.translations', 'http-auth-interceptor', 'http-auth-interceptor-buffer', 'pouchdb']).run(function($ionicPlatform, $cordovaStatusbar, $http, $httpBackend, $translate, $rootScope, $templateCache, Login, LastSeen, GlobalSettings, Api, FlexikonApi, Theme, Store, InAppPurchase) {

  /*
   * Initial config
   */
  GlobalSettings.init();
  Login.init();
  Store.initialize();
  Theme.select(Theme.getSelected());
  if (Api.getEnv() === 'development_mocked') {
    $httpBackend.whenGET(/.*templates\/.*/).passThrough();
    $httpBackend.whenGET(/.*tv.doccheck.com\/.*/).passThrough();
    $httpBackend.whenPOST(/.*login.doccheck.com\/.*/).passThrough();
    $httpBackend.whenGET(/.*login.doccheck.com\/.*/).passThrough();
  } else {
    $httpBackend.whenGET(/.*/).passThrough();
    $httpBackend.whenPOST(/.*/).passThrough();
  }

  /*
  if Api.getEnv().indexOf('development') >= 0 && ionic.Platform.isWebView()
    analytics.debugMode()
   */
  $ionicPlatform.ready(function() {
    var device, deviceInformation, ref, ref1;
    $rootScope.$broadcast('run-and-ready');
    $http.defaults.headers.post['Content-Type'] = false;
    $http.defaults.headers.post['Allow-Control-Allow-Origin'] = '*';
    if (ionic.Platform.isWebView()) {
      device = ionic.Platform.device();
      deviceInformation = ['os=' + device.platform, 'os-version=' + device.version, 'manufacturer=' + device.manufacturer, 'device=' + device.model];
      $http.defaults.headers.common['X-Doccheck-App'] = 'Flexikon App/1.7.0; ' + deviceInformation.join('; ');
    }
    ionic.Platform.fullScreen(true, true);
    if (typeof cordova !== "undefined" && cordova !== null) {
      if ((ref = cordova.plugins) != null) {
        if ((ref1 = ref.Keyboard) != null) {
          ref1.disableScroll(true);
        }
      }
    }
    if (typeof facebookConnectPlugin !== "undefined" && facebookConnectPlugin !== null) {
      facebookConnectPlugin.getLoginStatus();
    }
    GlobalSettings.init();
    $translate.use(GlobalSettings.getExtendedLanguage());
    window.addEventListener('native.keyboardshow', function() {
      return document.body.classList.add('keyboard-open');
    });
  });
}).config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $provide, $translateProvider, $httpProvider) {

  /*
   * Tab config
   */
  $provide.decorator('$httpBackend', function($delegate) {
    var key, proxy;
    proxy = function(method, url, data, callback, headers) {
      var interceptor;
      interceptor = function() {
        var _arguments, _this;
        _this = this;
        _arguments = arguments;
        setTimeout(function() {
          callback.apply(_this, _arguments);
        }, 1);
      };
      return $delegate.call(this, method, url, data, interceptor, headers);
    };
    for (key in $delegate) {
      proxy[key] = $delegate[key];
    }
    return proxy;
  });
  $ionicConfigProvider.views.swipeBackEnabled(false);
  $ionicConfigProvider.tabs.position("bottom");
  $ionicConfigProvider.tabs.style("standard");
  $ionicConfigProvider.backButton.text('').icon('fa fa-chevron-left');
  $ionicConfigProvider.backButton.previousTitleText(false);
  $ionicConfigProvider.views.maxCache(100);
  $ionicConfigProvider.views.forwardCache(true);
  $ionicConfigProvider.scrolling.jsScrolling(false);
  if (ionic.Platform.isAndroid()) {
    if (typeof StatusBar !== "undefined" && StatusBar !== null) {
      StatusBar.backgroundColorByHexString("#990026");
    }
  }

  /*
   * Language
   */
  if (!$translateProvider.use()) {
    $translateProvider.use('de_DE');
  }

  /*
   * Routing
   */
  $stateProvider.state("tabs", {
    url: "/tabs",
    templateUrl: "templates/TabView.html",
    abstract: true,
    controller: "TabCtrl"
  }).state("tabs.home", {
    url: "/home",
    abstract: true,
    views: {
      "home": {
        template: "<ion-nav-view></ion-nav-view>"
      }
    }
  }).state("tabs.home.overview", {
    url: "/overview",
    templateUrl: "templates/HomeView.html",
    controller: "HomeCtrl"
  }).state("tabs.home.article", {
    url: "/article/?id/?page/?section/?create",
    templateUrl: "templates/ArticleView.html",
    controller: "ArticleCtrl"
  }).state("tabs.home.login", {
    url: "/login/?message",
    templateUrl: "templates/LoginView.html",
    controller: "LoginCtrl"
  }).state("tabs.home.disclaimer", {
    url: "/disclaimer",
    templateUrl: "templates/DisclaimerView.html",
    controller: "DisclaimerCtrl"
  }).state("tabs.home.promotion", {
    url: "/promotion",
    templateUrl: "templates/PromotionView.html",
    controller: "PromotionCtrl"
  }).state("tabs.home.help", {
    url: "/help",
    templateUrl: "templates/HelpView.html",
    controller: "HelpCtrl"
  }).state("tabs.home.important", {
    url: "/important",
    templateUrl: "templates/ImportantHintView.html",
    controller: "ImportantHintCtrl"
  }).state("tabs.favorites", {
    url: "/favorites",
    abstract: true,
    views: {
      "favorites": {
        template: "<ion-nav-view></ion-nav-view>"
      }
    }
  }).state("tabs.favorites.overview", {
    url: "/overview",
    templateUrl: "templates/FavoritesView.html",
    controller: "FavoritesCtrl"
  }).state("tabs.favorites.article", {
    url: "/article/?id/?page/?section",
    templateUrl: "templates/ArticleView.html",
    controller: "ArticleCtrl"
  }).state("tabs.favorites.login", {
    url: "/login/?message",
    templateUrl: "templates/LoginView.html",
    controller: "LoginCtrl"
  }).state("tabs.favorites.disclaimer", {
    url: "/disclaimer",
    templateUrl: "templates/DisclaimerView.html",
    controller: "DisclaimerCtrl"
  }).state("tabs.favorites.promotion", {
    url: "/promotion",
    templateUrl: "templates/PromotionView.html",
    controller: "PromotionCtrl"
  }).state("tabs.favorites.help", {
    url: "/help",
    templateUrl: "templates/HelpView.html",
    controller: "HelpCtrl"
  }).state("tabs.favorites.important", {
    url: "/important",
    templateUrl: "templates/ImportantHintView.html",
    controller: "ImportantHintCtrl"
  }).state("tabs.search", {
    url: "/search",
    abstract: true,
    views: {
      "search": {
        template: "<ion-nav-view></ion-nav-view>"
      }
    }
  }).state("tabs.search.overview", {
    url: "/overview",
    templateUrl: "templates/SearchView.html",
    controller: "SearchCtrl"
  }).state("tabs.search.article", {
    url: "/article/?id/?page/?section",
    templateUrl: "templates/ArticleView.html",
    controller: "ArticleCtrl"
  }).state("tabs.search.login", {
    url: "/login/?message",
    templateUrl: "templates/LoginView.html",
    controller: "LoginCtrl"
  }).state("tabs.search.disclaimer", {
    url: "/disclaimer",
    templateUrl: "templates/DisclaimerView.html",
    controller: "DisclaimerCtrl"
  }).state("tabs.search.promotion", {
    url: "/promotion",
    templateUrl: "templates/PromotionView.html",
    controller: "PromotionCtrl"
  }).state("tabs.search.help", {
    url: "/help",
    templateUrl: "templates/HelpView.html",
    controller: "HelpCtrl"
  }).state("tabs.search.important", {
    url: "/important",
    templateUrl: "templates/ImportantHintView.html",
    controller: "ImportantHintCtrl"
  }).state("tabs.settings", {
    url: "/settings",
    abstract: true,
    views: {
      "settings": {
        template: "<ion-nav-view></ion-nav-view>"
      }
    }
  }).state("tabs.settings.overview", {
    url: "/overview",
    templateUrl: "templates/SettingsView.html",
    controller: "SettingsCtrl"
  }).state("tabs.settings.privacy", {
    url: "/privacy",
    templateUrl: "templates/PrivacyView.html",
    controller: "PrivacyCtrl"
  }).state("tabs.settings.disclaimer", {
    url: "/disclaimer",
    templateUrl: "templates/DisclaimerView.html",
    controller: "DisclaimerCtrl"
  }).state("tabs.settings.promotion", {
    url: "/promotion",
    templateUrl: "templates/PromotionView.html",
    controller: "PromotionCtrl"
  }).state("tabs.settings.help", {
    url: "/help",
    templateUrl: "templates/HelpView.html",
    controller: "HelpCtrl"
  }).state("tabs.settings.important", {
    url: "/important",
    templateUrl: "templates/ImportantHintView.html",
    controller: "ImportantHintCtrl"
  });
  $urlRouterProvider.otherwise('/tabs/home/overview');
});


/*
 * Ask module declartion
 */

angular.module("Flexikon.services", []);

angular.module("Flexikon.controllers", []);

angular.module("Flexikon.directives", []);

angular.module("Flexikon.translations", ['pascalprecht.translate']);

angular.module("templates", []);

angular.module("Flexikon.controllers").controller('ArticleCtrl', function($scope, $rootScope, $controller, $ionicNavBarDelegate, $ionicSideMenuDelegate, $timeout, NavBar, Theme, GuidedTour, StateChangeInterrupter) {
  $controller('TrackingCtrl', {
    $scope: $scope
  });
  $scope.$on("$ionicView.beforeEnter", function() {
    return $scope.$broadcast("article.beforeEnter", arguments);
  });
  $scope.$on("$ionicView.beforeLeave", function() {
    return $scope.$broadcast("article.beforeLeave", arguments);
  });
  $scope.$on('$ionicView.enter', function() {
    $ionicSideMenuDelegate.canDragContent(true);
    return $scope.$broadcast("article.enter", arguments);
  });
  $scope.$on('$ionicView.leave', function() {
    $ionicSideMenuDelegate.canDragContent(false);
    $scope.$broadcast("article.leave", arguments);
    return StateChangeInterrupter.unregisterCallback();
  });
  return $scope.darkThemeSelected = function() {
    return Theme.darkThemeSelected();
  };
});

angular.module("Flexikon.controllers").controller('DisclaimerCtrl', function($scope, $ionicScrollDelegate, $timeout, $controller) {
  var subSettingsCtrl;
  subSettingsCtrl = $controller('SubSettingsCtrl', {
    $scope: $scope
  });
  return $timeout(function() {
    return $ionicScrollDelegate.resize();
  });
});

angular.module("Flexikon.controllers").controller('FavoritesCtrl', function($scope, $controller) {
  $controller('TrackingCtrl', {
    $scope: $scope
  });
  return $scope.$on("$ionicView.beforeEnter", function() {
    return $scope.$broadcast("favs.beforeEnter", arguments);
  });
});

angular.module("Flexikon.controllers").controller('HelpCtrl', function($scope, $ionicScrollDelegate, $timeout, $controller) {
  var subSettingsCtrl;
  subSettingsCtrl = $controller('SubSettingsCtrl', {
    $scope: $scope
  });
  return $timeout(function() {
    return $ionicScrollDelegate.resize();
  });
});

angular.module("Flexikon.controllers").controller('HomeCtrl', function($scope, $controller, $ionicScrollDelegate, $timeout, GuidedTour) {
  $controller('TrackingCtrl', {
    $scope: $scope
  });
  $scope.$on("$ionicView.beforeEnter", function() {
    return $scope.$broadcast("home.beforeEnter", arguments);
  });
  $scope.$on("$ionicView.leave", function() {
    return $scope.$broadcast("home.leave", arguments);
  });
  $scope.$on("$ionicView.enter", function() {
    $scope.$broadcast("home.enter", arguments);
    return $ionicScrollDelegate.resize();
  });
  $scope.$on('$ionicView.afterEnter', function() {
    return ionic.Platform.ready(function() {
      if (navigator && navigator.splashscreen) {
        return navigator.splashscreen.hide();
      }
    });
  });
  $scope.$on('$ionicView.loaded', function() {});
  $scope.timeouts = [];
  return $scope.home = {
    title: '<div class="row row-center home-title-wrapper"> <img src="img/doc.png" class="eumel col"> <img src="img/doccheck.png" class="dclogo col"> </div>'
  };
});

angular.module("Flexikon.controllers").controller('ImportantHintCtrl', function($controller, $scope, $timeout, $ionicScrollDelegate) {
  var subSettingsCtrl;
  subSettingsCtrl = $controller('SubSettingsCtrl', {
    $scope: $scope
  });
  return $timeout(function() {
    return $ionicScrollDelegate.resize();
  });
});

angular.module("Flexikon.controllers").controller('LoginCtrl', function($scope, $rootScope, $ionicHistory) {
  $rootScope.$on('event:auth-loginConfirmed', function() {
    return $ionicHistory.goBack();
  });
  return $scope.back = function() {
    return $ionicHistory.goBack();
  };
});

angular.module("Flexikon.services").factory("PictureSlider", function($ionicModal, $ionicScrollDelegate, $ionicSlideBoxDelegate, $ionicGesture, $timeout, $ImageCacheFactory, PicturesApi) {
  var modal, scoperef;
  modal = void 0;
  scoperef = void 0;
  return {
    init: function($scope, def) {
      var self;
      self = this;
      self.scoperef = $scope;
      $ionicModal.fromTemplateUrl('templates/PictureSliderModal.html', {
        scope: $scope,
        animation: 'slide-in-out-right fade'
      }).then(function(modal) {
        self.modal = modal;
        if (def != null) {
          return def.resolve();
        }
      });
      self.scoperef.modalapi = {};
      self.scoperef.modalapi.lockIfZoomed = function() {
        var ref;
        if ((((ref = $ionicScrollDelegate.$getByHandle('pictureSliderScroll')) != null ? ref.getScrollView() : void 0) != null) && $ionicScrollDelegate.$getByHandle('pictureSliderScroll').getScrollView().__zoomLevel <= 1) {
          return $ionicSlideBoxDelegate.enableSlide(true);
        } else {
          return $ionicSlideBoxDelegate.enableSlide(false);
        }
      };
      self.scoperef.modalapi.triggerZoom = function(e) {
        var pos;
        pos = e.gesture.srcEvent.changedTouches[0];
        if ($ionicScrollDelegate.$getByHandle('pictureSliderScroll').getScrollView().__zoomLevel > 3.0) {
          return $ionicScrollDelegate.$getByHandle('pictureSliderScroll').zoomTo(1.0, true, pos.clientX, pos.clientY);
        } else {
          return $ionicScrollDelegate.$getByHandle('pictureSliderScroll').zoomBy(3.0, true, pos.clientX, pos.clientY);
        }
      };
      self.scoperef.modalapi.getCurrentTitle = function() {
        var ref, ref1, ref2;
        if (($ionicSlideBoxDelegate.currentIndex() != null) && ((ref = self.scoperef.pictureSliderModal) != null ? (ref1 = ref.pictures) != null ? ref1.length : void 0 : void 0) > 0) {
          return (ref2 = self.scoperef.pictureSliderModal.pictures[$ionicSlideBoxDelegate.currentIndex()]) != null ? ref2.title : void 0;
        }
        return '';
      };
      self.scoperef.modalapi.openInPictures = function() {
        var ref, ref1;
        if (($ionicSlideBoxDelegate.currentIndex() != null) && ((ref = self.scoperef.pictureSliderModal) != null ? (ref1 = ref.pictures) != null ? ref1.length : void 0 : void 0) > 0) {
          window.open(PicturesApi.getLinkFor('photo') + self.scoperef.pictureSliderModal.pictures[$ionicSlideBoxDelegate.currentIndex()].id, "_system");
        }
      };
      self.scoperef.modalapi.show = function(pictures, title, index) {
        var i, len, p, purls;
        if (title == null) {
          title = "";
        }
        if (index == null) {
          index = 0;
        }
        self.scoperef.pictureSliderModal = {
          index: index,
          title: title,
          pictures: pictures,
          shown: false,
          waiting: true
        };
        self.scoperef.pictureSliderModal.getPictureSize = function() {
          if (window.innerWidth < window.innerHeight) {
            return {
              width: '100%',
              height: 'auto'
            };
          } else {
            return {
              height: '100%',
              width: 'auto'
            };
          }
        };
        self.modal.show();
        $ionicSlideBoxDelegate.update();
        purls = [];
        for (i = 0, len = pictures.length; i < len; i++) {
          p = pictures[i];
          purls.push(p.thumbnails.o);
        }
        return $ImageCacheFactory.Cache(purls)["finally"](function() {
          var element;
          element = angular.element(document.querySelector('#pictureSliderScroll'));
          $ionicGesture.on('doubletap', self.scoperef.modalapi.triggerZoom, element);
          $ionicSlideBoxDelegate.update();
          $ionicSlideBoxDelegate.slide(self.scoperef.pictureSliderModal.index);
          self.scoperef.pictureSliderModal.shown = true;
          return $timeout(function() {
            return self.scoperef.pictureSliderModal.waiting = false;
          }, 1000);
        });
      };
      self.scoperef.modalapi.hide = function() {
        var base;
        if (typeof (base = self.scoperef).onSliderHide === "function") {
          base.onSliderHide($ionicSlideBoxDelegate.currentIndex());
        }
        self.scoperef.pictureSliderModal.shown = true;
        $ionicScrollDelegate.$getByHandle('pictureSliderScroll').zoomTo(1.0, true, 0, 0);
        return self.modal.hide();
      };
      return self.scoperef.$on('$destroy', function() {
        var ref;
        if (((ref = self.modal) != null ? ref.remove : void 0) != null) {
          self.modal.remove();
        }
        return self.modal = void 0;
      });
    },
    show: function($scope, pictures, title) {
      var d, self;
      if (title == null) {
        title = "";
      }
      self = this;
      $scope.pictureSliderModal = {
        title: title,
        pictures: pictures
      };
      d = $.Deferred();
      d.then(function() {
        var element;
        self.modal.show();
        element = angular.element(document.querySelector('#pictureSliderScroll'));
        return $ionicGesture.on('doubletap', $scope.modalapi.triggerZoom, element);
      });
      if (this.modal == null) {
        return this.init($scope, d);
      } else {
        return d.resolve();
      }
    },
    hide: function() {
      if (this.modal == null) {
        this.init();
      }
      return this.modal.hide();
    }
  };
});

angular.module("Flexikon.controllers").controller('PrivacyCtrl', function($scope, $controller, $filter, GlobalSettings, Constants, AskApiClient) {
  var subSettingsCtrl;
  return subSettingsCtrl = $controller('SubSettingsCtrl', {
    $scope: $scope
  });
});

angular.module("Flexikon.controllers").controller('PromotionCtrl', function($scope, $ionicScrollDelegate, $timeout, $controller, $sce, Network, GlobalSettings) {
  var subSettingsCtrl;
  subSettingsCtrl = $controller('SubSettingsCtrl', {
    $scope: $scope
  });
  $timeout(function() {
    return $ionicScrollDelegate.resize();
  });
  window.iframeLoad = function() {
    return document.getElementById("iframe").contentWindow.document.body.onclick = function(e) {
      var element;
      if (e.target.href !== void 0 || e.srcElement.href !== void 0 || e.target.parentElement.href !== void 0) {
        e = e || window.event;
        if ((e.target.href != null) || e.srcElement.href) {
          element = e.target || e.srcElement;
        } else {
          element = e.target.parentElement;
        }
        if (element.tagName === 'A' && element.href !== void 0 && element.href !== '' && (element.href.indexOf('http') > -1 || element.href.indexOf('www') > -1 || element.href.indexOf('market') > -1) && element.href.indexOf('#/app') === -1) {
          window.open(element.href, '_system', 'location=no');
          return false;
        }
      }
      return true;
    };
  };
  $scope.link = "http://www.doccheck.com/";
  $scope.link += GlobalSettings.getLanguageForURL();
  $scope.link += "/cms/apps/iframe/device/";
  $scope.link += ionic.Platform.isAndroid() ? "android" : "iphone";
  $scope.link += "/app/flexikon";
  $scope.link = $sce.trustAsResourceUrl($scope.link);
  return $scope.hasConnection = function() {
    return Network.hasConnection();
  };
});

angular.module("Flexikon.controllers").controller('SearchCtrl', function($scope, $rootScope, $state, $controller, $filter, $timeout, $ionicScrollDelegate, FlexikonApi, Favorites, QuickSearch, Store, Network, DcDateTime) {

  /**
   * [track view in google analytics]
   */
  $controller('TrackingCtrl', {
    $scope: $scope
  });
  $controller('BaseCtrl', {
    $scope: $scope
  });
  $scope.init = function() {
    $scope.$on('$ionicView.enter', function() {
      if (arguments[1].direction !== 'back') {
        $scope.term.value = $scope.term.model = QuickSearch.getAndClear() || '';
        $scope.resetParams();
        $scope.search.items = [];
        $scope.ui.loading = true;
        $scope.loadMore();
        $ionicScrollDelegate.scrollTop();
      }
      Favorites.getAll().then(function(result) {
        var fav, j, len, results;
        $scope.search.favorites = [];
        results = [];
        for (j = 0, len = result.length; j < len; j++) {
          fav = result[j];
          results.push($scope.search.favorites.push(fav._id));
        }
        return results;
      });
      $scope.isSummerbreak = void 0;
      return FlexikonApi.summerbreakCheck().then(function(response) {
        var ref;
        $scope.isSummerbreak = response.data['summer-break'];
        $scope.summerbreak = {};
        $scope.summerbreak.popoverHint = '';
        if (!isNaN(response.data['start-date'] != null)) {
          $scope.summerbreak.from = DcDateTime.getFormattedDate(new Date(response.data['start-date'] * 1000));
        }
        if (!isNaN(response.data['end-date'] != null)) {
          $scope.summerbreak.to = DcDateTime.getFormattedDate(new Date(response.data['end-date'] * 1000));
        }
        if (((ref = response.data['message']) != null ? ref.length : void 0) > 0) {
          $scope.summerbreak.message = response.data['message'];
        }
        if (($scope.summerbreak.from != null) && ($scope.summerbreak.to != null)) {
          return $scope.summerbreak.popoverHint += $filter('translate')('DC_ARTICLE.SUMMERBREAK.POPOVER_HINT_DATE', {
            from: $scope.summerbreak.from,
            to: $scope.summerbreak.to
          });
        } else {
          return $scope.summerbreak.popoverHint += $filter('translate')('DC_ARTICLE.SUMMERBREAK.POPOVER_HINT_PLAIN');
        }
      })["catch"](function(error) {
        if (!$scope.isSummerbreak) {
          return $scope.summerbreak = {
            popoverHint: $filter('translate')('DC_ARTICLE.SUMMERBREAK.POPOVER_HINT_FAILURE'),
            error: true
          };
        }
      });
    });
    $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
      if (toState.name.match(/((.*)\.){2}/)[0] !== fromState.name.match(/((.*)\.){2}/)[0]) {
        $scope.term.model = $scope.term.value = '';
        return $scope.search.items = [];
      }
    });
    return $scope.$watch("term.model", function(n, o) {
      $timeout.cancel($scope.suggestionTimeout);
      if ($scope.ui.searchFavs) {
        return;
      }
      if ($scope.term.model === $scope.term.value) {
        $scope.resetSuggestionStyle();
        return;
      }
      if (n.length <= 2 || n === $scope.term.value) {
        return;
      }
      $scope.clearSuggestions = false;
      return $scope.suggestionTimeout = $timeout(function() {
        return FlexikonApi.getSuggestions(n, 5).success(function(result) {
          if ($scope.clearSuggestions) {
            return;
          }
          $scope.form.newSuggestions = true;
          $timeout(function() {
            return $scope.form.newSuggestions = false;
          }, 1000);
          $scope.form.suggestions = result;
          return $scope.ui.suggestionStyle = {
            'opacity': 1,
            'webkit-transform': 'translateY(' + result.length * 36 + 'px)',
            'transform': 'translateY(' + result.length * 36 + 'px)'
          };
        }).error(function(error) {
          return console.warn(error);
        });
      });
    });
  };
  $scope.resume = function() {
    $scope.listenToScroll = true;
    $scope.onScroll();
    return $scope.hideOnDrag();
  };
  $scope.pause = function() {
    return $scope.listenToScroll = false;
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    $scope.$broadcast("search.beforeEnter", arguments);
    $scope.listenToScroll = true;
    $scope.onScroll();
    $scope.hideOnDrag();
    document.removeEventListener('resume', $scope.resume);
    document.removeEventListener('pause', $scope.pause);
    document.addEventListener('resume', $scope.resume);
    return document.addEventListener('pause', $scope.pause);
  });
  $scope.$on("$ionicView.leave", function() {
    $scope.listenToScroll = false;
    document.removeEventListener('resume', $scope.resume);
    return document.removeEventListener('pause', $scope.pause);
  });
  $scope.scroll = {
    interval: 20,
    currentStep: Date.now(),
    start: void 0
  };
  $scope.term = {
    model: '',
    value: ''
  };
  $scope.ui = {
    showSubheader: true,
    loading: true,
    suggestionStyle: {
      'webkit-transform': 'translateY(0)',
      'transform': 'translateY(0)'
    },
    error: false,
    searchFavs: false,
    searchHint: false,
    onlineAgain: false,
    scrollPosition: 0,
    onTop: true
  };
  $scope.search = {
    epp: 20,
    page: 1,
    items: [],
    inProgress: false,
    nomore: false,
    favorites: [],
    noExactMatch: false
  };
  $scope.render = {
    content: false
  };
  $timeout(function() {
    return $scope.render.content = true;
  }, 1000);
  $scope.onScroll = function() {
    var searchScroll;
    searchScroll = $ionicScrollDelegate.$getByHandle('SearchScroll');
    if ((searchScroll.getScrollPosition() == null) || Math.abs($scope.ui.scrollPosition - searchScroll.getScrollPosition().top) < 100) {
      return;
    }
    $scope.ui.scrollPosition = searchScroll.getScrollPosition().top;
    if ($scope.ui.onTop !== ($scope.ui.scrollPosition < 1000)) {
      $timeout(function() {
        return $scope.ui.onTop = $scope.ui.scrollPosition < 1000;
      });
    }
    if ($scope.listenToScroll) {
      return ionic.DomUtil.requestAnimationFrame($scope.onScroll);
    }
  };
  $scope.hideOnDrag = function($event) {
    return $rootScope.$broadcast('hide-on-drag', {
      deltaY: $event.gesture.deltaY
    });
  };
  $scope.hideOnDrag = function() {
    var delta, searchScroll;
    if ((Date.now() - $scope.scroll.currentStep) > $scope.scroll.interval) {
      searchScroll = $ionicScrollDelegate.$getByHandle('SearchScroll');
      delta = searchScroll.getScrollPosition().top - $scope.scroll.start;
      $rootScope.$broadcast('hide-on-drag', {
        deltaY: delta * -1
      });
      $scope.scroll.currentStep = Date.now();
    }
    if ($scope.listenToScroll) {
      return ionic.DomUtil.requestAnimationFrame($scope.hideOnDrag);
    }
  };
  $scope.hideOnDragRelease = function() {
    return $rootScope.$broadcast('hide-on-drag-release');
  };
  $scope.hideOnDragTouch = function() {
    var searchScroll;
    searchScroll = $ionicScrollDelegate.$getByHandle('SearchScroll');
    $scope.scroll.start = searchScroll.getScrollPosition().top;
    $scope.closeSuggestions();
    return $rootScope.$broadcast('hide-on-drag-touch');
  };
  $scope.onTouch = function() {
    var searchScroll;
    searchScroll = $ionicScrollDelegate.$getByHandle('SearchScroll');
    $scope.scroll.start = searchScroll.getScrollPosition().top;
    $scope.closeSuggestions();
    return $scope.hideOnDragTouch();
  };
  $scope.resetParams = function() {
    $scope.search.epp = 20;
    $scope.search.page = 1;
    return $scope.search.nomore = false;
  };
  $scope.resetResults = function() {
    $scope.resetParams();
    return $scope.search.items = [];
  };
  $scope.resetResults();
  $scope.isFavorite = function(title) {
    return $scope.search.favorites.indexOf(title) >= 0;
  };
  $scope.form = {
    initial: true,
    disciplineChanging: true,
    infos: {
      amount: 0
    },
    discipline: $filter('translate')('DC_ALL_DISCIPLINES')
  };
  $scope.loadMore = function(infinite) {
    console.log('Loading more %s', infinite);
    if ($scope.ui.onlineAgain) {
      $scope.ui.onlineAgain = false;
      $scope.ui.searchFavs = false;
      $scope.search.page = 1;
    }
    if ($scope.search.page === 1) {
      $scope.search.noExactMatch = false;
    }
    if (!$scope.search.inProgress) {
      $scope.ui.error = false;
      $scope.search.inProgress = true;
      if ($scope.search.items.length === 0) {
        $scope.ui.loading = true;
      }
      return FlexikonApi.getListing($scope.search.page, $scope.search.epp, $scope.term.value).success(function(result) {
        var item, j, len, noExactMatch, ref;
        document.removeEventListener("online", $scope.loadMore, false);
        if (result.length === 0 || (result.urls == null)) {
          $scope.search.nomore = true;
        }
        $scope.search.items.push.apply($scope.search.items, result.urls);
        noExactMatch = false;
        if ($scope.search.page === 1 && $scope.search.items.length > 0 && $scope.term.value.length > 0) {
          noExactMatch = true;
          ref = $scope.search.items;
          for (j = 0, len = ref.length; j < len; j++) {
            item = ref[j];
            if (item.title === $scope.term.value) {
              noExactMatch = false;
              break;
            }
          }
        }
        if ($scope.search.page === 1 && $scope.search.items.length > 0 && $scope.term.value.length > 0) {
          FlexikonApi.getArticle($scope.term.value).then(function(response) {
            var article, found, i, k, redirect, ref1, ref2, ref3, ref4, v;
            ref1 = response.data.query.pages;
            for (k in ref1) {
              v = ref1[k];
              article = v;
            }
            if (((article != null ? (ref2 = article.revisions) != null ? (ref3 = ref2[0]) != null ? ref3['*'] : void 0 : void 0 : void 0) != null) && ((ref4 = article.revisions[0]['*'].match(/^(#REDIRECT)|(#WEITERLEITUNG)/gmi)) != null ? ref4.length : void 0) > 0) {
              redirect = article.revisions[0]['*'].match(/\[\[(.*)\]\]/)[1];
              i = 0;
              found = false;
              while (i < $scope.search.items.length) {
                if ($scope.search.items[i].title.toUpperCase() === redirect.toUpperCase()) {
                  $scope.search.items.unshift($scope.search.items.splice(i, 1)[0]);
                  $scope.search.items[0].postfix = '(<span class="fa fa-arrow-right"> ' + $scope.term.value + '</span> )';
                  found = true;
                  break;
                }
                i++;
              }
              return $scope.search.noExactMatch = !found;
            } else {
              return $scope.search.noExactMatch = noExactMatch;
            }
          });
        } else if ($scope.search.page === 1) {
          $scope.search.noExactMatch = noExactMatch;
        }
        $scope.search.page++;
        $scope.ui.loading = false;
        $scope.search.inProgress = false;
        $ionicScrollDelegate.resize();
        return $scope.$broadcast('scroll.infiniteScrollComplete');
      }).error(function(error) {
        if (!Store.isOwned('flexikon_offline')) {
          $scope.ui.error = true;
        } else {
          $scope.ui.searchFavs = true;
          $scope.ui.searchHint = true;
        }
        $scope.ui.loading = false;
        $scope.search.inProgress = false;
        document.removeEventListener("online", $scope.onlineSearch, false);
        document.addEventListener("online", $scope.onlineSearch, false);
        return $scope.$broadcast('scroll.infiniteScrollComplete');
      });
    }
  };
  $scope.onlineSearch = function() {
    if ($scope.ui.onlineAgain) {
      $scope.ui.onlineAgain = false;
      $scope.searchFavs = false;
      $scope.loadMore();
      return;
    }
    if ($scope.ui.searchFavs && $scope.search.favorites.length > 0) {
      $scope.ui.searchHint = false;
      $scope.ui.onlineAgain = true;
      return;
    }
    return $scope.loadMore();
  };
  $scope.searchSubmit = function() {
    $scope.form.suggestions = [];
    $scope.clearSuggestions = true;
    if ($scope.ui.searchFavs && (!$scope.ui.onlineAgain && !Network.hasConnection())) {
      return;
    } else if ($scope.ui.searchFavs) {
      $scope.ui.searchFavs = false;
      $scope.ui.onlineAgain = true;
    }
    $ionicScrollDelegate.scrollTop();
    $scope.ui.onlineAgain = false;
    $scope.ui.searchFavs = false;
    $scope.ui.searchHint = false;
    $scope.getArticlesForTerm();
    return $scope.ui.loading = true;
  };
  $scope.searchClear = function() {
    $scope.form.suggestions = [];
    return $scope.clearSuggestions = true;
  };
  $scope.getArticlesForTerm = function() {
    $scope.form.suggestions = [];
    $scope.resetResults();
    $scope.resetSuggestionStyle();
    return $scope.loadMore();
  };
  $scope.openArticle = function(page, create, suggestion) {
    if (create == null) {
      create = false;
    }
    if (suggestion == null) {
      suggestion = false;
    }
    if (suggestion) {
      if ((typeof analytics !== "undefined" && analytics !== null) && $scope.term) {
        analytics.trackEvent('Article', 'autosuggest', page);
      }
    }
    page = page.replace(/&[^;]*;/g, '').replace(/<(.*?)>/g, '');
    $state.go('^.article', {
      page: window.decodeURIComponent(page),
      create: create
    });
    return $timeout(function() {
      return $scope.form.suggestions = [];
    });
  };
  $scope.closeFavHint = function() {
    return $scope.ui.searchHint = false;
  };
  $scope.closeOnlineHint = function() {
    return $scope.ui.onlineAgain = false;
  };
  $scope.closeSuggestions = function(event) {
    if ($scope.form.newSuggestions) {
      return;
    }
    $scope.resetSuggestionStyle();
    return $timeout(function() {
      $scope.form.suggestions = [];
      return $scope.clearSuggestions = true;
    });
  };
  $scope.resetSuggestionStyle = function() {
    return $scope.ui.suggestionStyle = {
      'opacity': 0,
      'webkit-transform': 'translateY(0)',
      'transform': 'translateY(0)'
    };
  };
  $scope.init();
});

angular.module("Flexikon.controllers").controller('SettingsCtrl', function($scope, $rootScope, $controller, $ionicScrollDelegate, $ionicHistory, $timeout, $translate, $filter, GlobalSettings, Login, GuidedTour, Api, LocalStorage, Store, Load) {
  $controller('TrackingCtrl', {
    $scope: $scope
  });
  $scope.selected = {
    language: GlobalSettings.Language().toUpperCase() || 'DE'
  };
  $scope.ui = {
    renderContent: false,
    restorable: false,
    flag: $filter('translate')($scope.selected.language),
    loading: false
  };
  $scope.$on("$ionicView.beforeEnter", function() {
    $scope.$broadcast("settings.beforeEnter", arguments);
    return $timeout(function() {
      return $scope.ui.restorable = !Store.isOwned('flexikon_offline');
    }, 2000);
  });
  $scope.$on("$ionicView.afterEnter", function() {
    return $ionicScrollDelegate.resize();
  });
  ionic.DomUtil.ready(function() {
    return $timeout(function() {
      $scope.ui.renderContent = true;
      return $scope.ui.restorable = !Store.isOwned('flexikon_offline');
    }, 1000);
  });
  ionic.Platform.ready(function() {
    $scope.languages = [
      {
        id: 'DE',
        label: $filter('translate')('LANG_DE')
      }, {
        id: 'EN',
        label: $filter('translate')('LANG_EN')
      }
    ];
    if (Api.getEnv().indexOf('development') >= 0) {
      return $scope.languages.push({
        id: 'XYZ',
        label: 'DEBUG'
      });
    }
  });
  $scope.$watch('selected.language', function(n, o) {
    if (n === o) {
      return;
    }
    GlobalSettings.Language(n);
    $translate.use(n.toLowerCase() + '_' + n.toUpperCase());
    $ionicHistory.clearCache();
    $scope.ui.flag = $filter('translate')('LANG_' + $scope.selected.language + '_FLAG');
    if ($scope.ui.flag.indexOf('XYZ') >= 0) {
      return $scope.ui.flag = '40px';
    }
  });
  $scope.isDev = function() {
    return Api.getEnv() === 'development';
  };
  $scope.getFlag = function() {
    return $scope.ui.flag;
  };
  $scope.signOut = function() {
    return Login.signOut();
  };
  $rootScope.$on('event:auth-loginCancelled', function() {
    return $timeout(function() {
      return $scope.resizeScroll();
    }, 500);
  });
  $rootScope.$on('event:auth-loginRequired', function() {
    return $timeout(function() {
      return $scope.resizeScroll();
    }, 500);
  });
  $rootScope.$on('event:auth-loginConfirmed', function() {
    return $timeout(function() {
      return $scope.resizeScroll();
    }, 500);
  });
  $rootScope.$on('event:auth-logout', function() {
    return $timeout(function() {
      return $scope.resizeScroll();
    }, 500);
  });

  /**
   * [hide restore immediately when premium is purchased]
   * @return
   */
  $rootScope.$on('InAppPurchase-succeeded', function() {
    return $timeout(function() {
      return $scope.ui.restorable = false;
    });
  });
  $scope.restorePurchase = function() {
    return Store.restore();
  };
  $scope.resizeScroll = function() {
    return $ionicScrollDelegate.$getByHandle('SettingsScroll').resize();
  };
  return $scope.startOverlay = function() {
    LocalStorage.unset('FlexikonHomeIntro');
    LocalStorage.unset('FlexikonArticleIntro');
    return $timeout(function() {
      return $scope.runHomeOverlay();
    });
  };
});

angular.module('Flexikon.controllers').controller('SubSettingsCtrl', function($scope, $state, $ionicHistory, $ionicPlatform, $ionicTabsDelegate, $ionicNavBarDelegate, $timeout, TabHide) {
  $scope.$on('$ionicView.enter', function() {
    return $timeout(function() {
      return TabHide.hide();
    });
  });
  $scope.$on('$ionicView.leave', function() {
    return TabHide.unhide();
  });
  $scope.selectTabForState = function(state) {
    if (state.indexOf('tabs.home') >= 0) {
      return $ionicTabsDelegate.select(0);
    } else if (state.indexOf('tabs.favorites') >= 0) {
      return $ionicTabsDelegate.select(1);
    } else if (state.indexOf('tabs.search') >= 0) {
      return $ionicTabsDelegate.select(2);
    } else if (state.indexOf('tabs.settings') >= 0) {
      return $ionicTabsDelegate.select(3);
    }
  };
  $scope.goBack = function() {
    $ionicPlatform.offHardwareBackButton($scope.goBack);
    return $ionicHistory.backView().go();

    /*
    		backView = $ionicHistory.backView()
    		$state.go('tabs.settings.overview')
    		$timeout(->
    			$scope.selectTabForState(backView.stateName)
    			backView.go()
    			TabHide.unhide()
    		)
     */
  };
  $scope.init = function() {
    TabHide.hide();
    return $scope.$on('$destroy', function() {
      return TabHide.unhide();
    });
  };
  return $scope.init();
});

angular.module("Flexikon.controllers").controller('TabCtrl', function($scope, $state, $rootScope, $timeout, $ionicHistory, $ionicScrollDelegate, $ionicSideMenuDelegate, $ionicTabsDelegate, $controller, Load, Login, TabHide, NavBar, Network, Favorites, FlexikonApi, LastSeen, Store, ToC, Theme, GlobalSettings, ExtendedState, StateChangeInterrupter, GuidedTour, FullscreenViewer) {
  ionic.Platform.ready(function() {
    $controller('ModalCtrl', {
      $scope: $scope
    });
    $ionicSideMenuDelegate.canDragContent(false);
    if (ionic.Platform.isWebView()) {
      analytics.startTrackerWithId('UA-2421261-69');
    }
    return $timeout(function() {
      if (typeof store !== "undefined" && store !== null) {
        return Store.initialize();
      }
    }, 1000);
  });
  $scope.STATES = {
    'home': 0,
    'favorites': 1,
    'search': 2,
    'settings': 3
  };
  $scope.tabs = {
    loading: false
  };
  $scope.login = {
    required: !Login.isAuthenticated()
  };
  $scope.connection = {
    available: true
  };
  $scope.rightButtons = {
    type: 'button-clear',
    content: 'Left Button',
    tap: function(e) {
      return $location.path("/");
    }
  };
  $scope.settings = {
    theme: Theme.getSelected(),
    stacktables: GlobalSettings.Stacktables() || false
  };
  $scope.goTo = function(state, index) {
    var sciCallback;
    sciCallback = StateChangeInterrupter.getCallback();
    if (sciCallback != null) {
      sciCallback('state', state, index);
      return;
    }
    return $state.go(state, {}, {});
  };
  $scope.toggleTheme = function() {
    return $scope.settings.theme = Theme.toggle();
  };
  $scope.toggleStacktables = function() {
    $scope.settings.stacktables = !$scope.settings.stacktables;
    return GlobalSettings.Stacktables($scope.settings.stacktables);
  };
  $scope.darkThemeSelected = function() {
    return Theme.darkThemeSelected();
  };
  $scope.navBarHidden = function() {
    return false;
  };
  $scope.toggleSideMenu = function() {
    return $ionicSideMenuDelegate.toggleRight();
  };
  $scope.tabsHidden = function() {
    return TabHide.hidden();
  };
  $scope.isLoading = function() {
    return Load.isLoading();
  };
  $scope.isBlockedByLoading = function() {
    return Load.isBlocked();
  };
  $scope.isLoginRequired = function(required) {
    if (required === void 0) {
      return $scope.login.required || !Login.isAuthenticated();
    } else {
      $scope.login.required = required;
      Load.isLoading(false);
      $scope.explApply();
      if (required) {
        return Login.deleteToken();
      }
    }
  };
  $scope.hasConnection = function() {
    return Network.hasConnection();
  };
  $rootScope.$on('event:auth-loginCancelled', function() {
    return $scope.isLoginRequired(true);
  });
  $rootScope.$on('event:auth-loginRequired', function() {
    return $scope.isLoginRequired(true);
  });
  $rootScope.$on('event:auth-loginConfirmed', function() {
    return $scope.isLoginRequired(false);
  });
  $rootScope.$on('event:auth-logout', function() {
    $scope.isLoginRequired(true);
    $ionicHistory.clearCache();
    return $ionicHistory.clearHistory();
  });

  /*
   *
   * This is necessary in addition to the ui-sref due to the fact that the AskForm has
   * to be able to interrupt the state change in case of unsaved changes.
   *
   * Even though the ui-sref notifies about the state change, its event's preventDefault
   * isn't actually preventing the change. Only an ng-click action might be prevented which
   * is triggered right here.
   *
   */
  $scope.switchTab = function(index) {
    if (index === 0) {
      return $state.transitionTo('tabs.home.overview', {}, {
        notify: true
      });
    } else if (index === 1) {
      return $state.transitionTo('tabs.favorites.overview', {}, {
        notify: true
      });
    } else if (index === 2) {
      return $state.transitionTo('tabs.search.overview', {}, {
        notify: true
      });
    } else if (index === 3) {
      return $state.transitionTo('tabs.settings.overview', {}, {
        notify: true
      });
    }
  };
  $scope.selectTabForState = function(state) {
    if (state.indexOf('tabs.home') >= 0) {
      return $ionicTabsDelegate.select(0);
    } else if (state.indexOf('tabs.favorites') >= 0) {
      return $ionicTabsDelegate.select(1);
    } else if (state.indexOf('tabs.search') >= 0) {
      return $ionicTabsDelegate.select(2);
    } else if (state.indexOf('tabs.settings') >= 0) {
      return $ionicTabsDelegate.select(3);
    }
  };
  $scope.openStatic = function(state) {
    $scope.selectTabForState(state);
    $state.transitionTo(state, {}, {
      reload: true
    });
    return $ionicSideMenuDelegate.toggleRight();
  };
  $scope.openInSameBranch = function(state) {
    ExtendedState.openInSameBranch(state);
    if ($ionicSideMenuDelegate.isOpenRight()) {
      return $ionicSideMenuDelegate.toggleRight();
    }
  };
  $scope.explApply = function() {
    if (!$scope.$$phase) {
      return $scope.$apply();
    }
  };
  $scope.isHome = function() {
    return $state.current.name.indexOf('home') >= 0;
  };
  $scope.openUrl = function(url) {
    var ref;
    if (typeof cordova !== "undefined" && cordova !== null) {
      return ref = window.open(url, "_system");
    } else {
      return window.open(url, "_blank");
    }
  };
  $scope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
    var newState;
    Load.isLoading(false);
    newState = toState.name.match(/\.(.*?)\./)[1];
    if ($ionicTabsDelegate.selectedIndex() !== $scope.STATES[newState]) {
      $ionicTabsDelegate.select($scope.STATES[newState]);
    }
    if (toState.name.match(/((.*)\.){2}/)[0] !== fromState.name.match(/((.*)\.){2}/)[0]) {
      NavBar.unhide();
      return $timeout(function() {
        if ($state.current.name.indexOf('overview') > 0) {
          return;
        }
        $state.transitionTo(toState.name.match(/((.*)\.){2}/)[0] + 'overview', toParams, {
          reload: false,
          notify: true
        });
        return $timeout(function() {
          return NavBar.unhide();
        });
      });
    }
  });
  $scope.runHomeOverlay = function() {
    GuidedTour.setRootElement(void 0);
    return GuidedTour.start('FlexikonHomeIntro', GuidedTour.getSteps('homeSteps'));
  };
  return ionic.DomUtil.ready(function() {
    return $timeout(function() {
      return $scope.runHomeOverlay();
    }, 500);
  });
});

angular.module("Flexikon.directives").directive('dcAd', function($timeout, $q, $rootScope, $sce, $http, $parse, $ionicGesture, Store, Api, GlobalSettings, InAppPurchase, UniqueID) {
  return {
    restrict: 'E',
    scope: {
      refreshEvent: '@',
      noAdCallback: '&',
      successCallback: '&',
      devIdDe: '@',
      devIdEn: '@',
      prodIdDe: '@',
      prodIdEn: '@'
    },
    template: '',
    link: function(scope, element, attrs) {

      /**
       * [urlparams - parameters for retrieving ad from adserver]
       */
      scope.urlparams = {
        rand: parseInt(UniqueID.get()),
        category: ionic.Platform.isIOS() ? 'ios' : 'android'
      };

      /**
       * [ad description]
       */
      scope.ad = {
        markup: '',
        "native": false,
        target: '',
        error: false,
        lastRefresh: -1
      };

      /**
       * [id - zone IDs for retrieving ads from the ad server]
       */
      scope.id = {
        development: {
          de: scope.devIdDe || '571',
          en: scope.devIdEn || '571'
        },
        production: {
          de: scope.prodIdDe || '575',
          en: scope.prodIdEn || '577'
        }
      };

      /**
       * [hide - hide completely (in case of premium or no ad retrieved)]
       * @return promise
       */
      scope.hide = function() {
        element.addClass('hiding');
        return $timeout(function() {
          element.removeClass('hiding');
          return element.addClass('hidden');
        }, 350);
      };

      /**
       * [fade - fade out on hide]
       * @return promise
       */
      scope.fade = function() {
        return $q(function(resolve, reject) {
          element.addClass('hiding');
          return $timeout(function() {
            return resolve();
          }, 350);
        });
      };

      /**
       * [show - show ad (when loaded)]
       * @return
       */
      scope.show = function() {
        element.removeClass('hidden');
        element.removeClass('hiding');
        element.addClass('showing');
        return $timeout(function() {
          return element.removeClass('showing');
        }, 350);
      };

      /**
       * [loadAdvertisement - retrieve ad from adserver]
       * @return
       */
      scope.loadAdvertisement = function() {
        if (scope.ad.lastRefresh !== -1 && (Date.now() - scope.ad.lastRefresh) / 1000 / 60 / 60 < 1) {
          return;
        }
        scope.fade();
        scope.ad.error = false;
        return $http({
          url: "http://adserver.doccheck.com/www/delivery/ajs.php?zoneid=" + scope.id[Api.getEnv()][GlobalSettings.Language()] + "&cb=" + scope.urlparams.rand + "&n=a906a3a4",
          method: "GET",
          cache: false
        }).success(function(result) {
          var dcad, s;
          if ((result.match(/href=\\'F\\'/g) != null) && result.match(/href=\\'F\\'/g).length > 0) {
            scope.hide();
            if (typeof scope.noAdCallback === "function") {
              scope.noAdCallback();
            }
            return;
          }
          s = document.createElement('script');
          $(s).attr('ng-init', "log()");
          $(s).html(result.replace(/document\.write\(/gmi, 'var dcad = ('));
          element.append(s);
          dcad = window.dcad;
          return $timeout(function() {
            var ref, targetMatch;
            if ((dcad != null ? dcad.length : void 0) === 0) {
              return;
            }
            if (((ref = dcad.match(/a href=([^ ]*)/)) != null ? ref.length : void 0) === 0) {
              return;
            }
            targetMatch = dcad.match(/a href=([^ ]*)/);
            if ((targetMatch != null ? targetMatch.length : void 0) > 0) {
              scope.ad.target = dcad.match(/a href=([^ ]*)/)[1].substr(1).slice(0, -1);
              dcad = dcad.replace(/a href=([^ ]*)/, function(match, s1) {
                return match.replace(s1, '');
              });
            }
            dcad = dcad.replace(/href="\/\//gmi, 'href="http://');

            /*
            iframe = document.createElement('iframe')
            element.append(iframe)
            frameDoc = iframe.document
            if iframe.contentWindow
              frameDoc = iframe.contentWindow.document
            frameDoc.open()
            frameDoc.writeln(dcad)
            frameDoc.close()
             */
            $(element).html(dcad);
            scope.gestureHandler = $ionicGesture.on('tap', scope.openAd, element);
            scope.gestureHandler = $ionicGesture.on('click', scope.preventDefault, element);
            if (typeof scope.successCallback === "function") {
              scope.successCallback();
            }
            scope.ad.lastRefresh = Date.now();
            return document.removeEventListener("online", scope.loadAdvertisement, false);
          });

          /*
          try
            scope.ad.markup = result.replace(/"\+"/g,'')
              .match(/<a.*\/a>/)[0]
              .replace(/\\'/g, "'")
              .replace(/<img /, "<img ng-click='openAd($event)' ")
              .replace(/<a /, "<a ng-click='openAd($event)' ")
            scope.ad.target = scope.ad.markup.match(/href=([^ ]*)/)[1].substr(1).slice(0, -1)
          
            imgsrc = scope.ad.markup.match(/src=(?:'|")(.*?)(?:'|")/)[1]
            scope.ad.markup = scope.ad.markup.replace(/<a /, "<a style='background-image: url(" + imgsrc + ")'")
          
            scope.ad.lastRefresh = Date.now()
          catch
            scope.ad.error = true
            scope.noAdCallback?()
            scope.hide()
            return
          
          scope.successCallback?()
          scope.show()
          #)
           */
        }).error(function(error) {
          scope.ad.error = true;
          if (typeof scope.noAdCallback === "function") {
            scope.noAdCallback();
          }
          scope.hide();
          document.removeEventListener("online", scope.loadAdvertisement, false);
          return document.addEventListener("online", scope.loadAdvertisement, false);
        });
      };

      /**
       * [openAd - follow ad link, open in system browser]
       * @param  {Event} $event [click event for stopping event propagation]
       * @return
       */
      scope.openAd = function($event) {
        var ref;
        $event.preventDefault();
        $event.stopPropagation();
        if (((ref = scope.ad.target) != null ? ref.length : void 0) > 0) {
          window.open(scope.ad.target, "_system");
        }
      };

      /**
       * [preventDefault]
       * @param  {[type]} $event []
       * @return {[type]}        []
       */
      scope.preventDefault = function($event) {
        $event.preventDefault();
        $event.stopPropagation();
      };

      /**
       * [hide ads immediately when premium is purchased]
       * @return
       */
      $rootScope.$on('InAppPurchase-succeeded', function() {
        return scope.hide();
      });

      /**
       * [show if not owned]
       * @return
       */
      $rootScope.$on('InAppPurchase-notowned', function() {
        if (!Store.isOwned()) {
          return scope.show();
        }
      });

      /**
       * intial check for premium
       */
      InAppPurchase.get('flexikon_offline').then(function(doc) {
        if (doc.article.purchased) {
          return scope.hide();
        } else {
          scope.loadAdvertisement();
          if ((scope.refreshEvent != null) && scope.refreshEvent.length > 0) {
            return scope.$on(scope.refreshEvent, scope.loadAdvertisement);
          }
        }
      })["catch"](function(doc) {
        if (typeof store === "undefined" || store === null) {
          console.warn('store object is not available - currently testing in browser? Otherwise check the plugin!');
          return;
        }
        if (!store.get('flexikon_offline').owned) {
          return scope.loadAdvertisement();
        }
      });
      return scope.$on('$destroy', function() {
        return typeof scope.gestureHandler === "function" ? scope.gestureHandler() : void 0;
      });
    }
  };
});

angular.module("Flexikon.controllers").controller('Dc3dModelCtrl', function($scope, $sce, $q, $ionicScrollDelegate, $location, $timeout, $ionicModal, $http, FullscreenViewer, ToC) {
  this.IFRAME_URL = 'https://sketchfab.com/models/{{id}}/embed';
  this.iframeParameters = {
    autostart: 1,
    camera: 0,
    transparent: 0,
    ui_controls: 0,
    ui_infos: 0,
    ui_related: 0,
    annotations_visible: 1,
    cardboard: 0
  };
  this.models = [];
  this.current = 0;
  this.fullscreen = false;
  $scope.vm = this;

  /**
   * [init description]
   * @return {[type]} [description]
   */
  this.init = (function(_this) {
    return function() {
      if (_this.id == null) {
        return;
      }
      _this.ids = _this.id.split(',');
      if (_this.ids.length === 0) {
        return;
      }
      return _this.fetchModels()["finally"](function() {
        _this.models = _this.models.filter(function(model) {
          return model != null;
        });
        if (_this.models.length > 0) {
          return _this.render = true;
        }
      });
    };
  })(this);

  /**
   * [fetchModels]
   * @return {[type]} []
   */
  this.fetchModels = (function(_this) {
    return function() {
      var i, id, j, promises, ref;
      promises = [];
      for (i = j = 0, ref = _this.ids.length - 1; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j) {
        id = _this.ids[i];
        promises.push(_this.fetchModelMetaData(id, i));
      }
      return $q.allSettled(promises);
    };
  })(this);

  /**
   * [fetchModelMetaData]
   * @param  {[type]} id []
   * @return {[type]}    []
   */
  this.fetchModelMetaData = (function(_this) {
    return function(id, index) {
      return $http.get('https://api.sketchfab.com/v2/models/' + id, {
        headers: {
          Authorization: ''
        }
      }).then(function(response) {
        var model, ref, ref1, ref2, ref3, ref4, ref5;
        if (!((response != null ? response.data : void 0) != null)) {
          return;
        }
        model = {};
        model.id = id;
        model.thumb = {};
        model.thumb.small = ((ref = response.data.thumbnails) != null ? (ref1 = ref.images) != null ? (ref2 = ref1[1]) != null ? ref2.url : void 0 : void 0 : void 0) || '';
        model.thumb.medium = ((ref3 = response.data.thumbnails) != null ? (ref4 = ref3.images) != null ? (ref5 = ref4[2]) != null ? ref5.url : void 0 : void 0 : void 0) || '';
        _this.models[index] = model;
        return _this.setUrl(index);
      })["catch"](function(error) {
        return this.error = true;
      });
    };
  })(this);

  /**
   * [switchModel]
   * @param  {[type]} index []
   * @return {[type]}       []
   */
  this.switchModel = (function(_this) {
    return function(index) {
      if (index === _this.current) {
        return;
      }
      _this.setUrl(index);
      _this.current = index;
    };
  })(this);

  /**
   * [toggleCardboard]
   * @return {[type]} []
   */
  this.toggleCardboard = (function(_this) {
    return function() {
      _this.iframeParameters.cardboard = (_this.iframeParameters.cardboard + 1) % 2;
      if (ionic.Platform.isIOS()) {
        window.open(_this.getUrl(_this.models[_this.current].id) + _this.getParameters(), '_blank', 'location=no,toolbar=yes');
        _this.iframeParameters.cardboard = (_this.iframeParameters.cardboard + 1) % 2;
        return;
      }
      _this.setUrl();
    };
  })(this);

  /**
   * [getUrl]
   * @param  {[type]} id []
   * @return {[type]}    []
   */
  this.getUrl = (function(_this) {
    return function(id) {
      return _this.IFRAME_URL.replace(/\{\{id\}\}/g, id);
    };
  })(this);

  /**
   * [openModal]
   * @return {[type]} []
   */
  this.openModal = function($event) {
    $event.preventDefault();
    $event.stopPropagation();
    FullscreenViewer.openModalFromUrl('templates/3DModelModal.html', $scope);
  };

  /**
   * [getParameters]
   * @return {[type]} []
   */
  this.getParameters = (function(_this) {
    return function() {
      var params;
      params = '?';
      angular.forEach(_this.iframeParameters, function(value, key) {
        return params += key + '=' + value + '&';
      });
      return params.substr(0, params.length - 1);
    };
  })(this);

  /**
   * [setUrl]
   * @param {[type]} id []
   */
  this.setUrl = (function(_this) {
    return function(index) {
      var model;
      index = index || _this.current;
      model = _this.models[index];
      return model.url = $sce.trustAsResourceUrl(_this.getUrl(model.id) + _this.getParameters());
    };
  })(this);
  this.init();
});

angular.module("Flexikon.directives").directive('dc3dmodel', function(Network) {
  return {
    restrict: 'E',
    scope: {
      id: '@'
    },
    controller: 'Dc3dModelCtrl as dcd',
    bindToController: true,
    templateUrl: 'templates/Dc3dModelTemplate.html'
  };
});

angular.module("Flexikon.directives").directive('dcBlockingLoad', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcBlockingLoadTemplate.html'
  };
});

angular.module("Flexikon.controllers").controller('DcButtonCtrl', function($scope) {

  /**
  	 * [onClick - perform click action]
  	 * @return
   */
  return $scope.onClick = function() {
    return $scope.action();
  };
});

angular.module("Flexikon.directives").directive('dcButton', function() {
  return {
    restrict: 'E',
    scope: {
      text: '@',
      action: '&'
    },
    templateUrl: 'templates/DcButtonTemplate.html',
    controller: 'DcButtonCtrl'
  };
});

angular.module("Flexikon.directives").directive('dcButtonBar', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcButtonBarTemplate.html',
    transclude: true
  };
});

angular.module("Flexikon.controllers").controller('DcCheckboxCtrl', function($scope, $timeout) {
  $scope.box = $scope.model;

  /**
  	 * [on form reset set to initial value]
  	 * @return {[type]} [description]
   */
  $scope.$on('form-reset', function() {
    $scope.box = $scope.model;
    return $scope.$$phase || $scope.$apply();
  });

  /**
  	 * [watch for changes]
  	 * @param  {[type]} n [new value]
  	 * @param  {[type]} o [old value]
  	 * @return
   */
  return $scope.watcher = $scope.$watch('model', function(n, o) {
    if ((o == null) && (n != null)) {
      $scope.box = $scope.model;
      $scope.watcher();
      return $scope.$watch('box.checked', function() {
        var ref, ref1;
        if ((((ref = $scope.model) != null ? ref.checked : void 0) != null) && (((ref1 = $scope.box) != null ? ref1.checked : void 0) != null)) {
          return $scope.model.checked = $scope.box.checked;
        }
      });
    }
  });
});

angular.module("Flexikon.directives").directive('dcCheckbox', function() {
  return {
    restrict: 'E',
    require: '',
    scope: {
      text: '@',
      model: '='
    },
    templateUrl: 'templates/DcCheckboxTemplate.html',
    controller: 'DcCheckboxCtrl'
  };
});

angular.module('Flexikon.directives').directive('dcCompile', [
  '$compile', function($compile) {
    return function(scope, element, attrs) {
      scope.$watch((function(scope) {
        return scope.$eval(attrs.dcCompile);
      }), function(value) {
        element.html(value);
        $compile(element.contents())(scope);
      });
    };
  }
]);

angular.module("Flexikon.controllers").controller('DcConfirmDialogCtrl', function($scope, $ionicNavBarDelegate, TabHide, NavBar) {

  /**
  	 * [onBackdropClick - if close on backdrop is allowed, do so]
  	 * @return
   */
  $scope.onBackdropClick = function() {
    if ($scope.closeOnBackdrop) {
      $scope.shown = false;
      return typeof $scope.backdropAction === "function" ? $scope.backdropAction() : void 0;
    }
  };

  /**
  	 * [watcher for hiding/unhiding bars]
  	 * @param  {[bool]} n [new value]
  	 * @param  {[bool]} o [old value]
  	 * @return
   */
  return $scope.$watch('shown', function(n, o) {
    if (o && !n) {
      NavBar.unhide();
      return TabHide.unhide();
    } else if (!o && n) {
      NavBar.hide();
      return TabHide.hide();
    }
  });
});

angular.module("Flexikon.directives").directive('dcConfirmDialog', function() {
  return {
    restrict: 'E',
    require: '',
    scope: {
      shown: '=',
      positive: '@',
      positiveAction: '&',
      negative: '@',
      negativeAction: '&',
      cancel: '@',
      cancelAction: '&',
      hint: '@',
      closeOnBackdrop: '=',
      backdropAction: '&'
    },
    templateUrl: 'templates/DcConfirmDialogTemplate.html',
    controller: 'DcConfirmDialogCtrl'
  };
});

angular.module("Flexikon.controllers").controller('DcConnectionErrorCtrl', function($scope) {
  $scope.bg = 'Dr_iphone4.svg';

  /**
  	 * [getStyle - set background image accordingly]
  	 * @return {[String]} [style for ng-style]
   */
  $scope.getStyle = function() {
    return "{'background-image' : 'url(img/" + $scope.bg + ")'}";
  };

  /**
  	 * [getSrc - get source path for background image]
  	 * @return {[String]} [source path]
   */
  return $scope.getSrc = function() {
    return 'img/' + $scope.bg;
  };
});

angular.module("Flexikon.directives").directive('dcConnectionError', function() {
  return {
    restrict: 'E',
    require: '',
    scope: {
      message: '@'
    },
    replace: true,
    templateUrl: 'templates/DcConnectionErrorTemplate.html',
    controller: 'DcConnectionErrorCtrl'
  };
});

angular.module("Flexikon.controllers").controller('DcDefinitionFormCtrl', function($scope, $timeout, FlexikonApi, ExtendedState, Load) {

  /**
   * [wiki - wiki content of the input]
   */
  $scope.wiki = {
    content: '==Definition==\n',
    initial: '==Definition==\n',
    changed: false
  };

  /**
   * [submit - create the article and lead the user to the corresponding detail page]
   * @return
   */
  this.submit = function() {
    if ($scope.wiki.initial.trim() === $scope.wiki.content.trim()) {
      return;
    }
    Load.isBlocked(true);
    return FlexikonApi.post(this.title(), $scope.wiki.content, void 0, function(result) {
      ExtendedState.openInSameBranch('article', {
        page: window.decodeURIComponent(this.title())
      });
      return Load.isBlocked(false);
    }, function(error) {
      return Load.isBlocked(false);
    });
  };
  $scope.$watch('wiki.content', function(n, o) {
    return $scope.wiki.changed = (n != null) && (n.trim() !== $scope.wiki.initial.trim());
  });
});

angular.module("Flexikon.directives").directive('dcDefinitionForm', function() {
  return {
    restrict: 'E',
    scope: {
      title: '&',
      summerbreak: '&',
      summerbreakInfo: '@'
    },
    templateUrl: 'templates/DcDefinitionFormTemplate.html',
    controller: 'DcDefinitionFormCtrl as ddfc',
    bindToController: true
  };
});

angular.module("Flexikon.directives").directive('ngEnter', function() {
  return function(scope, element, attrs) {

    /**
     * [use ng-enter="callback()" to perform an action when the enter key is pressed]
     * @param  {Event} event [for preventing default behaviour]
     * @return
     */
    return element.bind('keydown keypress', function(event) {
      if (event.which === 13) {
        scope.$apply(function() {
          return scope.$eval(attrs.ngEnter, {
            'event': event
          });
        });
        return event.preventDefault();
      }
    });
  };
});

angular.module("Flexikon.directives").directive('dcExpandable', function($rootScope, $ionicScrollDelegate, $timeout) {
  return {
    restrict: 'E',
    require: '',
    scope: {
      labelText: "@",
      open: "@",
      id: "@",
      action: "&",
      feedback: "@",
      onOpen: "&",
      onClose: "&",
      scrollable: '@',
      closable: '@',
      delegateHandle: '@'
    },
    templateUrl: 'templates/DcExpandableTemplate.html',
    transclude: true,
    link: function(scope, element, attrs) {

      /**
       * [content description]
       * @type {[type]}
       */
      scope.content = {
        shown: scope.$eval(scope.open) || false,
        scrollable: scope.$eval(scope.scrollable) || false,
        closable: scope.$eval(scope.closable)
      };
      if (scope.content.closable == null) {
        scope.content.closable = true;
      }
      scope.timeouts = [];
      scope.listeners = [];
      if (scope.content.shown) {
        element.addClass('shown');
      }
      scope.ui = {
        hasAction: scope.$eval(scope.feedback)
      };

      /**
       * [toggle - show/hide expandable contents]
       * @param  {[type]} triggered [description]
       * @return {[type]}           [description]
       */
      scope.toggle = function(triggered, data) {
        if (data == null) {
          data = {};
        }
        if (scope.content.shown && !scope.content.closable && !triggered) {
          return;
        }
        if (typeof scope.action === "function") {
          scope.action();
        }
        scope.content.shown = !scope.content.shown;
        if (scope.content.shown) {
          element.addClass('shown');
          if (scope.content.scrollable) {
            scope.timeouts.push($timeout(function() {
              return $ionicScrollDelegate.resize();
            }));
          }
        } else {
          element.removeClass('shown');
        }
        if (!data.preventDefault) {
          if (scope.content.shown) {
            if (typeof scope.onOpen === "function") {
              scope.onOpen();
            }
          } else {
            if (typeof scope.onClose === "function") {
              scope.onClose();
            }
          }
        }
        return scope.timeouts.push($timeout(function() {
          if (!scope.$$phase) {
            scope.$apply();
          }
          if (scope.delegateHandle != null) {
            return $ionicScrollDelegate.$getByHandle(scope.delegateHandle).resize();
          } else {
            return $ionicScrollDelegate.resize();
          }
        }, 250));
      };

      /**
       * [register listener for global events (open / close)]
       * @param  {[String]} n [new id]
       * @return
       */
      scope.listeners.push(attrs.$observe('id', function(n) {
        if ((n != null) && n !== '{{id}}') {
          scope.listeners.push($rootScope.$on('dcexpandable' + n + '-open', function(event, data) {
            if (!scope.content.shown) {
              return scope.toggle(void 0, data);
            }
          }));
          return scope.listeners.push($rootScope.$on('dcexpandable-close-all-but', function(event, data) {
            if (data.id !== n && scope.content.shown) {
              return scope.toggle(true);
            }
          }));
        }
      }));

      /**
       * [remove registered listener and remaining timeouts]
       * @return
       */
      return scope.$on('$destroy', function() {
        var i, j, len, len1, listener, ref, ref1, results, timeout;
        ref = scope.listeners;
        for (i = 0, len = ref.length; i < len; i++) {
          listener = ref[i];
          listener();
        }
        ref1 = scope.timeouts;
        results = [];
        for (j = 0, len1 = ref1.length; j < len1; j++) {
          timeout = ref1[j];
          results.push($timeout.cancel(timeout));
        }
        return results;
      });
    }
  };
});

angular.module("Flexikon.controllers").controller('DcFlexikonArticleCtrl', function($scope, $rootScope, $filter, $timeout, $controller, $ionicScrollDelegate, $ionicSideMenuDelegate, $ionicHistory, $state, $ionicPlatform, $cordovaVibration, $ionicPopover, $q, WikiHTML, Favorites, LastSeen, FlexikonApi, ToC, Theme, ArticleHistory, Load, Login, Store, StateChangeInterrupter, DcMediaWiki, DcDateTime, FontSize, DcHighlight, GuidedTour) {
  this.state = {
    isNew: false,
    isOffline: false,
    isFetching: false,
    isPurchased: false,
    showSearch: false,
    showHint: false,
    showOptions: false,
    showStyleOverlay: false,
    summerbreak: {
      active: void 0
    }
  };
  this.articleState = {
    edit: false,
    isUnsaved: false,
    isFavorite: false,
    hasSuccessor: false
  };
  this.buttonState = {
    showOptions: false
  };
  this.find = {
    model: '',
    count: 0,
    current: 0
  };
  this.scrolling = {
    last: -1,
    listen: true,
    inProgress: false,
    onTop: true,
    interval: 20,
    currentStep: Date.now()
  };
  this.fontSize = FontSize.getCurrent();
  this.listener = [];
  $scope.vm = this;

  /**
   * [init ]
   * @return {[type]} []
   */
  this.init = (function(_this) {
    return function() {
      $controller('DcFlexikonArticleModalCtrl', {
        $scope: $scope
      });
      $ionicPopover.fromTemplateUrl('summerbreakPopover.html', {
        scope: $scope
      }).then(function(popover) {
        return _this.state.summerbreak.popover = popover;
      });
      _this.addFindInPageListener();
      _this.listener.push($scope.$on('article.enter', function() {
        var ref, ref1, ref2;
        _this.fetchArticle().then(_this.isSummerbreak);
        ArticleHistory.push($state.current.name, _this.page || $state.params.page);
        _this.scrolling.listen = true;
        _this.articleState.hasSuccessor = ArticleHistory.forwardAvailable($state.current.name);
        if (((ref = _this.article) != null ? ref.toc : void 0) != null) {
          ToC.set(_this.article.toc);
        }
        if (((ref1 = _this.find) != null ? (ref2 = ref1.model) != null ? ref2.length : void 0 : void 0) > 0) {
          _this.find.count = DcHighlight.highlightWord($scope.getHTMLWrapper()[0], _this.find.model);
          if (_this.find.current >= 0 && _this.find.current < _this.find.count) {
            DcHighlight.focus(_this.find.current);
          }
        }
        window.addEventListener('orientationchange', $scope.toggleBars);
        return $scope.toggleBars();
      }));
      _this.listener.push($scope.$on('article.leave', function() {
        _this.scrolling.listen = false;
        DcHighlight.removeHighlights($scope.getHTMLWrapper()[0]);
        return window.removeEventListener('orientationchange', $scope.toggleBars);
      }));
      _this.listener.push($rootScope.$on("article:font-size-changed", function(event, data) {
        return _this.setFontSize();
      }));
      _this.listener.push($rootScope.$on("article:toggle-style-overlay", function(event, data) {
        return _this.state.showStyleOverlay = !_this.state.showStyleOverlay;
      }));
      _this.listener.push($scope.$watch(function() {
        return _this.fontSize;
      }, function(n, o) {
        return FontSize.set(n);
      }));
      _this.listener.push($scope.$watch(function() {
        return _this.wikiModel;
      }, function(n, o) {
        if (n == null) {
          return;
        }
        return _this.adjustWikiContent();
      }));
      $scope.$on('$destroy', function() {
        var i, len, listener, ref, results;
        ref = _this.listener;
        results = [];
        for (i = 0, len = ref.length; i < len; i++) {
          listener = ref[i];
          results.push(typeof listener === "function" ? listener() : void 0);
        }
        return results;
      });
    };
  })(this);

  /**
   *
   *
   * INITIAL LOADING & PROCESSING
   *
   *
   */

  /**
   * [fetchArticle]
   * @param  {[type]} page []
   * @return {[type]}      []
   */
  this.fetchArticle = (function(_this) {
    return function(page) {
      var extracted;
      if (_this.fetchPromise != null) {
        return _this.fetchPromise;
      }
      if (page == null) {
        page = _this.page || $state.params.page;
      }
      extracted = DcMediaWiki.getLanguageAndTitle(page);
      _this.language = extracted.language;
      _this.page = extracted.title;
      _this.state.isFetching = true;
      return _this.fetchPromise = FlexikonApi.getArticle(_this.page, _this.language).then(function(response) {
        var article, k, ref, ref1, ref2, ref3, ref4, ref5, v;
        _this.state.isOffline = false;
        if (Object.keys(response.data.query.pages)[0] === '-1') {
          _this.prepareNewArticle(page);
          return;
        }
        ref = response.data.query.pages;
        for (k in ref) {
          v = ref[k];
          article = v;
        }
        if ((((ref1 = article.revisions) != null ? (ref2 = ref1[0]) != null ? ref2['*'] : void 0 : void 0) != null) && (((ref3 = _this.article) != null ? (ref4 = ref3.content) != null ? ref4.wiki : void 0 : void 0) != null) && article.revisions[0]['*'] === _this.article.content.wiki) {
          return;
        }
        if (((ref5 = article.revisions[0]['*'].toUpperCase().match(/^(#REDIRECT)|(#WEITERLEITUNG)/gm)) != null ? ref5.length : void 0) > 0) {
          _this.fetchPromise = null;
          return _this.fetchArticle(article.revisions[0]['*'].match(/\[\[(.*)\]\]/)[1]);
        }
        _this.processArticle(article);
        _this.scrollToSection();
        _this.addToHistory();
        _this.fetchFavoriteState();
        _this.gaLogOpen();
        _this.setFontSize();
        if (!_this.articleState.isNew) {
          return _this.runOverlay();
        }

        /*
        TODO:
          $scope.runOverlay()
         */
      })["catch"](function(error) {
        _this.state.isOffline = true;
        if (!_this.isPremium()) {
          return;
        }
        _this.state.isPremium = true;
        return _this.fetchOfflineArticle(page);
      })["finally"](function() {
        _this.state.isFetching = false;
        return _this.fetchPromise = void 0;
      });
    };
  })(this);

  /**
   * [fetchOfflineArticle]
   * @param  {[type]} page []
   * @return {[type]}      []
   */
  this.fetchOfflineArticle = (function(_this) {
    return function(page) {
      if (page.lastIndexOf(':') >= 0) {
        page = page.substr(page.lastIndexOf(':') + 1);
      }
      return Favorites.get(page).then(function(result) {
        _this.state.isOffline = true;
        _this.language = result.article.language;
        _this.setArticleMeta(result.article.title, result.article.article);
        _this.versionDate = result.article.date;
        return _this.processArticle();

        /*
        $scope.timeouts.push $timeout(->
          $scope.runOverlay()
        , 1000)
         */
      }, function(error) {
        _this.state.noArticle = true;
        return _this.state.isFetching = false;
      });
    };
  })(this);

  /**
   * [isPremium]
   * @return {Boolean} []
   */
  this.isPremium = function() {
    return Store.isOwned('flexikon_offline');
  };

  /**
   * [setArticleMeta]
   * @param {[type]} title       []
   * @param {[type]} wikiContent []
   */
  this.setArticleMeta = (function(_this) {
    return function(title, wikiContent) {
      _this.article = {
        title: {},
        content: {}
      };
      _this.article.title.raw = title;
      _this.article.title.trimmed = title.replace(/\/|_| |'|"/g, '');
      _this.article.content.wiki = wikiContent;
      if (_this.article.content.wiki_save == null) {
        _this.article.content.wiki_save = _this.article.content.wiki;
      }
    };
  })(this);

  /**
   * [setFontSize]
   */
  this.setFontSize = function() {
    angular.element('.html-content').css('font-size', FontSize.getCurrent() + 'px');
  };

  /**
   * [addToHistory]
   */
  this.addToHistory = (function(_this) {
    return function() {
      if (_this.state.isNew) {
        return;
      }
      return LastSeen.get(_this.article.title.raw).then(function(result) {
        result.article.lastVisited = Date.now();
        return LastSeen.update(result);
      })["catch"](function(result) {
        return LastSeen.insert(_this.article.title.raw, {
          title: _this.article.title.raw,
          language: _this.language,
          lastVisited: Date.now()
        });
      });
    };
  })(this);

  /**
   * [prepareNewArticle]
   * @return {[type]} []
   */
  this.prepareNewArticle = (function(_this) {
    return function(page) {
      var promise;
      _this.state.showHint = true;
      _this.state.isNew = true;
      _this.processArticle({
        'title': page,
        'revisions': [
          {
            '*': '==Definition=='
          }
        ]
      });
      promise = _this.state.summerbreak.promise || _this.isSummerbreak();
      promise.then(function() {
        if (_this.state.summerbreak.active) {
          _this.state.summerbreak.popover.show({
            target: $scope.getSelf().find('.article-title')[0]
          });
          return;
        }
        return _this.toggleEdit();
      });
    };
  })(this);

  /**
   * [isSummerbreak]
   * @return {Boolean} []
   */
  this.isSummerbreak = (function(_this) {
    return function() {
      return $q(function(resolve, reject) {
        var ref;
        if (_this.state.summerbreak.active === true && (typeof $event !== "undefined" && $event !== null)) {
          if ((ref = _this.state.summerbreak.popover) != null) {
            ref.show($event);
          }
          return resolve();
        }
        if (_this.state.summerbreak.active === false) {
          return resolve();
        }
        return _this.state.summerbreak.promise = FlexikonApi.summerbreakCheck().then(function(response) {
          var ref1, ref2;
          angular.extend(_this.state.summerbreak, response.data);
          _this.state.summerbreak.active = _this.state.summerbreak['summer-break'] || false;
          if (!_this.state.summerbreak.active) {
            return resolve();
          }
          if ((_this.state.summerbreak['start-date'] != null) && !isNaN(parseInt(_this.state.summerbreak['start-date']))) {
            _this.state.summerbreak.from = DcDateTime.getFormattedDate(new Date(_this.state.summerbreak['start-date'] * 1000));
          }
          if ((_this.state.summerbreak['end-date'] != null) && !isNaN(parseInt(_this.state.summerbreak['end-date']))) {
            _this.state.summerbreak.to = DcDateTime.getFormattedDate(new Date(_this.state.summerbreak['end-date'] * 1000));
          }
          if (((ref1 = _this.state.summerbreak.message) != null ? ref1.length : void 0) > 0) {
            console.debug(_this.state.summerbreak.message);
          } else if ((_this.state.summerbreak.from != null) && (_this.state.summerbreak.to != null)) {
            _this.state.summerbreak.message = $filter('translate')('DC_ARTICLE.SUMMERBREAK.POPOVER_HINT_DATE', {
              from: _this.state.summerbreak.from,
              to: _this.state.summerbreak.to
            });
          } else {
            _this.state.summerbreak.message += $filter('translate')('DC_ARTICLE.SUMMERBREAK.POPOVER_HINT_PLAIN');
          }
          if (_this.articleState.edit) {
            _this.toggleEdit();
          }
          if (response.data === true) {
            $scope.ui.showWiki = !$scope.ui.showWiki;
          } else if (typeof $event !== "undefined" && $event !== null) {
            if ((ref2 = $scope.summerbreakPopover) != null) {
              ref2.show($event);
            }
          }
          return resolve();
        })["catch"](function(error) {
          if (_this.state.isOffline) {
            return reject();
          }
          if (!_this.state.summerbreak.active) {
            _this.state.summerbreak = {
              message: $filter('translate')('DC_ARTICLE.SUMMERBREAK.POPOVER_HINT_FAILURE'),
              error: true
            };
          }
          return reject();
        });
      });
    };
  })(this);

  /**
   * [discard]
   * @return {[type]} []
   */
  this.discard = (function(_this) {
    return function() {
      _this.article.content.wiki = _this.wikiSave;
      _this.articleState.isUnsaved = false;
      if (_this.articleState.edit) {
        _this.toggleEdit();
      }
    };
  })(this);

  /**
   * [save]
   * @param  {[type]} $event []
   * @return {[type]}        []
   */
  this.save = (function(_this) {
    return function($event) {
      Load.isBlocked(true);
      return _this.isSummerbreak($event).then(function() {
        var q, ref, ref1;
        if (_this.state.isSummerbreak) {
          return;
        }
        q = $q.defer();
        if (_this.articleState.isNew) {
          if ((typeof analytics !== "undefined" && analytics !== null) && (((ref = _this.article.title) != null ? ref.raw : void 0) != null)) {
            analytics.trackEvent('Article', 'create', $scope.article.title.raw);
          }
          _this.articleState.isNew = false;
        } else {
          if ((typeof analytics !== "undefined" && analytics !== null) && (((ref1 = _this.article.title) != null ? ref1.raw : void 0) != null)) {
            analytics.trackEvent('Article', 'edit', _this.article.title.raw);
          }
        }
        _this.adjustWikiContent();
        FlexikonApi.post(_this.article.title.raw, _this.article.content.wiki, void 0, function(result) {
          $ionicScrollDelegate.scrollTop(false);
          if (_this.articleState.edit) {
            _this.toggleEdit();
          }
          if (_this.articleState.isFavorite) {
            _this.toggleFavoriteState();
            _this.toggleFavoriteState();
          }
          return $timeout(function() {
            Load.isBlocked(false);
            _this.wikiSave = angular.copy(_this.article.content.wiki);
            _this.articleState.isUnsaved = false;
            StateChangeInterrupter.unregisterCallback();
            q.resolve();
            if (ionic.Platform.isWebView()) {
              return $cordovaToast.showLongCenter($filter('translate')('DC_ARTICLE_SAVED'));
            }
          });
        }, function(error) {
          return $timeout(function() {
            Load.isBlocked(false);
            q.reject();
            if (ionic.Platform.isWebView()) {
              return $cordovaToast.showLongCenter($filter('translate')('DC_ARTICLE_SAVED_ERROR'));
            }
          });
        });
        return q.promise;
      })["finally"](function() {
        return Load.isBlocked(false);
      });
    };
  })(this);

  /**
   * [fetchFavoriteState ]
   * @return {[type]} []
   */
  this.fetchFavoriteState = (function(_this) {
    return function() {
      return Favorites.exists(_this.article.title.raw).then(function(result) {
        return _this.articleState.isFavorite = result;
      });
    };
  })(this);

  /**
   * [toggleFavoriteState]
   * @return {[type]} []
   */
  this.toggleFavoriteState = (function(_this) {
    return function() {
      return Favorites.get(_this.article.title.raw).then(function(doc) {
        return Favorites["delete"](doc).then(function(result) {
          _this.articleState.isFavorite = false;
          $timeout.cancel(_this.articleState.favoritePulseTimeout);
          return $scope.getSelf().find('.favorite-button').removeClass('pulse');
        });
      })["catch"](function(error) {
        return Favorites.insert(_this.article.title.raw, {
          article: _this.article.content.wiki,
          title: _this.article.title.raw,
          language: _this.language,
          date: DcDateTime.getFormattedDate()
        }).then(function(result) {
          _this.articleState.isFavorite = true;
          $scope.getSelf().find('.favorite-button').addClass('pulse');
          return _this.articleState.favoritePulseTimeout = $timeout(function() {
            return $scope.getSelf().find('.favorite-button').removeClass('pulse');
          }, 1000);
        });
      });
    };
  })(this);

  /**
   * [processArticle]
   * @return {[type]} []
   */
  this.processArticle = (function(_this) {
    return function(article) {
      var parsedHTML, ref, ref1, tocResult;
      if (!(((ref = _this.article) != null ? (ref1 = ref.title) != null ? ref1.raw : void 0 : void 0) != null)) {
        _this.setArticleMeta(article.title, article.revisions[0]['*']);
      }
      parsedHTML = WikiHTML.toHTML(_this.article.content.wiki, $scope.language);
      tocResult = _this.generateToC(parsedHTML, _this.article.title.raw);
      _this.article.content.html = tocResult.article;
      _this.article.content.sections = DcMediaWiki.splitHtml(_this.article.content.html);
      _this.article.toc = tocResult.toc;
    };
  })(this);

  /**
   * [generateToC]
   * @param  {[type]} html  []
   * @param  {[type]} title []
   * @return {[type]}       []
   */
  this.generateToC = function(html, title) {
    return ToC.generate(html, title);
  };

  /**
   *
   *
   * TRACKING
   *
   *
   */

  /**
   * [gaLogOpen]
   * @return {[type]} []
   */
  this.gaLogOpen = (function(_this) {
    return function() {
      var ref;
      if (!((typeof analytics !== "undefined" && analytics !== null) && (((ref = _this.article.title) != null ? ref.raw : void 0) != null))) {
        return;
      }
      return analytics.trackEvent('Article', 'open', _this.article.title.raw);
    };
  })(this);

  /**
   *
   *
   * STATE CHANGES
   *
   *
   */

  /**
   * [back]
   * @return
   */

  /**
   * [openArticle]
   * @param  {String} page       []
   * @param  {String} section='' []
   * @return
   */
  this.openArticle = function(page, section) {
    if (section == null) {
      section = '';
    }
    if (this.articleState.isUnsaved) {
      $scope.openSavePopup('article', page, section);
      return;
    }
    $scope.closeModal();
    page = page.replace(/&[^;]*;/g, '');
    console.log(page);
    $state.go('^.article', {
      page: window.decodeURIComponent(page),
      section: section
    });
  };

  /**
   * [back]
   * @return {[type]} []
   */
  this.back = (function(_this) {
    return function() {
      if (_this.articleState.edit) {
        _this.articleState.edit = false;
        return;
      }
      if (_this.articleState.isUnsaved) {
        $scope.openSavePopup('back');
        return;
      }
      ArticleHistory.back($state.current.name);
      return $ionicHistory.backView().go();
    };
  })(this);

  /**
   * [forward]
   * @return {[type]} []
   */
  this.forward = (function(_this) {
    return function() {
      return _this.openArticle(ArticleHistory.forward($state.current.name));
    };
  })(this);

  /**
   *
   *
   * SCROLLING, POSITIONING & SIDE MENU
   *
   *
   */

  /**
   * [scrollToSection]
   * @param  {[type]} section []
   * @return {[type]}         []
   */
  this.scrollToSection = (function(_this) {
    return function(section, fails) {
      if (section == null) {
        section = $state.params.section;
      }
      if (section == null) {
        return;
      }
      if (section.targetId == null) {
        section = ToC.getSectionWithHeading(section);
      }
      if (!((section != null ? section.targetId : void 0) != null)) {
        return;
      }
      if (fails > 10) {
        return;
      }
      if (angular.element('#' + section.targetId).length === 0) {
        return $timeout(function() {
          return _this.scrollToSection(section, ++fails);
        }, 500);
      }
      return _this.anchorScroll(id);
    };
  })(this);

  /**
   * [expandAll]
   * @return {[type]} []
   */
  this.expandAll = (function(_this) {
    return function() {
      var expandableSections, i, len, results, section;
      expandableSections = document.querySelectorAll('#ArticleScroll-' + _this.article.title.trimmed + ' dc-flexikon-section dc-expandable');
      results = [];
      for (i = 0, len = expandableSections.length; i < len; i++) {
        section = expandableSections[i];
        if (section.id != null) {
          results.push($rootScope.$broadcast('dcexpandable' + section.id + '-open', {
            preventDefault: true
          }));
        } else {
          results.push(void 0);
        }
      }
      return results;
    };
  })(this);

  /**
   * [anchorScroll]
   * @param  {[type]} id []
   * @return {[type]}    []
   */
  this.anchorScroll = (function(_this) {
    return function(id) {
      var expandId;
      expandId = angular.element('#' + id).closest('dc-expandable').attr('id');
      $rootScope.$broadcast('dcexpandable' + expandId + '-open');
      return $timeout(function() {
        var targetElement, targetSection, top;
        targetElement = angular.element('#' + id);
        if (!((targetElement != null ? targetElement.length : void 0) > 0)) {
          return;
        }
        top = targetElement.position().top - 12;
        targetSection = targetElement.closest('dc-flexikon-section');
        if ((targetSection != null ? targetSection.length : void 0) > 0) {
          top += targetSection.position().top;
        }
        _this.getScroll().scrollTo(0, top, true);
        _this.closeSideMenu();
        return $timeout(function() {
          return ToC.setCurrentSection(expandId);
        }, 500);
      });
    };
  })(this);

  /**
   * [getScroll]
   * @return {[type]} []
   */
  this.getScroll = function() {
    return $ionicScrollDelegate.$getByHandle('ArticleScroll');
  };

  /**
   * [scrollTop]
   * @return {[type]} []
   */
  this.scrollTop = (function(_this) {
    return function() {
      return _this.getScroll().scrollTop(false);
    };
  })(this);

  /**
   * [resize]
   * @return {[type]} []
   */
  this.resize = (function(_this) {
    return function() {
      return _this.getScroll().resize();
    };
  })(this);

  /**
   * [closeSideMenu]
   * @return {[type]} []
   */
  this.closeSideMenu = function() {
    if ($ionicSideMenuDelegate.isOpenRight()) {
      $ionicSideMenuDelegate.toggleRight();
      return true;
    }
    return false;
  };

  /**
   * [toggleSideMenu]
   * @return {[type]} []
   */
  this.toggleSideMenu = function() {
    $ionicSideMenuDelegate.toggleRight();
  };

  /**
   *
   *
   * OPTIONS
   *
   *
   */

  /**
   * [toggleOptions]
   * @return {[type]} []
   */
  this.toggleOptions = (function(_this) {
    return function($event) {
      if ($event != null) {
        $event.preventDefault();
      }
      if ($event != null) {
        $event.stopPropagation();
      }
      _this.buttonState.showOptions = !_this.buttonState.showOptions;
    };
  })(this);

  /**
   * [hideOptions]
   * @return {[type]} []
   */
  this.hideOptions = (function(_this) {
    return function() {
      _this.buttonState.showOptions = false;
    };
  })(this);

  /**
   * [onButtonHold]
   * @param  {[type]} $event []
   * @return {[type]}        []
   */
  this.onButtonHold = (function(_this) {
    return function($event) {
      var $target, matrix, transform;
      if ($event != null) {
        $event.preventDefault();
      }
      if ($event != null) {
        $event.stopPropagation();
      }
      $target = angular.element($event.currentTarget);
      $target.css('-webkit-transition-duration', '0ms');
      $target.css('transition-duration', '0ms');
      matrix = $target.css('transform');
      if ((matrix.match('matrix') == null) || matrix.match('matrix').length === 0) {
        _this.buttonState.start = {
          x: 0,
          y: 0
        };
      } else {
        transform = matrix.match(/\(.*?\)/gi)[0];
        transform = transform.substr(1, transform.length - 2);
        transform = transform.split(', ');
        _this.buttonState.start = {
          x: parseFloat(transform[4]),
          y: parseFloat(transform[5])
        };
      }
      _this.buttonState.movable = true;
      $ionicSideMenuDelegate.canDragContent(false);
    };
  })(this);

  /**
   * [onButtonRelease]
   * @param  {[type]} $event []
   * @return {[type]}        []
   */
  this.onButtonRelease = (function(_this) {
    return function($event) {
      var $target, bottomBorder, button, header, matrix, tabs, transform;
      if ($event != null) {
        $event.preventDefault();
      }
      if ($event != null) {
        $event.stopPropagation();
      }
      _this.buttonState.movable = false;
      $target = angular.element($event.currentTarget);
      matrix = $target.css('transform');
      if ((matrix.match('matrix') == null) || matrix.match('matrix').length === 0) {
        return;
      }
      transform = matrix.match(/\(.*?\)/gi)[0];
      transform = transform.substr(1, transform.length - 2);
      transform = transform.split(', ');
      _this.buttonState.end = {
        x: parseFloat(transform[4]),
        y: parseFloat(transform[5])
      };
      if (_this.buttonState.end.x < (window.innerWidth / 2) * (-1)) {
        _this.buttonState.end.x = (window.innerWidth - 60) * (-1);
        $target.addClass('left');
      } else {
        _this.buttonState.end.x = 0;
        $target.removeClass('left');
      }
      bottomBorder = window.innerHeight - (tabs = 49) - (header = 44) - (button = 60);
      if (_this.buttonState.end.y < 0) {
        _this.buttonState.end.y = 0;
      } else if (_this.buttonState.end.y > bottomBorder) {
        _this.buttonState.end.y = bottomBorder;
        if (_this.state.showSearch) {
          _this.buttonState.end.y -= 48;
        }
      }
      if (_this.buttonState.end.y > bottomBorder - 120) {
        $target.addClass('bottom');
      } else {
        $target.removeClass('bottom');
      }
      $target.css('-webkit-transition-duration', '300ms');
      $target.css('transition-duration', '300ms');
      $target.css('transform', 'translate3D(' + _this.buttonState.end.x + 'px, ' + _this.buttonState.end.y + 'px, 100px)');
      $target.css('-webkit-transform', 'translate3D(' + _this.buttonState.end.x + 'px, ' + _this.buttonState.end.y + 'px, 100px)');
      $ionicSideMenuDelegate.canDragContent(true);
    };
  })(this);

  /**
   * [onScroll]
   * @return {[type]} []
   */
  this.onScroll = (function(_this) {
    return function() {
      var scroll;
      scroll = _this.getScroll();
      if (scroll.getScrollPosition() == null) {
        return;
      }
      if (Math.abs(_this.scrolling.last - scroll.getScrollPosition().top) < 100) {
        return;
      }
      _this.scrolling.last = scroll.getScrollPosition().top;
      if (_this.scrolling.onTop !== (_this.scrolling.last < 1000)) {
        $timeout(function() {
          return _this.scrolling.onTop = _this.scrolling.last < 1000;
        });
      }
      _this.preventClickOnScroll();
      _this.findActiveSection();
      if (!_this.scrolling.listen) {
        return;
      }
      return ionic.DomUtil.requestAnimationFrame(_this.onScroll);
    };
  })(this);

  /**
   * [preventClickOnScroll]
   * @return {[type]} []
   */
  this.preventClickOnScroll = (function(_this) {
    return function() {
      _this.scrolling.inProgress = true;
      $timeout.cancel(_this.scrolling.preventClickTimeout);
      _this.scrolling.preventClickTimeout = $timeout(function() {
        return _this.scrolling.inProgress = false;
      }, 150, false);
    };
  })(this);

  /**
   * [findActiveSection]
   * @return {[type]} []
   */
  this.findActiveSection = (function(_this) {
    return function() {
      var expandable, i, len, nearest, section, sections;
      nearest = {
        gap: 100000,
        section: void 0
      };
      sections = $scope.getHTMLWrapper()[0].getElementsByTagName('dc-flexikon-section');
      for (i = 0, len = sections.length; i < len; i++) {
        section = sections[i];
        if (Math.abs(section.offsetTop - _this.scrolling.last) < nearest.gap) {
          nearest.gap = Math.abs(section.offsetTop - _this.scrolling.last);
          nearest.section = angular.element(section);
        }
      }
      if (nearest.section != null) {
        expandable = nearest.section.find('dc-expandable');
        if ((expandable != null) && expandable.length > 0 && (expandable.attr('id') != null)) {
          ToC.setCurrentSection(expandable.attr('id'));
        }
      }
    };
  })(this);

  /**
   * [move]
   * @param  {[type]} $event []
   * @return {[type]}        []
   */
  this.onButtonDrag = (function(_this) {
    return function($event) {
      var x, y;
      if (!_this.buttonState.movable) {
        return;
      }
      $ionicSideMenuDelegate.canDragContent(false);
      $event.preventDefault();
      $event.stopPropagation();
      x = _this.buttonState.start.x + $event.gesture.deltaX;
      y = _this.buttonState.start.y + $event.gesture.deltaY;
      angular.element($event.currentTarget).css('transform', 'translate3D(' + x + 'px, ' + y + 'px, 100px)');
      angular.element($event.currentTarget).css('-webkit-transform', 'translate3D(' + x + 'px, ' + y + 'px, 100px)');
    };
  })(this);

  /**
   * [toggleFindInPage]
   * @return {[type]} []
   */
  this.toggleFindInPage = (function(_this) {
    return function($event, focus) {
      if (focus == null) {
        focus = true;
      }
      if ($event != null) {
        $event.preventDefault();
      }
      if ($event != null) {
        $event.stopPropagation();
      }
      _this.hideOptions();
      DcHighlight.removeHighlights($scope.getHTMLWrapper()[0]);
      _this.state.showSearch = !_this.state.showSearch;
      window.getSelection().removeAllRanges();
      if (!_this.state.showSearch) {
        $timeout(function() {
          return _this.find = {
            model: '',
            count: 0,
            current: 0
          };
        }, 150, false);
      } else if (focus) {
        $timeout(function() {
          return _this.focusFindInPage();
        }, 300);
      }
    };
  })(this);

  /**
   * [focusFindInPage]
   * @return {[type]} []
   */
  this.focusFindInPage = function() {
    var input;
    input = $scope.getSelf().find('#findInPage');
    input.focus();
    input[0].focus();
  };

  /**
   * [blurFindInPage]
   * @return {[type]} []
   */
  this.blurFindInPage = function() {
    var input;
    input = $scope.getSelf().find('#findInPage');
    input.blur();
    input[0].blur();
  };

  /**
   * [toggleFindInPage]
   * @return {[type]} []
   */
  this.hideFindInPage = (function(_this) {
    return function() {
      _this.state.showSearch = false;
    };
  })(this);

  /**
   * [addFindInPageListener]
   */
  this.addFindInPageListener = (function(_this) {
    return function() {
      _this.removeFindInPageListener();
      _this.listener.push(_this.findInPageListener = $scope.$watch(function() {
        return _this.find.model;
      }, function(n, o) {
        if (n === o || (o == null)) {
          return;
        }
        _this.find.count = 0;
        _this.find.current = 0;
        delete _this.find.searched;
        $timeout.cancel(_this.find.debounce);
        return _this.find.debounce = $timeout(function() {
          if (_this.find.model.length >= 3) {
            return _this.findInPage(false, false, false);
          }
        }, 300);
      }));
    };
  })(this);

  /**
   * [removeFindInPageListener]
   * @return {[type]} []
   */
  this.removeFindInPageListener = (function(_this) {
    return function() {
      if (typeof _this.findInPageListener === "function") {
        _this.findInPageListener();
      }
    };
  })(this);

  /**
   * [findInPage]
   * @return {[type]} []
   */
  this.findInPage = (function(_this) {
    return function(inverse, focus, blur) {
      if (focus == null) {
        focus = true;
      }
      if (blur == null) {
        blur = true;
      }
      $timeout.cancel(_this.find.debounce);
      if (_this.find.model.length === 0) {
        _this.find.count = DcHighlight.removeHighlights($scope.getHTMLWrapper()[0]);
        $timeout(_this.focusFindInPage);
        return;
      }
      _this.find.searched = true;
      if (_this.find.count === 0) {
        _this.find.count = DcHighlight.removeHighlights($scope.getHTMLWrapper()[0]);
        _this.find.count = DcHighlight.highlightWord($scope.getHTMLWrapper()[0], _this.find.model);
        if (_this.find.count > 0) {
          DcHighlight.focus(_this.find.current);
          _this.anchorScroll('dc-highlight-' + _this.find.current);
          if (blur) {
            _this.blurFindInPage();
          }
        } else if (focus) {
          $timeout(_this.focusFindInPage);
        }
        return;
      }
      if (!inverse) {
        _this.find.current = (_this.find.current + 1) % _this.find.count;
      } else if (inverse) {
        _this.find.current = (_this.find.current + _this.find.count - 1) % _this.find.count;
      }
      DcHighlight.focus(_this.find.current);
      _this.blurFindInPage();
      _this.anchorScroll('dc-highlight-' + _this.find.current);
    };
  })(this);

  /**
   * [scrollToSelection]
   * @return {[type]} []
   */
  this.scrollToSelection = (function(_this) {
    return function() {
      var parentNode, ref, selection, top;
      if (!((typeof window.getSelection === "function" ? window.getSelection() : void 0) != null)) {
        return;
      }
      selection = window.getSelection();
      if (!(((ref = selection.baseNode) != null ? ref.parentNode : void 0) != null)) {
        return;
      }
      parentNode = angular.element(selection.baseNode.parentNode);
      top = parentNode.offset().top - 96;
      return _this.getScroll().scrollBy(0, top, true);
    };
  })(this);

  /**
   *
   *
   * EDIT
   *
   *
   */

  /**
   * [editSection]
   * @param  {[type]} $event        []
   * @param  {[type]} section       []
   * @param  {[type]} sectionNumber []
   * @return {[type]}               []
   */
  this.editSection = (function(_this) {
    return function() {
      return function($event, section, sectionNumber) {
        var promise;
        promise = _this.state.summerbreak.promise || _this.isSummerbreak();
        return promise.then(function() {
          var mReg, match, preparedTitle;
          if (_this.state.summerbreak.active) {
            _this.state.summerbreak.popover.show($event);
            return;
          }
          preparedTitle = WikiHTML.toWiki("== *" + DcMediaWiki.escapeStringForRegex(section) + " *==");
          mReg = new RegExp(preparedTitle + '(?: |.)*((?!\\n==[^=])(.|\\n))*');
          match = _this.article.content.wiki.match(mReg)[0].replace(new RegExp('^' + section), '');
          _this.article.edit = {
            section: match,
            number: sectionNumber
          };
          return _this.toggleEdit($event);
        });
      };
    };
  })(this);

  /**
   * [editGlobal]
   * @param  {[type]} $event []
   * @return {[type]}        []
   */
  this.editGlobal = (function(_this) {
    return function($event) {
      var promise;
      promise = _this.state.summerbreak.promise || _this.isSummerbreak();
      promise.then(function() {
        if (_this.state.summerbreak.active) {
          _this.state.summerbreak.popover.show($event);
          return;
        }
        return _this.toggleEdit($event);
      });
    };
  })(this);

  /**
   * [adjustWikiContent]
   * @return {[type]} []
   */
  this.adjustWikiContent = (function(_this) {
    return function() {
      var ref;
      if (((ref = _this.article.edit) != null ? ref.section : void 0) != null) {
        _this.article.content.wiki = _this.article.content.wiki.replace(_this.article.edit.section, _this.wikiModel);
        _this.article.edit.section = _this.wikiModel;
      } else {
        _this.article.content.wiki = angular.copy(_this.wikiModel);
      }
      _this.articleState.isUnsaved = _this.article.content.wiki !== _this.article.content.wiki_save;
      if (_this.articleState.isUnsaved) {
        return StateChangeInterrupter.registerCallback($scope.openSavePopup);
      }
    };
  })(this);

  /**
   * [toggleEdit]
   * @param  {Boolean} force=false []
   * @return
   */
  this.toggleEdit = (function(_this) {
    return function($event, force, section) {
      var ref;
      if (force == null) {
        force = false;
      }
      if (section == null) {
        section = void 0;
      }
      if ($event != null) {
        $event.preventDefault();
        $event.stopPropagation();
      }
      if (!force && !Login.isAuthenticated()) {
        $state.go('^.login');
        return;
      }
      if (_this.toggleDisabled) {
        return;
      }
      _this.toggleDisabled = true;
      $timeout.cancel(_this.toggleTimeout);
      _this.toggleTimeout = $timeout(function() {
        return _this.toggleDisabled = false;
      }, 1000, false);
      _this.hideOptions();
      if (_this.articleState.edit) {
        _this.adjustWikiContent();
        _this.articleState.edit = false;
        _this.resize();
        _this.processArticle();
        return;
      }
      if (((ref = _this.article.edit) != null ? ref.section : void 0) != null) {
        _this.wikiModel = angular.copy(_this.article.edit.section);
      } else {
        _this.wikiModel = angular.copy(_this.article.content.wiki);
      }
      _this.wikiSave = angular.copy(_this.article.content.wiki);
      _this.articleState.edit = true;
      _this.resize();
    };
  })(this);

  /**
   * [handleClick]
   * @param  {[type]} $event []
   * @return {[type]}        []
   */
  this.handleClick = (function(_this) {
    return function($event) {
      var element, link, ref, ref1, strippedLink;
      if ((ref = _this.scrolling) != null ? ref.inProgress : void 0) {
        return;
      }
      element = $event.toElement;
      if (DcHighlight.isHighlightNode(element)) {
        element = element.parentNode;
      }
      if (element.tagName.toUpperCase() === 'A' && element.href.indexOf(location.origin) !== 0) {
        $event.preventDefault();
        $event.stopPropagation();
        window.open(element.href, '_system');
        return;
      }
      if (element.tagName.toUpperCase() === 'A' && element.href.indexOf(location.origin) === 0) {
        $event.preventDefault();
        $event.stopPropagation();
        link = element.href.substr(element.href.lastIndexOf('/') + 1);
        if (element.href.indexOf('#') >= 0) {
          strippedLink = link.replace(/<.*?>/gmi, '');
          if (link.indexOf('.html') > 0) {
            strippedLink = strippedLink.substr(strippedLink.indexOf('.html') + '.html'.length);
          }
          if (strippedLink.indexOf('#') === 0) {
            _this.anchorScroll(strippedLink.substr(1));
            return;
          }
        }
        return $scope.openModal($event, link, ((ref1 = element.attributes.getNamedItem('section')) != null ? ref1.value : void 0) || '');
      }
    };
  })(this);

  /**
   *
   * MODAL
   *
   */

  /**
   * [prepareModal]
   * @return {[type]} []
   */
  this.prepareModal = function() {
    return $ionicModal.fromTemplateUrl('articleLinkModal.html', {
      scope: $scope,
      animation: "slide-up-half fade"
    }).then(function(modal) {
      return this.modal = {
        handle: modal,
        title: void 0,
        section: void 0,
        content: '',
        error: false
      };
    });
  };

  /**
   * [darkThemeSelected]
   * @return {Boolean} []
   */
  this.darkThemeSelected = function() {
    return Theme.darkThemeSelected();
  };
  this.setTheme = function(theme) {
    return Theme.select(theme);
  };

  /**
   * GuidedTour
   */

  /**
   * [prepareOverlay]
   * @return {[type]} []
   */
  this.prepareOverlay = function() {
    GuidedTour.setRootElement($scope.getSelf());
    return;
    GuidedTour.start('FlexikonArticleIntro', [
      {
        selector: void 0,
        hint: ''
      }
    ]);
  };

  /**
   * [removeOverlay]
   * @return {[type]} []
   */
  this.removeOverlay = function() {
    GuidedTour.cancel();
  };

  /**
   * [runOverlay]
   * @return {[type]} []
   */
  this.runOverlay = function() {
    GuidedTour.setRootElement($scope.getSelf());
    if (GuidedTour.isPassed('FlexikonArticleIntro')) {
      return;
    }
    GuidedTour.setRootElement($scope.getSelf());
    return GuidedTour.start('FlexikonArticleIntro', [
      {
        selector: [
          {
            name: '.favorite-button',
            shape: 'round'
          }, {
            name: 'a[icon="fa fa-heart"]',
            shape: 'rect',
            global: true
          }
        ],
        hint: 'GUIDED_TOUR.ARTICLE_STEPS.NEW_BOOKMARK'
      }, {
        selector: [
          {
            name: '.dc-icon-button.options',
            shape: 'round'
          }
        ],
        hint: 'GUIDED_TOUR.ARTICLE_STEPS.OPTIONS',
        callbacks: {
          afterStep: (function(_this) {
            return function() {
              return _this.toggleOptions();
            };
          })(this)
        }
      }, {
        selector: [
          {
            name: '.dc-icon-button.search',
            shape: 'round'
          }
        ],
        hint: 'GUIDED_TOUR.ARTICLE_STEPS.FIND_IN_PAGE_BUTTON',
        callbacks: {
          afterStep: (function(_this) {
            return function() {
              return _this.toggleFindInPage(void 0, false);
            };
          })(this)
        }
      }, {
        selector: [
          {
            name: '.find-in-page .fa-close',
            shape: 'square'
          }, {
            name: '.find-in-page input',
            shape: 'square',
            noArrow: true
          }, {
            name: '.article-title',
            shape: 'square'
          }
        ],
        hint: 'GUIDED_TOUR.ARTICLE_STEPS.FIND_IN_PAGE_INPUT',
        callbacks: {
          onHighlight: (function(_this) {
            return function() {
              var typeTitleInSearch;
              typeTitleInSearch = function() {
                if (_this.find.model.length === _this.article.title.raw.length) {
                  return $q.resolve();
                }
                return $timeout(function() {
                  _this.find.model += _this.article.title.raw[_this.find.model.length];
                  return typeTitleInSearch();
                }, 100);
              };
              return typeTitleInSearch().then(function() {
                return $timeout(function() {
                  return _this.findInPage();
                }, 300);
              });
            };
          })(this),
          afterStep: (function(_this) {
            return function() {
              _this.toggleFindInPage();
              return _this.toggleOptions();
            };
          })(this)
        }
      }, {
        selector: [
          {
            name: '.dc-icon-button.edit',
            shape: 'round'
          }
        ],
        hint: 'GUIDED_TOUR.ARTICLE_STEPS.EDIT',
        callbacks: {
          afterStep: (function(_this) {
            return function() {
              _this.toggleEdit(void 0, true);
              return _this.toggleOptions();
            };
          })(this)
        }
      }, {
        selector: [
          {
            name: '.dc-icon-button.preview',
            shape: 'round'
          }
        ],
        hint: 'GUIDED_TOUR.ARTICLE_STEPS.PREVIEW',
        callbacks: {
          onFadeOut: (function(_this) {
            return function() {
              $timeout(function() {
                return _this.toggleEdit(void 0, true);
              }, 150);
            };
          })(this)
        },
        buttonText: 'GUIDED_TOUR.GO_FOR_IT',
        disableCancel: true
      }
    ], false);
  };
  this.init();
});

angular.module("Flexikon.directives").directive('dcFlexikonArticle', function($timeout, GuidedTour, $ionicSideMenuDelegate, Favorites, Store, NavBar, DcDateTime) {
  return {
    restrict: 'E',
    scope: {
      id: '@',
      page: '@'
    },
    templateUrl: 'templates/DcFlexikonArticleTemplate.html',
    controller: 'DcFlexikonArticleCtrl as flex',
    bindToController: true,
    link: function(scope, element, attrs) {
      scope.getSelf = function() {
        return element;
      };
      scope.getHTMLWrapper = function() {
        return element.find('.html-wrapper');
      };
      scope.toggleBars = function() {
        return $timeout(function() {
          if (window.innerHeight >= 768) {
            return;
          }
          if (window.innerWidth < window.innerHeight) {
            return scope.showBars();
          } else {
            return scope.hideBars();
          }
        }, 300);
      };
      scope.hideBars = function(force) {
        if ((window.innerHeight >= 768 || window.innerWidth < window.innerHeight) && !force) {
          return;
        }
        scope.barsHidden = true;
        return $timeout(function() {
          angular.element('.tab-nav.tabs').css('-webkit-transform', 'translateY(49px)');
          angular.element('.tab-nav.tabs').css('transform', 'translateY(49px)');
          element.find('ion-header-bar').css('-webkit-transform', 'translateY(-44px)');
          element.find('ion-header-bar').css('transform', 'translateY(-44px)');
          element.find('ion-content').css('top', '0px');
          return element.find('ion-content').css('bottom', '0px');
        }, 500);
      };
      scope.showBars = function() {
        scope.barsHidden = false;
        return $timeout(function() {
          angular.element('.tab-nav.tabs').css('-webkit-transform', 'translateY(0px)');
          angular.element('.tab-nav.tabs').css('transform', 'translateY(0px)');
          element.find('ion-header-bar').css('-webkit-transform', 'translateY(0px)');
          element.find('ion-header-bar').css('transform', 'translateY(0px)');
          element.find('ion-content').css('top', '44px');
          return element.find('ion-content').css('bottom', '49px');
        }, 500);
      };
      return;
      scope.listeners.push(scope.$on('$stateChangeStart', function(event, toState) {
        if (toState.name.indexOf('article') < 0) {
          scope.showBars();
          NavBar.unhide();
          return $ionicSideMenuDelegate.canDragContent(false);
        } else {
          return $timeout(function() {
            NavBar.hide();
            return $ionicSideMenuDelegate.canDragContent(true);
          });
        }
      }));
      scope.$on('$destroy', function() {
        return scope.showBars();
      });
      scope.runOverlay = function() {
        if (GuidedTour.isPassed('FlexikonArticleIntro')) {
          return;
        }
        GuidedTour.setRootElement(element);
        scope.showBars();
        return GuidedTour.start('FlexikonArticleIntro', [
          {
            selector: [
              {
                name: '.favorite-button',
                shape: 'round'
              }
            ],
            hint: 'DC_TUTORIAL_OVERLAY_NEWBOOKMARK',
            endCallback: function() {
              return scope.hideBars();
            }
          }, {
            selector: [
              {
                name: '.fa.fa-pencil',
                shape: 'round'
              }
            ],
            hint: 'DC_TUTORIAL_OVERLAY_EDIT',
            endCallback: function() {
              scope.article.wiki.edit = scope.article.wiki.content;
              return scope.toggleEdit(void 0, true);
            }
          }, {
            selector: [
              {
                name: '.fa.fa-eye',
                shape: 'round'
              }
            ],
            hint: 'DC_TUTORIAL_OVERLAY_PREVIEW',
            endCallback: function() {
              scope.toggleEdit(void 0, true);
              return scope.ui.unsaved = false;
            }
          }
        ], false);
      };
    }
  };
});

angular.module("Flexikon.controllers").controller('DcFlexikonArticleModalCtrl', function($scope, $state, $filter, $ionicSideMenuDelegate, $ionicModal, $ionicHistory, $ionicTabsDelegate, $ionicPopup, WikiHTML, FlexikonApi, StateChangeInterrupter, ArticleHistory) {

  /**
   * [Logic for the link definition modal - in case an internal link is triggered, the definition will show up in the modal offering to move on to the whole article]
   * @return {[type]} [description]
   */
  ionic.Platform.ready(function() {
    var ref, ref1;
    if (typeof cordova !== "undefined" && cordova !== null) {
      if ((ref = cordova.plugins) != null) {
        if ((ref1 = ref.Keyboard) != null) {
          ref1.disableScroll(true);
        }
      }
    }
    $ionicModal.fromTemplateUrl('articleLinkModal.html', {
      scope: $scope,
      animation: "slide-up-half fade"
    }).then(function(modal) {
      return $scope.modal = {
        handle: modal,
        title: void 0,
        section: void 0,
        content: '',
        error: false
      };
    });

    /**
     * [openModal - show the definition modal]
     * @param  {[Event]}  $event  [trigger click event]
     * @param  {[String]} page    [page string]
     * @param  {[String]}    section [section to open]
     * @return
     */
    $scope.openModal = function($event, page, section) {

      /**
       * if this defintion has been opened before, don't fetch once again, just reopen it and return
       */
      var language, match, ref2;
      if ($scope.modal.target === page) {
        $scope.modal.section = section;
        $scope.modal.handle.show($event);
        return;
      }

      /**
       * reset all ui values to clean the modal before fetching a new definition
       */
      $scope.modal.page = void 0;
      $scope.modal.target = void 0;
      $scope.modal.section = void 0;
      $scope.modal.content = '';

      /**
       * retrieve the page and the target
       * [target - string to identify the page]
       * [page   - formatted string to show as modal title]
       */
      $scope.modal.page = $scope.modal.target = decodeURIComponent(page);
      $scope.modal.page = $scope.modal.page.replace('_', ' ');
      $scope.modal.section = section;

      /**
       * target might contain a language prefix, so fetch it and proceed
       */
      page = $scope.modal.target;
      if (((ref2 = page.match(/^(:|\/)/)) != null ? ref2.length : void 0) > 0) {
        match = page.match(/(?::|\/)(.*)(?::|\/)/);
        page = page.replace(match[0], '').replace('_', ' ');
        language = match[1];
        $scope.modal.page = $scope.modal.target = decodeURIComponent(page);
        if ($scope.modal.target.indexOf(':') !== 0) {
          $scope.modal.target = ':' + language + ':' + $scope.modal.target;
        }
      }

      /**
       * no language given? So assume we keep the language of the currently shown article
       */
      if (!language) {
        language = $scope.vm.language;
      }

      /**
       * fetch the definition from the API
       */
      FlexikonApi.getDefinition(page, language).success(function(result) {
        $scope.modal.content = WikiHTML.toHTML(result.text).replace(/<br *\/?>/, ' ').replace(/<(.*?)>/gmi, '');

        /**
         * redirects might have occured - in case, check for the correct title to show as modal title
         */
        if (result.redirect_title != null) {
          $scope.modal.page = $scope.modal.target = decodeURIComponent(result.redirect_title);
        }
        if ($scope.modal.target.indexOf(':') !== 0) {
          return $scope.modal.target = ':' + language + ':' + $scope.modal.target;
        }
      }).error(function(data) {

        /**
         * error handling (404 -> not found; else -> unknown)
         */
        $scope.modal.error = true;
        if (data.error.code === 404) {
          $scope.modal["new"] = true;
          return $scope.modal.content = $filter('translate')('DC_ARTICLE_NOT_FOUND');
        } else {
          return $scope.modal.content = $filter('translate')('DC_ARTICLE_UNKNOWN_ERROR');
        }
      });

      /**
       * just make sure the side menu is closed
       */
      if ($ionicSideMenuDelegate.isOpenRight()) {
        $ionicSideMenuDelegate.toggleRight();
      }

      /**
       * trigger the show function of the actual modal handle
       */
      $scope.modal.handle.show($event);
    };

    /**
     * [openModalArticle - move on to the article the definition is shown for (if fetched successfully)]
     * @param  {[String]} page    [title of the article to open]
     * @param  {[String]} section [section to open (optional)]
     * @return
     */
    $scope.openModalArticle = function(page, section) {
      if ($scope.modal.error && !$scope.modal["new"]) {
        return;
      }
      return $scope.vm.openArticle(page, section);
    };

    /**
     * [closeModal]
     * @return
     */
    $scope.closeModal = function() {
      $scope.modal.handle.hide();
      if ($ionicSideMenuDelegate.isOpenRight()) {
        $ionicSideMenuDelegate.toggleRight();
      }
    };

    /**
     * [remove the modal completely when the article is destroyed]
     * @return
     */
    $scope.$on('$destroy', function() {
      $scope.modal.handle.remove();
    });

    /**
     * [reset the modal when hidden and fetching wasn't successful; otherwise keep the information in case the user opens the same definition again]
     * @return
     */
    $scope.$on('modal.hidden', function() {
      if ($scope.modal.error) {
        $scope.modal.error = false;
        $scope.modal.page = void 0;
        $scope.modal.target = void 0;
        $scope.modal.section = void 0;
        $scope.modal.content = '';
      }
    });

    /**
     * [modal removed event]
     * @return
     */
    return $scope.$on('modal.removed', function() {});
  });

  /**
   * [openSavePopup]
   * @param  {[type]} type [description]
   * @param  {[type]} a    [description]
   * @param  {[type]} b    [description]
   * @return {[type]}      [description]
   */
  return $scope.openSavePopup = function(type, a, b) {
    return $ionicPopup.confirm({
      title: $filter('translate')('DC_ARTICLE_LEAVE_HINT'),
      cssClass: 'dc-popup save-popup',
      buttons: [
        {
          text: $filter('translate')('DC_ARTICLE_LEAVE_WITH_SAVE'),
          type: 'dc-button-block dc-button-red',
          onTap: function(e) {
            return 'save';
          }
        }, {
          text: $filter('translate')('DC_ARTICLE_LEAVE_WITHOUT_SAVE'),
          type: 'dc-button-block dc-button-gray',
          onTap: function(e) {
            return 'leave';
          }
        }, {
          text: $filter('translate')('DC_ARTICLE_CANCEL_LEAVE'),
          type: 'dc-button-block dc-button-gray',
          onTap: function(e) {
            return 'cancel';
          }
        }
      ]
    }).then(function(res) {
      var leave, x;
      leave = function() {
        StateChangeInterrupter.unregisterCallback();
        if (type === 'back') {
          ArticleHistory.back($state.current.name);
          return $ionicHistory.goBack();
        } else if (type === 'article') {
          return $scope.vm.openArticle(a, b);
        } else if (type === 'state') {
          $state.go(a);
          return $ionicTabsDelegate.select(b);
        }
      };
      if (res === 'leave') {
        $scope.vm.discard();
        leave();
      } else if (res === 'save') {
        $scope.vm.save().then(function() {
          return leave();
        });
      } else if (res === 'cancel') {
        x = x;
      }
    });
  };
});

var indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

angular.module("Flexikon.controllers").controller('DcFavoriteSegmentsCtrl', function($scope, $state, $q, $timeout, $ionicSlideBoxDelegate, $controller, Favorites, LastSeen, FlexikonApi, DcDateTime, GlobalSettings) {
  $controller('BaseCtrl', {
    $scope: $scope
  });
  $scope.dot = $scope;
  $scope.segment = 0;
  $scope.alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ#';
  $scope.init = function() {
    $scope.getChannelListing();
    $scope.fetchLastSeen();
    return $scope.fetchFavorites().then(function() {
      return $ionicSlideBoxDelegate.update();
    });
  };
  $scope.$on('favs.beforeEnter', function() {
    return $scope.init();
  });
  $scope.setSegment = function(index) {
    return $scope.segment = index;
  };
  $scope.getAlphabetObject = function() {
    var i, len, letter, ref, temp;
    temp = {};
    ref = $scope.alphabet;
    for (i = 0, len = ref.length; i < len; i++) {
      letter = ref[i];
      temp[letter] = [];
    }
    return angular.copy(temp);
  };

  /**
  	 * [fetchLastSeen - fetch last seen articles from local db]
  	 * @return
   */
  $scope.fetchLastSeen = function() {
    return $q(function(resolve, reject) {
      return LastSeen.getAll().then(function(result) {
        var i, len, ls, ref;
        $scope.lastSeen = result;
        ref = $scope.lastSeen;
        for (i = 0, len = ref.length; i < len; i++) {
          ls = ref[i];
          ls.formattedDate = DcDateTime.getFormattedDate(ls.lastVisited);
        }
        return resolve();
      })["catch"](function(error) {
        $scope.lastSeen = [];
        return reject();
      });
    });
  };

  /**
  	 * [getChannelListing - fetch articles of current user]
  	 * @return
   */
  $scope.getChannelListing = function() {
    if (!$scope.isAuthenticated()) {
      return;
    }
    return FlexikonApi.getChannelListing().success(function(result) {
      var c, contribsTitle, i, len, ref, ref1, results;
      document.removeEventListener("online", $scope.getChannelListing, false);
      $scope.contribs = [];
      contribsTitle = [];
      ref = result.query.usercontribs;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        c = ref[i];
        if (ref1 = c.title, indexOf.call(contribsTitle, ref1) < 0) {
          contribsTitle.push(c.title);
          c.formattedDate = DcDateTime.getFormattedDate(new Date(c.timestamp).getTime());
          results.push($scope.contribs.push(c));
        } else {
          results.push(void 0);
        }
      }
      return results;
    }).error(function(error) {
      var ref;
      console.warn(error);
      document.removeEventListener("online", $scope.getChannelListing, false);
      document.addEventListener("online", $scope.getChannelListing, false);
      if (((ref = $scope.contribs) != null ? ref.length : void 0) > 0) {
        return;
      }
      return $scope.contribs = [];
    });
  };
  $scope.sortFavorites = function(favorites) {
    var favorite, i, len, letter, ref, sortedFavorites;
    sortedFavorites = $scope.getAlphabetObject();
    for (i = 0, len = favorites.length; i < len; i++) {
      favorite = favorites[i];
      letter = favorite.article.title[0];
      if (ref = letter.toUpperCase(), indexOf.call($scope.alphabet, ref) < 0) {
        letter = '#';
      }
      sortedFavorites[letter].push(favorite);
    }
    return sortedFavorites;
  };

  /**
  	 * [fetchFavorites - fetch favorites from local db]
  	 * @return
   */
  $scope.fetchFavorites = function() {
    return $q(function(resolve, reject) {
      return Favorites.getAll().then(function(result) {
        $scope.favorites = $scope.sortFavorites(result);
        return resolve();
      })["catch"](function(error) {
        $scope.favorites = [];
        return reject();
      });
    });
  };

  /**
  	 * [openArticle - open article]
  	 * @param  {[type]} page     [page title]
  	 * @param  {[type]} language [article language]
  	 * @return {[type]}
   */
  $scope.openArticle = function($event, page, language) {
    $event.preventDefault();
    $event.stopPropagation();
    if (language == null) {
      language = GlobalSettings.Language();
    }
    page = page.replace(/&[^;]*;/g, '');
    return $state.go('^.article', {
      page: ':' + language + ':' + window.decodeURIComponent(page)
    });
  };
  return $scope.init();
});

angular.module("Flexikon.directives").directive('dcFavoriteSegments', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcFavoriteSegmentsTemplate.html',
    controller: 'DcFavoriteSegmentsCtrl'
  };
});

var indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

angular.module("Flexikon.controllers").controller('DcFlexikonFavListingCtrl', function($scope, $rootScope, $controller, $q, $timeout, $location, $ionicScrollDelegate, Favorites, ExtendedState, LastSeen, FlexikonApi, Login, GlobalSettings) {
  $controller('BaseCtrl', {
    $scope: $scope
  });

  /**
  	 * [ui - ui state variables]
   */
  $scope.ui = {
    loading: false,
    contribsLoading: false
  };

  /**
  	 * [render - render state variables depending on loading status of sections]
   */
  $scope.render = {
    lastseen: true,
    favorites: true,
    contributions: true
  };

  /**
  	 * [init]
   */
  $scope.$on('favs.beforeEnter', function() {
    $scope.fetch();
    return $scope.getChannelListing();
  });

  /**
  	 * [fetch - fetch all resources from local dbs]
  	 * @return
   */
  $scope.fetch = function() {
    $scope.ui.loading = true;
    return $q.all([$scope.fetchFavorites(), $scope.fetchLastSeen()]).then(function() {
      return $timeout(function() {
        return $scope.ui.loading = false;
      });
    });
  };

  /**
  	 * [fetchFavorites - fetch favorites from local db]
  	 * @return
   */
  $scope.fetchFavorites = function() {
    return $q(function(resolve, reject) {
      return Favorites.getAll().then(function(result) {
        $scope.favorites = result;
        resolve();
        return $timeout(function() {
          return $scope.render.favorites = true;
        }, 100);
      })["catch"](function(error) {
        $scope.favorites = [];
        return reject();
      });
    });
  };

  /**
  	 * [fetchLastSeen - fetch last seen articles from local db]
  	 * @return
   */
  $scope.fetchLastSeen = function() {
    return $q(function(resolve, reject) {
      return LastSeen.getAll().then(function(result) {
        $scope.lastSeen = result;
        resolve();
        return $timeout(function() {
          return $scope.render.lastseen = true;
        }, 100);
      })["catch"](function(error) {
        $scope.lastSeen = [];
        return reject();
      });
    });
  };

  /**
  	 * [getChannelListing - fetch articles of current user]
  	 * @return
   */
  $scope.getChannelListing = function() {
    if (!$scope.isAuthenticated()) {
      return;
    }
    $scope.ui.contribsLoading = true;
    return FlexikonApi.getChannelListing().success(function(result) {
      var c, contribsTitle, i, len, ref, ref1;
      document.removeEventListener("online", $scope.getChannelListing, false);
      $scope.contribs = [];
      contribsTitle = [];
      ref = result.query.usercontribs;
      for (i = 0, len = ref.length; i < len; i++) {
        c = ref[i];
        if (ref1 = c.title, indexOf.call(contribsTitle, ref1) < 0) {
          contribsTitle.push(c.title);
          $scope.contribs.push(c);
        }
      }
      $scope.ui.contribsLoading = false;
      return $timeout(function() {
        return $scope.render.contributions = true;
      }, 100);
    }).error(function(error) {
      var ref;
      console.warn(error);
      document.removeEventListener("online", $scope.getChannelListing, false);
      document.addEventListener("online", $scope.getChannelListing, false);
      $scope.ui.contribsLoading = false;
      $scope.render.contributions = true;
      if (((ref = $scope.contribs) != null ? ref.length : void 0) > 0) {
        return;
      }
      $scope.contribs = [];
      return $scope.ui.contribsError = true;
    });
  };

  /**
  	 * [closeAllBut - close the other expandables when one is opened]
  	 * @param  {String} id [clicked expandable id]
  	 * @return {[type]}
   */
  $scope.closeAllBut = function(id) {
    return $rootScope.$broadcast('dcexpandable-close-all-but', {
      id: id
    });
  };

  /**
  	 * [openArticle - open article]
  	 * @param  {[type]} page     [page title]
  	 * @param  {[type]} language [article language]
  	 * @return {[type]}
   */
  $scope.openArticle = function($event, page, language) {
    $event.preventDefault();
    $event.stopPropagation();
    if (language == null) {
      language = GlobalSettings.Language();
    }
    page = page.replace(/&[^;]*;/g, '');
    return ExtendedState.openInSameBranch('article', {
      page: ':' + language + ':' + window.decodeURIComponent(page)
    });
  };
  $scope.fetch();
  return $scope.getChannelListing();
});

angular.module("Flexikon.directives").directive('dcFlexikonFavListing', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcFlexikonFavListingTemplate.html',
    controller: 'DcFlexikonFavListingCtrl'
  };
});

angular.module("Flexikon.controllers").controller('DcFlexikonHomeListingCtrl', function($scope, $state, $ionicLoading, $cordovaToast, $ionicScrollDelegate, $timeout, $filter, $rootScope, FlexikonApi, Api, Store) {

  /**
   * [ui - state variables]
   */
  $scope.ui = {
    loading: false,
    lastRefresh: -1
  };

  /**
   * [home - state variables for listing]
   */
  $scope.home = {
    items: [],
    show: 6,
    nomore: false,
    selection: [],
    offset: 0
  };

  /**
   * [ad - include ads regularly]
   * removed
  $scope.ad =
    offset   : 1
    interval : 7
   */

  /**
   * [scrollOnOrientationChange snapScroll after orientation change]
   * @return {[type]} [description]
   */
  $scope.scrollOnOrientationChange = function() {
    $scope.ui.automaticScroll = true;
    return $scope.timeouts.push($timeout(function() {
      var ref;
      if (((ref = $ionicScrollDelegate.$getByHandle('HomeScroll')) != null ? ref.getScrollPosition() : void 0) == null) {
        return;
      }
      return $scope.snapScroll();
    }, 500));
  };
  window.addEventListener('orientationchange', $scope.scrollOnOrientationChange);
  window.addEventListener('resize', $scope.scrollOnOrientationChange);

  /**
   * [watchers]
   */
  $scope.$on('home.leave', function() {
    window.removeEventListener('orientationchange', $scope.scrollOnOrientationChange);
    return window.removeEventListener('resize', $scope.scrollOnOrientationChange);
  });
  $scope.$on('home.enter', function() {
    window.addEventListener('orientationchange', $scope.scrollOnOrientationChange);
    return window.addEventListener('resize', $scope.scrollOnOrientationChange);
  });
  $scope.$on('$destroy', function() {
    window.removeEventListener('orientationchange', $scope.scrollOnOrientationChange);
    return window.removeEventListener('resize', $scope.scrollOnOrientationChange);
  });
  $scope.$on("home.beforeEnter", function() {
    var i, j, ref, ref1, refresh;
    $scope.home.offset = ($scope.home.offset + 3) % $scope.home.items.length;
    for (i = j = ref = $scope.home.offset, ref1 = $scope.home.offset + 2; ref <= ref1 ? j <= ref1 : j >= ref1; i = ref <= ref1 ? ++j : --j) {
      $scope.home.selection.unshift($scope.home.selection.pop());
    }
    refresh = $scope.ui.lastRefresh < 0 || (Date.now() - $scope.ui.lastRefresh) / 1000 / 60 / 60 > 24;
    if (Api.getEnv().indexOf('development') >= 0) {
      if (ionic.Platform.isWebView()) {
        $cordovaToast.showShortBottom('DEBUGGING - In production refresh interval is set to ' + 300 + ' second(s).');
      }
      refresh = $scope.ui.lastRefresh < 0 || (Date.now() - $scope.ui.lastRefresh) / 1000 > 300;
    }
    if (refresh) {
      return $scope.getArticles();
    }
  });
  $rootScope.$on('InAppPurchase-succeeded', function() {
    return $scope.getArticles();
  });
  $scope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState, fromParams) {
    if (fromState.name.indexOf('home') < 0 && toState.name.indexOf('home') >= 0) {
      return $ionicScrollDelegate.scrollTop(true);
    }
  });

  /**
   * [getArticles - get articles for listing]
   * @return
   */
  $scope.getArticles = function() {
    var itemsSave;
    if (($scope.home.items != null) && $scope.home.items.length > 0) {
      itemsSave = $scope.home.items.splice();
    }
    $scope.ui.loading = true;
    $scope.home.items = [];
    return FlexikonApi.getTopListing(200).success(function(result) {
      var ref;
      $scope.ui.lastRefresh = Date.now();
      if (((ref = $scope.home) != null ? ref.items : void 0) != null) {
        $scope.home.items = [];
        $timeout(function() {
          $scope.home.items = result._items.flexikon_top_articles;
          $scope.home.offset = 0;
          $scope.home.selection = $scope.home.items;

          /*
          if !$scope.isOfflineVersion()
            for i in [0..$scope.home.items.length]
              if (i + $scope.ad.offset) % $scope.ad.interval == 0
                $scope.home.items.splice(i, 0, {
                  ad: 'ad'
                  index: i
                  title: 'ad' + i
                })
           */
          $timeout(function() {
            return $ionicScrollDelegate.$getByHandle('HomeScroll').resize();
          });
          return $scope.ui.loading = false;
        });
      } else {
        $scope.home.items = result._items.flexikon_top_articles;
        $timeout(function() {
          return $ionicScrollDelegate.$getByHandle('HomeScroll').resize();
        });
        $scope.ui.loading = false;
      }
      return document.removeEventListener("online", $scope.getArticles, false);
    }).error(function(error) {
      if (itemsSave != null) {
        $scope.home.items = itemsSave;
        $timeout(function() {
          return $ionicScrollDelegate.$getByHandle('HomeScroll').resize();
        });
      }
      $scope.ui.loading = false;
      document.removeEventListener("online", $scope.getArticles, false);
      return document.addEventListener("online", $scope.getArticles, false);
    });
  };
  $scope.getArticles();

  /**
   * [loadMore - infinite load]
   * @return
   */
  $scope.loadMore = function() {
    if ($scope.home.nomore) {
      return;
    }
    if ($scope.home.show + 6 >= $scope.home.items.length) {
      $scope.home.show = $scope.home.items.length;
      $scope.home.nomore = true;
    } else {
      $scope.home.show += 6;
    }
    return $scope.$broadcast('scroll.infiniteScrollComplete');
  };

  /**
   * [isOfflineVersion - check if is premium]
   * @return {Boolean} [is premium version]
   */
  $scope.isOfflineVersion = function() {
    return Store.isOwned('flexikon_offline');
  };
  $scope.screenshotFilter = function(article) {
    return article.title === 'Influenza' || article.title === 'Leber' || article.title === 'Pollen';
  };

  /**
   * [openArticle - open article from listing]
   * @param  {[String]} page [title of page to open]
   * @return
   */
  return $scope.openArticle = function(page) {
    if (page == null) {
      return;
    }
    page = page.replace(/&[^;]*;/g, '').replace(/<(.*?)>/g, '');
    return $state.go('^.article', {
      page: window.decodeURIComponent(page)
    });
  };
});

angular.module("Flexikon.directives").directive('dcFlexikonHomeListing', function($timeout, $ionicScrollDelegate) {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcFlexikonHomeListingTemplate.html',
    controller: 'DcFlexikonHomeListingCtrl',
    link: function(scope, element, attrs) {

      /**
       * [cancelSnap - on tap prevent snap scroll]
       * @return
       */
      scope.cancelSnap = function() {
        return $timeout.cancel(scope.scrollTimeout);
      };

      /**
       * [setDelta - determine scroll correction for snap scroll dependent on scroll direction]
       * @param {[Event]} $event [scroll event]
       * @return
       */
      scope.setDelta = function($event) {
        scope.ui.automaticScroll = true;
        $timeout(function() {
          return scope.ui.automaticScroll = false;
        }, 250, false);
        if ($event.gesture.deltaY < 0) {
          return scope.ui.delta = 1;
        } else {
          return scope.ui.delta = 0;
        }
      };

      /**
       * [onScroll - determine scroll end]
       * @return
       */
      scope.onScroll = function() {
        var snapScrollTimeout;
        $timeout.cancel(scope.scrollTimeout);
        snapScrollTimeout = ionic.Platform.isWebView() && ionic.Platform.isIOS() ? 100 : 100;
        return scope.scrollTimeout = $timeout(function() {
          if (scope.ui.automaticScroll) {
            scope.ui.automaticScroll = false;
            return;
          }
          return scope.snapScroll(false);
        }, snapScrollTimeout);
      };

      /**
       * [snapScroll - snap to article on scroll end]
       * @return
       */
      return scope.snapScroll = function(orientationChange) {
        var columns, itemHeight, scrollHeight, scrollPosition;
        if (orientationChange == null) {
          orientationChange = true;
        }
        return;
        scrollHeight = element.find('ion-content').height();
        if (window.innerHeight > window.innerWidth) {
          itemHeight = scrollHeight * 0.3333;
          columns = 1;
        } else if (window.innerWidth >= 768) {
          itemHeight = scrollHeight * 0.5;
          columns = 2;
        } else {
          itemHeight = scrollHeight;
          columns = 1;
        }
        scrollPosition = $ionicScrollDelegate.$getByHandle('HomeScroll').getScrollPosition().top;
        if (orientationChange && (scope.itemToScroll == null)) {
          return;
        } else if (!orientationChange) {
          scope.itemToScroll = (parseInt(scrollPosition / itemHeight) + scope.ui.delta) * columns;
        }
        scope.ui.delta = 0;
        scope.ui.automaticScroll = true;
        $ionicScrollDelegate.$getByHandle('HomeScroll').scrollTo(0, parseInt(scope.itemToScroll / columns) * itemHeight, true);
      };
    }
  };
});

angular.module("Flexikon.directives").directive('dcFlexikonHomeListingItem', function() {
  return {
    restrict: 'E',
    scope: {
      item: '='
    },
    templateUrl: 'templates/dcFlexikonHomeListingItemTemplate.html',
    link: function(scope, element, attrs) {

      /**
       * DEPRECATED
       */
      scope.hide = function() {
        element.addClass('hidden');
      };

      /**
       * DEPRECATED
       */
      scope.show = function() {
        element.removeClass('hidden');
      };

      /**
       * DEPRECATED
       */
      if (scope.item.ad != null) {
        return scope.hide();
      }
    }
  };
});

angular.module("Flexikon.directives").directive('dcFlexikonSearchItem', function() {
  return {
    restrict: 'E',
    scope: {
      item: '='
    },
    templateUrl: 'templates/dcFlexikonSearchItemTemplate.html'
  };
});

angular.module("Flexikon.controllers").controller('DcFlexikonSectionCtrl', function($scope, $rootScope, $sce, $location, $ionicScrollDelegate, $timeout, WikiHTML, ToC) {

  /**
   * [ui - state variables]
   */
  $scope.ui = {
    edit: $scope.$eval($scope.allowEdit),
    renderAd: false,
    open: parseInt($scope.sectionId) === 1
  };

  /**
   * if is section with title, process it accordingly
   */
  $scope.title = $scope.section.match(/<h2.*>(.*)<\/h2>/g);
  if ($scope.title != null) {
    $scope.id = $scope.title[0].match(/id="(.*)"/)[1];
    $scope.title = $scope.title[0].replace(/<h2[^<]*>|<\/h2>/g, '');
    $scope.section = $scope.section.substr($scope.section.indexOf('</h2>') + '</h2>'.length);
  }

  /**
   * [editAction - set content of this section for editing]
   * @return
   */
  $scope.editAction = function($event) {
    return $scope.sectionEditAction()($event, $scope.title, $scope.sectionId);
  };

  /**
   * [anchorScroll - scroll to this section when opened]
   * @return
   */
  $scope.anchorScroll = function() {
    $timeout(function() {
      var scrollTo;
      scrollTo = angular.element('#' + $scope.id);
      if (scrollTo == null) {
        return;
      }
      return $ionicScrollDelegate.$getByHandle('ArticleScroll').scrollTo(0, scrollTo.closest('dc-flexikon-section').position().top + scrollTo.position().top - 12, true);
    }, 300);
    return $timeout(function() {
      return ToC.setCurrentSection($scope.id);
    }, 500);
  };
  $scope.onOpen = function() {
    $scope.anchorScroll();
    return $scope.ui.open = true;
  };
  return $scope.onClose = function() {
    return $scope.ui.open = false;
  };
});

angular.module("Flexikon.directives").directive('dcFlexikonSection', function($timeout, FontSize) {
  return {
    restrict: 'E',
    scope: {
      section: '=',
      sectionId: '@',
      sectionEditAction: '&',
      allowEdit: '@',
      article: '@'
    },
    templateUrl: 'templates/DcFlexikonSectionTemplate.html',
    controller: 'DcFlexikonSectionCtrl',
    link: function(scope, element, attrs) {
      return $timeout(function() {
        return element.find('.html-content').css('font-size', FontSize.getCurrent() + 'px');
      });
    }
  };
});

angular.module("Flexikon.directives").directive('dcFlexikonToolbar', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcFlexikonToolbarTemplate.html'
  };
});

angular.module("Flexikon.controllers").controller('DcGuidedTourCtrl', function($scope, $timeout, $interval, $window, $filter, $ionicPlatform, GuidedTour, $rootElement, $q) {
  this.KAPPA = .5522848;
  this.STATES = {
    FADE_IN: 0,
    FADE_OUT: 1,
    SHOW: 2,
    HIDE: 3,
    PAUSE: 4,
    WAITING: 5
  };
  this.debug = false;
  this.config = {
    line: {
      color: 'rgba(255,255,255,0.7)',
      width: 3
    },
    arrowHead: {
      color: '255,255,255',
      opacity: '0.7',
      width: 12,
      height: 12
    },
    backdrop: {
      enabled: true,
      color: '0,0,0',
      opacity: '0.7'
    },
    animation: {
      fps: 30,
      shrink: true,
      length: 500
    }
  };
  this.shown = false;
  this.running = false;
  this.state = this.STATES.PAUSE;
  this.frame = 0;
  this.framesPassed = 0;
  this.step = void 0;

  /**
   * [init]
   * @return {[type]} []
   */
  this.init = (function(_this) {
    return function() {
      _this.timeouts = [];
      GuidedTour.registerShowCallback(_this.show);
      GuidedTour.registerHideCallback(_this.hide);
      return GuidedTour.registerCancelCallback(_this.cancel);
    };
  })(this);

  /**
   *    ______      __             _       __   ______                 __  _
   *  /_  __/_  __/ /_____  _____(_)___ _/ /  / ____/_  ______  _____/ /_(_)___  ____  _____
   *   / / / / / / __/ __ \/ ___/ / __ `/ /  / /_  / / / / __ \/ ___/ __/ / __ \/ __ \/ ___/
   *  / / / /_/ / /_/ /_/ / /  / / /_/ / /  / __/ / /_/ / / / / /__/ /_/ / /_/ / / / (__  )
   * /_/  \__,_/\__/\____/_/  /_/\__,_/_/  /_/    \__,_/_/ /_/\___/\__/_/\____/_/ /_/____/
   */

  /**
   * [show]
   * @return {[type]} []
   */
  this.show = (function(_this) {
    return function(config) {
      var ref, scanvas;
      if (config == null) {
        config = {};
      }
      _this.setDimensions();
      window.addEventListener('orientationchange', _this.setDimensions);
      _this.canvas = document.createElement('canvas');
      _this.canvas.width = _this.width;
      _this.canvas.height = _this.height;
      scanvas = document.querySelector('canvas');
      if (typeof canvas !== "undefined" && canvas !== null) {
        _this.sctx = scanvas.getContext("2d");
        _this.ctx = canvas.getContext("2d");
      }
      _this.state = _this.STATES.SHOW;
      _this.resetState();
      _this.shown = true;
      angular.extend(_this.config, config);
      _this.deregisterBackButtonAction = $ionicPlatform.registerBackButtonAction(function() {
        return console.log('disabled');
      }, 600);
      _this.scaleTextOut();
      _this.step = void 0;
      _this.steps = GuidedTour.getSteps();
      _this.root = GuidedTour.getRootElement() || _this.root;
      if ((ref = _this.root) != null) {
        if (typeof ref.addClass === "function") {
          ref.addClass('guided-tour');
        }
      }
      _this.startDrawLoop();
    };
  })(this);

  /**
   * [setDimensions]
   */
  this.setDimensions = (function(_this) {
    return function() {
      _this.height = $window.innerHeight;
      _this.width = $window.innerWidth;
    };
  })(this);

  /**
   * [startFadeIn]
   * @return {[type]} []
   */
  this.startFadeIn = (function(_this) {
    return function() {
      _this.state = _this.STATES.FADE_IN;
    };
  })(this);

  /**
   * [startDrawLoop]
   * @return {[type]} []
   */
  this.startDrawLoop = (function(_this) {
    return function() {
      if (_this.lastFrame == null) {
        ionic.DomUtil.requestAnimationFrame(_this.draw);
      }
    };
  })(this);

  /**
   * [stopDrawLoop]
   * @return {[type]} []
   */
  this.stopDrawLoop = (function(_this) {
    return function() {
      _this.state = _this.STATES.PAUSE;
    };
  })(this);

  /**
   * [getNextStep]
   * @return {[type]} []
   */
  this.getNextStep = (function(_this) {
    return function() {
      var afterStepPromise, ref, ref1;
      afterStepPromise = ((ref = _this.step) != null ? (ref1 = ref.callbacks) != null ? typeof ref1.afterStep === "function" ? ref1.afterStep() : void 0 : void 0 : void 0) || $q.resolve();
      return afterStepPromise.then(function() {
        if (_this.steps.length === 0) {
          return void 0;
        }
        return _this.step = _this.steps.splice(0, 1)[0];
      }).then(function() {
        var ref2, ref3;
        return ((ref2 = _this.step) != null ? (ref3 = ref2.callbacks) != null ? typeof ref3.beforeStep === "function" ? ref3.beforeStep() : void 0 : void 0 : void 0) || $q.resolve();
      }).then(function() {
        return $q(function(resolve) {
          return ionic.DomUtil.requestAnimationFrame(function() {
            return resolve(_this.step);
          });
        });
      });
    };
  })(this);

  /**
   * [draw]
   * @return {[type]}      []
   */
  this.draw = (function(_this) {
    return function() {
      var currentOpacity, steps;
      if ((_this.lastFrame != null) && Date.now() - _this.lastFrame < _this.getIntervalDuration()) {
        return ionic.DomUtil.requestAnimationFrame(_this.draw);
      }
      if ((_this.state === _this.STATES.PAUSE || _this.state === _this.STATES.WAITING) && _this.frame % _this.config.animation.fps <= 1) {
        _this.frame = 0;
        return void 0;
      }
      if (_this.lastFrame == null) {
        _this.frame = (_this.frame + 1) % _this.config.animation.fps;
      } else {
        steps = parseInt((Date.now() - _this.lastFrame) / _this.getIntervalDuration());
        if (_this.config.animation.fps - steps < steps) {
          _this.frame = (_this.frame + steps) % _this.config.animation.fps;
        } else {
          _this.frame = (_this.frame + 1) % _this.config.animation.fps;
        }
      }
      _this.lastFrame = Date.now();
      if (_this.state === _this.STATES.SHOW) {
        if (_this.frame === 0) {
          _this.state = _this.STATES.PAUSE;
          return ionic.DomUtil.requestAnimationFrame(function() {
            return _this.getNextStep().then(function() {
              _this.state = _this.STATES.FADE_IN;
              _this.setText(_this.step.hint);
              _this.resetState();
              return _this.startDrawLoop();
            });
          });
        }
        currentOpacity = parseFloat(_this.config.backdrop.opacity) * _this.getIntervalProgress();
        _this.clearCanvas(_this.config.backdrop.color, currentOpacity);
      } else if (_this.state === _this.STATES.HIDE) {
        if (_this.frame <= 1) {
          _this.hide();
          return ionic.DomUtil.requestAnimationFrame(_this.draw);
        }
        currentOpacity = parseFloat(_this.config.backdrop.opacity) * (1 - _this.getIntervalProgress());
        _this.clearCanvas(_this.config.backdrop.color, currentOpacity);
      } else if (_this.state === _this.STATES.FADE_IN) {
        _this.fadeStepIn();
      } else if (_this.state === _this.STATES.FADE_OUT) {
        _this.fadeStepOut();
      }
      _this.framesPassed++;
      _this.sctx.drawImage(_this.canvas, 0, 0);
      return ionic.DomUtil.requestAnimationFrame(_this.draw);
    };
  })(this);

  /**
   * [resetState]
   * @return {[type]} []
   */
  this.resetState = (function(_this) {
    return function() {
      _this.framesPassed = 0;
      _this.frame = 0;
      _this.lastFrame = void 0;
    };
  })(this);

  /**
   * [proceedToNextStep]
   * @return {[type]} []
   */
  this.proceedToNextStep = (function(_this) {
    return function($event) {
      var promise, ref, ref1;
      if ($event != null) {
        $event.preventDefault();
      }
      if ($event != null) {
        $event.stopPropagation();
      }
      _this.lastFrame = void 0;
      if (_this.state !== _this.STATES.WAITING) {
        return;
      }
      promise = ((ref = _this.step) != null ? (ref1 = ref.callbacks) != null ? typeof ref1.onFadeOut === "function" ? ref1.onFadeOut() : void 0 : void 0 : void 0) || $q.resolve();
      promise.then(function() {
        _this.state = _this.STATES.FADE_OUT;
        return _this.startDrawLoop();
      });
    };
  })(this);

  /**
   * [fadeStepIn]
   * @return {[type]} []
   */
  this.fadeStepIn = (function(_this) {
    return function() {
      var promise, ref, ref1;
      if (_this.frame === 0) {
        _this.state = _this.STATES.PAUSE;
        promise = ((ref = _this.step) != null ? (ref1 = ref.callbacks) != null ? typeof ref1.onHighlight === "function" ? ref1.onHighlight() : void 0 : void 0 : void 0) || $q.resolve();
        promise.then(function() {
          _this.frame = _this.config.animation.fps - 1;
          if (_this.step != null) {
            _this.highlightElements(_this.step.selector, _this.config.animation.fps, false);
          }
          _this.resetState();
          return _this.state = _this.STATES.WAITING;
        });
        return;
      }
      _this.clearCanvas();
      if (_this.step != null) {
        _this.highlightElements(_this.step.selector, _this.config.animation.fps, false);
        if (_this.step.hint != null) {
          _this.setText(_this.step.hint);
        }
      }
      return _this.scaleTextIn();
    };
  })(this);

  /**
   * [fadeStepOut]
   * @return {[type]} []
   */
  this.fadeStepOut = (function(_this) {
    return function() {
      var ref, ref1;
      if (_this.frame === 0) {
        if (_this.steps.length === 0) {
          _this.state = _this.STATES.HIDE;
          if ((ref = _this.step) != null) {
            if ((ref1 = ref.callbacks) != null) {
              if (typeof ref1.afterStep === "function") {
                ref1.afterStep();
              }
            }
          }
          GuidedTour.setPassed();
        } else {
          _this.state = _this.STATES.PAUSE;
          ionic.DomUtil.requestAnimationFrame(function() {
            return _this.getNextStep().then(function() {
              _this.state = _this.STATES.FADE_IN;
              _this.resetState();
              return _this.startDrawLoop();
            });
          });
        }
        _this.resetState();
        return;
      }
      _this.scaleTextOut();
      _this.clearCanvas();
      return _this.highlightElements(_this.step.selector, _this.config.animation.fps, true);
    };
  })(this);

  /**
   * [highlightElements ]
   * @param  {[type]} elements=[] []
   * @param  {[type]} duration    []
   * @param  {[type]} fade=false  []
   * @return {[type]}             []
   */
  this.highlightElements = (function(_this) {
    return function(elements, duration, fade) {
      var element, j, len, progress;
      if (elements == null) {
        elements = [];
      }
      if (fade == null) {
        fade = false;
      }
      progress = _this.getIntervalProgress();
      if (fade) {
        progress = 1 - progress;
        if (_this.steps.length === 0) {
          _this.clearCanvas('0,0,0', progress * parseFloat(_this.config.backdrop.opacity));
        }
      }
      for (j = 0, len = elements.length; j < len; j++) {
        element = elements[j];
        _this.highlightElement(element, duration, fade);
      }
      if (_this.framesPassed >= duration) {
        _this.state = _this.STATES.WAITING;
        _this.resetState();
      }
    };
  })(this);
  this.showText = function(progress) {
    return $('#guided-tour #hint').css('opacity', progress);
  };
  this.scaleTextIn = function() {
    $('#guided-tour #hint').css('-webkit-transform', 'scale3D(1, 1, 1)');
    return $('#guided-tour #hint').css('transform', 'scale3D(1, 1, 1)');
  };
  this.scaleTextOut = function() {
    $('#guided-tour #hint').css('-webkit-transform', 'scale3D(0, 1, 1)');
    return $('#guided-tour #hint').css('transform', 'scale3D(0, 1, 1)');
  };

  /**
   * [highlightElement]
   * @param  {[type]} element  []
   * @param  {[type]} duration []
   * @param  {[type]} fade     []
   * @return {[type]}          []
   */
  this.highlightElement = (function(_this) {
    return function(element, duration, fade) {
      var domElement, progress;
      if (element.global) {
        domElement = angular.element(element.name);
      } else {
        domElement = _this.root.find(element.name);
      }
      if (domElement.length === 0) {
        return;
      }
      progress = _this.getIntervalProgress();
      if (fade) {
        progress = 1 - progress;
      }
      _this.prepareBrush('rgba(255,255,255,' + progress + ')', 'destination-out');
      if (element.shape === 'round') {
        _this.drawEllipse(domElement[0].getBoundingClientRect().left - 10, domElement[0].getBoundingClientRect().top - 10, domElement[0].offsetWidth + 20, domElement[0].offsetHeight + 20, 10);
      } else {
        _this.drawRoundedRectangle(domElement[0].getBoundingClientRect().left - 10, domElement[0].getBoundingClientRect().top - 10, domElement[0].offsetWidth + 20, domElement[0].offsetHeight + 20, 10, 1);
      }
      if (!fade && !_this.hideArrows() && !element.noArrow) {
        return _this.drawArrowToElement(domElement, progress, fade && !_this.config.animation.shrink);
      }
    };
  })(this);

  /**
   * [hideArrows]
   * @return {Boolean} []
   */
  this.hideArrows = function() {
    return (this.width > this.height && this.height < 768) || (this.height > this.width && this.height <= 480);
  };

  /**
   * [getIntervalDuration]
   * @return {[type]} []
   */
  this.getIntervalDuration = (function(_this) {
    return function() {
      return 1000 / _this.config.animation.fps * _this.config.animation.length / 1000;
    };
  })(this);

  /**
   * [getIntervalProgress]
   * @return {[type]} []
   */
  this.getIntervalProgress = (function(_this) {
    return function() {
      return _this.frame / (_this.config.animation.fps - 1);
    };
  })(this);

  /**
   * [hide]
   * @return {[type]} []
   */
  this.hide = (function(_this) {
    return function($event) {
      var ref;
      if ($event != null) {
        $event.preventDefault();
      }
      if ($event != null) {
        $event.stopPropagation();
      }
      if ((ref = _this.root) != null) {
        if (typeof ref.removeClass === "function") {
          ref.removeClass('guided-tour');
        }
      }
      _this.resetState();
      _this.deregisterBackButtonAction();
      $interval.cancel(_this.drawLoop);
      _this.clearCanvas('0,0,0', 0);
      GuidedTour.setPassed();
      $timeout(function() {
        _this.shown = false;
        _this.step = void 0;
        _this.setText('');
        _this.scaleTextOut();
        return _this.stopDrawLoop();
      });
      window.removeEventListener('orientationchange', _this.setDimensions);
    };
  })(this);

  /**
   *      _________    _   ___    _____   _____    __  ____________________    ____________  __
   *     / ____/   |  / | / / |  / /   | / ___/   / / / /_  __/  _/_  __/ /   /  _/_  __/\ \/ /
   *   / /   / /| | /  |/ /| | / / /| | \__ \   / / / / / /  / /  / / / /    / /  / /    \  /
   *  / /___/ ___ |/ /|  / | |/ / ___ |___/ /  / /_/ / / / _/ /  / / / /____/ /  / /     / /
   *  \____/_/  |_/_/ |_/  |___/_/  |_/____/   \____/ /_/ /___/ /_/ /_____/___/ /_/     /_/
   */

  /**
   * [getRGBAColor]
   * @param  {[type]} color   []
   * @param  {[type]} opacity []
   * @return {[type]}         []
   */
  this.getRGBAColor = function(color, opacity) {
    if (opacity == null) {
      return 'rgba(' + color + ', 1)';
    }
    return 'rgba(' + color + ',' + opacity + ')';
  };

  /**
   * [clearCanvas]
   * @return {[type]} []
   */
  this.clearCanvas = (function(_this) {
    return function(color, opacity) {
      if (color == null) {
        color = _this.config.backdrop.color;
      }
      if (opacity == null) {
        opacity = _this.config.backdrop.opacity;
      }
      _this.ctx.canvas.width = _this.width;
      _this.ctx.canvas.height = _this.height;
      _this.ctx.clearRect(0, 0, _this.ctx.canvas.width, _this.ctx.canvas.height);
      _this.ctx.fillStyle = _this.getRGBAColor(color, opacity);
      _this.ctx.fillRect(0, 0, _this.width, _this.height);
    };
  })(this);

  /**
   * [drawArrowHead]
   * @param  {[type]} arrow   []
   * @param  {[type]} start []
   * @param  {[type]} stepEnd   []
   * @param  {[type]} alpha   []
   * @return {[type]}         []
   */
  this.drawArrowHead = (function(_this) {
    return function(arrow, start, stepEnd, opacity, control, bezierEnd, bezierControl) {
      var angle, hx, hy, sizex, sizey;
      sizex = 18;
      sizey = 18;
      angle = _this.findBezierAngle(opacity, start, stepEnd, control, bezierEnd, bezierControl);
      angle += Math.PI / 2;
      hx = sizex / 2;
      hy = sizey / 2;
      _this.ctx.translate(stepEnd.x, stepEnd.y);
      _this.ctx.rotate(angle);
      _this.ctx.translate(-hx, -hy);
      _this.ctx.beginPath();
      _this.ctx.moveTo(0, 0);
      _this.ctx.lineTo(0, 1 * sizey);
      _this.ctx.lineTo(1 * sizex, 1 * hy);
      _this.ctx.closePath();
      _this.ctx.fill();
      _this.ctx.setTransform(1, 0, 0, 1, 0, 0);
    };
  })(this);

  /**
   * [drawEllipse]
   * @param  {[type]} x   []
   * @param  {[type]} y   []
   * @param  {[type]} w   []
   * @param  {[type]} h   []
   * @param  {[type]} r=0 []
   * @param  {[type]} a   []
   * @return {[type]}     []
   */
  this.drawEllipse = (function(_this) {
    return function(x, y, w, h, r, a) {
      var ox, oy, xe, xm, ye, ym;
      if (r == null) {
        r = 0;
      }
      x -= r / 2;
      y -= r / 2;
      w += r;
      h += r;
      ox = (w / 2) * _this.KAPPA;
      oy = (h / 2) * _this.KAPPA;
      xe = x + w;
      ye = y + h;
      xm = x + w / 2;
      ym = y + h / 2;
      _this.ctx.beginPath();
      _this.ctx.moveTo(x, ym);
      _this.ctx.bezierCurveTo(x, ym - oy, xm - ox, y, xm, y);
      _this.ctx.bezierCurveTo(xm + ox, y, xe, ym - oy, xe, ym);
      _this.ctx.bezierCurveTo(xe, ym + oy, xm + ox, ye, xm, ye);
      _this.ctx.bezierCurveTo(xm - ox, ye, x, ym + oy, x, ym);
      _this.ctx.closePath();
      _this.ctx.fill();
      _this.ctx.lineJoin = _this.ctx.lineCap = 'round';
      _this.ctx.shadowBlur = 20;
      _this.ctx.lineWidth = 0;
      return _this.ctx.stroke();
    };
  })(this);

  /**
   * [drawEllipseByCenter]
   * @param  {[type]} cx    []
   * @param  {[type]} cy    []
   * @param  {[type]} w     []
   * @param  {[type]} h     []
   * @param  {[type]} dummy []
   * @param  {[type]} a     =             10 []
   * @return {[type]}       []
   */
  this.drawEllipseByCenter = (function(_this) {
    return function(cx, cy, w, h, dummy, a) {
      if (a == null) {
        a = 10;
      }
      _this.drawEllipse(cx - w / 2.0, cy - h / 2.0, w, h, dummy, a);
    };
  })(this);

  /**
   * [drawRoundedRectangle]
   * @param  {[type]} x []
   * @param  {[type]} y []
   * @param  {[type]} w []
   * @param  {[type]} h []
   * @param  {[type]} r []
   * @param  {[type]} a =             10 []
   * @return {[type]}   []
   */
  this.drawRoundedRectangle = (function(_this) {
    return function(x, y, w, h, r, a) {
      if (a == null) {
        a = 10;
      }
      if (w < 2 * r) {
        r = w / 2;
      }
      if (h < 2 * r) {
        r = h / 2;
      }
      _this.ctx.beginPath();
      _this.ctx.moveTo(x + r, y);
      _this.ctx.arcTo(x + w, y, x + w, y + h, r);
      _this.ctx.arcTo(x + w, y + h, x, y + h, r);
      _this.ctx.arcTo(x, y + h, x, y, r);
      _this.ctx.arcTo(x, y, x + w, y, r);
      _this.ctx.closePath();
      _this.ctx.fill();
      _this.ctx.lineJoin = _this.ctx.lineCap = 'round';
      _this.ctx.shadowBlur = 20;
      _this.ctx.lineWidth = 0;
      _this.ctx.stroke();
    };
  })(this);

  /**
   * [getQuadraticBezierPoint]
   * @param  {[type]} step    []
   * @param  {[type]} anchor1 []
   * @param  {[type]} anchor2 []
   * @param  {[type]} control []
   * @return {[type]}         []
   */
  this.getQuadraticBezierPoint = function(step, anchor1, anchor2, control) {
    var x, y;
    x = (1 - step) * (1 - step) * anchor1.x + 2 * (1 - step) * step * control.x + step * step * anchor2.x;
    y = (1 - step) * (1 - step) * anchor1.y + 2 * (1 - step) * step * control.y + step * step * anchor2.y;
    return {
      x: x,
      y: y
    };
  };

  /**
   * [prepareBrush]
   * @param  {[type]} strokeStyle              []
   * @param  {[type]} globalCompositeOperation []
   * @param  {[type]} fillStyle=strokeStyle    []
   * @return {[type]}                          []
   */
  this.prepareBrush = (function(_this) {
    return function(strokeStyle, globalCompositeOperation, fillStyle) {
      if (fillStyle == null) {
        fillStyle = strokeStyle;
      }
      _this.ctx.strokeStyle = _this.strokeStyle = strokeStyle;
      _this.ctx.fillStyle = _this.fillStyle = fillStyle;
      _this.ctx.globalCompositeOperation = _this.globalCompositeOperation = globalCompositeOperation || _this.globalCompositeOperation;
    };
  })(this);

  /**
   * [setText]
   * @param {[type]} text []
   */
  this.setText = (function(_this) {
    return function(text) {
      if (_this.text === $filter('translate')(text)) {
        return;
      }
      return $timeout(function() {
        _this.text = $filter('translate')(text);
        return $scope.getSelf().find('.content').html(_this.text);
      }, 0, false);
    };
  })(this);

  /**
   * [clearText]
   * @return {[type]} []
   */
  this.clearText = (function(_this) {
    return function() {
      _this.animate.fadeOut = true;
      _this.timeouts.push($timeout(function() {
        return _this.setText('');
      }, 250, false));
      return _this.timeouts.push($timeout(function() {
        return _this.animate.fadeOut = false;
      }, 500, false));
    };
  })(this);

  /**
   * [checkForIntersection]
   * @param  {[type]} element ]
   * @return {[type]}         ]
   */
  this.checkForIntersection = function(element) {
    var $hint, cHighlightBottom, cHighlightTop, hintBottom, hintTop;
    $hint = $scope.getSelf().find('#hint');
    hintTop = $hint[0].getBoundingClientRect().top;
    hintBottom = hintTop + $hint[0].offsetHeight;
    cHighlightTop = element[0].getBoundingClientRect().top;
    cHighlightBottom = element[0].getBoundingClientRect().top + element[0].offsetHeight;
    if (hintTop >= cHighlightTop && hintTop <= cHighlightBottom || hintBottom >= cHighlightTop && hintBottom <= cHighlightBottom) {
      return true;
    }
    return false;
  };

  /**
   * [avoidIntersection]
   * @return {[type]} []
   */
  this.avoidIntersection = (function(_this) {
    return function() {
      var h, j, len, ref;
      ref = _this.currentHighlight;
      for (j = 0, len = ref.length; j < len; j++) {
        h = ref[j];
        if (_this.checkForIntersection(h.el)) {
          return true;
        }
      }
      return false;
    };
  })(this);

  /**
   * [drawArrowToElement]
   * @param  {[type]} element                  []
   * @param  {[type]} alpha=@cc.animationSteps []
   * @return {[type]}                          []
   */
  this.drawArrowToElement = (function(_this) {
    return function(element, opacity, fade) {
      var $hint, bezierControl, bezierEnd, fadeOpacity, start, stepControl, stepEnd;
      $hint = $scope.getSelf().find('#hint');
      start = {
        x: _this.width / 2
      };
      bezierEnd = {
        x: element[0].getBoundingClientRect().left + element[0].offsetWidth / 2
      };

      /*
      if bezierEnd.x > start.x
        start.x += 24
      else
        start.x -= 24
       */
      if ($hint[0].getBoundingClientRect().top > element[0].getBoundingClientRect().top + element[0].offsetHeight) {
        start.y = $hint[0].getBoundingClientRect().top - 12;
        bezierEnd.y = element[0].getBoundingClientRect().bottom + 24;
      } else {
        start.y = $hint[0].getBoundingClientRect().bottom + 12;
        bezierEnd.y = element[0].getBoundingClientRect().top - 24;
      }
      bezierControl = {
        x: bezierEnd.x,
        y: start.y
      };
      _this.prepareBrush(_this.getRGBAColor('255,255,255,1'), 'source-over');
      _this.drawEllipseByCenter(start.x, start.y, 12, 12);
      _this.drawEllipseByCenter(start.x, start.y, 6, 6);

      /*
      bezierControl =
        x : start.x
        y : bezierEnd.y
       */
      if (!fade) {
        stepEnd = _this.getQuadraticBezierPoint(opacity, start, bezierEnd, bezierControl);
        stepControl = {
          x: bezierEnd.x - (1 - opacity) * (bezierEnd.x - start.x),
          y: start.y
        };

        /*
        stepControl =
          x : start.x
          y : bezierEnd.y - (1 - opacity) * (bezierEnd.y - start.y)
         */
        _this.prepareBrush(_this.getRGBAColor('255,255,255', opacity), 'source-over');
        _this.drawCubic(start, stepEnd, opacity, stepControl);
        _this.drawArrowHead({
          h: 12,
          w: 12
        }, start, stepEnd, opacity, stepControl, bezierEnd, bezierControl);
      } else {
        fadeOpacity = 1 - 1 / _this.config.animation.fps;
        stepEnd = _this.getQuadraticBezierPoint(fadeOpacity, start, bezierEnd, bezierControl);
        stepControl = {
          x: bezierEnd.x - (1 - fadeOpacity) * (bezierEnd.x - start.x),
          y: start.y
        };
        _this.prepareBrush(_this.getRGBAColor('255,255,255', opacity), 'source-over');
        _this.drawCubic(start, stepEnd, opacity, stepControl);
        _this.drawArrowHead({
          h: 12,
          w: 12
        }, start, stepEnd, fadeOpacity, stepControl, bezierEnd, bezierControl);
      }
    };
  })(this);
  this.drawDebugCircle = (function(_this) {
    return function(point, color, radius) {
      if (color == null) {
        color = 'white';
      }
      if (radius == null) {
        radius = 12;
      }
      if (!_this.debug) {
        return;
      }
      _this.prepareBrush(color, 'source-over');
      _this.drawEllipseByCenter(point.x, point.y, radius, radius);
      _this.ctx.stroke();
    };
  })(this);

  /**
   * [drawCubic]
   * @param  {[type]} startPt []
   * @param  {[type]} endPt   []
   * @param  {[type]} alpha   []
   * @return {[type]}         []
   */
  this.drawCubic = (function(_this) {
    return function(startPt, endPt, alpha, control) {
      _this.drawDebugCircle(control, 'red', 12);
      _this.ctx.moveTo(startPt.x, startPt.y);
      _this.ctx.lineWidth = 4;
      _this.ctx.quadraticCurveTo(control.x, control.y, endPt.x, endPt.y);
      _this.ctx.stroke();
    };
  })(this);

  /**
   * [drawLine]
   * @param  {[type]} startPt []
   * @param  {[type]} endPt   []
   * @param  {[type]} alpha   []
   * @return {[type]}         []
   */
  this.drawLine = (function(_this) {
    return function(startPt, endPt, alpha) {
      _this.ctx.moveTo(startPt.x, startPt.y);
      _this.ctx.lineWidth = 3;
      _this.ctx.lineTo(endPt.x, endPt.y);
      _this.ctx.stroke();
    };
  })(this);

  /**
   * [drawCalculatedBezier - helper]
   * @param  {[type]} start   []
   * @param  {[type]} end     []
   * @param  {[type]} control []
   * @return {[type]}         []
   */
  this.drawCalculatedBezier = (function(_this) {
    return function(start, end, control) {
      var i, point, results, step, steps;
      if (!_this.debug) {
        return;
      }
      steps = 10;
      i = 0;
      results = [];
      while (i < steps) {
        step = i / 10;
        point = _this.getQuadraticBezierPoint(step, start, end, control);
        _this.drawDebugCircle(point, 'yellow', 8);
        results.push(i++);
      }
      return results;
    };
  })(this);

  /**
   * [findBezierAngle]
   * @param  {[type]} value         []
   * @param  {[type]} anchor1       []
   * @param  {[type]} anchor2       []
   * @param  {[type]} control       []
   * @param  {[type]} bezierEnd     []
   * @param  {[type]} bezierControl []
   * @return {[type]}               []
   */
  this.findBezierAngle = (function(_this) {
    return function(value, anchor1, anchor2, control, bezierEnd, bezierControl) {
      var a, alpha, b, c, na1, na2;
      na1 = _this.getQuadraticBezierPoint(value - 0.1, anchor1, bezierEnd, bezierControl);
      na2 = _this.getQuadraticBezierPoint(value + 0.1, anchor1, bezierEnd, bezierControl);
      _this.drawDebugCircle(na1, 'orange', 8);
      _this.drawDebugCircle(na2, 'orange', 8);
      a = Math.abs(na2.y - na1.y);
      b = Math.abs(na2.x - na1.x);
      c = Math.sqrt(a * a + b * b);
      if (na1.x > na2.x && na1.y <= na2.y || na1.y > na2.y && na1.x <= na2.x) {
        alpha = Math.PI * 2 - Math.atan2(a, b) + Math.PI / 2;
      } else {
        alpha = Math.atan2(a, b) + Math.PI * 1.5;
      }
      if (na1.y > na2.y) {
        alpha += Math.PI;
      }
      return alpha;
    };
  })(this);
  this.init();
});

angular.module("Flexikon.directives").directive('dcGuidedTour', function() {
  return {
    restrict: 'E',
    replace: true,
    scope: {
      steps: '&',
      rootElement: '='
    },
    templateUrl: 'templates/DcGuidedTourTemplate.html',
    controller: 'DcGuidedTourCtrl as gtc',
    bindToController: true,
    link: function(scope, element, attrs) {
      return scope.getSelf = function() {
        return element;
      };
    }
  };
});

angular.module("Flexikon.services").factory("GuidedTour", function($rootElement) {
  return {

    /**
     * [currentSteps]
     * @type {Array}
     */
    currentSteps: [],
    rootElement: $rootElement,
    context: 'introduction',
    closable: true,
    homeSteps: [
      {
        selector: [
          {
            name: 'a[icon="fa fa-home"]',
            shape: 'round'
          }
        ],
        hint: 'DC_TUTORIAL_OVERLAY_HOME'
      }, {
        selector: [
          {
            name: 'a[icon="fa fa-heart"]',
            shape: 'round'
          }
        ],
        hint: 'DC_TUTORIAL_OVERLAY_BOOKMARK'
      }, {
        selector: [
          {
            name: 'a[icon="fa fa-search"]',
            shape: 'round'
          }
        ],
        hint: 'DC_TUTORIAL_OVERLAY_SEARCH'
      }, {
        selector: [
          {
            name: 'a[icon="fa fa-cog"]',
            shape: 'round'
          }
        ],
        hint: 'DC_TUTORIAL_OVERLAY_SETTINGS'
      }
    ],

    /**
     * [registerShowCallback]
     * @param  {Function} callback []
     * @return
     */
    registerShowCallback: function(callback) {
      this.show = callback;
    },

    /**
     * [registerHideCallback]
     * @param  {Function} callback []
     * @return
     */
    registerHideCallback: function(callback) {
      this.hide = callback;
    },

    /**
     * [registerCancelCallback]
     * @param  {Function} callback []
     * @return
     */
    registerCancelCallback: function(callback) {
      this.cancel = callback;
    },

    /**
     * [setSteps]
     * @param {Array} steps []
     * @return
     */
    setSteps: function(steps) {
      return this.currentSteps = steps;
    },

    /**
     * [getSteps]
     * @param  {String} identifier []
     * @return {Array}  [prepared steps array]
     */
    getSteps: function(identifier) {
      if ((identifier != null) && this[identifier]) {
        return this[identifier].slice();
      }
      return this.currentSteps;
    },
    setRootElement: function(element) {
      return this.rootElement = element || $rootElement;
    },
    getRootElement: function() {
      return this.rootElement;
    },

    /**
     * [setContext description]
     * @param
     */
    setContext: function(context) {
      this.context = context;
    },

    /**
     * [getContext]
     * @return {String} [context]
     */
    getContext: function() {
      return this.context;
    },

    /**
     * [setClosable]
     * @param {Boolean} closable []
     * @return
     */
    setClosable: function(closable) {
      this.closable = closable;
    },

    /**
     * [isClosable]
     * @return {Boolean} []
     */
    isClosable: function() {
      return this.closable;
    },

    /**
     * [setPassed]
     */
    setPassed: function() {
      return localStorage.setItem(this.context, 'done');
    },

    /**
     * [isPassed]
     * @param  {String}  context=@context []
     * @return {Boolean}                  []
     */
    isPassed: function(context) {
      if (context == null) {
        context = this.context;
      }
      return (localStorage.getItem(context) != null) && localStorage.getItem(context) === 'done';
    },

    /**
     * [cancel]
     * @return
     */
    cancel: function() {
      this.cancel();
    },

    /**
     * [stop]
     * @return
     */
    stop: function() {
      this.hide();
    },

    /**
     * [start]
     * @param  {[type]} context       [description]
     * @param  {[type]} steps         [description]
     * @param  {[type]} closable=true [description]
     * @return {[type]}               [description]
     */
    start: function(context, steps, closable) {
      if (closable == null) {
        closable = true;
      }
      this.setContext(context);
      this.setSteps(steps);
      this.setClosable(closable);
      if (!this.isPassed()) {
        this.show();
      }
    }
  };
});

angular.module("Flexikon.directives").directive('dcFullWidth', function() {
  return {
    restrict: 'A',
    scope: true,
    link: function(scope, element, attrs) {

      /**
      		 * full width directive for removing horizontal offset
       */
      return element.css('margin-left', '-' + element.offset().left + 'px');
    }
  };
});

angular.module("Flexikon.directives").directive('dcHint', function() {
  return {
    restrict: 'E',
    scope: {
      text: '@',
      closeAction: '&'
    },
    templateUrl: 'templates/DcHintTemplate.html'
  };
});

angular.module("Flexikon.controllers").controller('DcIconButtonCtrl', function($scope) {

  /**
  	 * [onClick - execute on click action]
  	 * @param  {[Event]} $event [click event]
  	 * @return
   */
  return $scope.onClick = function($event) {
    return $scope.action({
      event: $event
    });
  };
});

angular.module("Flexikon.directives").directive('dcIconButton', function() {
  return {
    restrict: 'E',
    scope: {
      icon: '@',
      action: '&',
      label: '@'
    },
    templateUrl: 'templates/DcIconButtonTemplate.html',
    controller: 'DcIconButtonCtrl'
  };
});

angular.module("Flexikon.directives").directive('dcLoadError', function() {
  return {
    restrict: 'E',
    scope: {
      message: '@',
      icon: '@',
      crossed: '@'
    },
    templateUrl: 'templates/DcLoadErrorTemplate.html'
  };
});

angular.module("Flexikon.directives").directive('dcInput', function() {
  return {
    restrict: 'E',
    templateUrl: 'templates/DcInputTemplate.html',
    scope: {
      labelText: '@',
      hintText: '@',
      requiredHintText: '@',
      icon: '@',
      iconAction: '&',
      required: '=',
      model: '=',
      editable: '=',
      valid: '=',
      validHint: '@'
    },
    transclude: true
  };
});

angular.module("Flexikon.controllers").controller('DcLoadingSpinnerCtrl', function($scope) {
  var ua, version;
  $scope.ui = {
    icon: 'spiral'
  };

  /**
  	 * [ua - set different spinner for ensure animation if is older android version]
   */
  ua = navigator.userAgent;
  if (ua.indexOf("Android") >= 0) {
    version = parseFloat(ua.slice(ua.indexOf("Android") + 8));
    if (version <= 4.3) {
      return $scope.ui.icon = 'android';
    }
  }
});

angular.module("Flexikon.directives").directive('dcLoadingSpinner', function() {
  return {
    restrict: 'E',
    scope: {
      answer: '@'
    },
    templateUrl: 'templates/DcLoadingSpinnerTemplate.html',
    controller: 'DcLoadingSpinnerCtrl'
  };
});

angular.module("Flexikon.controllers").controller('DcLoginCtrl', function($scope, $timeout, Login, Load) {
  $scope.form = {
    user: '',
    pw: ''
  };
  $scope.$watchGroup(['form.user', 'form.pw'], function(o, n) {
    $scope.failed = false;
    return $scope.form.submitted = false;
  });

  /**
  	 * [submitLogin - submit login]
  	 * @return
   */
  $scope.submitLogin = function() {
    if ($scope.form.user && $scope.form.pw) {
      Load.isBlocked(true);
      return Login.sendLoginRequest($scope.form.user, $scope.form.pw, function(data, status, headers, config) {
        $scope.form.user = "";
        $scope.form.pw = "";
        $scope.form.submitted = false;
        $scope.form.failed = false;
        $scope.form.noConnection = false;
        return Load.isBlocked(false);
      }, function(data, status, headers, config) {
        var ref1;
        $scope.form.pw = "";
        $scope.form.submitted = true;
        if (status === 0) {
          $scope.form.noConnection = true;
          $scope.form.failed = false;
        } else {
          $scope.form.failed = true;
          $scope.form.noConnection = false;
          if (((ref1 = data.strErrorMessage) != null ? ref1.length : void 0) > 0) {
            $scope.form.errorMsg = data.strErrorMessage;
          }
        }
        return Load.isBlocked(false);
      });
    } else {
      return $scope.form.submitted = true;
    }
  };

  /**
  	 * [openUrl - open PW forgotten or register link in external browser]
  	 * @param  {[String]} url [url to navigate to]
  	 * @return
   */
  return $scope.openUrl = function(url) {
    var ref;
    if (typeof cordova !== "undefined" && cordova !== null) {
      return ref = window.open(url, "_system");
    } else {
      return window.open(url, "_blank");
    }
  };
});

angular.module("Flexikon.directives").directive('dcLogin', function() {
  return {
    restrict: 'E',
    require: '',
    scope: {
      infoText: '@'
    },
    templateUrl: 'templates/DcLoginTemplate.html',
    controller: 'DcLoginCtrl'
  };
});

angular.module("Flexikon.controllers").controller('DcMediaCtrl', function($scope) {

  /**
  	 * implement MediaViewer in future release
  	 * (wait for backend rework)
   */
});

angular.module("Flexikon.directives").directive('dcmedia', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcMediaTemplate.html',
    controller: 'DcMediaCtrl'
  };
});

angular.module("Flexikon.directives").directive('dcmediaviewer', function(PicturesApi, $ionicGesture, $timeout, $ionicSlideBoxDelegate, NavBar, PictureSlider) {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcMediaViewerTemplate.html',
    link: function(scope, element, attrs) {
      scope.pictures = {
        ids: attrs.items.replace(/img_/g, '').split(',')
      };
      scope.current = {
        index: 0
      };
      scope.ui = {
        width: window.innerWidth,
        widththird: window.innerWidth / 3,
        loading: true,
        error: false,
        noPictures: false,
        maxHeight: 200
      };
      scope.slider = {
        position: 0
      };
      PicturesApi.getPicturesForMediaViewer(scope.pictures.ids).success(function(result) {
        if (result.length === 0) {
          scope.pictures.results = [];
          scope.ui.nopictures = true;
          return;
        }
        scope.ui.nopictures = false;
        return scope.pictures.results = result._items.pictures_photo_app;
      }).error(function(error) {
        console.warn(error);
        return scope.ui.error = true;
      })["finally"](function() {
        return scope.ui.loading = false;
      });
      scope.onSliderHide = function(index) {
        scope.current.index = index;
        return scope.setScrollPosition();
      };
      scope.getSliderStyle = function() {
        return {
          '-webkit-transform': 'translate3d(-' + scope.slider.position + 'px, 0, 0)',
          'transform': 'translate3d(-' + scope.slider.position + 'px, 0, 0)'
        };
      };
      scope.clicked = function($event, $index) {
        if (scope.current.index === $index) {
          scope.modalapi.show(scope.pictures.results, '', scope.current.index);
          return;
        }
        scope.current.index = $index;
        scope.slider.position = scope.current.index * $event.target.width;
      };
      scope.increaseIndex = function(apply) {
        if (apply == null) {
          apply = false;
        }
        if (scope.current.index < scope.pictures.results.length - 1) {
          scope.current.index++;
          return scope.setScrollPosition(apply);
        }
      };
      scope.decreaseIndex = function(apply) {
        if (apply == null) {
          apply = false;
        }
        if (scope.current.index > 0) {
          scope.current.index--;
          return scope.setScrollPosition(apply);
        }
      };
      scope.goToIndex = function(index) {
        scope.current.index = index;
        return scope.setScrollPosition();
      };
      scope.close = function() {
        return scope.ui.bigPicture = false;
      };
      scope.getItemDimension = function() {
        var dim, margin;
        dim = scope.ui.width / 3;
        margin = 0;
        if (scope.ui.width / 3 > scope.ui.maxHeight) {
          margin = (dim - scope.ui.maxHeight + 20) / 2;
          dim = scope.ui.maxHeight - 20;
        }
        return {
          'width': dim + 'px',
          'height': dim + 'px',
          'margin': margin + 'px'
        };
      };
      scope.setScrollPosition = function(apply) {
        if (apply == null) {
          apply = false;
        }
        scope.slider.position = scope.current.index * scope.ui.width / 3;
        if (apply) {
          return scope.$$phase || scope.$digest();
        }
      };
      scope.refresh = function() {
        var width;
        scope.setScreenWidth();
        scope.$$phase || scope.$digest(function() {
          scope.getItemDimension();
          return scope.setScrollPosition();
        });
        width = window.innerWidth;
        return $timeout(function() {
          if (width === window.innerWidth) {
            return;
          }
          scope.setScreenWidth();
          return scope.$$phase || scope.$digest(function() {
            scope.getItemDimension();
            scope.setScrollPosition();
            return $timeout(function() {
              return scope.setScrollPosition();
            });
          });
        }, 1000);
      };
      window.addEventListener('orientationchange', scope.refresh);
      scope.setScreenWidth = function() {
        scope.ui.width = window.innerWidth - 12;
        return scope.ui.widththird = (window.innerWidth - 12) / 3;
      };

      /**
      		 *
      		 *	Gesture handling
      		 *
       */

      /**
      		 * [onDragLeft - drag left gesture]
      		 * @return
       */
      scope.onDragLeft = function() {
        event.preventDefault();
        event.stopPropagation();
        event.gesture.stopDetect();
        event.gesture.preventDefault();
        event.gesture.stopPropagation();
        if (scope.current.index < scope.pictures.results.length - 1) {
          return scope.increaseIndex(true);
        }
      };
      scope.dragLeftAction = $ionicGesture.on('dragleft', scope.onDragLeft, element);

      /**
      		 * [onDragRight - drag right gesture]
      		 * @return
       */
      scope.onDragRight = function() {
        event.preventDefault();
        event.stopPropagation();
        event.gesture.stopDetect();
        event.gesture.preventDefault();
        event.gesture.stopPropagation();
        if (scope.current.index > 0) {
          return scope.decreaseIndex(true);
        }
      };
      scope.dragRightAction = $ionicGesture.on('dragright', scope.onDragRight, element);

      /**
      		 * [remove drag gesture handlers on destroy]
       */
      scope.$on('$destroy', function() {
        window.removeEventListener('orientationchange', scope.refresh);
        $ionicGesture.off(scope.dragLeftAction, 'dragleft', scope.onDragLeft);
        return $ionicGesture.off(scope.dragRightAction, 'dragright', scope.onDragRight);
      });
      return PictureSlider.init(scope);
    }
  };
});

angular.module("Flexikon.directives").directive('dcParseWiki', function($timeout, FlexikonApi) {
  return {
    replace: true,
    restrict: 'E',
    scope: {
      wikiText: '@',
      language: '@'
    },
    templateUrl: 'templates/DcParseWikiTemplate.html',
    link: function(scope, element, attrs) {
      scope.ui = {
        error: false
      };
      if (scope.wikiText.indexOf('{cite') >= 0) {
        element.addClass('cite');
      }
      return FlexikonApi.getTemplate(scope.wikiText.replace(/\\\{/g, '{').replace(/<dc/g, '<#dc'), scope.language, function(data) {
        scope.parsedWikiText = data.parse.text['*'].replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/<\#dc/g, '<dc').replace(/src="\//gmi, 'src="http://dccdn.de/flexikon.doccheck.com/');
        return $timeout(function() {
          return scope.loaded = true;
        });
      }, function(error) {
        console.warn(error);
        scope.ui.error = true;
        return scope.loaded = true;
      });
    }
  };
});

angular.module("Flexikon.controllers").controller('DcPublishCtrl', function($scope, $sce, $ionicScrollDelegate, $location, $timeout, FlexikonApi, PublishApi, $ionicModal, FullscreenViewer, ToC) {
  if ($scope.id != null) {
    $scope.preview = $sce.trustAsResourceUrl(FlexikonApi.getBaseUrl() + 'publish/document/thumbnail/' + $scope.id + '/medium/');
    PublishApi.getPublishContent($scope.id, window.innerWidth + 2, window.innerHeight - 44).success(function(response) {
      return $scope.modalTemplate = '<ion-modal-view> <div class="fullscreen-modal-wrapper document-modal" ng-controller="ModalCtrl">' + '<ion-header-bar align-title="center" class="bar-doccheck" no-tap-scroll="true"> <button class="button back-button buttons button-clear fa fa-chevron-left header-item" ng-click="closeModal()"></button> <h1 class="title"></h1> <button class="button open-external buttons button-clear fa fa-external-link header-item" ng-click="openUrl(\'' + PublishApi.getLinkFor('document') + $scope.id + '\')"></button> </ion-header-bar>' + response.data + '</div> </ion-modal-view>';
    }).error(function(error) {
      console.warn(error);
      return $scope.error = true;
    });
  }

  /**
  	 * [toggleFullscreen - open publish fullscreen viewer]
  	 * @return
   */
  return $scope.toggleFullscreen = function() {
    return FullscreenViewer.openModal($scope.modalTemplate, $scope);
  };
});

angular.module("Flexikon.directives").directive('dcpublish', function($ionicGesture) {
  return {
    restrict: 'E',
    scope: {
      id: '@'
    },
    templateUrl: 'templates/DcPublishTemplate.html',
    controller: 'DcPublishCtrl',
    link: function(scope, element, attrs) {
      scope.onDragUp = function() {
        event.preventDefault();
        event.stopPropagation();
        event.gesture.stopDetect();
        event.gesture.preventDefault();
        return event.gesture.stopPropagation();
      };
      scope.dragUpAction = $ionicGesture.on('dragup', scope.onDragUp, element);
      scope.onDragDown = function() {
        event.preventDefault();
        event.stopPropagation();
        event.gesture.stopDetect();
        event.gesture.preventDefault();
        return event.gesture.stopPropagation();
      };
      scope.dragDownAction = $ionicGesture.on('dragdown', scope.onDragDown, element);
      return scope.$on('$destroy', function() {
        $ionicGesture.off(scope.dragUpAction, 'dragup', scope.onDragLeft);
        return $ionicGesture.off(scope.dragDownAction, 'dragdown', scope.onDragDown);
      });
    }
  };
});

angular.module("Flexikon.controllers").controller('DcPurchaseCtrl', function($scope, Store, ABTest) {
  $scope.ui = {
    version: 0
  };

  /**
  	 * [order - order In-App-Purchase]
  	 * @return
   */
  $scope.order = function() {
    ABTest.trackEvent('started');
    return Store.order();
  };

  /**
  	 * [isOfflineVersion - check if is already owned]
  	 * @return
   */
  return $scope.isOfflineVersion = function() {
    return Store.isOwned('flexikon_offline');
  };
});

angular.module("Flexikon.directives").directive('dcPurchase', function($rootScope, $q, $timeout, Store) {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcPurchaseTemplate.html',
    controller: 'DcPurchaseCtrl',
    link: function(scope, element, attrs) {
      if (Store.isOwned()) {
        element.addClass('hidden');
      }

      /**
      		 * [hide ads immediately when premium is purchased]
      		 * @return
       */
      $rootScope.$on('InAppPurchase-succeeded', function() {
        return scope.hide();
      });

      /**
      		 * [show if not owned]
      		 * @return
       */
      $rootScope.$on('InAppPurchase-notowned', function() {
        if (!Store.isOwned()) {
          return scope.show();
        }
      });

      /**
      		 * [hide - hide completely (in case of premium or no ad retrieved)]
      		 * @return promise
       */
      scope.hide = function() {
        element.addClass('hiding');
        return $timeout(function() {
          element.removeClass('hiding');
          return element.addClass('hidden');
        }, 350);
      };

      /**
      		 * [fade - fade out on hide]
      		 * @return promise
       */
      scope.fade = function() {
        return $q(function(resolve, reject) {
          element.addClass('hiding');
          return $timeout(function() {
            return resolve();
          }, 350);
        });
      };

      /**
      		 * [show - show ad (when loaded)]
      		 * @return
       */
      return scope.show = function() {
        element.removeClass('hidden');
        element.removeClass('hiding');
        element.addClass('showing');
        return $timeout(function() {
          return element.removeClass('showing');
        }, 350);
      };
    }
  };
});

angular.module("Flexikon.controllers").controller('DcQuickSearchCtrl', function($scope, $state, $ionicTabsDelegate, $timeout, QuickSearch, FlexikonApi) {
  $scope.dot = $scope;
  $scope.term = {
    model: ''
  };

  /**
   * [submit - submit action for quick search]
   * @return
   */
  $scope.submit = function() {
    if ($scope.term.model.length > 2) {
      QuickSearch.set($scope.term.model);
      $ionicTabsDelegate.select(2);
      $state.transitionTo('tabs.search.overview', {}, {
        reload: true,
        inherit: false,
        notify: true
      });
      $scope.term.model = '';
      if ((typeof analytics !== "undefined" && analytics !== null) && $scope.term) {
        return analytics.trackEvent('Article', 'quicksearch', $scope.term.value);
      }
    }
  };
  $scope.$watch("term.model", function(n, o) {
    $timeout.cancel($scope.suggestionTimeout);
    if (n.length <= 2) {
      return;
    }
    $scope.clearSuggestions = false;
    return $scope.suggestionTimeout = $timeout(function() {
      return FlexikonApi.getSuggestions(n, 5).success(function(result) {

        /**
        $scope.form.newSuggestions = true
        $timeout(->
          $scope.form.newSuggestions = false
        , 1000)
         */
        return $scope.suggestions = result;
      }).error(function(error) {
        return console.warn(error);
      });
    });
  });

  /**
   * [openArticle - open article from listing]
   * @param  {[String]} page [title of page to open]
   * @return
   */
  return $scope.openArticle = function(page) {
    if (page == null) {
      return;
    }
    if ((typeof analytics !== "undefined" && analytics !== null) && $scope.term) {
      analytics.trackEvent('Article', 'autosuggest', page);
    }
    page = page.replace(/&[^;]*;/g, '').replace(/<(.*?)>/g, '');
    $state.go('^.article', {
      page: window.decodeURIComponent(page)
    });
    $scope.suggestions = [];
    return $scope.term.model = '';
  };
});

angular.module("Flexikon.directives").directive('dcQuickSearch', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcQuickSearchTemplate.html',
    controller: 'DcQuickSearchCtrl'
  };
});

angular.module("Flexikon.controllers").controller('DcRadioButtonCtrl', function($scope, $interval) {
  $scope.dir = {
    model: $scope.model.value
  };
  $scope.$on('form-reset', function() {
    return $scope.dir = {
      model: $scope.model.value
    };
  });
  return $scope.$watch('dir.model', function(n, o) {
    return $scope.model.value = n;
  }, true);
});

angular.module("Flexikon.directives").directive('dcRadioButton', function() {
  return {
    restrict: 'E',
    require: '',
    scope: {
      label: '@',
      text: '@',
      model: '=',
      radioOptions: '='
    },
    templateUrl: 'templates/DcRadioButtonTemplate.html',
    controller: 'DcRadioButtonCtrl'
  };
});

angular.module("Flexikon.controllers").controller('DcSearchBarCtrl', function($scope, $state, $timeout, Network) {
  $scope.offline = $scope.offline || false;

  /**
   * [submit - search bar submit action]
   * @param  {[Event]} $event [submit event]
   * @return
   */
  $scope.submit = function($event) {
    var ref;
    if ($scope.isClearButton()) {
      $scope.term.model = '';
      if (typeof $scope.clearAction === "function") {
        $scope.clearAction();
      }
      $timeout(function() {
        return angular.element('.search-view #search-field')[0].focus();
      });
      return;
    }
    if ($event != null) {
      $event.target.blur();
    }
    if ((ref = document.activeElement) != null) {
      if (typeof ref.blur === "function") {
        ref.blur();
      }
    }
    $scope.term.value = $scope.term.model;
    if (typeof $scope.submitAction === "function") {
      $scope.submitAction();
    }
    if ((typeof analytics !== "undefined" && analytics !== null) && $scope.term) {
      return analytics.trackEvent('Article', 'search', $scope.term.value);
    }
  };

  /**
   * [isClearButton - clear text from input if text equals last searched term]
   * @return {Boolean} [true if equals]
   */
  return $scope.isClearButton = function() {
    return $scope.term.value.length > 0 && $scope.term.value === $scope.term.model || $scope.offline && $scope.term.model.length > 0 && !Network.hasConnection();
  };
});

angular.module("Flexikon.directives").directive('dcSearchBar', function() {
  return {
    restrict: 'E',
    scope: {
      submitAction: '&',
      clearAction: '&',
      term: '=',
      offline: '='
    },
    templateUrl: 'templates/DcQuickSearchTemplate.html',
    controller: 'DcSearchBarCtrl'
  };
});

angular.module("Flexikon.directives").directive('dcSelect', function() {
  return {
    restrict: 'E',
    scope: {
      label: '@',
      options: '&',
      initialOption: '&',
      image: '@',
      imageSize: '@'
    },
    template: 'templates/DcSelect.html'
  };
});

angular.module("Flexikon.controllers").controller('DcSideMenuCtrl', function($scope, $rootScope, $ionicModal, $state, $ionicScrollDelegate, $ionicSideMenuDelegate, $location, $timeout, $ionicPopover, ToC, FontSize, Store, Api, Theme, LocalStorage, GuidedTour) {
  $scope.ui = {
    toc: false,
    showToc: true,
    tocContent: void 0,
    activeSection: -1,
    fontSize: FontSize.getCurrent()
  };
  $scope.search = {
    term: '',
    index: -1,
    length: -1
  };
  ionic.Platform.ready(function() {
    $scope.env = {
      dev: Api.getEnv().indexOf('development') >= 0
    };
    $ionicModal.fromTemplateUrl('templates/styleModal.html', {
      scope: $scope
    }).then(function(modal) {
      return $scope.modal = modal;
    });
    $ionicPopover.fromTemplateUrl('stylePopover.html', {
      scope: $scope
    }).then(function(popover) {
      return $scope.popover = popover;
    });
    $scope.toggleToc = function() {
      return $scope.ui.showToc = !$scope.ui.showToc;
    };
    $scope.selectTheme = function(theme) {
      return Theme.select(theme);
    };
    $scope.openPopover = function($event) {
      $rootScope.$broadcast('article:toggle-style-overlay');
      if ($ionicSideMenuDelegate.isOpenRight()) {
        return $ionicSideMenuDelegate.toggleRight();
      }
    };
    $scope.closePopover = function() {
      $scope.popover.hide();
      if ($ionicSideMenuDelegate.isOpenRight()) {
        $ionicSideMenuDelegate.toggleRight();
      }
    };
    $scope.$on('$destroy', function() {
      $scope.popover.remove();
    });
    $scope.$on('popover.hidden', function() {});
    return $scope.$on('popover.removed', function() {});
  });
  $scope.$on('$stateChangeStart', function(event, toState, fromState) {
    return $timeout(function() {
      return $scope.ui.toc = false;
    });
  });
  $scope.share = function() {
    var ref;
    if (((ref = window.plugins) != null ? ref.socialsharing : void 0) == null) {
      console.debug('Social sharing only available on device via plugin. However, this would be the text: \nhttp://flexikon.doccheck.com/' + window.encodeURIComponent(ToC.getTitle()));
      return;
    }
    window.plugins.socialsharing.share('DocCheck Flexikon: ' + ToC.getTitle() + '\n', null, null, 'http://flexikon.doccheck.com/' + window.encodeURIComponent(ToC.getTitle()));
    if ((typeof analytics !== "undefined" && analytics !== null) && ToC.getTitle()) {
      return analytics.trackEvent('Article', 'share', ToC.getTitle());
    }
  };
  $rootScope.$on('new-toc-available', function() {
    return $timeout(function() {
      if ($state.current.name.indexOf('article') > 0) {
        return $timeout(function() {
          $scope.ui.tocContent = [];
          $scope.ui.toc = false;
          return $timeout(function() {
            $scope.ui.toc = true;
            return $scope.ui.tocContent = ToC.get();
          });
        });
      }
    });
  });
  $scope.anchorScroll = function(id) {
    var expandId;
    expandId = angular.element('#' + id).closest('dc-expandable').attr('id');
    $rootScope.$broadcast('dcexpandable' + expandId + '-open');
    return $timeout(function() {
      var scrollTo;
      scrollTo = angular.element('#' + id);
      if (scrollTo == null) {
        return;
      }
      $ionicScrollDelegate.$getByHandle('ArticleScroll').scrollTo(0, scrollTo.closest('dc-flexikon-section').position().top + scrollTo.position().top - 12, true);
      $ionicSideMenuDelegate.toggleRight();
      return $timeout(function() {
        ToC.setCurrentSection(expandId);
        return $scope.fetchActiveSection();
      }, 500);
    });
  };
  $scope.increaseFontSize = function($event) {
    $event.preventDefault();
    $event.stopPropagation();
    return $scope.ui.fontSize = FontSize.increase();
  };
  $scope.decreaseFontSize = function($event) {
    $event.preventDefault();
    $event.stopPropagation();
    return $scope.ui.fontSize = FontSize.decrease();
  };
  $scope.resetFontSize = function($event) {
    $event.preventDefault();
    $event.stopPropagation();
    return $scope.ui.fontSize = FontSize.reset();
  };
  $scope.isOfflineVersion = function() {
    return Store.isOwned('flexikon_offline');
  };
  $scope.order = function() {
    return Store.order('flexikon_offline');
  };
  $scope.fetchActiveSection = function() {
    return $scope.ui.activeSection = ToC.getCurrentSection();
  };
  $scope.doNothing = function($event) {
    $event.preventDefault();
    return $event.stopPropagation();
  };
  $scope.runArticleOverlay = function() {
    $ionicSideMenuDelegate.toggleRight();
    return GuidedTour.start('FlexikonArticleIntro', [
      {
        selector: void 0,
        hint: 'DC_TUTORIAL_OVERLAY_FLEXIKON'
      }, {
        selector: [
          {
            name: '.fa.fa-bars',
            shape: 'round'
          }
        ],
        hint: 'DC_TUTORIAL_OVERLAY_TOC'
      }, {
        selector: [
          {
            name: '.fa.fa-heart-o',
            shape: 'round'
          }
        ],
        hint: 'DC_TUTORIAL_OVERLAY_NEWBOOKMARK'
      }, {
        selector: [
          {
            name: 'dc-icon-button[action="editGlobal()"]',
            shape: 'round'
          }
        ],
        hint: 'DC_TUTORIAL_OVERLAY_EDIT'
      }
    ]);
  };
  $scope.reloadActiveSection = $rootScope.$on('reloadActiveSection', function() {
    return $scope.fetchActiveSection();
  });
  $scope.clearFindInPage = $rootScope.$on('findInPage-termCleared', function() {
    return $scope.search.term = '';
  });
  $scope.$watch('ui.fontSize', function(n, o) {
    return FontSize.set(n);
  });
  return $scope.$on('$destroy', function() {
    $scope.reloadActiveSection();
    return $scope.clearFindInPage();
  });
});

angular.module("Flexikon.directives").directive('dcSideMenu', function() {
  return {
    restrict: 'E',
    scope: false,
    templateUrl: 'templates/DcSideMenuTemplate.html',
    controller: 'DcSideMenuCtrl'
  };
});

angular.module("Flexikon.controllers").controller('DcSwiffyCtrl', function($scope, $http, $timeout, $q, $sce) {
  return;
  $scope.ui = {
    script: false
  };
  $timeout(function() {
    return $scope.ui.script = true;
  });
  $scope.swiffy = {
    js: $sce.trustAsResourceUrl("http://flexikon.doccheck.com/de/extensions/dc_flash/swiffy/data/" + $scope.name + ".js")
  };
  $scope.init = function() {
    var q;
    window.addEventListener('orientationchange', $scope.checkDimensions);
    q = $q.defer();
    return q.promise.then(function() {
      return $timeout(function() {
        return $scope.loaded = true;
      });
    }, function() {
      return $timeout(function() {
        return $scope.loaded = false;
      });
    });
  };

  /*
  $scope.checkLoadingStatus = (q, failCount=0) ->
    $timeout(->
      $scope.name = $scope.name.replace(/\ /g, '_')
      if $scope['Data_' + name]?
        #if window['Data_' + $scope.name]?
        $scope.objModuleData = $scope['Data_' + name]
        $scope.checkDimensions()
  
        $scope.stage = new swiffy.Stage(document.getElementById($scope.id), $scope.objModuleData.data)
  
        objSwiffyContainer = angular.element('#' + $scope.id)
        $scope.stage.start()
        q.resolve()
        return
  
      if failCount >= 5
        q.reject
        return
  
      $scope.checkLoadingStatus(q, ++failCount)
    , 1000)
   */
  $scope.checkDimensions = function() {
    var ratio;
    ratio = window.innerWidth / parseInt($scope.objModuleData.css.width);
    $scope.objModuleData.css.width = (parseInt($scope.objModuleData.css.width) * ratio) + 'px';
    return $scope.objModuleData.css.height = (parseInt($scope.objModuleData.css.height) * ratio) + 'px';
  };
  return $scope.init();
});

angular.module("Flexikon.directives").directive('dcswiffy', function($sce, $http, $timeout) {
  return {
    restrict: 'E',
    scope: {
      name: '@'
    },
    templateUrl: 'templates/DcSwiffyTemplate.html',
    controller: 'DcSwiffyCtrl',
    link: function(scope, elem, attrs, ctrl) {
      var script, scriptElem;
      return;
      scope.dot = scope;
      scope.id = "html5ModuleContainerID" + parseInt(Math.random() * 1000000);
      scope.prepareSwiffyElement = function() {
        scope.loaded = true;
        return $timeout(function() {
          scope.name = scope.name.replace(/\ /g, '_');
          if (scope['Data_' + scope.name] != null) {
            return;
            scope.objModuleData = scope['Data_' + scope.name];
            scope.checkDimensions();
            scope.stage = new swiffy.Stage(document.getElementById(scope.id), scope.objModuleData.data);
            return scope.stage.start();
          }
        }, 1000);
      };
      $http.get('http://flexikon.doccheck.com/de/extensions/dc_flash/swiffy/data/' + scope.name + '.js').then(function(response) {
        var error;
        try {
          scope.$eval(response.data.replace('var ', ''));
          return scope.prepareSwiffyElement();
        } catch (error1) {
          error = error1;
          return console.warn(error);
        }
      });
      return;
      script = '<script async="async" src="http://flexikon.doccheck.com/de/extensions/dc_flash/swiffy/data/' + scope.name + '.js"></script>';
      scriptElem = angular.element(script);
      elem.prepend(scriptElem);
      return scriptElem.on('ready', function() {});
    }
  };
});

angular.module("Flexikon.controllers").controller('DcTableCtrl', function($scope) {});

angular.module("Flexikon.directives").directive('dcTable', function($timeout, $ionicScrollDelegate, $ionicGesture, $location, UniqueID, ToC, GlobalSettings) {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcTableTemplate.html',
    controller: 'DcTableCtrl',
    transclude: true,
    link: function(scope, element, attr) {
      scope.table = element.find('table');
      scope.id = UniqueID.get();
      element.attr('id', scope.id);
      scope.ui = {
        full: false,
        "extends": false
      };
      scope.style = {
        maxHeight: 250,
        marginBottom: 30
      };
      scope.tableExtendsWrapper = function() {
        scope.table = element.find('table');
        if (element.height() <= 0) {
          return false;
        }
        if (scope.table.height() <= 750) {
          scope.ui["extends"] = false;
          scope.style.maxHeight = 764;
          scope.style.marginBottom = 0;
          return;
        }
        if (element.height() < scope.table.height()) {
          scope.ui["extends"] = true;
        }
        return scope.ui["extends"];
      };
      scope.extendHeight = function() {
        scope.table = element.find('table');
        if (!GlobalSettings.Stacktables() || scope.table.height() - scope.style.maxHeight < 750) {
          scope.style.maxHeight = scope.table.height() + 14;
          scope.style.marginBottom = 0;
          scope.ui.full = true;
        } else {
          scope.style.marginBottom = 30;
          scope.style.maxHeight += 500;
          scope.ui.full = false;
        }
        return $timeout(function() {
          if (!scope.$$phase) {
            scope.$apply();
          }
          return $ionicScrollDelegate.$getByHandle('ArticleScroll').resize();
        }, 550);
      };
      scope.resetHeight = function() {
        scope.table = element.find('table');
        scope.style.maxHeight = 250;
        scope.style.marginBottom = 30;
        scope.ui.full = false;
        scope.ui["extends"] = true;
        scope.anchorScroll(scope.id);
        return $timeout(function() {
          if (!scope.$$phase) {
            scope.$apply();
          }
          return $ionicScrollDelegate.$getByHandle('ArticleScroll').resize();
        }, 550);
      };
      scope.anchorScroll = function(id) {
        var scrollTo;
        scrollTo = angular.element('#' + id);
        if (scrollTo == null) {
          return;
        }
        return $ionicScrollDelegate.$getByHandle('ArticleScroll').scrollTo(0, scrollTo.closest('dc-flexikon-section').position().top + scrollTo.position().top - 12, true);

        /*
        			$location.hash(id)
        			$ionicScrollDelegate.$getByHandle('ArticleScroll').anchorScroll(true)
         */
      };
      scope.onElementClick = function($event) {
        var el, elHeight, offset, parentHeight;
        if ($event.toElement.tagName.toUpperCase() === 'TABLE') {
          return;
        }
        el = angular.element($event.toElement);
        offset = el.offset().top - el.offsetParent().offset().top;
        elHeight = el.height();
        parentHeight = el.offsetParent().height();
        if (elHeight + offset > parentHeight) {
          return scope.style.maxHeight = elHeight + offset + 36;
        }
      };
      scope.onDrag = function() {
        event.preventDefault();
        event.stopPropagation();
        event.gesture.stopDetect();
        event.gesture.preventDefault();
        return event.gesture.stopPropagation();
      };
      scope.dragRightAction = $ionicGesture.on('dragright', scope.onDrag, element);
      scope.dragLeftAction = $ionicGesture.on('dragleft', scope.onDrag, element);
      return scope.$on('$destroy', function() {
        window.removeEventListener('orientationchange', scope.refresh);
        $ionicGesture.off(scope.dragLeftAction, 'dragleft', scope.onDrag);
        return $ionicGesture.off(scope.dragRightAction, 'dragright', scope.onDrag);
      });
    }
  };
});

angular.module("Flexikon.controllers").controller('DcTocEntryCtrl', function() {});

angular.module("Flexikon.directives").directive('dcTocEntry', function($compile) {
  return {
    restrict: 'E',
    replace: true,
    scope: false,
    link: function(scope, element, attrs) {
      var elmnt;
      elmnt = $compile('<div id="toc{{entry.targetId}}" ng-class="{\'in-view\' : entry.level == 1 && entry.targetId == ui.activeSection}" class="level' + attrs.level + '" ng-click="anchorScroll(\'' + attrs.targetid + '\')">' + attrs.target + '</div>')(scope);
      element.html("");
      return element.replaceWith(elmnt);
    }
  };
});

angular.module("Flexikon.controllers").controller('DcTvCtrl', function($scope, $http, $attrs, $sce, $timeout) {
  var detailUri;
  $scope.ui = {
    error: false,
    loaded: false
  };
  $scope.listeners = [];
  detailUri = "http://tv.doccheck.com/de/service/movie/details/";
  if ($attrs.key != null) {
    detailUri += "identkey/?identkey=" + $attrs.key;
  } else if ($attrs.id != null) {
    detailUri += "id/?id=" + $attrs.id;
  }
  $http.get(detailUri).success(function(result) {
    var prv;
    prv = result.data.previewImage;
    if (prv.indexOf('//') === 0) {
      prv = 'http:' + prv;
    }
    $scope.dcTvVideo = {
      previewImage: prv,
      url: $sce.trustAsResourceUrl(result.data.mp4HqUri || result.data.mp4Uri)
    };
    $timeout(function() {
      return $scope.bindFullscreenListener();
    });
    return $scope.ui.loaded = true;
  }).error(function(error) {
    console.warn(error);
    $scope.ui.error = true;
    return $scope.ui.loaded = true;
  });
  $scope.$on('$destroy', function() {
    var i, len, listener, ref, results;
    ref = $scope.listeners;
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      listener = ref[i];
      results.push(listener());
    }
    return results;
  });
  $scope.getPreviewStyle = function() {
    if ($scope.dcTvVideo.previewImage != null) {
      return {
        'background-image': 'url(' + $scope.dcTvVideo.previewImage + ')'
      };
    }
    return {
      'background-image': 'url()'
    };
  };
  return $scope.getPreviewUrl = function() {
    return $scope.dcTvVideo.previewImage || '';
  };
});

angular.module("Flexikon.directives").directive('dctv', function($ionicPlatform) {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/DcTvTemplate.html',
    controller: 'DcTvCtrl',
    link: function(scope, element, attrs) {
      scope.screen = {
        width: element.closest('dc-expandable').width() - parseInt(element.closest('.html-content').css('padding')) * 2
      };
      scope.listeners.push(scope.$on('article.beforeLeave', function() {
        var ref, ref1;
        return (ref = element.find('video')) != null ? (ref1 = ref[0]) != null ? ref1.pause() : void 0 : void 0;
      }));
      scope.bindFullscreenListener = function() {
        return element.find('video').bind('webkitfullscreenchange mozfullscreenchange fullscreenchange', function(event) {
          var state;
          state = document.fullScreen || document.mozFullScreen || document.webkitIsFullScreen;
          if (state) {
            return scope.deregisterBackButtonAction = $ionicPlatform.registerBackButtonAction(function() {
              scope.exitFullscreen();
            }, 101);
          } else {
            return scope.deregisterBackButtonAction();
          }
        });
      };
      return scope.exitFullscreen = function() {
        return element.find('video')[0].webkitExitFullscreen();
      };
    }
  };
});

angular.module("Flexikon.controllers").controller('TemplateCtrl', function() {});

angular.module("Flexikon.directives").directive('detectFocus', function($timeout) {
  return {
    'restrict': 'AC',
    'scope': {
      'onFocus': '&',
      'onBlur': '&'
    },
    'link': function(scope, elem, attrs) {
      elem.on('focus', function() {
        if (typeof scope.onFocus === "function") {
          scope.onFocus();
        }
      });
      elem.on('blur', function() {
        if (!this.refocussing) {
          if (typeof scope.onBlur === "function") {
            scope.onBlur();
          }
        }
      });
    }
  };
});

angular.module("Flexikon.controllers").controller('DetectGestureCtrl', function() {});

angular.module("Flexikon.directives").directive('detectGesture', function() {
  return {
    restrict: 'A',
    require: '',
    controller: 'DetectGestureCtrl',
    link: function(scope, elem, attrs) {
      var gestureType;
      gestureType = attrs.gestureType;
      scope.reportEvent = function() {
        return console.debug(event);
      };
      switch (gestureType) {
        case 'swipe':
          $ionicGesture.on('swipe', scope.reportEvent, elem);
          break;
        case 'swiperight':
          $ionicGesture.on('swiperight', scope.reportEvent, elem);
          break;
        case 'swipeleft':
          $ionicGesture.on('swipeleft', scope.reportEvent, elem);
          break;
        case 'doubletap':
          $ionicGesture.on('doubletap', scope.reportEvent, elem);
          break;
        case 'tap':
          $ionicGesture.on('tap', scope.reportEvent, elem);
          break;
        case 'scroll':
          $ionicGesture.on('scroll', scope.reportEvent, elem);
          break;
      }
    }
  };
});

angular.module("Flexikon.directives").directive('hideOnDrag', function($rootScope, $timeout) {
  return {
    restrict: 'A',
    scope: false,
    link: function(scope, element, attrs) {
      scope.ui = {
        delta: 0,
        style: {
          '-webkit-transition': 'transform ease-in-out 300ms',
          'transition': 'transform ease-in-out 300ms',
          '-webkit-transform': 'translateY(0)',
          'transform': 'translateY(0)'
        },
        hidden: false,
        up: attrs.up !== "false",
        listening: false
      };
      scope.pullElement = attrs.pullElement || '';
      scope.pushElement = attrs.pushElement || '';
      $rootScope.$on('hide-on-drag-touch', function(event, data) {
        return scope.ui.listening = true;
      });
      $rootScope.$on('hide-on-drag', function(event, data) {
        var pullElement, pushElement, transform;
        if (!scope.ui.listening) {
          return;
        }
        scope.ui.delta = data.deltaY / 2;
        if (scope.ui.hidden) {
          scope.ui.delta -= element.height();
        }
        transform = scope.ui.delta;
        if (scope.ui.up) {
          if (transform > 0) {
            transform = 0;
          }
          if (transform < element.height() * -1) {
            transform = element.height() * -1;
          }
        } else {
          if (transform < 0) {
            transform = 0;
          }
          if (transform > element.height()) {
            transform = element.height();
          }
        }
        scope.ui['-webkit-transform'] = 'translateY(' + transform + 'px)';
        scope.ui['transform'] = 'translateY(' + transform + 'px)';
        scope.ui['-webkit-transform-inverted'] = 'translateY(' + (transform * -1) + 'px)';
        scope.ui['transform-inverted'] = 'translateY(' + (transform * -1) + 'px)';
        element.css('-webkit-transform', scope.ui['-webkit-transform']);
        element.css('transform', scope.ui['transform']);
        element.css('-webkit-transition-duration', '0ms');
        element.css('transition-duration', '0ms');
        pullElement = angular.element(scope.pullElement);
        if ((pullElement != null ? pullElement.length : void 0) > 0) {
          pullElement.css('-webkit-transform', scope.ui['-webkit-transform']);
          pullElement.css('transform', scope.ui['transform']);
          pullElement.css('-webkit-transition-duration', '0ms');
          pullElement.css('transition-duration', '0ms');
        }
        pushElement = angular.element(scope.pushElement);
        if ((pushElement != null ? pushElement.length : void 0) > 0) {
          pushElement.css('-webkit-transform', scope.ui['-webkit-transform-inverted']);
          pushElement.css('transform', scope.ui['transform-inverted']);
          pushElement.css('-webkit-transition-duration', '0ms');
          return pushElement.css('transition-duration', '0ms');
        }
      });

      /*
       * Released
       */
      $rootScope.$on('hide-on-drag-release', function(event, data) {
        var pullElement, pushElement, transform;
        scope.ui.listening = false;
        element.css('-webkit-transition', scope.ui['-webkit-transition']);
        element.css('transition', scope.ui['transition']);
        element.css('-webkit-transition-duration', '300ms');
        element.css('transition-duration', '300ms');
        pullElement = angular.element(scope.pullElement);
        if ((pullElement != null ? pullElement.length : void 0) > 0) {
          pullElement.css('-webkit-transition', scope.ui['-webkit-transition']);
          pullElement.css('transition', scope.ui['transition']);
          pullElement.css('-webkit-transition-duration', '300ms');
          pullElement.css('transition-duration', '300ms');
        }
        pushElement = angular.element(scope.pushElement);
        if ((pushElement != null ? pushElement.length : void 0) > 0) {
          pushElement.css('-webkit-transition', scope.ui['-webkit-transition']);
          pushElement.css('transition', scope.ui['transition']);
          pushElement.css('-webkit-transition-duration', '300ms');
          pushElement.css('transition-duration', '300ms');
        }
        if (scope.ui.delta < element.height() / 2 * -1 && scope.ui.up) {
          transform = element.height() * -1;
          scope.ui.hidden = true;
        } else if (scope.ui.delta < element.height() / 2 && !scope.ui.up) {
          transform = element.height();
          scope.ui.hidden = true;
        } else {
          transform = 0;
          scope.ui.hidden = false;
        }
        element.css('-webkit-transform', 'translateY(' + transform + 'px)');
        element.css('transform', 'translateY(' + transform + 'px)');
        if ((pullElement != null ? pullElement.length : void 0) > 0) {
          pullElement.css('-webkit-transform', 'translateY(' + transform + 'px)');
          pullElement.css('transform', 'translateY(' + transform + 'px)');
        }
        if ((pushElement != null ? pushElement.length : void 0) > 0) {
          if (transform !== 0) {
            pushElement.css('-webkit-transform', 'translateY(100%)');
            pushElement.css('transform', 'translateY(100%)');
          } else {
            pushElement.css('-webkit-transform', 'translateY(0)');
            pushElement.css('transform', 'translateY(0)');
          }
        }
        scope.$on('$stateChangeStart', function() {
          if (scope.ui.hidden) {
            scope.ui.hidden = false;
            scope.ui.delta = 0;
            return $timeout(function() {
              angular.element('.tab-nav.tabs').css('-webkit-transform', 'translateY(0px)');
              return angular.element('.tab-nav.tabs').css('transform', 'translateY(0px)');
            });
          }
        });
        return scope.$on('$destroy', function() {
          if (scope.ui.hidden) {
            scope.ui.hidden = false;
            return $timeout(function() {
              angular.element('.tab-nav.tabs').css('-webkit-transform', 'translateY(0px)');
              return angular.element('.tab-nav.tabs').css('transform', 'translateY(0px)');
            });
          }
        });
      });
    }
  };
});

angular.module("Flexikon.directives").directive('ngBackgroundImage', function() {
  return function(scope, element, attrs) {
    attrs.$observe('ngBackgroundImage', function(value) {
      if (value.indexOf('//') === 0) {
        value = 'http:' + value;
      }
      element.css({
        'background-image': 'url(' + value + ')',
        'background-size': 'cover',
        'background-repeat': 'no-repeat'
      });
    });
  };
});

angular.module("Flexikon.controllers").controller('RefCtrl', function($scope, $attrs) {});

angular.module("Flexikon.directives").directive('ref', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/RefTemplate.html',
    controller: 'RefCtrl',
    transclude: true,
    link: function(scope, element, attrs, ctrl, transclude) {
      return transclude(scope, function(clone) {
        element.prepend(clone);
        return element.wrap('<div class="ref"></div>');
      });
    }
  };
});

angular.module("Flexikon.directives").directive('textarea', function() {
  return {
    restrict: 'E',
    scope: {
      noIonic: '='
    },
    link: function(scope, element, attr) {
      if (scope.noIonic) {
        return element.bind('touchend touchmove touchstart', function(e) {
          return e.stopPropagation();
        });
      }
    }
  };
});

angular.module("Flexikon.controllers").controller('ReferencesCtrl', function() {});

angular.module("Flexikon.directives").directive('references', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/ReferencesTemplate.html',
    controller: 'ReferencesCtrl',
    link: function(scope, element, attrs) {
      var i, rand, refs;
      refs = element.closest('.article-container').find('ref');
      scope.refs = [];
      rand = parseInt(Math.random() * 10000);
      i = 1;
      return refs.each(function() {
        scope.refs.push('<a id="refbot' + rand + '" href="#ref' + rand + '" class="fa fa-long-arrow-up"></a> ' + this.innerHTML);
        angular.element(this).attr('id', 'ref' + rand).attr('count', i);
        angular.element(this).append("<a href=\"#refbot" + rand + "\" class=\"super\"> [" + i + "]</a>");
        rand++;
        return i++;
      });
    }
  };
});

angular.module("Flexikon.controllers").controller('YoutubeCtrl', function($scope, $attrs, $http, $filter, FullscreenViewer) {
  $scope.yt = {
    title: '',
    previewImage: 'http://img.youtube.com/vi/' + $attrs.v + '/0.jpg',
    error: false
  };
  $http.get("https://noembed.com/embed?format=json&url=https://www.youtube.com/watch?v=" + $attrs.v).success(function(data) {
    return $scope.yt.title = data.title;
  }).error(function(data) {
    return $scope.yt.error = true;
  });
  $scope.modalTemplate = '<ion-modal-view> <div class="fullscreen-modal-wrapper youtube-modal" ng-controller="ModalCtrl"> <ion-header-bar align-title="center" class="bar-doccheck" no-tap-scroll="true"> <button class="button back-button buttons button-clear fa fa-chevron-left header-item" ng-click="closeModal()"></button> <h1 class="title">{{yt.title}}</h1> <button class="button open-external buttons button-clear fa fa-external-link header-item" ng-click="openUrl(\'https://www.youtube.com/watch?v=' + $attrs.v + '\')"></button> </ion-header-bar> <iframe id="player" type="text/html" width="640" height="390" src="http://www.youtube.com/embed/' + $attrs.v + '?enablejsapi=1&autoplay=1" frameborder="0" > </iframe> </div> </ion-modal-view>';
  return $scope.openFullscreen = function() {
    FullscreenViewer.openModal($scope.modalTemplate, $scope);
    return typeof screen !== "undefined" && screen !== null ? typeof screen.lockOrientation === "function" ? screen.lockOrientation('landscape') : void 0 : void 0;
  };
});

angular.module("Flexikon.directives").directive('youtube', function() {
  return {
    restrict: 'E',
    scope: true,
    templateUrl: 'templates/YoutubeTemplate.html',
    controller: 'YoutubeCtrl'
  };
});

angular.module('Flexikon.services').config(function($provide) {

  /**
   * []
   * @param  {[type]} $delegate []
   * @return {[type]}           []
   */
  return $provide.decorator('$q', function($delegate) {
    var $q;
    $q = $delegate;

    /**
     * []
     * @param  {[type]} promises []
     * @return {[type]}          []
     */
    $q.allSettled = $q.allSettled || function(promises) {
      var checkPromiseStates, deferred, failedOnce, results, states;
      deferred = $q.defer();
      if (angular.isArray(promises)) {
        states = [];
        results = [];
        failedOnce = false;
        if (promises.length === 0) {
          deferred.resolve(results);
          return;
        }

        /**
         * [Initialize states array to be ]
         * @param  {[type]} promise []
         * @param  {[type]} key     []
         * @return {[type]}         []
         */
        angular.forEach(promises, function(promise, key) {
          return states[key] = false;
        });

        /**
         * [checkPromiseStates]
         * @param  {[type]} states   []
         * @param  {[type]} results  []
         * @param  {[type]} deferred []
         * @param  {[type]} failed   []
         * @return {[type]}          []
         */
        checkPromiseStates = function(states, results, deferred, failed) {
          var allFinished;
          allFinished = true;
          angular.forEach(states, function(state, key) {
            if (!state) {
              return allFinished = false;
            }
          });
          if (allFinished) {
            if (failed) {
              return deferred.reject(results);
            } else {
              return deferred.resolve(results);
            }
          }
        };

        /**
         * [Run through the promises and check the overall state when a single one is resolved]
         * @param  {[type]} promise []
         * @param  {[type]} key     []
         * @return {[type]}         []
         */
        angular.forEach(promises, function(promise, key) {
          return $q.when(promise).then(function(result) {
            states[key] = true;
            results[key] = result;
            return checkPromiseStates(states, results, deferred, failedOnce);
          }, function(reason) {
            failedOnce = true;
            states[key] = true;
            results[key] = reason;
            return checkPromiseStates(states, results, deferred, failedOnce);
          });
        });
      } else {
        return $q.when(promises);
      }
      return deferred.promise;
    };
    return $q;
  });
});

angular.module("Flexikon.services").factory("ABTest", function(LocalStorage) {
  return {
    initialized: false,
    version: 0,
    init: function() {
      if (LocalStorage.isSet('dc_flexikon_ab_test_banner_version')) {
        this.version = LocalStorage.get('dc_flexikon_ab_test_banner_version');
        this.initialized = true;
        return;
      }
      this.version = Math.floor(Math.random() * 2);
      LocalStorage.set('dc_flexikon_ab_test_banner_version', this.version);
      this.initialized = true;
      return this.trackEvent('Persisted');
    },
    get: function() {
      if (!this.initialized) {
        this.init();
      }
      return this.version;
    },
    trackEvent: function(action) {
      var bversion;
      switch (this.version) {
        case 0:
          bversion = 'Version1_Eumel_Red';
          break;
        case 1:
          bversion = 'Version2_Cable_Green';
      }
      if (typeof analytics !== "undefined" && analytics !== null) {
        return analytics.trackEvent('Purchase', action, bversion);
      } else {
        return console.debug('Analytics not available. Not tracking "Purchase"|"' + action + '"|"' + bversion + '"');
      }
    }
  };
});

angular.module("Flexikon.services").factory("Api", function(LocalStorage, GlobalSettings) {
  return {

    /**
     * [environment - either production or development]
     * @type {String}
     */
    environment: 'production',
    key: {
      production: '9fd69bd4f0328ce9722ba707fdbd7920abeaab414ad43b69',
      development: '47a96224506c475a5632998c9fb95826f00058401369ace8',
      development_mocked: '47a96224506c475a5632998c9fb95826f00058401369ace8'
    },
    getEnv: function() {
      return this.environment;
    },
    getApiKey: function() {
      return this.key[this.environment];
    },
    getAccessToken: function() {
      return LocalStorage.get('dc_flexikon_access_token');
    }
  };
});

angular.module("Flexikon.services").factory("FontSize", function($rootScope, LocalStorage) {
  return {
    baseFontSize: 17,
    minFontSize: 11,
    maxFontSize: 25,
    interval: 2,
    currentFontSize: parseInt(LocalStorage.get('fontSize')) || 17,
    set: function(value) {
      if (value < this.minFontSize) {
        value = this.minFontSize;
      }
      if (value > this.maxFontSize) {
        value = this.maxFontSize;
      }
      this.currentFontSize = value;
      this.persist();
      return $rootScope.$broadcast("article:font-size-changed", {
        fontSize: this.currentFontSize
      });
    },
    increase: function() {
      if (this.currentFontSize < this.maxFontSize) {
        this.currentFontSize += this.interval;
        this.persist();
        $rootScope.$broadcast("article:font-size-changed", {
          fontSize: this.currentFontSize
        });
      }
      return this.currentFontSize;
    },
    decrease: function() {
      if (this.currentFontSize > this.minFontSize) {
        this.currentFontSize -= this.interval;
        this.persist();
        $rootScope.$broadcast("article:font-size-changed", {
          fontSize: this.currentFontSize
        });
      }
      return this.currentFontSize;
    },
    persist: function() {
      return LocalStorage.set('fontSize', this.currentFontSize);
    },
    reset: function() {
      this.currentFontSize = this.baseFontSize;
      this.persist();
      $rootScope.$broadcast("article:font-size-changed", {
        fontSize: this.currentFontSize
      });
      return this.currentFontSize;
    },
    getCurrent: function() {
      return parseInt(LocalStorage.get('fontSize')) || this.currentFontSize;
    }
  };
});

angular.module("Flexikon.services").factory("ArticleHistory", function() {
  return {
    hst: {},
    push: function(stateName, articleName, language) {
      if (language == null) {
        language = 'de';
      }
      console.log('ArticleHistory %s, %s', stateName, articleName);
      if (this.hst[stateName] == null) {
        this.hst[stateName] = {
          stateHistory: [],
          stateIndex: -1
        };
      }
      if (this.hst[stateName].stateHistory.indexOf(articleName) >= 0) {
        this.hst[stateName].stateIndex = this.hst[stateName].stateHistory.indexOf(articleName);
        return this.forwardAvailable(stateName);
      }
      this.hst[stateName].stateIndex++;
      if (this.hst[stateName].stateHistory[this.hst[stateName].stateIndex] !== articleName) {
        this.hst[stateName].stateHistory.splice(this.hst[stateName].stateIndex, this.hst[stateName].stateHistory.length - this.hst[stateName].stateIndex);
        this.hst[stateName].stateHistory.push(articleName);
        return this.forwardAvailable(stateName);
      }
    },
    getCurrent: function(stateName) {
      return this.hst[stateName].stateHistory[this.hst[stateName].stateIndex];
    },
    backAvailable: function(stateName) {
      var ref;
      return ((ref = this.hst[stateName]) != null ? ref.stateIndex : void 0) >= 0 || false;
    },
    forwardAvailable: function(stateName) {
      var ref, ref1;
      return ((ref = this.hst[stateName]) != null ? ref.stateIndex : void 0) < ((ref1 = this.hst[stateName]) != null ? ref1.stateHistory.length : void 0) - 1 || false;
    },
    back: function(stateName) {
      if (this.backAvailable(stateName)) {
        if (this.hst[stateName].stateIndex > -1) {
          this.hst[stateName].stateIndex--;
        }
        return this.getCurrent(stateName);
      }
    },
    forward: function(stateName) {
      if (this.forwardAvailable(stateName)) {
        this.hst[stateName].stateIndex++;
        return this.hst[stateName].stateHistory[this.hst[stateName].stateIndex];
      }
    },
    getListing: function() {
      return hst;
    }
  };
});

angular.module("Flexikon.services").factory("ArticleLoading", function($timeout) {
  return {
    lockCounter: 0,
    locks: [],
    timeouts: {},
    requestLock: function(timeout) {
      if (timeout == null) {
        timeout = 5000;
      }
      this.timeouts[this.lockCounter] = $timeout(function() {
        return this.releaseLock(this.lockCounter);
      }, timeout);
      locks.push(this.lockCounter);
      return this.lockCounter++;
    },
    releaseLock: function(lock) {
      this.locks.splice(this.locks.indexOf(lock), 1);
      $timeout.cancel(this.timeouts[lock]);
    },
    isLocked: function() {
      return this.locks.length > 0;
    }
  };
});

angular.module("Flexikon.services").factory("Camera", function() {
  return {
    takePhoto: function(successCallback, errorCallback) {
      return navigator.camera.getPicture(function(uri) {
        return successCallback(uri);
      }, function(error) {
        return errorCallback(error);
      }, {
        quality: 100,
        destinationType: 1,
        encodingType: 1,
        correctOrientation: true,
        saveToPhotoAlbum: true
      });
    }
  };
});

angular.module("Flexikon.services").factory("DcDateTime", function() {
  return {
    getFormattedDate: function(date) {
      var dd, mm, today, yyyy;
      if (date == null) {
        today = new Date;
      } else {
        today = new Date(date);
      }
      dd = today.getDate();
      mm = today.getMonth() + 1;
      yyyy = today.getFullYear();
      if (dd < 10) {
        dd = '0' + dd;
      }
      if (mm < 10) {
        mm = '0' + mm;
      }
      today = dd + '.' + mm + '.' + yyyy;
      return today;
    }
  };
});

angular.module("Flexikon.services").factory("DcHighlight", function() {
  this.amount = 0;
  this.current = 0;
  this.focused = -1;

  /**
   * [highlightWord]
   * @param  {[type]} root []
   * @param  {[type]} word []
   * @return {[type]}      []
   */
  this.highlightWord = (function(_this) {
    return function(root, word) {
      var result;
      _this.removeHighlights(root);
      if ((word == null) || word.length === 0) {
        return;
      }
      if (root == null) {
        return;
      }
      result = _this.textNodesUnder(root);
      _this.highlightIntercepted(result, word);
      return _this.amount;
    };
  })(this);

  /**
   * [textNodesUnder]
   * @param  {[type]} root []
   * @return {[type]}      []
   */
  this.textNodesUnder = function(root) {
    var node, text, walk;
    walk = document.createTreeWalker(root, NodeFilter.SHOW_TEXT, null, false);
    text = [];
    node = void 0;
    while ((node = walk.nextNode())) {
      text.push(node);
    }
    return text;
  };

  /**
   * [removeHighlights]
   * @param  {[type]} root []
   * @return {[type]}      []
   */
  this.removeHighlights = (function(_this) {
    return function(root) {
      var highlight, highlights, j, len, plainText, wrapper;
      _this.amount = 0;
      _this.current = 0;
      _this.focused = -1;
      highlights = Array.apply(null, root.querySelectorAll('.highlighted')).reverse();
      for (j = 0, len = highlights.length; j < len; j++) {
        highlight = highlights[j];
        wrapper = highlight.parentElement;
        if (highlight.innerHTML.trim().length === 0) {
          wrapper.removeChild(highlight);
        } else {
          plainText = document.createTextNode(highlight.innerHTML);
          wrapper.replaceChild(plainText, highlight);
        }
      }
      root.normalize();
      return _this.amount;
    };
  })(this);

  /**
   * [highlightIntercepted]
   * @param  {[type]} nodes []
   * @param  {[type]} word  []
   * @return {[type]}       []
   */
  this.highlightIntercepted = (function(_this) {
    return function(nodes, word) {
      var matches, plainTextNodes, splittedWord, wildcardRegex, wildcardWord;
      plainTextNodes = nodes.map(function(node, index) {
        return '#' + index + '#' + node.nodeValue;
      }).join('');
      splittedWord = word.split(/(?!^)/gmi);
      wildcardWord = '(#\\d+#)[^#]*' + splittedWord.join('(#\\d+#)* *');
      wildcardRegex = new RegExp(wildcardWord, "gmi");
      matches = plainTextNodes.match(wildcardRegex);
      if (matches == null) {
        return;
      }
      return matches.forEach(function(match) {
        var node, nodeIndex, nodeIndexes;
        nodeIndexes = match.match(/#(\d+)#/gmi);
        if (nodeIndexes == null) {
          return;
        }
        if (nodeIndexes.length > 1) {
          return nodeIndexes.forEach(function(nodeIndex) {
            var firstIndex, firstLength, firstMatch, firstWord, firstWordRegex, lastIndex, lastLength, lastMatch, lastWord, lastWordRegex, leftNode, rightNode;
            nodeIndex = parseInt(nodeIndex.replace(/#/gmi, ''));
            leftNode = nodes[nodeIndex - 1];
            lastWord = splittedWord.join('?') + '?$';
            lastWordRegex = new RegExp(lastWord, "gmi");
            lastMatch = leftNode.nodeValue.match(lastWord);
            lastLength = lastMatch[0].length;
            lastIndex = lastMatch.index;
            if ((lastMatch == null) || lastMatch.length === 0 || lastMatch[0].length === 0) {
              return;
            }
            _this.highlight(leftNode, word.substr(lastIndex, lastLength), lastIndex);
            rightNode = nodes[nodeIndex];
            firstWord = '^' + splittedWord.join('?') + '?';
            firstWordRegex = new RegExp(firstWord, "gmi");
            firstMatch = rightNode.nodeValue.match(firstWord);
            firstLength = firstMatch[0].length;
            firstIndex = firstMatch.index;
            return _this.highlight(rightNode, word.substr(firstIndex, firstLength), firstIndex, false);
          });
        } else {
          nodeIndex = parseInt(nodeIndexes[0].replace(/#/gmi, ''));
          node = nodes[nodeIndex];
          return _this.highlight(node, word, node.nodeValue.toLowerCase().indexOf(word.toLowerCase()));
        }
      });
    };
  })(this);

  /**
   * [highlight ]
   * @param  {[type]} node   []
   * @param  {[type]} length []
   * @param  {[type]} i      []
   * @return {[type]}        []
   */
  this.highlight = (function(_this) {
    return function(node, word, i, count) {
      var after, highlighted, parent, span;
      if (count == null) {
        count = true;
      }
      parent = node.parentNode;
      if (parent.className.indexOf('highlighted') >= 0) {
        return;
      }
      if (word.length === 0 || i < 0) {
        return;
      }
      if (count) {
        _this.amount++;
      }
      span = document.createElement('span');
      span.className = 'highlighted';
      span.id = 'dc-highlight-' + (_this.amount - 1);
      if (i === 0 && i + word.length === node.nodeValue.length) {
        parent.replaceChild(span, node);
        span.appendChild(node);
        return;
      } else if (i === 0) {
        after = node.splitText(i + word.length);
        parent.replaceChild(span, node);
        span.appendChild(node);
      } else if (i + word.length === node.nodeValue.length) {
        highlighted = node.splitText(i);
        parent.replaceChild(span, highlighted);
        span.appendChild(highlighted);
        return;
      } else {
        after = node.splitText(i + word.length);
        highlighted = node.splitText(i);
        span.appendChild(highlighted);
        after.parentNode.insertBefore(span, after);
      }
      i = after.nodeValue.toLowerCase().indexOf(word.toLowerCase());
      if (i >= 0) {
        _this.highlight(after, word, i);
      }
    };
  })(this);

  /**
   * [unfocus]
   * @return {[type]} []
   */
  this.unfocus = (function(_this) {
    return function() {
      var focusedNodes, j, len, node, results;
      if (_this.focused >= 0) {
        focusedNodes = document.querySelectorAll('#dc-highlight-' + _this.focused);
        results = [];
        for (j = 0, len = focusedNodes.length; j < len; j++) {
          node = focusedNodes[j];
          if (node != null) {
            results.push(node.className = node.className.replace(' focused', ''));
          } else {
            results.push(void 0);
          }
        }
        return results;
      }
    };
  })(this);

  /**
   * [focus]
   * @param  {[type]} count []
   * @return {[type]}       []
   */
  this.focus = (function(_this) {
    return function(count) {
      var focusedNodes, j, len, node, results;
      if (_this.focused === count) {
        return;
      }
      _this.unfocus();
      _this.focused = count;
      focusedNodes = document.querySelectorAll('#dc-highlight-' + count);
      results = [];
      for (j = 0, len = focusedNodes.length; j < len; j++) {
        node = focusedNodes[j];
        if (node.className.indexOf(' focused') < 0) {
          results.push(node.className += ' focused');
        } else {
          results.push(void 0);
        }
      }
      return results;
    };
  })(this);

  /**
   * [isHighlightNode]
   * @param  {[type]}  node []
   * @return {Boolean}      []
   */
  this.isHighlightNode = function(node) {
    var ref;
    return (node != null ? (ref = node.tagName) != null ? ref.toLowerCase() : void 0 : void 0) === 'span' && node.className.indexOf('highlighted') >= 0;
  };
  return this;
});

angular.module("Flexikon.services").factory("DcMediaWiki", function(GlobalSettings) {
  return {
    splitHtml: function(content) {
      var i, index, len, section, sections;
      sections = content.split('<h2');
      for (index = i = 0, len = sections.length; i < len; index = ++i) {
        section = sections[index];
        if (section.indexOf('</h2') >= 0) {
          sections[index] = '<h2' + section;
        }
      }
      return sections;
    },
    splitWiki: function(article) {
      var index, results, splitResult;
      $scope.splittedWiki = {};
      splitResult = $scope.wiki.article.substr($scope.wiki.article.indexOf('\n==')).split(/(?:\n\=\=)([^\=]+)(?:\=\=)/gm);
      index = splitResult[0].length === 0 ? 1 : 0;
      results = [];
      while (index < splitResult.length) {
        results.push($scope.splittedWiki[splitResult[index++]] = splitResult[index++]);
      }
      return results;
    },
    getLanguageAndTitle: function(page) {
      var language, match, ref;
      language = GlobalSettings.Language();
      if (((ref = page.match(/^(:|\/)/)) != null ? ref.length : void 0) === 2) {
        match = page.match(/(?::|\/)(.{2})(?::|\/)/);
        page = page.replace(match[0], '');
        language = match[1];
      }
      return {
        language: language,
        title: page
      };
    },
    escapeStringForRegex: function(str) {
      return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
    }
  };
});

var DcPouchDB;

DcPouchDB = (function(pouchDB) {
  return {

    /**
     * [prepareDBName]
     * @param  {[type]} database []
     * @return {[type]}          []
     */
    prepareDBName: function(database) {
      var prefix, ua, version;
      this.logging = true;
      prefix = 'help_patient_';
      ua = navigator.userAgent;
      if (ua.indexOf("Android") >= 0) {
        version = parseFloat(ua.slice(ua.indexOf("Android") + 8));
        if (version <= 4.3) {
          prefix = 'websql://' + prefix;
        }
      }
      this.dbname = prefix + database;
      ionic.Platform.ready((function(_this) {
        return function() {
          var ref;
          if ((_this.logger != null) && _this.logging) {
            return (ref = _this.logger) != null ? ref.debug('initialized |') : void 0;
          }
        };
      })(this));
      return this.dbname;
    },

    /**
     * [getAll]
     * @param  {[type]} limit []
     * @return {[type]}       []
     */
    getAll: function(limit) {
      var options, ref, self;
      if (limit == null) {
        limit = 0;
      }
      if (this.logging) {
        if (this.logger != null) {
          if ((ref = this.logger) != null) {
            ref.debug('getAll');
          }
        }
      }
      self = this;
      options = {};
      if (limit > 0) {
        options.limit = limit;
      }
      return this.db.allDocs(options).then(function(results) {
        var doc, i, len, ref1, result;
        result = [];
        ref1 = results.rows;
        for (i = 0, len = ref1.length; i < len; i++) {
          doc = ref1[i];
          result.push(self.db.get(doc.id));
        }
        return self.q.all(result);
      });
    },

    /**
     * [get]
     * @param  {[type]} id []
     * @return {[type]}    []
     */
    get: function(id) {
      var ref;
      if (this.logging) {
        if (this.logger != null) {
          if ((ref = this.logger) != null) {
            ref.debug('get | %s', id);
          }
        }
      }
      return this.db.get(id + '');
    },

    /**
     * [insert]
     * @param  {[type]} id='-1'  []
     * @param  {[type]} document []
     * @return {[type]}          []
     */
    insert: function(id, document) {
      var ref;
      if (id == null) {
        id = '-1';
      }
      if (this.logging) {
        if (this.logger != null) {
          if ((ref = this.logger) != null) {
            ref.debug('insert | id : %s | value : %o', id, document);
          }
        }
      }
      return this.db.post({
        _id: id + '',
        article: document
      });
    },

    /**
     * [update]
     * @param  {[type]} doc []
     * @return {[type]}     []
     */
    update: function(doc) {
      var ref;
      if (this.logging) {
        if (this.logger != null) {
          if ((ref = this.logger) != null) {
            ref.debug('update | article : %o', doc);
          }
        }
      }
      return this.db.put(doc);
    },

    /**
     * [insertOrUpdate]
     * @param  {[type]} id    []
     * @param  {[type]} value []
     * @return {[type]}       []
     */
    insertOrUpdate: function(id, value) {
      var ref;
      if (this.logging) {
        if (this.logger != null) {
          if ((ref = this.logger) != null) {
            ref.debug('insert or update | id : %s | value : %o', id, value);
          }
        }
      }
      return this.db.get(id + '').then((function(_this) {
        return function(doc) {
          doc.article = value;
          return _this.update(doc);
        };
      })(this))["catch"]((function(_this) {
        return function(error) {
          return _this.insert(id, value);
        };
      })(this));
    },

    /**
     * [exists]
     * @param  {[type]} id []
     * @return {[type]}    []
     */
    exists: function(id) {
      var ref, self;
      if (this.logging) {
        if (this.logger != null) {
          if ((ref = this.logger) != null) {
            ref.debug('exists | %s', id);
          }
        }
      }
      self = this;
      return this.q(function(resolve, reject) {
        return self.get(id + '').then(function() {
          return resolve(true);
        })["catch"](function() {
          return resolve(false);
        });
      });
    },

    /**
     * [delete]
     * @param  {[type]} doc []
     * @return {[type]}     []
     */
    "delete": function(doc) {
      var ref;
      if (this.logging) {
        if (this.logger != null) {
          if ((ref = this.logger) != null) {
            ref.debug('delete | %o', doc);
          }
        }
      }
      return this.db.remove(doc);
    },

    /**
     * [clear]
     * @return {[type]} []
     */
    clear: function() {
      var ref, self;
      if (this.logging) {
        if (this.logger != null) {
          if ((ref = this.logger) != null) {
            ref.debug('clear');
          }
        }
      }
      self = this;
      return this.getAll().then(function(results) {
        var doc, i, len, result;
        result = [];
        for (i = 0, len = results.length; i < len; i++) {
          doc = results[i];
          result.push(self["delete"](doc));
        }
        return self.q.all(result);
      });
    }
  };
})();

angular.module("Flexikon.services").factory("ExtendedState", function($state) {
  return {
    openInSameBranch: function(newStateName, paramObj) {
      var curr;
      curr = $state.current.name;
      curr = curr.substring(0, curr.lastIndexOf('.') + 1);
      return $state.go(curr + newStateName, paramObj);
    },
    getCurrentBranch: function() {
      var curr;
      curr = $state.current.name;
      return curr.substring(0, curr.lastIndexOf('.') + 1);
    }
  };
});

angular.module("Flexikon.services").factory("Favorites", function(pouchDB, $q) {
  var Favorites;
  Favorites = Object.create(DcPouchDB, {
    q: {
      value: $q
    }
  });
  Favorites.db = pouchDB(Favorites.prepareDBName('favorites'));
  return Favorites;
});

angular.module("Flexikon.services").factory("FlexikonApi", (function(_this) {
  return function($http, $httpBackend, $timeout, $cacheFactory, $q, Api, FlexikonMocking, LocalStorage, GlobalSettings, Login) {
    _this.baseUrl = {
      production: 'http://www.doccheck.com/',
      development: 'http://apps.dev55.antwerpes.de/',
      development_mocked: '/'
    };
    _this.flexikonBaseUrl = {
      production: 'http://flexikon.doccheck.com/de/api.php',
      development: 'http://doccheck-flexikon4.dev55.antwerpes.de/de/api.php',
      development_mocked: '/api.php'
    };
    _this.searchBaseUrl = {
      production: 'http://search.doccheck.com/autosuggest.php',
      development: 'http://search.doccheck.com/autosuggest.php',
      development_mocked: '/'
    };
    _this.basePath = 'api/';
    _this.api = {
      article: 'flexikon_article/',
      top: 'flexikon_top-article/',
      definition: 'flexikon_definition',
      summerbreak: 'flexikon_summerbreak/'
    };

    /*
     * ^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=
     * Utility
     * ^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=
     */
    _this.getBaseUrl = function() {
      return _this.baseUrl[Api.getEnv()];
    };
    _this.getUrlForApi = function(api) {
      return _this.baseUrl[Api.getEnv()] + _this.basePath + _this.api[api];
    };
    _this.getFlexikonUrlForLanguage = function(language) {
      var url;
      if (language == null) {
        language = GlobalSettings.Language();
      }
      url = _this.flexikonBaseUrl[Api.getEnv()].replace('/de/', '/' + language + '/');
      return url;
    };
    _this.getListing = function(page, epp, term) {
      var paramObject;
      if (page == null) {
        page = 1;
      }
      if (epp == null) {
        epp = 18;
      }
      if (term == null) {
        term = '';
      }
      paramObject = {
        page: page,
        epp: epp,
        dc_api_key: Api.getApiKey(),
        term: term,
        language: GlobalSettings.Language()
      };
      return $http({
        url: _this.getUrlForApi('article'),
        method: "GET",
        cache: false,
        params: paramObject
      });
    };
    _this.getTopListing = function(epp) {
      var paramObject;
      if (epp == null) {
        epp = 3;
      }
      paramObject = {
        epp: epp,
        dc_api_key: Api.getApiKey(),
        language: GlobalSettings.Language()
      };
      return $http({
        url: _this.getUrlForApi('top'),
        method: "GET",
        cache: false,
        params: paramObject
      });
    };
    _this.getDefinition = function(page, language) {
      var paramObject;
      if (language == null) {
        language = GlobalSettings.Language();
      }
      paramObject = {
        title: page,
        language: language,
        dc_api_key: Api.getApiKey()
      };
      return $http({
        url: _this.getUrlForApi('definition'),
        method: "GET",
        cache: false,
        params: paramObject
      });
    };
    _this.getPreview = function(page, section, language) {
      var paramObject, url;
      if (language == null) {
        language = GlobalSettings.Language();
      }
      paramObject = {
        action: 'parse',
        format: 'json',
        page: page,
        section: section,
        disabletoc: true
      };
      url = _this.getFlexikonUrlForLanguage(language);
      return $http({
        url: url,
        method: "GET",
        cache: false,
        params: paramObject
      });
    };
    _this.getArticle = function(page, language) {
      var paramObject, url;
      if (language == null) {
        language = GlobalSettings.Language();
      }
      paramObject = {
        action: 'query',
        format: 'json',
        rvprop: 'content',
        prop: 'revisions',
        titles: page
      };
      url = _this.getFlexikonUrlForLanguage(language);

      /*
      return $http({
        url: url
        method: "GET"
        cache: false
        params: paramObject
      })
       */
      return $http.get(url, {
        params: paramObject,
        cache: false
      });
    };
    _this.summerbreakCheck = function() {
      var language, paramObject, url;
      if (typeof language === "undefined" || language === null) {
        language = GlobalSettings.Language();
      }
      paramObject = {
        action: 'dcissummerbreak',
        format: 'json'
      };
      url = _this.getFlexikonUrlForLanguage(language);
      return $http.get(url, {
        params: paramObject,
        cache: false,
        timeout: 10000
      });
    };
    _this.getChannelListing = function() {
      var paramObject, userId;
      userId = LocalStorage.get('dc_flexikon_user_id') || 'no:user:specified';
      paramObject = {
        action: 'query',
        list: 'usercontribs',
        ucuser: userId,
        uclimit: 100,
        ucdir: 'older',
        format: 'json',
        ucprop: 'title|timestamp'
      };
      return $http({
        url: _this.getFlexikonUrlForLanguage(GlobalSettings.Language()),
        method: "GET",
        cache: false,
        params: paramObject
      });
    };
    _this.getSuggestions = function(q, count, mql) {
      var paramObject, ref;
      if (count == null) {
        count = 5;
      }
      if (mql == null) {
        mql = 2;
      }
      if ((ref = _this.suggestionCancel) != null) {
        ref.resolve();
      }
      _this.suggestionCancel = $q.defer();
      paramObject = {
        q: q.toLowerCase(),
        count: count,
        mql: mql,
        dictionary: 'flexikon_title'
      };
      return $http({
        url: _this.searchBaseUrl[Api.getEnv()],
        method: "GET",
        cache: false,
        params: paramObject,
        timeout: _this.suggestionCancel.promise
      });
    };
    _this.getTemplate = function(templatetext, language, successCallback, errorCallback, progressCallback) {
      var fd, xhr;
      if ((language == null) || language === 'undefined') {
        language = GlobalSettings.Language();
      }
      fd = new FormData();
      fd.append('text', templatetext);
      xhr = new XMLHttpRequest();
      xhr.upload.addEventListener('progress', function(e) {
        if (progressCallback) {
          return progressCallback(e);
        }
      }, false);
      xhr.addEventListener("load", function(e) {
        if (successCallback) {
          return successCallback(JSON.parse(this.response), e);
        }
      }, false);
      xhr.addEventListener("error", function(e) {
        if (errorCallback) {
          return errorCallback(e);
        }
      }, false);
      xhr.addEventListener("abort", function(e) {
        if (errorCallback) {
          return errorCallback(e);
        }
      }, false);
      xhr.open('POST', _this.getFlexikonUrlForLanguage(language) + '?action=parse&format=json&title=dummy');
      _this.setDocCheckHeader(xhr);
      xhr.setRequestHeader('Cache-Control', 'no-cache');
      xhr.setRequestHeader("Accept", "application/json");
      if (typeof startedCallback !== "undefined" && startedCallback !== null) {
        startedCallback();
      }
      return xhr.send(fd);
    };
    _this.post = function(title, text, section, successCallback, errorCallback, progressCallback) {
      var fd, xhr;
      fd = new FormData();
      fd.append('title', title);
      fd.append('text', text);
      fd.append('language', GlobalSettings.Language());
      if ((section != null) && section !== -1) {
        fd.append('section', section);
      }
      xhr = new XMLHttpRequest();
      xhr.upload.addEventListener('progress', function(e) {
        if (progressCallback) {
          return progressCallback(e);
        }
      }, false);
      xhr.addEventListener("load", function(e) {
        if (successCallback) {
          return successCallback(this.response, e);
        }
      }, false);
      xhr.addEventListener("error", function(e) {
        if (errorCallback) {
          return errorCallback(e);
        }
      }, false);
      xhr.addEventListener("abort", function(e) {
        if (errorCallback) {
          return errorCallback(e);
        }
      }, false);
      xhr.open('POST', _this.getUrlForApi('article') + '?dc_api_key=' + Api.getApiKey() + '&language=' + GlobalSettings.Language());
      xhr.setRequestHeader('Cache-Control', 'no-cache');
      xhr.setRequestHeader('Authorization', Login.getAccessToken());
      xhr.setRequestHeader('dc_api_key', Api.getApiKey());
      xhr.setRequestHeader("Accept", "application/json");
      _this.setDocCheckHeader(xhr);
      if (typeof startedCallback !== "undefined" && startedCallback !== null) {
        startedCallback();
      }
      return xhr.send(fd);
    };
    _this.setDocCheckHeader = function(xhr) {
      var device, deviceInformation;
      device = ionic.Platform.device();
      if (device == null) {
        deviceInformation = [];
      } else {
        deviceInformation = ['os=' + device.platform, 'os-version=' + device.version, 'manufacturer=' + device.manufacturer, 'device=' + device.model];
      }
      return xhr.setRequestHeader('X-Doccheck-App', 'Flexikon App/1.4.0; ' + deviceInformation.join('; '));
    };
    return {
      getBaseUrl: _this.getBaseUrl,
      getUrlForApi: _this.getUrlForApi,
      getFlexikonUrlForLanguage: _this.getFlexikonUrlForLanguage,
      setDocCheckHeader: _this.setDocCheckHeader,
      getListing: _this.getListing,
      getTopListing: _this.getTopListing,
      getChannelListing: _this.getChannelListing,
      getDefinition: _this.getDefinition,
      getPreview: _this.getPreview,
      getArticle: _this.getArticle,
      getTemplate: _this.getTemplate,
      getSuggestions: _this.getSuggestions,
      summerbreakCheck: _this.summerbreakCheck,
      post: _this.post
    };
  };
})(this));

angular.module("Flexikon.services").factory("FlexikonMocking", function($httpBackend, Api) {
  var extractId, extractPage, extractParam, generateMockArticle;
  console.debug('#=-=Initializing Mocking...=#=-=#=-=#');
  if (Api.getEnv() === 'development_mocked') {
    console.debug('# Mocking is currently enabled');
    console.debug('# Set environment in Api service to \"development\"');
    console.debug('# or \"production\" to disable it.');
    console.debug('#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n');
    generateMockArticle = function(id, page) {
      var article;
      id = id || parseInt(Math.random() * 50000);
      return article = {
        query: {
          pages: {
            "12345": {
              id: '' + id,
              title: page || 'Mocked Article' + id,
              revisions: [
                {
                  "*": "''Synonym: Cor''<br /> \n'''''Englisch''': [[:en:Heart|heart]]'' \n \n==Definition== \nDas menschliche '''Herz''' ist das zentrale [[Organ]] des [[Blutkreislauf]]s. Es handelt sich um ein [[Muskel|muskuläres]] [[Hohlorgan]] und funktioniert als Druck- und Saugpumpe, die pro Minute etwa 5 bis 6 Liter [[Blut]] durch den menschlichen Körper pumpt. Es ist Teil des [[kardiovaskuläres System|kardiovaskulären System]]s. \n \nDie Lehre von Struktur, Funktion und Erkrankungen des Herzens ist die [[Kardiologie]]. Die Zellen des Herzens werden als [[Kardiomyozyt]]en bezeichnet. \n \n==Anatomie== \n===Übersicht=== \nDas Herz befindet sich im [[Mediastinum]] hinter dem [[Sternum]] und liegt im \"Herzbeutel\", der durch die beiden Blätter des [[Perikard]]s gebildet wird. Der größte Teil der [[kardial]]en Masse wird durch die Herzmuskulatur ([[Myokard]]) gebildet, die zum Lumen hin mit [[Endokard]] ausgekleidet ist, nach außen hin vom [[Epikard]] bedeckt wird. \n \nAnatomisch ist das Herz aus zwei Kammern (Ventrikel) und zwei Vorhöfen (Atrien), den so genannten [[Herzhöhle]]n, aufgebaut. Sie sind durch [[Herzklappe]]n voneinander getrennt und in den Körper- beziehungsweise Lungenkreislauf eingeschaltet. Die bindegewebige Trennschicht zwischen Vorhof- und Ventrikelmyokard in der Ventilebene des Herzens bezeichnet man als [[Herzskelett]]. Für die proprietäre Blutversorgung des Herzens sind die [[Koronararterie]]n verantwortlich. \n \nDie nach [[kranial]] und [[dorsal]] weisende Fläche des Herzens, an der die großen Gefäßstämme münden, bezeichnet man als [[Herzbasis]] (Basis cordis), das ihr entgegen gesetzte Ende als [[Herzspitze]] (Apex cordis). \n \n<dcmedia id=\"Bw4096IOdN9DEP6H5Tmk1g\" view=\"max\" /> \n \n===Dimensionen=== \nDas Herz eines Erwachsenen ist etwa 12 cm lang, und misst im Querschnitt an der breitesten Stelle 8 bis 9 cm, an der tiefsten ca. 6 cm. Das Gewicht schwankt beim Mann zwischen 280 bis 340 Gramm, bei der Frau zwischen 230 bis 280 Gramm. Über den größten Teil des Lebens nimmt die Herzmasse kontinuierlich zu. \n \n===Einteilung=== \nDas Herz ist durch [[Herzseptum|Septen]] vertikal in eine rechte und eine linke Hälfte geteilt, horizontal durch eine zirkuläre Einschnürung und die [[Segelklappe]]n in 2 [[Herzvorhof|Herzvorhöfe]] und 2 [[Herzkammer]]n. Damit ergeben sich insgesamt vier [[Herzhöhle]]n: \n \n* Rechter Vorhof (Atrium cordis dextrum) \n* Rechte Kammer (rechter Ventrikel, Ventriculus cordis dexter) \n* Linker Vorhof (Atrium cordis sinistrum) \n* Linke Kammer (linker Ventrikel, Ventriculus cordis sinister) \n \nDiese Aufteilung des Herzens ist auch von außen erkennbar. Zwischen den Vorhöfen und den Kammern verläuft als zirkuläre Einschnürung der [[Sulcus coronarius]]. Zwischen den Kammern finden sich als Einziehungen der Herzmuskulatur der [[Sulcus interventricularis anterior]] und der [[Sulcus interventricularis posterior]]. \n \n===Außenflächen=== \nMan unterscheidet anatomisch mehrere Außenflächen des Herzens: \n* ''Facies sternocostalis'': zum [[Brustbein]] (Sternum) und zu den [[Rippe]]n hin gelegene Fläche \n* ''Facies diaphragmatica'': zum [[Zwerchfell]] (Diaphragma) hin gelegene Fläche \n* ''Facies pulmonalis'': zur [[Lunge]] hin gelegene Fläche \n \n===Innenflächen=== \nDie mit Endokard überzogene Innenfläche des Herzens ist nicht glatt und unstrukturiert, sondern im Bereich der Herzventrikel von vernetzen rundlichen Muskelbälkchen, den [[Trabeculae carneae]], überzogen. Ferner entspringen hier die [[Papillarmuskel]]n, welche über Sehnenfäden ([[Chordae tendineae]])  die Segelklappen verspannen. \n \n===Blutversorgung=== \nDie Versorgung des Herzens mit arteriellem Blut erfolgt über zwei große  Koronargefäße, die [[Arteria coronaria dextra]] und die [[Arteria coronaria sinistra]]. Sie bilden untereinander zahlreiche [[Anastomose]]n. Diese Anastomosen reichen jedoch nicht aus, um einen vollständigen [[Kollateralkreislauf]] zu bilden. Man spricht deshalb von funktionellen [[Endarterie]]n. Bei Verschluss eines Astes kommt es zu einer [[Ischämie]] des Versorgungsgebiets. Bei lang andauernder Ischämie kommt es zur [[Nekrose]] des [[Herzmuskelgewebe]]s. \n \nDer Abtransport des venösen Blutes erfolgt über die [[Koronarvene]]n (u.a. die [[Vena cardiaca magna]]) und den [[Sinus coronarius]]. \n \n''Weitere Einzelheiten siehe'': [[Koronararterie]]n \n \n===Innervation=== \nDie [[vegetativ]]e [[Innervation]] des Herzens erfolgt über [[sympathisch]]e Nervenfasern der [[Halsganglion|Halsganglien]], die auch als [[Herznerv]]en (Nervi cardiaci) bezeichnet werden, und [[parasympathisch]]e Fasern des [[Nervus vagus]] (Nervus X). Sie strahlen in ein Nervengeflecht, den [[Plexus cardiacus]], an der Herzbasis ein. Die interne elektrische Steuerung der Herztätigkeit erfolgt über das Reizleitungssystem des Herzens. \n \n''Weitere Einzelheiten siehe'': [[Erregungsleitungssystem des Herzens]] \n \n===Topographie=== \nDas Herz liegt innerhalb des [[Thorax]] im mittleren [[Mediastinum]], wobei sich seine Kontur auf die 2. bis 5. [[Rippe]] projiziert. Oben reicht die Herzbasis etwa zwei Zentimeter über den rechten [[Sternum|Sternalrand]] hinaus, unten grenzt die Herzspitze bis fast an die linke [[Medioklavikularlinie]]. Lateral wird das Herz jeweils von den beiden [[Pleura]]blättern des linken und rechten [[Lunge]]nflügels begrenzt. Der linke Vorhof steht [[dorsal]] in direktem Kontakt mit dem [[Ösophagus]]. [[Ventral]] des Herzens befindet sich die vordere Brustwand mit dem [[Sternum]] und dem dahinter liegenden [[Thymus]]. [[Kaudal]] sitzt das Herz dem Zwerchfell auf, das mit dem Perikard verwachsen ist. \n \n===Klinische Anatomie=== \nFür die Lokalisation klinischer Befunde wird das [[AHA]]-System der [[kardiale Segmentierung|kardialen Segmentierung]] verwendet. \n \n==Embryologie== \nDie Herzanlage ([[kardiogene Platte]]) entwickelt sich um den 18. Tag in der Nähe der [[Membrana buccopharyngea]] aus dem Seitenplattenmesoderm ([[Herzschlauch]], [[Gefäß]]e, [[Epikard]], [[Perikard]]) und der [[Neuralleiste]] (Herzseptum in der Ausflussbahn). \nZunächst bilden [[Angioblast]]en Blutinseln, aus denen sich ein hufeisenförmiger [[Plexus|Gefäßplexus]] bildet. Die Zellen in seinem Inneren werden zu primitiven [[Blutzelle]]n, die peripheren Zellen zu [[Endothelzelle]]n. \n \nDer Gefäßplexus verschmilzt anschließend beidseitig zu je einem [[Endokardrohr]]. Durch die laterale Abfaltung verlagern sich die Endokardrohre nach [[medial]] und verschmelzen dort zum unpaaren Herzschlauch. Ihn umgebende [[Mesenchym]]zellen des [[viszeral]]en Blattes verdichten sich zum [[Myokard]]. Zwischen Endothel (Endokard) und dem Myokard liegt die [[Herzgallerte]], die [[extrazellulär]]es Material des Mesenchyms darstellt. \n \nDie kraniokaudale Abfaltung verursacht das Absteigen (''[[Descensus cordis]]'') dieser Strukturen und die Verlagerung in die Perikardhöhle (s.u.) des sich bildenden Herzens. Im [[Mesoderm]] entsteht durch Spaltbildung die primäre Perikardhöhle, worin der Herzschlauch über das dorsale Mesoderm befestigt ist. Der mittlere Teil des dorsalen Mesoderms [[Degeneration|degeneriert]], wodurch sich der [[Sinus transversus pericardii]] bildet. \n \nAusweitungen des primitiven Herzschlauchs sind: \n* [[Truncus arteriosus]] \n* [[Bulbus cordis]] \n* [[Ventriculus cordis communis]] \n* [[Atrium commune]] \n* [[Sinus venosus]] \n \nAm 22. Tag beginnt das Myokard rhythmische Kontraktionen. \n \n''siehe Hauptartikel'': [[Embryonale Herzentwicklung]] \n \n==Physiologie== \nDie Hauptaufgabe des Herzens ist die Aufrechterhaltung des [[Blutkreislauf]]s. Neben der Pumpfunktion wird dem Herzen auch eine Aufgabe bei der [[Blutdruck]]regulation zugeschrieben, die spezielle endokrine Zellen vor allem in den Atrien wahrnehmen. In diesem Zusammenhang ist das atriale natriuretische Peptid ([[ANP]]) beschrieben. Das Herz ist ebenso in der Lage, auf eine Veränderung des [[Blutvolumen]]s zu reagieren. So steigt zum Beispiel bei erhöhtem Volumen die [[Herzfrequenz]] an ([[Bainbridge-Reflex]]). Ebenso wird die [[Kontraktilität]] der Herzmuskelzellen gesteigert ([[Frank-Starling-Mechanismus]]). \n \n==Klinik== \n===Klinische Untersuchung=== \nDie klinische Untersuchung des Herzens basiert im Wesentlichen auf der [[Auskultation]] der [[Herzton|Herztöne]] und [[Herzgeräusch]]e sowie der [[Palpation]] des [[Puls]]es. \n{| \n! [http://tv.doccheck.com/de/movie/565/how-to-make-it-herzuntersuchung/ How to make it: Herzuntersuchung] \n|- \n| <dctv key=\"lkkndsgkselp\" preview=\"4\" duration=\"653\" /> \n|} \n \n===Apparative Diagnostik=== \nFür die Untersuchung des Herzens stehen zahlreiche Verfahren zur Verfügung, die [[invasiv]] oder [[nicht-invasiv]] sein können. Dazu zählen u.a.: \n* [[EKG]] \n* [[Echokardiografie]] \n* [[Kardio-CT]] \n* [[Kardio-MRT]] \n* [[Linksherzkatheteruntersuchung]] \n* [[Rechtsherzkatheteruntersuchung]] \n===Wichtige Erkrankungen=== \nDie Erkrankungen des Herzens sind die Domäne der [[Kardiologie]]. Da das Herz funktionell eng mit dem Gefäßsystem im Zusammenhang steht, spricht man auch von [[Herz-Kreislauf-Erkrankung]]en. Wichtige Erkrankungen sind: \n* [[Koronare Herzkrankheit]] (KHK) \n* [[Herzinfarkt]] \n* [[Herzinsuffizienz]] \n* [[Herzklappenvitium|Herzklappenvitien]] \n* [[Herzrhythmusstörung]]en \n* [[Myokardiopathie]]n \n \n==Literatur== \nHerrmann-Lingen, C.: Depression und koronare Herzkrankheit. In: herzmedizin 26 (2009). H.2, S.76-81. [http://load.doccheck.com/de/load.php/sid/5e43f8831ace77fb455e2c30ae02fa90/cl/details/anid/9384a5c837ba80a10.82337569/listtype/search/searchparam/herzmedizin%202%202009| Volltext abrufen] \n \n==Weblinks== \n* [http://www.herz.hexal.de/grundwissen/herz/blutfluss.php 3D-Animation des schlagendes Herzens mit vielen Infos (Hexal)] \n* [http://www-medlib.med.utah.edu/kw/pharm/hyper_heart1.html 2D-Animation des schlagenden Herzens mit Diagrammen (engl.)] \n* [http://www.dgk-herzfuehrer.de Deutsche Gesellschaft für Kardiologie] \n* [http://www.gstcvs.org Deutsche Gesellschaft für Thorax-, Herz- und Gefäßchirurgie] \n \n[[en:Heart]]"
                }
              ]
            }
          }
        }
      };
    };
    extractParam = function(url, param, def) {
      var match;
      match = url.match(new RegExp(param + '=([^&]*)(&|$)'));
      if (match == null) {
        return def;
      }
      return match[1] || def;
    };
    extractId = function(url) {
      var match;
      match = url.match(/\/\d+(\?|$)/);
      if (match == null) {
        return;
      }
      return match[0].replace('/', '').replace('?', '');
    };
    extractPage = function(url) {
      return url.match(/\/\d+(\?|$)/)[0].replace('/', '').replace('?', '');
    };

    /*
    		 *	getArticle
     */
    $httpBackend.when('GET', /^\/api.php\?/).respond(function(method, url, data) {
      var id, page, result;
      console.debug('Mocking Article Detail response..');
      id = extractParam(url, 'id', '123456');
      page = extractParam(url, 'page', 'Mocked Heading');
      result = generateMockArticle(id, page);
      return [200, result, {}];
    });

    /*
    		 *	getListing
     */
    return $httpBackend.when('GET', /^\/de\/api\/flexikon_article\/(\?.*)/).respond(function(method, url, data) {
      var i, j, mockedArticle, ref, result;
      console.debug('Mocking Article Listing response..');
      result = {};
      result.urls = [];
      data = {};
      data.epp = parseInt(extractParam(url, 'epp', 20));
      data.page = parseInt(extractParam(url, 'page', 1));
      data.term = extractParam(url, 'term', 'Article');
      data.excellent = angular.fromJson(extractParam(url, 'excellent', false));
      for (i = j = 1, ref = data.epp; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
        mockedArticle = {
          id: '' + (i + data.epp * (data.page - 1)),
          title: 'Mocked ' + data.term + ' ' + (i + data.epp * (data.page - 1)),
          content_highlight: 'Lorem ipsum Minim enim reprehenderit eu dolore id eu et amet dolore Duis quis eu esse minim officia Excepteur id ut ad ullamco Ut Duis. Lorem ipsum Minim enim reprehenderit eu dolore id eu et amet dolore Duis quis eu esse minim officia Excepteur id ut ad ullamco Ut Duis. ',
          picture_url: './img/' + (i % 3 === 0 ? 'blinky.png' : i % 3 === 1 ? 'clyde.jpg' : i % 3 === 2 ? 'inky.png' : void 0)
        };
        result.urls.push(mockedArticle);
      }
      return [200, result, {}];
    });
  } else {
    console.debug('# Mocking is currently disabled');
    console.debug('# Set environment in Api service to \"development_mocked\"');
    console.debug('#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n');
    return {};
  }
});

angular.module("Flexikon.services").factory("FullscreenViewer", function($ionicModal, $q) {
  this.modal = void 0;

  /**
   * [initModal ]
   * @param  {[type]} template []
   * @param  {[type]} scope    []
   * @return {[type]}          []
   */
  this.initModal = (function(_this) {
    return function(template, scope) {
      if (_this.modal) {
        _this.modal.remove();
      }
      _this.modal = $ionicModal.fromTemplate(template, {
        scope: scope,
        animation: 'slide-in-out-right fade'
      });
      return scope.$on('$destroy', function() {
        if (_this.modal != null) {
          _this.modal.remove();
          return _this.modal = void 0;
        }
      });
    };
  })(this);

  /**
   * [initModalFromUrl]
   * @param  {[type]} url   []
   * @param  {[type]} scope []
   * @return {[type]}       []
   */
  this.initModalFromUrl = (function(_this) {
    return function(url, scope, cssClass) {
      if (_this.modal) {
        _this.modal.remove();
      }
      return $ionicModal.fromTemplateUrl(url, {
        scope: scope,
        animation: 'slide-in-out-right fade',
        cssClass: 'BLUBB'
      }).then(function(modal) {
        _this.modal = modal;
        return scope.$on('$destroy', function() {
          if (_this.modal != null) {
            _this.modal.remove();
            return _this.modal = void 0;
          }
        });
      });
    };
  })(this);

  /**
   * [openModal]
   * @param  {[type]} template []
   * @param  {[type]} scope    []
   * @return {[type]}          []
   */
  this.openModal = (function(_this) {
    return function(template, scope) {
      if (template != null) {
        _this.initModal(template, scope);
      }
      return _this.modal.show();
    };
  })(this);

  /**
   * [openModalFromUrl]
   * @param  {[type]} url   []
   * @param  {[type]} scope []
   * @return {[type]}       []
   */
  this.openModalFromUrl = (function(_this) {
    return function(url, scope, cssClass) {
      if (url != null) {
        return _this.initModalFromUrl(url, scope).then(function() {
          return _this.modal.show();
        });
      }
    };
  })(this);

  /**
   * [closeModal]
   * @return {[type]} []
   */
  this.closeModal = (function(_this) {
    return function() {
      if (typeof screen !== "undefined" && screen !== null) {
        if (typeof screen.unlockOrientation === "function") {
          screen.unlockOrientation();
        }
      }
      if (_this.modal != null) {
        _this.modal.hide()["finally"](_this.modal.remove);
        return _this.modal = void 0;
      }
    };
  })(this);
  return {
    initModal: this.initModal,
    initModalFromUrl: this.initModalFromUrl,
    openModal: this.openModal,
    openModalFromUrl: this.openModalFromUrl,
    closeModal: this.closeModal
  };
});

angular.module("Flexikon.services").factory("GlobalSettings", function(LocalStorage) {
  return {
    settings: {
      privacy: void 0,
      language: 'de',
      answerability: void 0,
      stacktables: false
    },
    init: function() {
      var self;
      console.debug('#=-=Initializing GlobalSettings...-=#');
      if (LocalStorage.isSet('flexikon_settings_save')) {
        this.settings = JSON.parse(LocalStorage.get('flexikon_settings_save'));
      }
      console.debug('# The currently set language is: ' + this.settings.language);
      console.debug('#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n');
      self = this;
      if (this.settings.language == null) {
        if ((typeof navigator !== "undefined" && navigator !== null ? navigator.language : void 0) == null) {
          this.settings.language = 'de';
        } else {
          this.settings.language = navigator.language.substr(0, navigator.language.indexOf('-')).toLowerCase() || 'de';
        }
      }
      if (this.settings.privacy == null) {
        this.settings.privacy = 0;
      }
      if (!this.settings.answerability) {
        this.settings.answerability = 2;
      }
      return this.persist();
    },
    persist: function() {
      return LocalStorage.set('flexikon_settings_save', JSON.stringify(this.settings));
    },
    Privacy: function(value) {
      if (value === void 0) {
        return this.settings.privacy;
      } else {
        this.settings.privacy = value;
        return this.persist();
      }
    },
    Language: function(value) {
      if (value === void 0) {
        return this.settings.language || 'de';
      } else {
        this.settings.language = value.toLowerCase();
        return this.persist();
      }
    },
    Answerability: function(value) {
      if (value === void 0) {
        return this.settings.answerability;
      } else {
        this.settings.answerability = value;
        return this.persist();
      }
    },
    Stacktables: function(value) {
      if (value === void 0) {
        return this.settings.stacktables;
      } else {
        this.settings.stacktables = value;
        return this.persist();
      }
    },
    getExtendedLanguage: function() {
      return this.settings.language + '_' + this.settings.language.toUpperCase();
    },
    getLanguageForURL: function() {
      if (this.settings.language === 'en') {
        return 'com';
      }
      return this.settings.language;
    }
  };
});

angular.module("Flexikon.services").factory("InAppPurchase", function(pouchDB, $q) {
  var InAppPurchase;
  InAppPurchase = Object.create(DcPouchDB, {
    q: {
      value: $q
    }
  });
  InAppPurchase.db = pouchDB(InAppPurchase.prepareDBName('inAppPurchase'));
  return InAppPurchase;
});

angular.module("Flexikon.services").factory("LastSeen", function(pouchDB, $q) {
  var LastSeen;
  LastSeen = Object.create(DcPouchDB, {
    q: {
      value: $q
    }
  });
  LastSeen.db = pouchDB(LastSeen.prepareDBName('lastSeen'));
  return LastSeen;
});

angular.module("Flexikon.services").factory("Load", function($rootScope, $timeout) {
  return {
    loading: false,
    blocked: false,
    timeout: void 0,
    isLoading: function(loading) {
      if (loading === void 0) {
        return this.loading;
      } else {
        return this.loading = loading;
      }
    },
    isBlocked: function(block) {
      var self;
      if (block === void 0) {
        return this.blocked;
      } else {
        this.blocked = block;
        if (this.blocked) {
          self = this;
          $timeout(function() {
            return self.isBlocked(false);
          }, 30000);
        } else {
          $timeout.cancel(this.timeout);
        }
        return $rootScope.$$phase || $rootScope.$apply();
      }
    }
  };
});

angular.module("Flexikon.services").factory("LocalStorage", [
  "$window", function($window) {
    return {
      set: function(key, value) {
        return $window.localStorage[key] = value;
      },
      get: function(key, defaultValue) {
        return $window.localStorage[key] || defaultValue;
      },
      unset: function(key) {
        return $window.localStorage[key] = '';
      },
      isSet: function(key) {
        return $window.localStorage[key] !== void 0 && $window.localStorage[key] !== '' && $window.localStorage[key] !== {};
      },
      setObject: function(key, value) {
        return $window.localStorage[key] = JSON.stringify(value);
      },
      getObject: function(key) {
        return JSON.parse($window.localStorage[key] || {});
      }
    };
  }
]);

angular.module("Flexikon.services").factory("LoginDB", function(pouchDB, $q) {
  var Login;
  Login = Object.create(DcPouchDB, {
    q: {
      value: $q
    }
  });
  Login.db = pouchDB(Login.prepareDBName('login'));
  return Login;
});

angular.module("Flexikon.services").factory("Login", function($http, $rootScope, Api, LocalStorage, authService, Load, GlobalSettings, Favorites, UserSave, LastSeen, LoginDB) {

  /*
  	 *	Login Constants
   */
  var accessToken, clientSecret, grantType, intialized, loginId, strDcLanguage, tokenDomain, url;
  url = 'https://login.doccheck.com/';
  tokenDomain = 'service/oauth/access_token/';
  loginId = '2000000008360';
  clientSecret = 'AhChoo!Opqlkt2$h!';
  strDcLanguage = GlobalSettings.Language();
  grantType = 'authorization_code';
  intialized = false;
  accessToken = '';
  return {

    /*
    	 *	Initialiaze on app restart
     */
    init: function() {
      if (!this.initialized) {
        console.debug('#=-=Initializing Login...=-=#=-=#=-=#');
        $http.defaults.headers.post['Content-Type'] = false;
        $http.defaults.headers.post['Allow-Control-Allow-Origin'] = '*';
        $http.defaults.headers.common['Accept'] = 'application/json';
        LoginDB.get('dc_flexikon_access_token').then((function(_this) {
          return function(token) {
            $http.defaults.headers.common['Authorization'] = token.article;
            _this.accessToken = token.article;
            console.debug('#=-=Token restore completed =-=#=-=#=-=#');
            console.debug('# Restored oAuth token from local database');
            console.debug('#');
            console.debug('# Current authorization header: ');
            console.debug('# ' + $http.defaults.headers.common.Authorization);
            console.debug('#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n');
            return authService.loginConfirmed();
          };
        })(this))["catch"]((function(_this) {
          return function() {
            _this.accessToken = '';
            console.debug('#=-=Token restore failed =-=#=-=#=-=#');
            console.debug('# No token to restore');
            return console.debug('#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n');
          };
        })(this));
        return strDcLanguage = GlobalSettings.Language();
      }
    },

    /*
    	 * Collect token
     */
    collectToken: function(code) {
      return $http({
        url: url + tokenDomain,
        method: "POST",
        cache: false,
        params: {
          client_id: loginId,
          client_secret: clientSecret,
          grant_type: grantType,
          code: code
        }
      });
    },

    /*
    	 * Login
     */
    sendLoginRequest: function(username, password, successCallback, errorCallback) {
      var self;
      self = this;
      return $http({
        url: url,
        method: "POST",
        cache: false,
        params: {
          login_id: loginId,
          strDcLanguage: strDcLanguage,
          language: strDcLanguage,
          username: username,
          password: password
        }
      }).success(function(data, status, headers, config) {
        if (data.boolSuccess) {
          LocalStorage.set('dc_flexikon_user_id', data.strUserId);
          UserSave.get(LocalStorage.get('dc_flexikon_user_id')).then(function(data) {
            var fav, i, j, len, len1, ls, ref, ref1, results, userData;
            userData = JSON.parse(data.article);
            ref = userData.lastSeen;
            for (i = 0, len = ref.length; i < len; i++) {
              ls = ref[i];
              LastSeen.insert(ls._id, ls.article);
            }
            ref1 = userData.favorites;
            results = [];
            for (j = 0, len1 = ref1.length; j < len1; j++) {
              fav = ref1[j];
              results.push(Favorites.insert(fav._id, fav.article));
            }
            return results;
          }, function(error) {
            return console.debug('Couldn\'t fetch favorites for ' + LocalStorage.get('dc_flexikon_user_id'));
          });
          return self.collectToken(data.arrUrlParams.code).success(function(data, status, headers, config) {
            var token;
            if (!data.access_token) {
              self.errorFunction();
              if (typeof errorCallback === "function") {
                errorCallback(data, status, headers, config);
              }
              authService.loginCancelled();
              return;
            }
            token = data.token_type + " " + data.access_token;
            console.debug('#=-=New access token:=-=#=-=#=-=#=-=#');
            console.debug('# ' + token);
            console.debug('#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#=-=#\n\n');
            self.saveToken(token);
            self.setDefaultHeader(token);
            if (typeof successCallback === "function") {
              successCallback(data, status, headers, config);
            }
            return authService.loginConfirmed();
          }).error(function(data, status, headers, config) {
            self.errorFunction();
            if (typeof errorCallback === "function") {
              errorCallback(data, status, headers, config);
            }
            return authService.loginCancelled();
          });
        } else {
          self.errorFunction();
          if (typeof errorCallback === "function") {
            errorCallback(data, status, headers, config);
          }
          return authService.loginCancelled();
        }
      }).error(function(data, status, headers, config) {
        self.errorFunction();
        if (typeof errorCallback === "function") {
          errorCallback(data, status, headers, config);
        }
        return authService.loginCancelled();
      });
    },
    errorFunction: function() {
      this.deleteToken();
      return this.unsetDefaultHeader();
    },

    /*
    	 *	Logout
     */
    signOut: function() {
      var always;
      this.deleteToken();
      this.unsetDefaultHeader();
      always = function() {
        Favorites.clear();
        LastSeen.clear();
        LocalStorage.unset('pushToken');
        LocalStorage.set('last_dc_flexikon_user_id', LocalStorage.get('dc_flexikon_user_id'));
        LocalStorage.unset('dc_flexikon_user_id');
        $rootScope.$broadcast('event:auth-logout');
      };
      return Favorites.getAll().then(function(favData) {
        return LastSeen.getAll().then(function(lsData) {
          var saveObject;
          saveObject = {
            lastSeen: lsData,
            favorites: favData
          };
          return UserSave.get(LocalStorage.get('dc_flexikon_user_id')).then(function(doc) {
            doc.article = JSON.stringify(saveObject);
            UserSave.update(doc);
            return always();
          }, function(error) {
            UserSave.insert(LocalStorage.get('dc_flexikon_user_id'), JSON.stringify(saveObject));
            return always();
          });
        });
      });
    },

    /*
    	 * Determine if a token is present and if it's still valid
     */
    isAuthenticated: function() {
      return (this.accessToken != null) && this.accessToken.length > 0 && parseInt(LocalStorage.get('dc_flexikon_token_expires_at')) > (Date.now());
    },

    /*
    	 *	Save token + expiry
     */
    saveToken: function(token) {
      var expiresIn, loginTime;
      console.debug(token);
      loginTime = new Date().getTime();
      expiresIn = 1000 * 60 * 60 * 24 * 31 * 6;
      this.accessToken = token;
      LoginDB.get('dc_flexikon_access_token').then((function(_this) {
        return function(doc) {
          doc.article = token;
          return LoginDB.update(token);
        };
      })(this))["catch"]((function(_this) {
        return function() {
          return LoginDB.insert('dc_flexikon_access_token', token);
        };
      })(this));
      return LocalStorage.set('dc_flexikon_token_expires_at', loginTime + expiresIn);
    },

    /*
    	 *
     */
    deleteToken: function() {
      this.accessToken = '';
      return LoginDB.get('dc_flexikon_access_token').then((function(_this) {
        return function(doc) {
          return LoginDB["delete"](doc);
        };
      })(this));
    },
    setDefaultHeader: function(token) {
      return $http.defaults.headers.common.Authorization = token;
    },
    unsetDefaultHeader: function() {
      return $http.defaults.headers.common.Authorization = '';
    },
    getAccessToken: function() {
      return this.accessToken;
    }
  };
});

angular.module("Flexikon.services").factory("NavBar", function() {
  return {
    isHidden: false,
    hidden: function() {
      return this.isHidden;
    },
    hide: function() {
      return this.isHidden = true;
    },
    unhide: function() {
      return this.isHidden = false;
    }
  };
});

angular.module("Flexikon.services").factory("Network", function() {
  return {
    hasConnection: function() {
      var ref;
      if ((typeof navigator !== "undefined" && navigator !== null ? (ref = navigator.connection) != null ? ref.type : void 0 : void 0) != null) {
        return navigator.connection.type !== "unknown" && navigator.connection.type !== "none";
      }
      return true;
    }
  };
});

angular.module("Flexikon.services").factory("PicturesApi", function($http, Api, GlobalSettings, Login) {
  return {
    baseUrl: {
      production: 'http://pictures.doccheck.com/',
      development: 'http://pictures-stage.dev55.antwerpes.de/'
    },
    basePath: '',
    pending: {
      listing: void 0
    },
    api: {
      photo: 'api_photo/',
      photos: 'api_photos/ids/',
      channel: 'api_channel/'
    },
    link: {
      photo: 'photo/'
    },

    /*
     * ^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=
     * Utility
     * ^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=
     */
    getLinkFor: function(type, language) {
      if (language == null) {
        language = GlobalSettings.getLanguageForURL();
      }
      return this.baseUrl[Api.getEnv()] + this.basePath + language + '/' + this.link[type];
    },
    getUrlForApi: function(api) {
      return this.baseUrl[Api.getEnv()] + this.basePath + this.api[api];
    },
    getPictures: function(idArray) {
      var d, pictures;
      d = $.Deferred();
      pictures = [];
      if (idArray.length > 0) {
        this.loadPictures(idArray, d);
      } else {
        d.resolve(pictures);
      }
      return d;
    },
    loadPictures: function(idArray, def, pictures) {
      var paramObject, self;
      if (pictures == null) {
        pictures = [];
      }
      self = this;
      paramObject = {
        dc_api_key: Api.getApiKey()
      };
      return $http({
        url: this.getUrlForApi('photo') + idArray.shift(),
        method: 'GET',
        params: paramObject,
        cache: true
      }).success(function(response) {
        pictures.push(response);
        if (idArray.length > 0) {
          return self.loadPictures(idArray, def, pictures);
        } else {
          return def.resolve(pictures);
        }
      }).error(function(error) {
        console.warn(error);
        if (idArray.length > 0) {
          return self.loadPictures(idArray, def, pictures);
        } else {
          return def.resolve(pictures);
        }
      });
    },
    getPicture: function(id) {
      var paramObject;
      paramObject = {
        dc_api_key: Api.getApiKey()
      };
      return $http({
        url: this.getUrlForApi('photo') + id,
        method: 'GET',
        params: paramObject,
        cache: true
      });
    },
    getUserPictures: function(page, epp) {
      var paramObject, url;
      if (page == null) {
        page = 1;
      }
      if (epp == null) {
        epp = 20;
      }
      url = this.getUrlForApi('channel') + 'token_owner';
      paramObject = {
        page: page,
        epp: epp,
        dc_api_key: Api.getApiKey(),
        language: GlobalSettings.Language()
      };
      return $http({
        url: url,
        method: 'GET',
        cache: false,
        timeout: 10000,
        transformRequest: function(obj) {
          var p, str;
          str = [];
          for (p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        },
        params: paramObject
      });
    },
    uploadPicture: function(data, successCallback, errorCallback, startedCallback, progressCallback) {
      var createBlob, createFileName, fd, imgData, imgMime, qData, qUrl, xhr;
      createBlob = function(base64str, mime) {
        var binary, blob, buffer, i, len, view;
        binary = atob(base64str.replace(/\s/g, ''));
        len = binary.length;
        buffer = new ArrayBuffer(len);
        view = new Uint8Array(buffer);
        i = 0;
        while (i < len) {
          view[i] = binary.charCodeAt(i);
          i++;
        }
        blob = new Blob([view], {
          type: mime
        });
        return blob;
      };
      imgData = data.substr(data.indexOf(',') + 1);
      imgMime = data.substr(data.indexOf(':') + 1, data.indexOf(';') - 1 - data.indexOf(':'));
      data = createBlob(imgData, imgMime);
      qUrl = this.getUrlForApi('photo');
      qData = {
        Filedata: data,
        language: GlobalSettings.Language()
      };
      createFileName = function() {
        var d;
        d = new Date();
        return "" + d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + "-" + d.getHours() + "-" + d.getMinutes() + "-" + d.getSeconds() + "-AskApp." + imgMime.substr(imgMime.indexOf('/') + 1);
      };
      fd = new FormData();
      fd.append('Filedata', data, createFileName());
      fd.append('language', GlobalSettings.Language());
      fd.append('visibility', 1);
      xhr = new XMLHttpRequest();
      xhr.upload.addEventListener('progress', function(e) {
        if (progressCallback) {
          return progressCallback(e);
        }
      }, false);
      xhr.addEventListener("load", function(e) {
        if (successCallback) {
          return successCallback(this.response, e);
        }
      }, false);
      xhr.addEventListener("error", function(e) {
        if (errorCallback) {
          return errorCallback(e);
        }
      }, false);
      xhr.addEventListener("abort", function(e) {
        if (errorCallback) {
          return errorCallback(e);
        }
      }, false);
      xhr.open('POST', qUrl);
      xhr.setRequestHeader('Cache-Control', 'no-cache');
      xhr.setRequestHeader('Authorization', Login.getAccessToken());
      xhr.setRequestHeader('dc_api_key', Api.getApiKey());
      xhr.setRequestHeader("Accept", "application/json");
      if (startedCallback) {
        startedCallback();
      }
      return xhr.send(fd);
    },
    getPicturesForMediaViewer: function(ids) {
      var paramObject;
      paramObject = {
        'ids[]': ids,
        dc_api_key: Api.getApiKey()
      };
      return $http({
        url: this.getUrlForApi('photos'),
        method: "GET",
        cache: false,
        params: paramObject
      });
    }
  };
});

angular.module("Flexikon.services").factory("PublishApi", function(Api, $http, GlobalSettings) {
  return {
    baseUrl: {
      production: 'http://www.doccheck.com/',
      development: 'http://apps.dev55.antwerpes.de/',
      development_mocked: '/'
    },
    basePath: 'publish/',
    api: {
      viewer: 'api_viewer'
    },
    link: {
      document: 'document/'
    },
    apikey: 'fed698de08ed2d3df9dae8af45d1ee9865ebb0575b7d0f9b',

    /*
     * ^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=
     * Utility
     * ^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=^=
     */
    getBaseUrl: function() {
      return this.baseUrl[Api.getEnv()];
    },
    getLinkFor: function(type, language) {
      if (language == null) {
        language = GlobalSettings.getLanguageForURL();
      }
      return this.baseUrl[Api.getEnv()] + language + '/' + this.link[type];
    },
    getUrlForApi: function(api) {
      return this.baseUrl[Api.getEnv()] + this.basePath + this.api[api];
    },

    /*
     *
     */
    getPublishContent: function(id, width, height) {
      var paramObject;
      paramObject = {
        dc_api_key: this.apikey,
        id: id,
        language: GlobalSettings.Language(),
        height: height,
        width: width
      };
      return $http({
        url: this.getUrlForApi('viewer'),
        method: "GET",
        cache: false,
        params: paramObject
      });
    }
  };
});

angular.module("Flexikon.services").factory("QuickSearch", function() {
  return {
    keyword: void 0,
    set: function(keyword) {
      return this.keyword = keyword;
    },
    getAndClear: function() {
      var keyword;
      keyword = this.keyword;
      this.keyword = void 0;
      return keyword;
    }
  };
});

angular.module("Flexikon.services").factory("ScrollDelegateHandle", function($ionicScrollDelegate) {
  return {
    inTab: function(tab, handle) {
      var i, inst, instance, len, ref;
      inst = void 0;
      ref = $ionicScrollDelegate._instances;
      for (i = 0, len = ref.length; i < len; i++) {
        instance = ref[i];
        if (instance.$$delegateHandle === handle && instance.getScrollPosition().top > 0 && ((inst == null) || inst.getScrollPosition().top < instance.getScrollPosition().top)) {
          inst = instance;
        }
      }
      return inst;
    }
  };
});

angular.module("Flexikon.services").factory("StateChangeInterrupter", function() {
  return {
    interruptCallback: void 0,
    registerCallback: function(callback) {
      return this.interruptCallback = callback;
    },
    unregisterCallback: function() {
      return this.interruptCallback = void 0;
    },
    getCallback: function() {
      if (this.interruptCallback != null) {
        return this.interruptCallback;
      } else {

      }
    }
  };
});

angular.module("Flexikon.services").factory("Store", function($rootScope, Load, Api, InAppPurchase, ABTest) {
  return {
    owned: [],
    FREE_PREMIUM: false,
    initialize: function() {
      var self;
      console.debug('Initializing Store...');
      this.owned = [];
      self = this;
      InAppPurchase.get('flexikon_offline').then(function(doc) {
        if (ionic.Platform.isWebView()) {
          return self.owned.push('flexikon_offline');
        } else {
          return InAppPurchase["delete"](doc);
        }
      })["catch"](function(error) {
        return console.debug('Nothing found!');
      });
      InAppPurchase.get('dc_flexikon_offline').then(function(doc) {
        if (ionic.Platform.isWebView()) {
          return self.owned.push('dc_flexikon_offline');
        } else {
          console.debug('DELETING');
          return InAppPurchase["delete"](doc);
        }
      })["catch"](function(error) {
        return console.debug('Nothing found!');
      });
      if (typeof store === "undefined" || store === null) {
        console.warn('store object is not available - currently testing in browser? Otherwise check the plugin!');
        return;
      }
      store.register({
        id: 'flexikon_offline',
        alias: 'Flexikon Offline',
        type: store.NON_CONSUMABLE
      });
      store.when('flexikon_offline').approved(function(product) {
        var price;
        if (self.owned.indexOf('flexikon_offline') < 0) {
          self.owned.push('flexikon_offline');
          ABTest.trackEvent('approved');
          if ((product != null ? product.price : void 0) != null) {
            price = parseFloat(product.price.replace(',', '.'));
          }
          if (isNaN(price)) {
            price = 2.99;
          }
          console.debug('Price: ' + price);
        }
        console.debug('Approved offline usage');
        return product.finish();
      });
      store.when('flexikon_offline').finished(function(product) {
        console.debug('Finished offline usage');
        self.owned.push('flexikon_offline');
        InAppPurchase.insert('flexikon_offline', {
          purchased: true
        });
        $rootScope.$broadcast('InAppPurchase-succeeded');
        return Load.isBlocked(false);
      });
      store.when('flexikon_offline').cancelled(function(product) {
        console.debug('Cancelled offline usage');
        return Load.isBlocked(false);
      });
      store.when("flexikon_offline").updated(function(product) {
        if (product.owned && self.owned.indexOf('flexikon_offline') < 0) {
          self.owned.push('flexikon_offline');
          InAppPurchase.insert('flexikon_offline', {
            purchased: true
          });
          return $rootScope.$broadcast('InAppPurchase-succeeded');
        } else if (!product.owned) {
          return InAppPurchase.get('flexikon_offline').then(function(doc) {
            InAppPurchase["delete"](doc);
            return $rootScope.$broadcast('InAppPurchase-notowned');
          });
        }
      });
      store.refresh();
      return this.initialized = true;
    },
    isOwned: function(id) {
      return this.FREE_PREMIUM && Api.getEnv().indexOf('dev') >= 0 || this.owned.indexOf(id) >= 0 || this.owned.indexOf('dc_' + id) >= 0;
    },
    checkForOwnedDcProducts: function() {},
    removeDcProducts: function() {},
    ownedByDcUser: function(id) {
      if (id == null) {
        id = 'flexikon_offline';
      }
      this.owned.push('dc_' + id);
      InAppPurchase.insert('dc_flexikon_offline', {
        purchased: true
      });
      return $rootScope.$broadcast('InAppPurchase-succeeded');
    },
    dcUserLogout: function(id) {
      if (id == null) {
        id = 'flexikon_offline';
      }
      if (this.owned.indexOf('dc_' + id)) {
        this.owned.splice(this.owned.indexOf('dc_' + id));
        return InAppPurchase.get('dc_' + id).then(function(doc) {
          InAppPurchase["delete"](doc);
          return $rootScope.$broadcast('InAppPurchase-notowned');
        });
      }
    },
    restore: function() {
      if (!this.initialized) {
        this.initialize();
      }
      if (!ionic.Platform.isWebView()) {
        console.warn('store object is not available - currently testing in browser? Otherwise check the plugin!');
        this.owned.push('flexikon_offline');
        InAppPurchase.insert('flexikon_offline', {
          purchased: true
        });
        $rootScope.$broadcast('InAppPurchase-succeeded');
        Load.isBlocked(false);
        return;
      }
      store.refresh();
    },
    order: function(product) {
      Load.isBlocked(true);
      if (!ionic.Platform.isWebView()) {
        console.warn('store object is not available - currently testing in browser? Otherwise check the plugin!');
        this.owned.push('flexikon_offline');
        InAppPurchase.insert('flexikon_offline', {
          purchased: true
        });
        $rootScope.$broadcast('InAppPurchase-succeeded');
        Load.isBlocked(false);
        return;
      }
      if (!this.initialized) {
        this.initialize();
      }
      return store.order('flexikon_offline');
    }
  };
});

angular.module("Flexikon.services").factory("TabHide", function() {
  var tabsHidden;
  tabsHidden = false;
  return {
    hide: function() {
      return tabsHidden = true;
    },
    unhide: function() {
      return tabsHidden = false;
    },
    hidden: function() {
      return tabsHidden;
    }
  };
});

angular.module("Flexikon.services").factory("Theme", function(LocalStorage) {
  return {
    theme: LocalStorage.get('theme') || 'light',
    select: function(theme) {
      LocalStorage.set('theme', theme);
      this.theme = theme;
      if (this.darkThemeSelected()) {
        angular.element('body').addClass('dark-theme');
      } else {
        angular.element('body').removeClass('dark-theme');
      }
      return this.theme;
    },
    toggle: function() {
      if (this.theme === 'dark') {
        this.theme = 'light';
      } else {
        this.theme = 'dark';
      }
      LocalStorage.set('theme', this.theme);
      return this.theme;
    },
    darkThemeSelected: function() {
      return this.theme === 'dark';
    },
    getSelected: function() {
      return this.theme || LocalStorage.get('theme') || 'light';
    }
  };
});

angular.module("Flexikon.services").factory("ToC", function($rootScope) {
  return {
    currentTitle: '',
    currentToc: [],
    currentSection: -1,
    generate: function(article, title) {
      var h, heading, headings, i, id, len, regex, x;
      this.currentTitle = title;
      this.currentToc = [];
      this.currentSection = -1;
      regex = new RegExp('<h(.)>(.+?)<\/h.>', 'g');
      headings = article.match(regex) || [];
      id = parseInt(Math.random() * 100000);
      for (i = 0, len = headings.length; i < len; i++) {
        h = headings[i];
        heading = h.substr(h.indexOf('>') + 1);
        heading = heading.substr(0, heading.indexOf('<'));
        if (h[2] - 1 <= 3) {
          this.currentToc.push({
            level: h[2] - 1,
            heading: heading,
            id: id,
            targetId: title.replace(/_| |'|"/g, '-') + id
          });
        }
        if (this.currentSection < 0) {
          this.currentSection = title.replace(/_| |'|"/g, '-') + id;
        }
        article = article.replace(h, '<h' + h[2] + ' id="' + title.replace(/_| |'|"/g, '-') + (id++) + '">' + heading + '</h' + h[2] + '>');
      }
      x = {
        article: article,
        toc: this.currentToc.slice()
      };
      $rootScope.$broadcast('new-toc-available');
      return x;
    },
    setCurrentSection: function(section) {
      this.currentSection = section;
      return $rootScope.$broadcast('reloadActiveSection');
    },
    getCurrentSection: function() {
      return this.currentSection;
    },
    getTitle: function() {
      return this.currentTitle;
    },
    getSectionWithHeading: function(heading) {
      var i, len, ref, section;
      ref = this.currentToc;
      for (i = 0, len = ref.length; i < len; i++) {
        section = ref[i];
        if (section.heading === heading) {
          return section;
        }
      }
    },
    get: function() {
      return this.currentToc;
    },
    set: function(toc) {
      this.currentToc = toc;
      return $rootScope.$broadcast('new-toc-available');
    }
  };
});

angular.module("Flexikon.services").factory("UniqueID", function() {
  return {
    id: Math.floor(Math.random() * 100000),
    get: function() {
      return this.id++;
    }
  };
});

angular.module("Flexikon.services").factory("UserSave", function(pouchDB, $q) {
  var UserSave;
  UserSave = Object.create(DcPouchDB, {
    q: {
      value: $q
    }
  });
  UserSave.db = pouchDB(UserSave.prepareDBName('userSave'));
  return UserSave;
});

angular.module("Flexikon.services").factory("WikiHTML", function(GlobalSettings, $timeout) {
  var self;
  self = this;
  self.lists = [];
  self.placeholders = [];

  /**
   * [parseTable - parse a complete Wiki syntax table to html and wrap it with a dc-table directive for styling and scrolling purposes]
   * @param  {[String]} tableinner [content of the table]
   * @return {[String]}            [parsed table]
   */
  self.parseTable = function(tableinner) {
    var col, columns, hasColumns, header, headerrows, j, len, len1, len2, len3, len4, m, n, o, p, ref, ref1, row, table, tableHtml, tablerows, th;
    tableinner = tableinner.replace(/\n( |\t)*/gmi, '\n').replace(/\n *\n/gmi, '\n');
    tablerows = tableinner.trim().split(/(?:^|\n)\|-(.*)(?:\n)?/g);
    table = {
      caption: null,
      header: [],
      rows: []
    };

    /*
    if tablerows[0].match(/\n!/gmi)?.length > 0
      heads = tablesrows.unshift()
      heads = heads.replace(/\n!/gmi, '\\n!!').split(/\n!/gmi)
      tablerows.unshift.apply(heads)
     */
    for (j = 0, len = tablerows.length; j < len; j++) {
      row = tablerows[j];
      if (row.indexOf('|+ ') === 0) {
        table.caption = row.substr('|+ '.length);
      } else if (row.indexOf('! ') === 0) {
        table.header.push.apply(table.header, row.replace(/^! *\|? */, '').split(/\n! |\ !! | \|\| /g));
      } else if (row.indexOf('!') === 0) {
        headerrows = row.replace(/^! *\|?!? */gmi, '').split(/\n! *|\ !! | \|\| /gmi);
        if (headerrows.length === 1) {
          headerrows = headerrows[0].split(/\n/gmi);
        }
        table.header.push.apply(table.header, headerrows);
      } else if (row.indexOf('|') === 0) {
        table.rows.push(row.replace(/^\| /, '').split(/\n\||\|\|/g));
      }
    }
    tableHtml = "<dc-table><ion-scroll has-bouncing='false' direction='x'><table>";
    if (table.caption != null) {
      tableHtml += "<caption>" + table.caption + "</caption>";
    }
    if (table.header.length === 0 && table.rows.length === 1 || table.header.length === 1 && table.rows.length === 0) {
      tableHtml = tableHtml.replace('<table', '<table class="no-stack single-row"');
    }
    if (table.header.length > 0) {
      tableHtml += "<tr>";
      ref = table.header;
      for (m = 0, len1 = ref.length; m < len1; m++) {
        header = ref[m];
        header = header.split(/\n\| /g);
        th = header.splice(0, 1);
        tableHtml += "<th>" + th + "</th>";
        for (n = 0, len2 = header.length; n < len2; n++) {
          columns = header[n];
          hasColumns = true;
          tableHtml = tableHtml.replace('<table', '<table class="no-stack"');
          tableHtml += "<td>" + columns + "</td>";
        }
        if (hasColumns) {
          tableHtml += '</tr><tr>';
        }
      }
      tableHtml += "";
      tableHtml += '</tr>';
    }
    if (table.rows.length > 0) {
      ref1 = table.rows;
      for (o = 0, len3 = ref1.length; o < len3; o++) {
        row = ref1[o];
        tableHtml += "<tr>";
        for (p = 0, len4 = row.length; p < len4; p++) {
          col = row[p];
          col = col.split('|');
          if (col.length === 2) {
            tableHtml += "<td " + col[0] + ">" + col[1] + "</td>";
          } else if (col.length === 1) {
            tableHtml += "<td>" + col[0] + "</td>";
          }
        }
        tableHtml += "</tr>";
      }
    }
    tableHtml += "</table></ion-scroll></dc-table>\n";
    if (tableinner.indexOf('<dctv') > 0) {
      tableHtml = tableHtml.replace('<table', '<table class="no-stack"');
    }
    return tableHtml;
  };

  /**
   * [parseCompleteList - parse a complete list (might consist of multiple nested ols and uls )]
   * @param  {[String]} match [the list match from the according regex]
   * @return {[String]}       [returns the list HTML]
   */
  self.parseCompleteList = function(match) {
    var closeTagsToLevel, content, findFirstUnmatched, indicator, j, len, listHTML, openTagsFromLevel, r, rows, tagForChar, unmatched;
    listHTML = '';

    /**
     * [tagForChar - helper for parsing lists]
     * @param  {[char]} c [Wiki syntax character]
     * @return {[String]} [the according list tag name]
     */
    tagForChar = function(c) {
      if (c === '*') {
        return 'ul';
      }
      if (c === '#') {
        return 'ol';
      }
      return 'UNDEFINED';
    };

    /**
     * [findFirstUnmatched - find the position of the first indicator not matching the current]
     * @param  {[String]} indicator [current indicator sequnce]
     * @return {[int]}              [position of the first unmatched]
     */
    findFirstUnmatched = function(indicator) {
      var i, j, pos, ref;
      pos = -1;
      for (i = j = ref = indicator.length - 1; ref <= 0 ? j <= 0 : j >= 0; i = ref <= 0 ? ++j : --j) {
        if (indicator[i] !== self.lists[i]) {
          pos = i;
        }
      }
      return pos;
    };

    /**
     * [closeTagsToLevel - helper for closing all currently open tags down to a certain level]
     * @param  {[int]} l [level]
     * @return
     */
    closeTagsToLevel = function(l) {
      var results;
      results = [];
      while (self.lists.length > l) {
        results.push(listHTML += '</li></' + tagForChar(self.lists.pop()) + '>');
      }
      return results;
    };

    /**
     * [openTagsFromLevel - helper for opening tags for lists up to a certain level]
     * @param  {[int]} l          [level]
     * @param  {[char]} indicator [Wiki syntax list indicator]
     * @return {[type]}
     */
    openTagsFromLevel = function(l, indicator) {
      var i, j, ref, ref1, results;
      results = [];
      for (i = j = ref = l, ref1 = indicator.length - 1; ref <= ref1 ? j <= ref1 : j >= ref1; i = ref <= ref1 ? ++j : --j) {
        listHTML += '\n<' + tagForChar(indicator[i]) + '><li>';
        results.push(self.lists.push(indicator[i]));
      }
      return results;
    };
    rows = match.split('\n');
    for (j = 0, len = rows.length; j < len; j++) {
      r = rows[j];
      if ((r.indexOf != null) && (r.indexOf('*') === 0 || r.indexOf('#') === 0)) {
        match = r.match(/^([\*\#]+)(.*)$/);
        indicator = match[1];
        content = match[2];
        if (indicator.length < self.lists.length) {
          closeTagsToLevel(indicator.length);
        }
        unmatched = findFirstUnmatched(indicator);
        if (unmatched >= 0) {
          closeTagsToLevel(unmatched);
          openTagsFromLevel(unmatched, indicator);
        } else {
          listHTML += '</li><li>';
        }
        listHTML += content;
      }
    }
    closeTagsToLevel(0);
    listHTML += '\n';
    return listHTML;
  };
  return {
    rules: {
      toWiki: {
        blocks: [
          {
            rex: /<dc-table>(.*?)<\/dc-table>/g,
            to: function(match, s1) {
              return s1;
            }
          }, {
            rex: /<ol>(.*?)<\/ol>/g,
            to: function(match, s1) {
              return match.replace(/\<ol>/g, '\n').replace(/\<li>/g, '# ').replace(/\<\/li>/g, '\n').replace(/\<\/ol>/g, '');
            }
          }, {
            rex: /<ul>(.*?)<\/ul>/g,
            to: function(match, s1) {
              return match.replace(/\<ul>/g, '\n').replace(/\<li>/g, '* ').replace(/\<\/li>/g, '\n').replace(/\<\/ul>/g, '');
            }
          }, {
            rex: /<table>(.*?)<\/table>/g,
            to: function(match, s1) {
              return match.replace(/\<table>/g, '{|').replace(/\<\/table>/g, '\n|}\n');
            }
          }, {
            rex: /<tbody>(.*?)<\/tbody>/g,
            to: function(match, s1) {
              return match.replace(/\<tbody>|<\/tbody>/g, '');
            }
          }, {
            rex: /\<tr>(.*?)(<th>(.*)<\/th>)(.*?)<\/tr>/g,
            to: function(match, s1, s2) {
              return s2.replace(/(<tr>)|(<\/tr>)/g, '').replace(/<th>/g, '\n! \'\'\'').replace(/<\/th>/g, '\'\'\'');
            }
          }, {
            rex: /\<tr>(.*?)(<td>(.*)<\/td>)(.*?)<\/tr>/g,
            to: function(match, s1, s2) {
              return '\n' + s2.replace(/(<tr>)/g, '\n').replace(/<\/tr>/g, '').replace(/<\/td>.*?<td>/g, '||').replace(/<td>/g, '\|-\n\| ').replace(/<\/td>/g, '');
            }
          }
        ],
        inlines: [
          {
            rex: /<p>([ \t\f\v\xB6]*?)<\/p>/g,
            to: function(match, s1) {
              return s1;
            }
          }, {
            rex: /<h1>(.*?)<\/h1>/mgi,
            to: function(match, s1) {
              return '=' + s1 + '=\n';
            }
          }, {
            rex: /<h2>(.*?)<\/h2>/mgi,
            to: function(match, s1) {
              return '==' + s1 + '==\n';
            }
          }, {
            rex: /<h3>(.*?)<\/h3>/mgi,
            to: function(match, s1) {
              return '===' + s1 + '===\n';
            }
          }, {
            rex: /<h4>(.*?)<\/h4>/mgi,
            to: function(match, s1) {
              return '====' + s1 + '====\n';
            }
          }, {
            rex: /<h5>(.*?)<\/h5>/mgi,
            to: function(match, s1) {
              return '=====' + s1 + '=====\n';
            }
          }, {
            rex: /(<b>|<strong>)(.*?)(<\/strong>|<\/b>)/mgi,
            to: function(match, s1, s2) {
              return '\'\'\'' + s2 + '\'\'\'';
            }
          }, {
            rex: /(<em>|<i>)(.*?)(<\/em>|<\/i>)/mgi,
            to: function(match, s1, s2) {
              return '\'\'' + s2 + '\'\'';
            }
          }
        ]
      },

      /*
       * ToDo:
       * - FlexiAds - Aspirin
       * - DcTv - Herz
       */
      toHTML: {
        prioInlines: [
          {
            rex: /<!--(.|\n)*-->/gmi,
            to: function(match) {
              return '';
            }
          }, {
            rex: /<(?:.*?)[^\s-]\/>/g,
            to: function(match, s1, s2) {
              return match.replace(/\/>/g, ' />');
            }
          }, {
            rex: /\{\{Quiz((?:\n|.)*?)\}\}/gm,
            to: function(match) {
              return '';
            }
          }, {
            rex: /\{\{((?:\n|.)*?)\}\}/gm,
            to: function(match) {
              self.placeholders.push(match);
              return '<dc-parse-wiki wiki-text="~~PLACEHOLDER' + (self.placeholders.length - 1) + '~~"></dc-parse-wiki>';
            }
          }, {
            rex: /<(?:\/?)(?:(?:.|\n)*?)>/gm,
            to: function(match) {
              return match.replace('<', '&lt;');
            }
          }, {
            rex: /&lt;(?:\/?)(?:b|bdi|del|i|ins|u|font|big|small|sub|sup|h1|h2|h3|h4|h5|h6|cite|code|em|s|strike|strong|tt|var|div|center|blockquote|ol|ul|dl|table|caption|pre|ruby|rb|rp|rt|rtc|p|span|abbr|dfn|kbd|samp|data|time|mark|br|wbr|hr|li|dt|dd|table|tr|td|th|div|blockquote|ol|ul|li|dl|dt|dd|font|big|small|sub|sup|var|kbd|samp|em|strong|q|ruby|bdo|youtube|references|ref|(?:dc.*?))(>| (?:.*?)>)/gmi,
            to: function(match) {
              return match.replace('&lt;', '<');
            }
          }, {
            rex: /<pre>((.|\n)*?)<\/pre>/gm,
            to: function(match) {
              self.placeholders.push(match);
              return '~~PLACEHOLDER' + (self.placeholders.length - 1) + '~~';
            }
          }, {
            rex: /(?:\[\[)(?:.*?:)(.+?).swf?(?:\]\])/g,
            to: function(match, s1) {
              return '<dcswiffy name="' + s1 + '"></dcswiffy>';
            }
          }, {
            rex: /(\[\[.{2}:.+?\]\])/gmi,
            to: function(match, s1) {
              return '';
            }
          }, {
            rex: /\[\[(Fachgebiet|Discipline|Tag):(.*?)\]\]/gi,
            to: function(match) {
              return '';
            }
          }, {
            rex: /\[\[(?:\#([^\]]*?)\|)?(?:([^\]]*?)\|)?([^\]]*?)\]\]([a-zA-Z0-9äöüÄÖÜßéèêáàâóòôúùûíìîñÉÈÊÁÀÂÓÒÔÚÙÛÍÌÎ]*)/gi,
            to: function(match, s1, s2, s3, s4) {
              var article, section, title;
              section = s1 || '';
              if ((s2 != null) && (s3 != null)) {
                article = s2;
                title = s3 + s4;
              } else {
                title = s3 + s4;
                article = s3;
              }
              return '<a href="' + article + '" section="' + section + '" title="' + title + '">' + title + "</a>";
            }
          }, {
            rex: /(?:\[\[)([^\]]+?)\|([^\]]+)(?:\]\])([a-zA-Z0-9]*)/gi,
            to: function(match, s1, s2, s3) {
              return '<a href="' + s1 + '" title="' + s2 + '">' + s2 + s3 + "</a>";
            }
          }, {
            rex: /(?:\[\[)(.*?)(?:\]\])([a-zA-Z0-9]*)/gi,
            to: function(match, s1, s2) {
              return '<a href="' + s1 + '">' + s1 + s2 + "</a>";
            }
          }, {
            rex: /(?:\[)(http:\/\/.+?) (.+?)\]/gi,
            to: function(match, s1, s2) {
              return '<a class="external-link" href="' + s1 + '" title="' + s2 + '">' + s2 + "</a>";
            }
          }, {
            rex: /(?:\[)(http:\/\/.*?)(?:\])([a-zA-Z0-9]*)/gi,
            to: function(match, s1, s2) {
              return '<a class="external-link" href="' + s1 + '">' + s1 + s2 + "</a>";
            }
          }
        ],
        blocks: [
          {
            rex: /((?:^|\n)(?:(?:[\*\#])(?:.|\n[\*\#])+)(?:[\n]|$))/gm,
            to: function(match) {
              return self.parseCompleteList(match);
            }
          }, {
            rex: /<table(.|\n)*?<\/table>/gm,
            to: function(match) {
              return '<dc-table><ion-scroll has-bouncing="false" direction="x">' + match + '</ion-scroll></dc-table>';
            }
          }, {
            rex: /\{\|(?:[^\n]*)((.|\n)*?)\|\}\n*/gm,
            to: function(match, tableinner) {
              return self.parseTable(tableinner);
            }
          }, {
            rex: /<p>((.|\n)*?)<\/p>/mgi,
            to: function(match, s1) {
              return s1;
            }
          }
        ],
        inlines: [
          {
            rex: /<br ?\/?>/gmi,
            to: function(match) {
              return '<br />';
            }
          }, {
            rex: /(?:^|\n)\======(.*?)\======/mgi,
            to: function(match, s1) {
              return '\n<h6>' + s1 + '</h6>\n';
            }
          }, {
            rex: /(?:^|\n)\=====(.*?)\=====/mgi,
            to: function(match, s1) {
              return '\n<h5>' + s1 + '</h5>\n';
            }
          }, {
            rex: /(?:^|\n)\====(.*?)\====/mgi,
            to: function(match, s1) {
              return '\n<h4>' + s1 + '</h4>\n';
            }
          }, {
            rex: /(?:^|\n)\===(.*?)\===/mgi,
            to: function(match, s1) {
              return '\n<h3>' + s1 + '</h3>\n';
            }
          }, {
            rex: /(?:^|\n)\== *(.*?) *\==(?:[ \n]*)/mgi,
            to: function(match, s1) {
              return '\n<h2>' + s1 + '</h2>\n';
            }
          }, {
            rex: /(?:^|\n)\= *(.*?) *\=(?:[ \n]*)/mgi,
            to: function(match, s1) {
              return '\n<h1>' + s1 + '</h1>\n';
            }
          }, {
            rex: /(?:^|\n)(?!<)((?:.|\n[^\n<])+)/gmi,
            to: function(match, s1) {
              return '<p>' + s1 + '</p>';
            }
          }, {
            rex: /<p><\/p>/gmi,
            to: function() {
              return '';
            }
          }, {
            rex: /'{3}(.*?)(?:'{3}|(\n|<br ?\/?>|$))/mgi,
            to: function(match, s1, s2) {
              if (s2 == null) {
                s2 = '';
              }
              return '<strong>' + s1 + '</strong>' + s2;
            }
          }, {
            rex: /'{2}(.*?)(?:'{2}|(\n|<br ?\/?>|$))/mgi,
            to: function(match, s1, s2) {
              if (s2 == null) {
                s2 = '';
              }
              return '<em>' + s1 + '</em>' + s2;
            }
          }, {
            rex: /(?:^|\n)(?!<)( *)/gi,
            to: function(match, s1) {
              return '';
            }
          }, {
            rex: /<(dc\w*) (.*?)\/>/g,
            to: function(match, s1, s2) {
              return '<' + s1 + ' ' + s2 + '></' + s1 + '>';
            }
          }
        ]
      }
    },

    /**
     * [applyRules - apply all the rules defined above for either Wiki->HTML conversion or vice versa]
     * @param  {[String]} str      [String containing the Wiki/HTML content]
     * @param  {[String]} dir      [either 'toHTML' or 'toWiki']
     * @param  {[String]} language [language for getting info boxes from the flexikon directly]
     * @return {[String]}          [the parsed string]
     */
    applyRules: function(str, dir, language) {
      var j, k, len, ref, rule, ruleblock;
      ref = this.rules[dir];
      for (k in ref) {
        ruleblock = ref[k];
        for (j = 0, len = ruleblock.length; j < len; j++) {
          rule = ruleblock[j];
          str = str.replace(rule.rex, rule.to);
        }
      }
      str = this.replacePlaceholders(str, language);
      return str;
    },

    /**
     * [toHTML - helper for calling applyRules accordingly; parses Wiki syntax to HTML]
     * @param  {[String]} str      [String containing the Wiki content]
     * @param  {[String]} language [language for getting info boxes from the flexikon directly]
     * @return {[String]}            [the parsed string]
     */
    toHTML: function(str, language) {
      str = this.applyRules(str, 'toHTML', language);
      return str;
    },

    /**
     * [toWiki - helper for calling applyRules accordingly; parses HTML to Wiki syntax]
     * @param  {[String]} str      [String containing the Wiki content]
     * @param  {[String]} language [language for getting info boxes from the flexikon directly]
     * @return {[String]}            [the parsed string]
     */
    toWiki: function(str, language) {
      return this.applyRules(str, 'toWiki', language);
    },

    /**
     * [
     * replacePlaceholders - some parts must be replaced be placeholders
     * while parsing to ensure, they can be evaluated correctly afterwards
     * ]
     * @param  {[String]} str      [String containing the placeholders]
     * @param  {[String]} language [language for getting info boxes from the flexikon directly]
     * @return {[String]}            [the string with all contents]
     */
    replacePlaceholders: function(str, language) {
      var i, j, ref;
      if ((self.placeholders == null) || self.placeholders.length === 0) {
        return str;
      }
      for (i = j = ref = self.placeholders.length - 1; ref <= 0 ? j <= 0 : j >= 0; i = ref <= 0 ? ++j : --j) {
        str = str.replace('~~PLACEHOLDER' + i + '~~', self.placeholders.pop().replace(/\{\{/g, '\\{\\{').replace(/"/g, '&quot;'));
      }
      str = str.replace(/\<dc\-parse\-wiki/gm, '<dc-parse-wiki language="' + language + '"');
      return str;
    },

    /**
     * DEPRECATED
     * @return
     */
    stacktables: function(expectedTableCount, failCount) {
      var j, len, results, self_stacktables, table, tables;
      if (expectedTableCount == null) {
        expectedTableCount = 0;
      }
      if (failCount == null) {
        failCount = 0;
      }
      if (!GlobalSettings.Stacktables()) {
        return;
      }
      if (expectedTableCount === 0) {
        return;
      }
      self_stacktables = this;
      tables = angular.element('.article-html').last().find('table');
      if (tables.length < expectedTableCount && failCount < 10) {
        $timeout(function() {
          return self_stacktables.stacktables(expectedTableCount, failCount++);
        }, 500);
        return;
      }
      results = [];
      for (j = 0, len = tables.length; j < len; j++) {
        table = tables[j];
        if (!angular.element(table).hasClass('no-stack') && !angular.element(table).hasClass('stacktable') && angular.element(table).closest('dc-parse-wiki').length === 0) {
          results.push(angular.element(table).stacktable());
        } else {
          results.push(void 0);
        }
      }
      return results;
    }
  };
});

angular.module("Flexikon.controllers").controller('BaseCtrl', function($scope, Network, Login) {
  $scope.hasConnection = function() {
    return Network.hasConnection();
  };
  return $scope.isAuthenticated = function() {
    return Login.isAuthenticated();
  };
});

angular.module("Flexikon.controllers").controller('ModalCtrl', function($scope, FullscreenViewer) {

  /**
  	 * [closeModal]
  	 * @param  {[type]} $event []
  	 * @return {[type]}        []
   */
  $scope.closeModal = function($event) {
    if ($event != null) {
      $event.preventDefault();
      $event.stopPropagation();
    }
    return FullscreenViewer.closeModal();
  };

  /**
  	 * [openUrl]
  	 * @param  {[type]} url []
  	 * @return {[type]}     []
   */
  $scope.openUrl = function(url) {
    window.open(url, '_system');
  };

  /**
  	 * [hideLoadingSpinnerWithId]
  	 * @param  {[type]} id []
  	 * @return {[type]}    []
   */
  return window.hideLoadingSpinnerWithId = document.hideLoadingSpinnerWithId = function(id) {
    return $('#load' + id).addClass('hide');
  };
});

angular.module("Flexikon.controllers").controller('TrackingCtrl', function($scope, $state, $location) {
  return ionic.Platform.ready(function() {
    return $scope.$on('$ionicView.enter', function() {
      var analyticsStateName, capitalize;
      capitalize = function(s) {
        return s.replace(/(?:^|\s)\S/g, function(a) {
          return a.toUpperCase();
        });
      };
      analyticsStateName = capitalize($state.current.name.replace('tabs.', '').replace('.', ' '));
      console.debug('Tracking View: ' + analyticsStateName);
      if (ionic.Platform.isWebView()) {
        return analytics.trackView(analyticsStateName);
      }
    });
  });
});

angular.module("Flexikon.translations").config(function($translateProvider) {
  return $translateProvider.translations('de_DE', {

    /*
     *
     * 888888   8888888
     * 88   88  88
     * 88    88 88
     * 88    88 8888
     * 88    88 88
     * 88   88  88
     * 888888   8888888
     *
     */

    /*
     * Globals
     */
    'GLOB_DC_FLEXIKON': 'DocCheck Flexikon',
    'GLOB_NO_CONNECTION': 'Keine Verbindung!',

    /*
     * Views
     */
    'DC_HOME_ERROR': 'Da ist was schiefgelaufen.<br /><br />Überprüfe Deine Internetverbindung und versuche es erneut!',
    'FAVORITES_TITLE': 'Favoriten',
    'SAVED_ARTICLES': 'Gespeicherte Artikel',
    'SAVED_ARTICLES_NOTHING': 'Du hast noch keine Artikel gespeichert.',
    'CONTRIBUTIONS': 'Meine Artikel',
    'CONTRIBUTIONS_NOTHING': 'Du hast noch keine Artikel erstellt oder bearbeitet.',
    'CONTRIBUTIONS_ERROR': 'Deine Artikel konnten nicht abgerufen werden.<br /Überprüfe Deine Internetverbindung und versuche es erneut!',
    'CONTRIBUTIONS_SIGNIN': 'Logge Dich ein, um Deine Beteiligungen am Flexikon zu sehen.',
    'LAST_SEEN': 'Zuletzt angesehen',
    'LAST_SEEN_NOTHING': 'Du hast noch keine Artikel angesehen.',
    'SEARCH_TITLE': 'Suche',
    'SEARCH_ERROR': 'Da ist was schiefgelaufen.<br /><br />Überprüfe Deine Internetverbindung und versuche es erneut!',
    'SEARCH_NO_FAVS': 'Da ist was schiefgelaufen.<br /><br />Überprüfe Deine Internetverbindung und versuche es erneut!',
    'SEARCH_DEFINE': 'Nichts gefunden? Mach den Anfang und schreib eine Definition.',
    'SETTINGS_HEADING': 'Einstellungen',
    'SETTINGS_SIGNOUT': 'Abmelden',
    'SETTINGS_PRIVACY': '',
    'SETTINGS_HELP': 'Hilfe & Tipps',
    'SETTINGS_PROMOTION': 'Mehr von DocCheck',
    'SETTINGS_DISCLAIMER': 'Disclaimer',
    'SETTINGS_PROFILE': 'Profil einrichten',
    'SETTINGS_LANGUAGE': 'Sprache',
    'SETTINGS_IMPORTANT': 'Wichtiger Hinweis',
    'SETTINGS_OFFLINE': 'Artikel offline speichern',
    'SETTINGS_RESTORE_PURCHASE': 'In-App-Kauf wiederherstellen',
    'PROMOTION_HEADING': 'Mehr von DocCheck',
    'PROFILE_HEADING': 'Profil einrichten',
    'HELP_HEADING': 'Hilfe & Tipps',
    'HELP_CONTENT': '<b class="heading"> Wofür kann ich die DocCheck Flexikon App nutzen? </b> <br /> <ul> <li> Greif auf mehr als 45.000 medizinische Artikel zu  </li> <li> Korrigiere und schreibe Artikel zu Themen Deiner Wahl  </li> <li> Markiere besonders relevante Artikel und speichere sie Dir offline ab  </li> </ul> <br /> <b class="heading"> Wie bearbeite ich bestehende Artikel?</b> <br /> Artikel, die bereits im Flexikon vorhanden sind, kannst Du über das Stift-Icon im Artikel bearbeiten. Aus dem Bearbeitungsmodus heraus kannst Du Dir Deine Änderungen erst einmal ansehen oder sie direkt speichern. <br /> <br /> <b class="heading"> Wie erstelle ich neue Artikel?</b> <br /> Wenn Du einen Begriff in der Flexikon-Suche nicht findest, kannst Du dort selbst mit einer Definition beginnen. Sobald Du Deine Definition speicherst, wird ein neuer Artikel angelegt, den Du über das Stift-Icon bearbeiten kannst. <br /> <br /> <b class="heading"> Wie kann ich einen Artikel als Favorit markieren? </b> <br /> Zunächst loggst Du Dich mit Deinem DocCheck Account ein. Wenn Du einen Artikel gefunden hast, den Du später schnell wiederfinden möchtest, kannst Du ihn über das Herz-Icon im oberen Balken markieren. Ab jetzt wird er unten in der Navigation unter „Favoriten“ auftauchen. <br /> <br /> <b class="heading"> Wie kann ich Artikel offline speichern? </b> <br /> Um Artikel lokal zu speichern, kannst Du im Inhaltsverzeichnis die kostenpflichtige Option „Artikel offline speichern“ auswählen. Im Anschluss sind alle Artikel, die Du Dir als Favoriten markiert hast, auch ohne Internetzugang abrufbar. Sobald Du Dein Gerät wieder mit dem Internet verbindest, werden die Artikel auf den neusten Stand gebracht. Videos und Medien sind ausschließlich online verfügbar.<br /> <br /> <b class="heading"> Wie kann ich die Optik der App individuell anpassen? </b> In der Detailansicht eines Artikels befindet sich oben rechts das Menü. Hier kannst Du unter „Ansicht“ die Schriftgröße und das Farbschema anpassen, über „O“ wird die Größe auf die Originalansicht zurückgesetzt. Außerdem kannst Du hier im Inhaltsverzeichnis zwischen einzelnen Kapiteln im Artikel navigieren.<br /> <br /> <b> Wichtiger Hinweis: </b> Das DocCheck Flexikon ist ein offenes Lexikon, das ausschließlich der Aus- und Weiterbildung dient. Es ist keine Anleitung zur Selbsttherapie und kein Ersatz für eine ärztliche Beratung oder Behandlung.</b> Es wird von den teilnehmenden Autoren nach bestem Wissen gepflegt. Die Autoren und die Betreiber des DocCheck Flexikons übernehmen keine Haftung für Schäden, die durch unreflektierte bzw. nicht-kontrollierte Anwendung von Empfehlungen, Inhalten oder Meinungsäußerungen entstehen, die im DocCheck Flexikon zu Lehr- oder Demonstrationszwecken publiziert sind.<br /> Artikel, die Angaben zum Einsatz und zur Dosierung von Medikamenten machen, entsprechen der persönlichen Einschätzung der Autoren. Sie sind kein Ersatz für die Empfehlungen des Herstellers oder des behandelnden Arztes oder Apothekers.<br /> <br />',
    'SIDEMENU_TOC': 'Inhaltsverzeichnis',
    'SIDEMENU_AUTHORS': 'Autoren des Artikels',
    'SIDEMENU_VERSIONS': 'Versionen',
    'SIDEMENU_SHARE': 'Artikel teilen',
    'SIDEMENU_FONTSIZE': 'Ansicht',
    'POPOVER_FONTSIZE': 'Schriftgröße',
    'POPOVER_THEME': 'Farbschema',
    'IMPORTANT_HEADING': 'Wichtiger Hinweis',
    'IMPORTANT_CONTENT': '',
    'DISCLAIMER_CONTENT': 'Das DocCheck Flexikon ist ein offenes Lexikon, das ausschließlich der Aus- und Weiterbildung von Angehörigen und Studenten der medizinischen Fachkreise (z.B. Ärzte, Apotheker, Tierärzte, Zahnärzte) dient. Es ist keine Anleitung zur Selbsttherapie und kein Ersatz für eine ärztliche Beratung oder Behandlung.</b> Es wird von den teilnehmenden Autoren nach bestem Wissen gepflegt. Die Autoren und die Betreiber des DocCheck Flexikons übernehmen keine Haftung für Schäden, die durch unreflektierte bzw. nicht-kontrollierte Anwendung von Empfehlungen, Inhalten oder Meinungsäußerungen entstehen, die im DocCheck Flexikon zu Lehr- oder Demonstrationszwecken publiziert sind.<br /> Artikel, die Angaben zum Einsatz und zur Dosierung von Medikamenten machen, entsprechen der persönlichen Einschätzung der Autoren. Sie sind kein Ersatz für die Empfehlungen des Herstellers oder des behandelnden Arztes oder Apothekers.<br />',
    'DISCLAIMER_IMPRESS': 'Impressum',
    'DISCLAIMER_HEADING': 'Disclaimer',
    'ARTICLE_TITLE': 'Artikel',

    /*
     * Directives
     */
    'DC_DEFINITION_NO_RESULTS': 'Zu Deinem Suchbegriff gibt es noch keine Einträge',
    'DC_DEFINITION_PLEASE_DEFINE': 'Mach den Anfang und definiere "{{title}}"',
    'DC_DEFINITION_SUBMIT': 'Abschicken',
    'DC_ARTICLE_HEADING': 'Artikel',
    'DC_ARTICLE_DEFINE': 'Dieser Artikel existiert noch nicht.<br />Mach jetzt den Anfang!',
    'DC_ARTICLE_FINDINPAGE_PLACEHOLDER': 'Suchen...',
    'DC_ARTICLE_SAVED': 'Artikel erfolgreich gespeichert',
    'DC_ARTICLE_SAVED_ERROR': 'Artikel konnte nicht gespeichert werden. Überprüfe Deine Internetverbindung und versuche es erneut!',
    'DC_ARTICLE_OFFLINE_HINT': '(zuletzt aktualisiert am {{date}})',
    'DC_ARTICLE_OFFLINE_BUY': 'Der Artikel konnte nicht abgerufen werden. Prüfe Deine Internetverbindung oder versuche es später erneut. <br /><br /> Wenn Du in Zukunft Flexikon-Artikel auch offline lesen möchtest - die Vollversion der App macht\'s möglich!',
    'DC_ARTICLE_OFFLINE_BOUGHT': 'Der Artikel konnte nicht abgerufen werden. Prüfe Deine Internetverbindung oder versuche es später erneut. <br /><br /> Du möchtest diesen Artikel immer parat haben? Dann füge ihn zu Deinen Favoriten hinzu und lese ihn offline!',
    'DC_ARTICLE_RETRY': 'Erneut versuchen',
    'DC_ARTICLE': {
      'SUMMERBREAK': {
        'POPOVER_HINT_PLAIN': '<div class="dc-bold">Sommerpause</div> <br /> Das Flexikon hat Sommerpause! Für mehr Informationen besuche die Website!',
        'POPOVER_HINT_DATE': '<div class="dc-bold">Sommerpause</div> <br /> Das Flexikon hat vom {{from}} bis zum {{to}} Sommerpause!',
        'POPOVER_HINT_FAILURE': 'Es konnte keine Verbindung zu DocCheck hergestellt werden!<br /> Prüfe Deine Verbindung oder versuche es später erneut!',
        'COME_BACK': 'Nach der Sommerpause kannst Du wieder wie gewohnt Artikel erstellen & editieren!'
      }
    },
    'DC_TABLE_SHOW_MORE': 'Mehr...',
    'DC_TABLE_SHOW_LESS': 'Weniger...',
    'DC_PUBLISH_NOT_ALLOWED': 'Entweder konnte das Dokument nicht abgerufen werden oder das Dokument kann aufgrund seiner Rechte-Einstellungen nicht angezeigt werden.',
    'DC_3D_ERROR': '',
    'DC_3D_CLOSE': 'Zurück zum Artikel',
    'DC_MEDIA_VIEWER_ERROR': '',
    'DC_PARSE_ERROR': '',
    'DC_LOGIN_USERNAME': 'Nutzername',
    'DC_LOGIN_PASSWORD': 'Passwort',
    'DC_LOGIN_PASSWORDFORGOTTEN': 'Passwort vergessen?',
    'DC_LOGIN_REGISTER': 'Kostenlos registrieren',
    'DC_LOGIN_SUBMIT': 'Einloggen',
    'DC_LOGIN_REQ_USER': 'Bitte gib Deinen Nutzernamen ein.',
    'DC_LOGIN_REQ_PASSWORD': 'Bitte gib Dein Passwort ein.',
    'DC_LOGIN_FAILED': 'Nutzername oder Passwort nicht korrekt.',
    'DC_LOGIN_SETTINGS': 'Bitte logge Dich mit Deinem DocCheck Passwort ein, um alle Funktionen zu nutzen.',
    'LANG_DE': 'Deutsch',
    'LANG_EN': 'Englisch',

    /*
     * Neue Keys! Done
     */

    /*
    'DC_PURCHASE_TEXT_VERSION1'         : 'Alle Flexikon-Artikel <span class="white">werbefrei</span> und<br /><span class="white">Favoriten offline</span> lesen für nur <span class="white">2,99 €</span>'
     */
    'DC_PURCHASE_TEXT_VERSION1': 'Du möchtest <span class="white">Favoriten offline</span> lesen<br />und Flexikon-Artikel <span class="white">werbefrei</span> genießen?',
    'DC_PURCHASE_TEXT_VERSION1b': '<ul><li><span class="white">Favoriten offline</span> lesen</li><li>Flexikon <span class="white">werbefrei genießen</span></li></ul>',
    'DC_PURCHASE_TEXT_BUTTON': 'Jetzt upgraden!',
    'DC_PURCHASE_TEXT_VERSION2': 'Alle Flexikon-Artikel werbefrei und<br/>Favoriten offline lesen für nur 2,99 €',
    'DC_OPEN': 'weiter zum Artikel',
    'DC_ARTICLE_LEAVE_HINT': 'Du hast Deine Änderungen noch nicht gespeichert. Möchtest Du den Artikel wirklich verlassen?',
    'DC_ARTICLE_LEAVE_WITH_SAVE': 'Änderungen speichern',
    'DC_ARTICLE_LEAVE_WITHOUT_SAVE': 'Änderungen verwerfen',
    'DC_ARTICLE_CANCEL_LEAVE': 'Zurück zum Artikel',
    'DC_ARTICLE_NOT_FOUND': 'Dieser Artikel existiert noch nicht. Mach jetzt den Anfang mit einer Definition!',
    'DC_ARTICLE_NO_CONNECTION_TITLE': 'Keine Verbindung',
    'DC_ARTICLE_NO_CONNECTION': 'Der Artikel konnte nicht abgerufen werden. Prüfe Deine Internetverbindung oder versuche es später erneut!',
    'DC_ARTICLE_LOGIN': 'Bitte logge dich mit Deinem DocCheck Passwort ein, um diesen Artikel zu editieren!',
    'DC_CREATE': 'Artikel erstellen',
    'DC_QUICKSEARCH_PLACEHOLDER': 'Suchen',
    'SEARCH_SEARCHING_FAVS': 'Dein Gerät ist nicht mit dem Internet verbunden. Stell die Verbindung wieder her oder durchsuche Deine Favoriten.',
    'SEARCH_ONLINE_AGAIN': 'Die Internetverbindung ist wieder verfügbar! Starte einen neuen Suchlauf für mehr Ergebnisse.',

    /*
     * Neue Keys!
     */
    'YOUTUBE_PREFIX': 'Youtube Video',
    'YOUTUBE_TITLE_NOT_LOADED': 'Videotitel konnte nicht abgerufen werden.',
    'MODEL_NOT_LOADED': '3D Modell konnte nicht abgerufen werden.',
    'DOCUMENT_NOT_LOADED': 'Dokument konnte nicht abgerufen werden.',
    'SEARCH_LATEST': 'Kürzlich bearbeitete Artikel',
    'SETTINGS_OVERLAY_HOME_RERUN': 'Guided Tour starten',
    'DC_TUTORIAL_OVERLAY_HOME': 'Entdecke wechselnde aktuelle Top Artikel direkt auf der Startseite.',
    'DC_TUTORIAL_OVERLAY_BOOKMARK': 'Hier findest Du Deine Favoriten-Artikel, die Du mit der Vollversion der App auch im Offline Modus ansehen kannst!',
    'DC_TUTORIAL_OVERLAY_SEARCH': 'Suche nach konkreten Fachbegriffen aus der Medizin.',
    'DC_TUTORIAL_OVERLAY_SETTINGS': 'Verwalte und individualisiere die App nach Deinen Ansprüchen.',
    'DC_TUTORIAL_OVERLAY_NEWBOOKMARK': 'Markiere diesen Artikel als Favorit, um ihn unter Deinen persönlichen Lieblingsartikeln zu speichern',
    'DC_TUTORIAL_OVERLAY_EDIT': 'Editiere diesen Artikel und...',
    'DC_TUTORIAL_OVERLAY_PREVIEW': '...sieh\' Dir die Änderungen in der Vorschau an',
    'DC_TUTORIAL_OVERLAY_TOC': 'Im Seitenmenü findest Du das Inhaltsverzeichnis und weitere Funktionen.',
    'DC_TUTORIAL_OVERLAY_APPEARANCE': 'Wähle Schriftgröße und Farbschema aus.',
    'DC_TUTORIAL_OVERLAY_SHARE': 'Empfiehl diesen Artikel an Freunde und Kollegen weiter!',
    'DC_TUTORIAL_OVERLAY_PREMIUM': 'Deine Favoriten kannst Du auch offline und werbefrei lesen!',
    'SEARCH_CREATE': 'Nicht gefunden, wonach Du gesucht hast? Mache den Anfang und schreibe eine <b>Definition</b>.',
    'LANG_DE_FLAG': '0px',
    'LANG_EN_FLAG': '-40px',
    'GUIDED_TOUR': {
      'CONFIRM_BUTTON': 'Weiter',
      'GO_FOR_IT': 'Los geht\'s!',
      'ARTICLE_STEPS': {
        'NEW_BOOKMARK': 'Markiere diesen Artikel als Favorit, um ihn zu Deinen persönlichen Lieblingsartikeln hinzuzufügen.',
        'OPTIONS': 'Unter diesem Button findest Du weitere verfügbare Aktionen.<br /> <br /> Um ihn an einer anderen Stelle zu platzieren, halte den Button lange gedrückt und ziehe ihn an die gewünschte Stelle.',
        'FIND_IN_PAGE_BUTTON': 'Über diesen Button öffnest Du die Suche innerhalb des Artikels.',
        'FIND_IN_PAGE_INPUT': 'Mit dieser Funktion kannst Du den Artikel nach Begriffen durchsuchen.',
        'EDIT': 'Editiere diesen Artikel und...',
        'PREVIEW': '...siehe Dir die Änderungen in der Vorschau an.'
      }
    },
    'STYLE_OVERLAY': {
      'TITLE': 'Ansicht',
      'FONTSIZE': 'Textgröße',
      'THEME': 'Farbschema',
      'DARK': 'dunkel',
      'LIGHT': 'hell'
    }
  });
});

angular.module("Flexikon.translations").config(function($translateProvider) {
  return $translateProvider.translations('en_EN', {

    /*
     *
     * 888888  88    88
     * 88      888   88
     * 88      8888  88
     * 88888   88 88 88
     * 88      88  8888
     * 88      88   888
     * 888888  88    88
     *
     */

    /*
     * Globals
     */
    'GLOB_DC_FLEXIKON': 'DocCheck Flexikon',
    'GLOB_NO_CONNECTION': 'No connection!',

    /*
     * Views
     */
    'DC_HOME_ERROR': 'Something went wrong.<br /><br />Please check your internet connection and try again!',
    'FAVORITES_TITLE': 'Favorites',
    'SAVED_ARTICLES': 'Saved articles',
    'SAVED_ARTICLES_NOTHING': 'You haven\'t saved any articles yet.',
    'CONTRIBUTIONS': 'My articles',
    'CONTRIBUTIONS_NOTHING': 'You haven\'t created or edited any articles yet.',
    'CONTRIBUTIONS_ERROR': 'Your articles couldn\'t be accessed.<br /Please check your internet connection and try again!',
    'CONTRIBUTIONS_SIGNIN': 'Log in to see your contributions to Flexikon.',
    'LAST_SEEN': 'Last seen',
    'LAST_SEEN_NOTHING': 'You haven\'t viewed any article yet.',
    'SEARCH_TITLE': 'Search',
    'SEARCH_ERROR': 'Something went wrong.<br /><br />Please check your internet connection and try again!',
    'SEARCH_DEFINE': 'No results? Be the first and write a definition.',
    'SETTINGS_HEADING': 'Settings',
    'SETTINGS_SIGNOUT': 'Sign out',
    'SETTINGS_PRIVACY': '',
    'SETTINGS_HELP': 'Help & tips',
    'SETTINGS_PROMOTION': 'More from DocCheck',
    'SETTINGS_DISCLAIMER': 'Disclaimer',
    'SETTINGS_PROFILE': 'Set up profile',
    'SETTINGS_LANGUAGE': 'Language',
    'SETTINGS_IMPORTANT': 'Important note',
    'SETTINGS_OFFLINE': 'Save article offline',
    'SETTINGS_RESTORE_PURCHASE': 'Restore In-App-Purchase',
    'PROMOTION_HEADING': 'More from DocCheck',
    'PROFILE_HEADING': 'Set up profile',
    'HELP_HEADING': 'Help & tips',
    'HELP_CONTENT': '<b class="heading"> What can I use the DocCheck Flexikon App for? </b> <br /> <ul> <li> Have access to more than 45,000 medical articles  </li> <li> Edit and write articles on topics of your choice  </li> <li> Mark especially relevant articles and save them offline  </li> </ul> <br /> <b class="heading"> How can I edit existing articles?</b> <br /> You can edit already existing articles in the Flexikon with the pen icon within the article. Within the edit mode you can first have a look at your changes or save them directly. <br /> <br /> <b class="heading"> How can I create a new article?</b> <br /> When you don\'t find a term within the Flexikon search you can start with a definition yourself. As soon as you save the definition, a new article is created. You can then edit the article through the pen icon. <br /> <br /> <b class="heading"> How can I mark an article as favorite? </b> <br /> First, you log in with your DocCheck account. When you have found an article which you would like to find again quickly later, you can mark it through the heart-icon in the upper bar. From now on it will be displayed in the navigation under "favorites". <br /> <br /> <b class="heading"> How can I save an article offline? </b> <br /> In order to save articles locally, you can choose the chargeable option "Save article offline" within the table of contents. After that, all articles which you have marked as favorites will be available without internet connection. As soon as you reconnect your device to the internet, your articles will be updated to the newest version. Videos and media are only available online.<br /> <br /> <b class="heading">How can I customize the view of the app? </b> <br /> The menu (or burger button) is available at the top of each article on the right. Click „view“ in order to change the font size and color scheme. By pressing „o“ you reset the size. In addition, you can navigate through individual sections of the article using the table of contents. Through this you can quickly jump to different chapters within an article. <br /> <br /> <b> Important note: </b> The DocCheck Flexikon is an open encyclopedia, which is meant exclusively for training and education. It is not a manual for self-therapy and no substitute for medical advice or treatment.</b> It is maintained by the participating authors in the best of their knowledge. The authors and operators of the DocCheck Flexikon assume no liability for any damage which is caused due to nonreflective or uncontrolled application of recommendations, contents or opinions that have been published in the DocCheck Flexikon for educational or demonstration purposes.<br /> Articles which provide information on the use and dosage of drugs correspond to the personal opinion of the authors. They are no substitute for the recommendations of the manufacturer or the physician or pharmacist in charge.<br /> <br />',
    'SIDEMENU_TOC': 'Table of contents',
    'SIDEMENU_AUTHORS': 'Authors of the article',
    'SIDEMENU_VERSIONS': 'Versions',
    'SIDEMENU_SHARE': 'Share article',
    'SIDEMENU_FONTSIZE': 'View',
    'POPOVER_FONTSIZE': 'Font Size',
    'POPOVER_THEME': 'Color scheme',
    'IMPORTANT_HEADING': 'Important note',
    'IMPORTANT_CONTENT': '',
    'DISCLAIMER_CONTENT': 'The DocCheck Flexikon is an open encyclopedia, which is meant exclusively for training and education of healthcare professionals (e.g. physicians, pharmacists, veterinarians, dentists, medical students). It is not a manual for self-therapy and no substitute for medical advice or treatment.</b> It is maintained by the participating authors in the best of their knowledge. The authors and operators of the DocCheck Flexikon assume no liability for any damage caused due to nonreflective or uncontrolled application of recommendations, contents or opinions that have been published in the DocCheck Flexikon for educational or demonstration purposes.<br /> Articles which provide information on the use and dosage of drugs correspond to the personal opinion of the authors. They are no substitute for the recommendations of the manufacturer or the physician or pharmacist in charge.<br />',
    'DISCLAIMER_IMPRESS': 'Imprint',
    'DISCLAIMER_HEADING': 'Disclaimer',
    'ARTICLE_TITLE': 'Article',

    /*
     * Directives
     */
    'DC_DEFINITION_NO_RESULTS': 'There are no entries to your search term yet',
    'DC_DEFINITION_PLEASE_DEFINE': 'Make a start and define "{{title}}"',
    'DC_DEFINITION_SUBMIT': 'Submit',
    'DC_ARTICLE_HEADING': 'Article',
    'DC_ARTICLE_DEFINE': 'This article doesn\'t exist yet.<br />Make a start!',
    'DC_ARTICLE_FINDINPAGE_PLACEHOLDER': 'Search...',
    'DC_ARTICLE_SAVED': 'Article saved successfully',
    'DC_ARTICLE_SAVED_ERROR': 'Article couldn\'t be saved. Please check your internet connection and try again!',
    'DC_ARTICLE_OFFLINE_HINT': '(last synchronized on {{date}})',
    'DC_ARTICLE_OFFLINE_BUY': 'The article couldn\'t be accessed. Please check your internet connection and try again later. <br /><br /> In case you want to read Flexikon articles offline in the future - the full version of the App makes it possible!',
    'DC_ARTICLE_OFFLINE_BOUGHT': 'The article couldn\'t be accessed. Please check your internet connection and try again later. <br /><br /> You always want to have this article on hand? Then add it to your favorites and read it offline!',
    'DC_ARTICLE_RETRY': 'Try again',
    'DC_ARTICLE': {
      'SUMMERBREAK': {
        'POPOVER_HINT_PLAIN': '<div class="dc-bold">Summerbreak</div> <br /> Flexikon\'s in summerbreak! For more information visit the website!',
        'POPOVER_HINT_DATE': '<div class="dc-bold">Summerbreak</div> <br /> Flexikon\'s in summerbreak from {{from}} to {{to}}!',
        'POPOVER_HINT_FAILURE': 'A connection to DocCheck couldn\'t be established!<br /> Check your connection or try again later!',
        'COME_BACK': 'After the summerbreak you\'ll be able to create & edit articles as usual!'
      }
    },
    'DC_TABLE_SHOW_MORE': 'More...',
    'DC_TABLE_SHOW_LESS': 'Less...',
    'DC_PUBLISH_NOT_ALLOWED': 'Either the document couldn\'t be accessed or the document can\'t be displayed due to its rights-settings.',
    'DC_3D_ERROR': '',
    'DC_3D_CLOSE': 'back to article',
    'DC_MEDIA_VIEWER_ERROR': '',
    'DC_PARSE_ERROR': '',
    'DC_LOGIN_USERNAME': 'Username',
    'DC_LOGIN_PASSWORD': 'Password',
    'DC_LOGIN_PASSWORDFORGOTTEN': 'Password forgotten?',
    'DC_LOGIN_REGISTER': 'Register for free',
    'DC_LOGIN_SUBMIT': 'Log in',
    'DC_LOGIN_REQ_USER': 'Please enter your username.',
    'DC_LOGIN_REQ_PASSWORD': 'Please enter your password.',
    'DC_LOGIN_FAILED': 'Wrong username or password.',
    'DC_LOGIN_SETTINGS': 'Please log in with your DocCheck password in order to use all features.',
    'LANG_DE': 'German',
    'LANG_EN': 'English',

    /*
     * Neue Keys!
     */

    /*
    'DC_PURCHASE_TEXT_VERSION1'         : 'Read all Flexikon articles <span class="white">free of ads</span> and <span class="white">favorites offline</span> for just <span class="white">2,99 €'
     */
    'DC_PURCHASE_TEXT_VERSION1': 'You want to view your <span class="white">favorites offline</span><br />and enjoy <span class="white">ad-free</span> articles?',
    'DC_PURCHASE_TEXT_VERSION1b': '<ul><li>viewing <span class="white">Favorites offline</span></li><li><span class="white">ad-free</span> version</li></ul>',
    'DC_PURCHASE_TEXT_BUTTON': ' Get the Upgrade!',
    'DC_PURCHASE_TEXT_VERSION2': 'Read all Flexikon articles free of ads<br />and favorites offline for just 2,99 €',
    'DC_OPEN': 'continue to article',
    'DC_ARTICLE_LEAVE_HINT': 'You haven\'t saved your changes yet. Are you sure you want to leave the article?',
    'DC_ARTICLE_LEAVE_WITH_SAVE': 'Save changes',
    'DC_ARTICLE_LEAVE_WITHOUT_SAVE': 'Delete changes',
    'DC_ARTICLE_CANCEL_LEAVE': 'Back to the article',
    'DC_ARTICLE_NOT_FOUND': 'This article doesn\'t exist yet. Start now with a definition!',
    'DC_ARTICLE_NO_CONNECTION_TITLE': 'No connection',
    'DC_ARTICLE_NO_CONNECTION': 'The article couldn\'t be accessed. Please check your internet connection and try again later!',
    'DC_ARTICLE_LOGIN': 'Please log in with your DocCheck password in order to edit this article!',
    'DC_CREATE': 'Create article',
    'DC_QUICKSEARCH_PLACEHOLDER': 'Search',
    'DC_SEARCH_SEARCHING_FAVS': 'Your device isn\'t connected to the internet. Restore your connection or search your favorites.',
    'DC_SEARCH_ONLINE_AGAIN': 'Internet connection is available again! Start a new search for more results.',

    /*
     * Neue Keys!
     */
    'YOUTUBE_PREFIX': 'Youtube Video',
    'YOUTUBE_TITLE_NOT_LOADED': 'Video title couldn\'t be retreived.',
    'MODEL_NOT_LOADED': '3D model couldn\'t be retreived.',
    'SEARCH_LATEST': 'Recently edited articles',
    'SETTINGS_OVERLAY_HOME_RERUN': 'Start the guided tour',
    'DC_TUTORIAL_OVERLAY_HOME': 'Discover current top articles',
    'DC_TUTORIAL_OVERLAY_BOOKMARK': 'Here you can find your favorite articles, which you can read also in offline mode',
    'DC_TUTORIAL_OVERLAY_SEARCH': 'Search for specific medical articles',
    'DC_TUTORIAL_OVERLAY_SETTINGS': 'Administer and customize the app according to your requirements',
    'DC_TUTORIAL_OVERLAY_NEWBOOKMARK': 'Mark this article as a favorite to save it under your personal items',
    'DC_TUTORIAL_OVERLAY_EDIT': 'Edit this article and...',
    'DC_TUTORIAL_OVERLAY_PREVIEW': '...preview the changes you\'ve made',
    'DC_TUTORIAL_OVERLAY_TOC': 'In the sidemenu you find the table of contents and additional functions.',
    'DC_TUTORIAL_OVERLAY_APPEARANCE': 'Choose font size and color scheme.',
    'DC_TUTORIAL_OVERLAY_SHARE': 'Recommend this article to friends or colleagues!',
    'DC_TUTORIAL_OVERLAY_PREMIUM': 'You cant read your favorites offline and ad-free!',
    'SEARCH_CREATE': 'Not found what you were looking for? Be the first and write a <b>definition</b>.',
    'LANG_DE_FLAG': '0px',
    'LANG_EN_FLAG': '-40px'
  });
});

angular.module("Flexikon.translations").config(function($translateProvider) {
  return $translateProvider.translations('es_ES', {

    /*
     *
     * 8888888 8888888
     * 88      88
     * 88      88
     * 8888    8888888
     * 88           88
     * 88           88
     * 8888888 8888888
     *
     */
    'DC_PICTURES': 'Doc<b>Check</b> Pictures',
    'SEARCH_PLACEHOLDER': 'Buscar',
    'SEARCH_CONNECTION_INFO': 'Connection to DocCheck Pictures couldn\'t be established.',
    'SEARCH_NEWEST_PICTURES': 'Imágenes más recientes',
    'SEARCH_NO_RESULTS': 'No results for this keyword',
    'SEARCH_RESULTS_FOR': 'resultados por',
    'DETAIL_DELETE_CHECK_HEADING': 'Borrar imagen',
    'DETAIL_DELETE_CHECK_CONTENT': '¿Estás seguro de que quieres borrar este imagen?',
    'DETAIL_DELETE_SUCCESS_HEADING': 'Deleted successfully',
    'DETAIL_DELETE_SUCCESS_CONTENT': 'The picture has been deleted successfully.',
    'DETAIL_DELETE_FAILURE_HEADING': 'Deletion failed',
    'DETAIL_DELETE_FAILURE_CONTENT': 'The picture couldn\'t be deleted. Please check your connection or try again later.',
    'DETAIL_PICINFO_FAILURE_CONTENT': 'The information concerning this picture couldn\'t be loaded. Please check your connection or try again later.',
    'EDIT_TITLE': 'Editar imagen',
    'EDIT_PLACEHOLDER_DESCRIPTION': 'Descripción',
    'EDIT_PLACEHOLDER_TAG': 'Añadir etiqueta',
    'EDIT_PLACEHOLDER_TITLE': 'Título',
    'EDIT_CHANGES_SUCCESS_HEADING': 'Changes successful',
    'EDIT_CHANGES_SUCCESS_CONTENT': 'Your changes have been performed successfully.',
    'EDIT_CHANGES_FAILURE_HEADING': 'Changes failed',
    'EDIT_CHANGES_FAILURE_CONTENT': 'Your changes couldn\'t be submitted. Please check your connection or try again later.',
    'EDIT_VISIBILITY_LABEL': 'Visibilidad',
    'EDIT_VISIBILITY_PRIVATE': 'privado',
    'EDIT_VISIBILITY_PUBLIC': 'público',
    'EDIT_VISIBILITY_DCMEMBER': 'DocCheck-member',
    'EDIT_VISIBILITY_MEDIC': 'medical member',
    'SEARCH_OWN_PICTURES': 'Mis imágenes',
    'SEARCH_OWN_LOGIN_REQUIRED': 'To view your own pictures please log in first.',
    'FEEDBACK_TITLE': 'Send feedback',
    'HELP_TITLE': 'Help &amp; tips',
    'HELP_CONTENT': '<b style="color:#000">What is the Pictures App?</b><br /> DocCheck Pictures is the free medical picture library of Europe\s largest Healthcare-Community. The library contains enthält u.a. Fallbeispiele, Befunddokumentationen, Mikrofotografien, bildgebende Verfahren der Medizin und schematische Darstellungen. Stöbern Sie in über 20.000 Medizinbildern und teilen Sie Ihre interessanten Fälle mit über 1.000.000 Kollegen. <br /> Mit der kostenlosen App haben Sie das Bildarchiv immer dabei und können Fälle ganz einfach per Knopfdruck teilen. <br /> <br /> <b style="color:#000">Wie kann ich ein Bild hochladen?</b><br /> Wenn Sie auf die Kamera in der Mitte unten klicken, können Sie auswählen, ob Sie Bilder aus Ihrem Archiv hochladen wollen oder direkt ein Foto aufnehmen wollen. Das frisch aufgenommene Foto wird dann automatisch direkt bei DocCheck hochgeladen.<br /> <br /> <b style="color:#000">Wer kann meine Bilder sehen?</b><br /> Das kommt ganz auf Ihre Sichtbarkeitseinstellungen an. Diese können Sie ändern, wenn Sie in den Einstellungen auf „Standard-Datenschutz“ klicken.<br /> <br /> <b style="color:#000">Was muss ich bei der Veröffentlichung von Patientenbildern beachten?</b><br /> Da gerade bei Bildern die Erkennbarkeit der Patienten nicht vollkommen ausgeschlossen werden kann und Bilder von Krankheiten die Intimsphäre des Patienten betreffen, ist eine Einwilligung des Patienten erforderlich. Bitte sorgen Sie in jedem Fall dafür, dass die Gesichter der Patienten nicht abgebildet werden und veröffentlichen Sie keine Namen Ihrer Patienten.',
    'PRIVACY_TITLE': 'Privacy',
    'SETTINGS_TITLE': 'Settings',
    'SETTINGS_NOTIFICATIONS': 'Notifications',
    'SETTINGS_SAVE_LOCALLY': 'Save locally',
    'SETTINGS_SIGN_OUT': 'Sign out',
    'SETTINGS_HELP': 'Help &amp; tips',
    'SETTINGS_PRIVACY': 'Privacy',
    'SETTINGS_FEEDBACK': 'Send feedback',
    'SETTINGS_PROMOTION': 'Additional information',
    'CONNECTION_ERROR': 'Connection failed',
    'NO_CONNECTION_HEADING': 'No connection',
    'NO_CONNECTION_CONTENT': 'No internet connection available. Please connect your device to the Internet and try again.',
    'YES': 'Sí',
    'NO': 'No',
    'CONFIRM': 'Okay',
    'CANCEL': 'Cancel',
    'SUBMIT': 'Submit',
    'LOADING': 'Loading...',
    'LOGIN_REQUIRED': 'Login required',
    'LOGIN_REQUIRED_CONTENT': 'Please log in first to use this function.',
    'LOGIN_FAILED': 'Login failed',
    'LOGIN_FAILED_CONTENT': 'Username or password not correct.',
    'LOGIN_INCORRECT': 'Invalid combination of username and password.',
    'UPLOAD_SUCCESS_HEADING': 'Upload finished',
    'UPLOAD_SUCCESS_CONTENT': 'The upload has finished successfully.',
    'UPLOAD_FAILURE_HEADING': 'Upload canceled',
    'UPLOAD_FAILURE_CONTENT': 'The upload couldn\'t be finished. Please check your connection or try again later.',
    'UPLOAD_IN_PROGRESS_HEADING': 'Upload...',
    'UPLOAD_IN_PROGRESS_CONTENT': 'Picture is being uploaded...',
    'DISCLAIMER_TITLE': 'Disclaimer',
    'SETTINGS_DISCLAIMER': 'Disclaimer',
    'IMPRESS': 'Impress',
    'LANGUAGE': 'Language',
    'ADDITIONAL_INFORMATION': 'Additional information',
    'OFFLINE': 'An error occured while loading.<br /> Please check your Internet connection and try again.',
    'SEARCH_OWN_NO_ITEMS': 'You haven\'t uploaded any images yet. Click on the camrea below and start right now!',
    'PRIVACY_VISIBILITY_TEXT': 'Hier kannst Du einstellen, wer Deine Bilder sehen darf.',
    'PRIVACY_RIGHTS_LABEL': 'Rights',
    'PRIVACY_RIGHTS_TEXT': 'Welche Rechte liegen auf deinen Bildern?',
    'PRIVACY_ALL_RIGHTS_RESERVED': 'All rights reserved',
    'PRIVACY_CREATIVE_COMMONS': 'Creative Commons',
    'PRIVACY_CC_ATTR': 'Attribution',
    'PRIVACY_CC_ATTR_NODER': 'Attribution-NoDerivs',
    'PRIVACY_CC_ATTR_SHARE': 'Attribution-ShareAlike',
    'PRIVACY_CC_ATTR_NONCOMM': 'Attribution-NonCommercial',
    'PRIVACY_CC_ATTR_NONCOMM_NODER': 'Attribution-NonCommercial-NoDerivs',
    'PRIVACY_CC_ATTR_NONCOMM_SHARE': 'Attribution-NonCommercial-ShareAlike',
    'PRIVACY_PUBLIC_DOMAIN': 'Public Domain Dedication',
    'OVERLAY_TAKE_PHOTO': 'Take photo',
    'OVERLAY_OPEN_GALLERY': 'Pick from gallery',
    'PRIVACY_IN_FUTURE': 'Soon you will also be able to change your default rights settings here.',
    'DETAIL_INFO': 'Details',
    'LOGIN_REQUIRED_REF': 'Sign in to see more exciting pictures and to upload your own.',
    'DISCLAIMER_CONTENT': ''
  });
});

angular.module("Flexikon.translations").config(function($translateProvider) {
  return $translateProvider.translations('fr_FR', {

    /*
     *
     * 88888888 8888888
     * 88       88    88
     * 88       88    88
     * 88888    8888888
     * 88       88   88
     * 88       88    88
     * 88       88     88
     *
     */
    'DC_PICTURES': 'Doc<b>Check</b> Pictures',
    'SEARCH_PLACEHOLDER': 'Chercher',
    'SEARCH_CONNECTION_INFO': 'Connexion à DocCheck Pictures n\'a pas pu être établie.',
    'SEARCH_NEWEST_PICTURES': 'Dernières photos',
    'SEARCH_NO_RESULTS': 'Pas de résultats pour ce terme',
    'SEARCH_RESULTS_FOR': 'Résultats pour',
    'DETAIL_DELETE_CHECK_HEADING': 'Effacer photo',
    'DETAIL_DELETE_CHECK_CONTENT': 'Es-tu sûr de vouloir supprimer cette image ?',
    'DETAIL_DELETE_SUCCESS_HEADING': 'Supprimé avec succès',
    'DETAIL_DELETE_SUCCESS_CONTENT': 'The picture has been deleted successfully.',
    'DETAIL_DELETE_FAILURE_HEADING': 'Effacement a échoué.',
    'DETAIL_DELETE_FAILURE_CONTENT': 'Les informations d\'image n’ont pas pu être retirés. S’il te plaît contrôle ta connexion et réessaye plus tard.',
    'DETAIL_PICINFO_FAILURE_CONTENT': 'Les informations d\'image n’ont pas pu être chargés. S’il te plaît contrôle ta connexion et réessaye plus tard.',
    'EDIT_TITLE': 'Modifier photo',
    'EDIT_PLACEHOLDER_DESCRIPTION': 'Description',
    'EDIT_PLACEHOLDER_TAG': 'Ajouter tag',
    'EDIT_PLACEHOLDER_TITLE': 'Titre',
    'EDIT_CHANGES_SUCCESS_HEADING': 'Changements enregistrés avec succès',
    'EDIT_CHANGES_SUCCESS_CONTENT': 'Tes changements ont été enregistrés.',
    'EDIT_CHANGES_FAILURE_HEADING': 'Changements échoués.',
    'EDIT_CHANGES_FAILURE_CONTENT': 'Tes changements ne pouvaient pas être appliqués. Vérifie ta connexion ou réessaye plus tard.',
    'EDIT_VISIBILITY_LABEL': 'Visibilité',
    'EDIT_VISIBILITY_PRIVATE': 'privé',
    'EDIT_VISIBILITY_PUBLIC': 'publique',
    'EDIT_VISIBILITY_DCMEMBER': 'DocCheck-membre',
    'EDIT_VISIBILITY_MEDIC': 'membre médical',
    'SEARCH_OWN_PICTURES': 'Mes images',
    'SEARCH_OWN_LOGIN_REQUIRED': 'Connecte-toi pour voir tes images.',
    'FEEDBACK_TITLE': 'Envoyer feedback',
    'HELP_TITLE': 'Aide &amp; tuyau',
    'HELP_CONTENT': '<b style="color:#000">Qu’est-ce que c’est l’application Pictures ?</b><br /> DocCheck Pictures est l’archive d’images gratuite de la plus grande communauté des professionnels de la santé en Europe. L’archive contient, en autre, des études de cas, des documentations des résultats, des microphotographies, l’imagerie en médecine et des schémas. Trifouille dans plus de 20.000 images médicales et partage tes cas intéressants avec plus de 1.000.000 collègues. <br /> Avec l’application gratuite tu as l’archive d’images sur toi toujours et tu peux partagez tes cas facilement en appuyant sur un seul button. <br /> <br /> <b style="color:#000">Comment puis-je télécharger une image ?</b><br /> Si tu cliques sur la caméra au milieu ci-dessus, tu peux choisir si tu souhaites télécharger des images à partir de ta bibliothèque ou si tu souhaites prendre une photo directement. La nouvelle image est automatiquement téléchargée directement sur DocCheck.<br /> <br /> <b style="color:#000">Qui peut voir mes images ?</b><br /> Cela dépend de vos paramètres de visibilité. Vous pouvez changer cela en cliquant dans les paramètres « protection des données standard ».<br /> <br /> <b style="color:#000">Que dois-je prendre en considération en ce qui concerne la publication des images des patients ?</b><br /> Chez les photos la récognition des patients ne peut pas être complètement exclu et des images de maladies affectent la vie privée des patients. Donc, le consentement du patient est nécessaire. S’il te plaît prend soin en tout cas que les visages des patients ne sont pas visible et ne publie pas les noms de tes patients.',
    'PRIVACY_TITLE': 'Protection des données',
    'SETTINGS_TITLE': 'Paramètres',
    'SETTINGS_NOTIFICATIONS': 'Notifications',
    'SETTINGS_SAVE_LOCALLY': 'Enregistrer locale',
    'SETTINGS_SIGN_OUT': 'Déconnecter',
    'SETTINGS_HELP': 'Aide &amp; tuyau',
    'SETTINGS_PRIVACY': 'Protection des données',
    'SETTINGS_FEEDBACK': 'Envoyer feedback',
    'SETTINGS_PROMOTION': 'Plus d’informations',
    'CONNECTION_ERROR': 'Connexion a échoué',
    'NO_CONNECTION_HEADING': 'Pas de connection',
    'NO_CONNECTION_CONTENT': 'Pas de connexion internet disponible. S’il te plaît connecte ton appareil à l’internet et essaye à nouveau.',
    'YES': 'Oui',
    'NO': 'Non',
    'CONFIRM': 'Okay',
    'CANCEL': 'Annuler',
    'SUBMIT': 'Envoyer',
    'LOADING': 'Chargement…',
    'LOGIN_REQUIRED': 'Login nécessaire',
    'LOGIN_REQUIRED_CONTENT': 'S’il te plaît connecte-toi pour utiliser cette fonction.',
    'LOGIN_FAILED': 'Connexion a échoué',
    'LOGIN_FAILED_CONTENT': 'Nom d\'utilisateur ou mot de passe incorrect.',
    'LOGIN_INCORRECT': 'Combinaison de nom d\'utilisateur et mot de passe non invalide.',
    'UPLOAD_SUCCESS_HEADING': 'Téléchargement fini',
    'UPLOAD_SUCCESS_CONTENT': 'Ton image a été téléchargée.',
    'UPLOAD_FAILURE_HEADING': 'Téléchargement annulé',
    'UPLOAD_FAILURE_CONTENT': 'L\'image n\'a pas pu être téléchargé. S’il te plaît vérifie ta connexion internet ou le format de fichier',
    'UPLOAD_IN_PROGRESS_HEADING': 'Téléchargement…',
    'UPLOAD_IN_PROGRESS_CONTENT': 'Votre image sera téléchargée…',
    'DISCLAIMER_TITLE': 'Disclaimer',
    'SETTINGS_DISCLAIMER': 'Disclaimer',
    'IMPRESS': 'Impress',
    'LANGUAGE': 'Language',
    'ADDITIONAL_INFORMATION': 'Additional information',
    'OFFLINE': 'An error occured while loading.<br /> Please check your Internet connection and try again.',
    'SEARCH_OWN_NO_ITEMS': 'You haven\'t uploaded any images yet. Click on the camrea below and start right now!',
    'PRIVACY_VISIBILITY_TEXT': 'Hier kannst Du einstellen, wer Deine Bilder sehen darf.',
    'PRIVACY_RIGHTS_LABEL': 'Rights',
    'PRIVACY_RIGHTS_TEXT': 'Welche Rechte liegen auf deinen Bildern?',
    'PRIVACY_ALL_RIGHTS_RESERVED': 'All rights reserved',
    'PRIVACY_CREATIVE_COMMONS': 'Creative Commons',
    'PRIVACY_CC_ATTR': 'Attribution',
    'PRIVACY_CC_ATTR_NODER': 'Attribution-NoDerivs',
    'PRIVACY_CC_ATTR_SHARE': 'Attribution-ShareAlike',
    'PRIVACY_CC_ATTR_NONCOMM': 'Attribution-NonCommercial',
    'PRIVACY_CC_ATTR_NONCOMM_NODER': 'Attribution-NonCommercial-NoDerivs',
    'PRIVACY_CC_ATTR_NONCOMM_SHARE': 'Attribution-NonCommercial-ShareAlike',
    'PRIVACY_PUBLIC_DOMAIN': 'Public Domain Dedication',
    'OVERLAY_TAKE_PHOTO': 'Take photo',
    'OVERLAY_OPEN_GALLERY': 'Pick from gallery',
    'PRIVACY_IN_FUTURE': 'Soon you will also be able to change your default rights settings here.',
    'DETAIL_INFO': 'Details',
    'LOGIN_REQUIRED_REF': 'Sign in to see more exciting pictures and to upload your own.',
    'DISCLAIMER_CONTENT': ''
  });
});

angular.module("Flexikon.translations").config(function($translateProvider) {
  return $translateProvider.translations('it_IT', {

    /*
    	   *
    	   * 88 88888888888
    	   * 88     88
    	   * 88     88
    	   * 88     88
    	   * 88     88
    	   * 88     88
    	   * 88     88
    	   *
     */
    'DC_PICTURES': 'DocCheck Pictures',
    'SEARCH_PLACEHOLDER': 'Search',
    'SEARCH_CONNECTION_INFO': 'Connection to DocCheck Pictures couldn\'t be established.',
    'SEARCH_NEWEST_PICTURES': 'Newest pictures',
    'SEARCH_NO_RESULTS': 'No results for this keyword',
    'SEARCH_RESULTS_FOR': 'results for',
    'DETAIL_DELETE_CHECK_HEADING': 'Confirm deletion',
    'DETAIL_DELETE_CHECK_CONTENT': 'Are you sure you want to delete this picture?',
    'DETAIL_DELETE_SUCCESS_HEADING': 'Deleted successfully',
    'DETAIL_DELETE_SUCCESS_CONTENT': 'The picture has been deleted successfully.',
    'DETAIL_DELETE_FAILURE_HEADING': 'Deletion failed',
    'DETAIL_DELETE_FAILURE_CONTENT': 'The picture couldn\'t be deleted. Please check your connection or try again later.',
    'DETAIL_PICINFO_FAILURE_CONTENT': 'The information concerning this picture couldn\'t be loaded. Please check your connection or try again later.',
    'EDIT_TITLE': 'Edit picture',
    'EDIT_PLACEHOLDER_DESCRIPTION': 'Description',
    'EDIT_PLACEHOLDER_TAG': 'Add tag',
    'EDIT_PLACEHOLDER_TITLE': 'Title',
    'EDIT_CHANGES_SUCCESS_HEADING': 'Changes successful',
    'EDIT_CHANGES_SUCCESS_CONTENT': 'Your changes have been performed successfully.',
    'EDIT_CHANGES_FAILURE_HEADING': 'Changes failed',
    'EDIT_CHANGES_FAILURE_CONTENT': 'Your changes couldn\'t be submitted. Please check your connection or try again later.',
    'EDIT_VISIBILITY_LABEL': 'Visibility',
    'EDIT_VISIBILITY_PRIVATE': 'private',
    'EDIT_VISIBILITY_PUBLIC': 'public',
    'EDIT_VISIBILITY_DCMEMBER': 'DocCheck-member',
    'EDIT_VISIBILITY_MEDIC': 'medical member',
    'SEARCH_OWN_PICTURES': 'I miei immagini',
    'SEARCH_OWN_LOGIN_REQUIRED': 'To view your own pictures please log in first.',
    'FEEDBACK_TITLE': 'Send feedback',
    'HELP_TITLE': 'Help &amp; tips',
    'HELP_CONTENT': '<b style="color:#000">What is the Pictures App?</b><br /> DocCheck Pictures is the free medical picture library of Europe\s largest Healthcare-Community. The library contains enthält u.a. Fallbeispiele, Befunddokumentationen, Mikrofotografien, bildgebende Verfahren der Medizin und schematische Darstellungen. Stöbern Sie in über 20.000 Medizinbildern und teilen Sie Ihre interessanten Fälle mit über 1.000.000 Kollegen. <br /> Mit der kostenlosen App haben Sie das Bildarchiv immer dabei und können Fälle ganz einfach per Knopfdruck teilen. <br /> <br /> <b style="color:#000">Wie kann ich ein Bild hochladen?</b><br /> Wenn Sie auf die Kamera in der Mitte unten klicken, können Sie auswählen, ob Sie Bilder aus Ihrem Archiv hochladen wollen oder direkt ein Foto aufnehmen wollen. Das frisch aufgenommene Foto wird dann automatisch direkt bei DocCheck hochgeladen.<br /> <br /> <b style="color:#000">Wer kann meine Bilder sehen?</b><br /> Das kommt ganz auf Ihre Sichtbarkeitseinstellungen an. Diese können Sie ändern, wenn Sie in den Einstellungen auf „Standard-Datenschutz“ klicken.<br /> <br /> <b style="color:#000">Was muss ich bei der Veröffentlichung von Patientenbildern beachten?</b><br /> Da gerade bei Bildern die Erkennbarkeit der Patienten nicht vollkommen ausgeschlossen werden kann und Bilder von Krankheiten die Intimsphäre des Patienten betreffen, ist eine Einwilligung des Patienten erforderlich. Bitte sorgen Sie in jedem Fall dafür, dass die Gesichter der Patienten nicht abgebildet werden und veröffentlichen Sie keine Namen Ihrer Patienten.',
    'PRIVACY_TITLE': 'Privacy',
    'SETTINGS_TITLE': 'Settings',
    'SETTINGS_NOTIFICATIONS': 'Notifications',
    'SETTINGS_SAVE_LOCALLY': 'Save locally',
    'SETTINGS_SIGN_OUT': 'Sign out',
    'SETTINGS_HELP': 'Help &amp; tips',
    'SETTINGS_PRIVACY': 'Privacy',
    'SETTINGS_FEEDBACK': 'Send feedback',
    'SETTINGS_PROMOTION': 'Additional information',
    'CONNECTION_ERROR': 'Connection failed',
    'NO_CONNECTION_HEADING': 'No connection',
    'NO_CONNECTION_CONTENT': 'No internet connection available. Please connect your device to the Internet and try again.',
    'YES': 'Yes',
    'NO': 'No',
    'CONFIRM': 'Okay',
    'CANCEL': 'Cancel',
    'SUBMIT': 'Submit',
    'LOADING': 'Loading...',
    'LOGIN_REQUIRED': 'Login required',
    'LOGIN_REQUIRED_CONTENT': 'Please log in first to use this function.',
    'LOGIN_FAILED': 'Login failed',
    'LOGIN_FAILED_CONTENT': 'Username or password not correct.',
    'LOGIN_INCORRECT': 'Invalid combination of username and password.',
    'UPLOAD_SUCCESS_HEADING': 'Upload finished',
    'UPLOAD_SUCCESS_CONTENT': 'The upload has finished successfully.',
    'UPLOAD_FAILURE_HEADING': 'Upload canceled',
    'UPLOAD_FAILURE_CONTENT': 'The upload couldn\'t be finished. Please check your connection or try again later.',
    'UPLOAD_IN_PROGRESS_HEADING': 'Upload...',
    'UPLOAD_IN_PROGRESS_CONTENT': 'Picture is being uploaded...',
    'DISCLAIMER_TITLE': 'Disclaimer',
    'SETTINGS_DISCLAIMER': 'Disclaimer',
    'IMPRESS': 'Impress',
    'LANGUAGE': 'Language',
    'ADDITIONAL_INFORMATION': 'Additional information',
    'OFFLINE': 'An error occured while loading.<br /> Please check your Internet connection and try again.',
    'SEARCH_OWN_NO_ITEMS': 'You haven\'t uploaded any images yet. Click on the camrea below and start right now!',
    'PRIVACY_VISIBILITY_TEXT': 'Hier kannst Du einstellen, wer Deine Bilder sehen darf.',
    'PRIVACY_RIGHTS_LABEL': 'Rights',
    'PRIVACY_RIGHTS_TEXT': 'Welche Rechte liegen auf deinen Bildern?',
    'PRIVACY_ALL_RIGHTS_RESERVED': 'All rights reserved',
    'PRIVACY_CREATIVE_COMMONS': 'Creative Commons',
    'PRIVACY_CC_ATTR': 'Attribution',
    'PRIVACY_CC_ATTR_NODER': 'Attribution-NoDerivs',
    'PRIVACY_CC_ATTR_SHARE': 'Attribution-ShareAlike',
    'PRIVACY_CC_ATTR_NONCOMM': 'Attribution-NonCommercial',
    'PRIVACY_CC_ATTR_NONCOMM_NODER': 'Attribution-NonCommercial-NoDerivs',
    'PRIVACY_CC_ATTR_NONCOMM_SHARE': 'Attribution-NonCommercial-ShareAlike',
    'PRIVACY_PUBLIC_DOMAIN': 'Public Domain Dedication',
    'OVERLAY_TAKE_PHOTO': 'Take photo',
    'OVERLAY_OPEN_GALLERY': 'Pick from gallery',
    'PRIVACY_IN_FUTURE': 'Soon you will also be able to change your default rights settings here.',
    'DETAIL_INFO': 'Details',
    'LOGIN_REQUIRED_REF': 'Sign in to see more exciting pictures and to upload your own.',
    'DISCLAIMER_CONTENT': ''
  });
});

angular.module("Flexikon.translations").config(function($translateProvider) {
  return $translateProvider.translations('nl_NL', {

    /*
    	   *
    	   * 888     88 88
    	   * 8888    88 88
    	   * 88 88   88 88
    	   * 88  88  88 88
    	   * 88   88 88 88
    	   * 88    8888 88 
    	   * 88     888 8888888888
    	   *
     */
    'DC_PICTURES': 'DocCheck Pictures',
    'SEARCH_PLACEHOLDER': 'Search',
    'SEARCH_CONNECTION_INFO': 'Connection to DocCheck Pictures couldn\'t be established.',
    'SEARCH_NEWEST_PICTURES': 'Newest pictures',
    'SEARCH_NO_RESULTS': 'No results for this keyword',
    'SEARCH_RESULTS_FOR': 'results for',
    'DETAIL_DELETE_CHECK_HEADING': 'Confirm deletion',
    'DETAIL_DELETE_CHECK_CONTENT': 'Are you sure you want to delete this picture?',
    'DETAIL_DELETE_SUCCESS_HEADING': 'Deleted successfully',
    'DETAIL_DELETE_SUCCESS_CONTENT': 'The picture has been deleted successfully.',
    'DETAIL_DELETE_FAILURE_HEADING': 'Deletion failed',
    'DETAIL_DELETE_FAILURE_CONTENT': 'The picture couldn\'t be deleted. Please check your connection or try again later.',
    'DETAIL_PICINFO_FAILURE_CONTENT': 'The information concerning this picture couldn\'t be loaded. Please check your connection or try again later.',
    'EDIT_TITLE': 'Edit picture',
    'EDIT_PLACEHOLDER_DESCRIPTION': 'Description',
    'EDIT_PLACEHOLDER_TAG': 'Add tag',
    'EDIT_PLACEHOLDER_TITLE': 'Title',
    'EDIT_CHANGES_SUCCESS_HEADING': 'Changes successful',
    'EDIT_CHANGES_SUCCESS_CONTENT': 'Your changes have been performed successfully.',
    'EDIT_CHANGES_FAILURE_HEADING': 'Changes failed',
    'EDIT_CHANGES_FAILURE_CONTENT': 'Your changes couldn\'t be submitted. Please check your connection or try again later.',
    'EDIT_VISIBILITY_LABEL': 'Visibility',
    'EDIT_VISIBILITY_PRIVATE': 'private',
    'EDIT_VISIBILITY_PUBLIC': 'public',
    'EDIT_VISIBILITY_DCMEMBER': 'DocCheck-member',
    'EDIT_VISIBILITY_MEDIC': 'medical member',
    'SEARCH_OWN_PICTURES': 'Own pictures',
    'SEARCH_OWN_LOGIN_REQUIRED': 'To view your own pictures please log in first.',
    'FEEDBACK_TITLE': 'Send feedback',
    'HELP_TITLE': 'Help &amp; tips',
    'HELP_CONTENT': '<b style="color:#000">What is the Pictures App?</b><br /> DocCheck Pictures is the free medical picture library of Europe\s largest Healthcare-Community. The library contains enthält u.a. Fallbeispiele, Befunddokumentationen, Mikrofotografien, bildgebende Verfahren der Medizin und schematische Darstellungen. Stöbern Sie in über 20.000 Medizinbildern und teilen Sie Ihre interessanten Fälle mit über 1.000.000 Kollegen. <br /> Mit der kostenlosen App haben Sie das Bildarchiv immer dabei und können Fälle ganz einfach per Knopfdruck teilen. <br /> <br /> <b style="color:#000">Wie kann ich ein Bild hochladen?</b><br /> Wenn Sie auf die Kamera in der Mitte unten klicken, können Sie auswählen, ob Sie Bilder aus Ihrem Archiv hochladen wollen oder direkt ein Foto aufnehmen wollen. Das frisch aufgenommene Foto wird dann automatisch direkt bei DocCheck hochgeladen.<br /> <br /> <b style="color:#000">Wer kann meine Bilder sehen?</b><br /> Das kommt ganz auf Ihre Sichtbarkeitseinstellungen an. Diese können Sie ändern, wenn Sie in den Einstellungen auf „Standard-Datenschutz“ klicken.<br /> <br /> <b style="color:#000">Was muss ich bei der Veröffentlichung von Patientenbildern beachten?</b><br /> Da gerade bei Bildern die Erkennbarkeit der Patienten nicht vollkommen ausgeschlossen werden kann und Bilder von Krankheiten die Intimsphäre des Patienten betreffen, ist eine Einwilligung des Patienten erforderlich. Bitte sorgen Sie in jedem Fall dafür, dass die Gesichter der Patienten nicht abgebildet werden und veröffentlichen Sie keine Namen Ihrer Patienten.',
    'PRIVACY_TITLE': 'Privacy',
    'SETTINGS_TITLE': 'Settings',
    'SETTINGS_NOTIFICATIONS': 'Notifications',
    'SETTINGS_SAVE_LOCALLY': 'Save locally',
    'SETTINGS_SIGN_OUT': 'Sign out',
    'SETTINGS_HELP': 'Help &amp; tips',
    'SETTINGS_PRIVACY': 'Privacy',
    'SETTINGS_FEEDBACK': 'Send feedback',
    'SETTINGS_PROMOTION': 'Additional information',
    'CONNECTION_ERROR': 'Connection failed',
    'NO_CONNECTION_HEADING': 'No connection',
    'NO_CONNECTION_CONTENT': 'No internet connection available. Please connect your device to the Internet and try again.',
    'YES': 'Yes',
    'NO': 'No',
    'CONFIRM': 'Okay',
    'CANCEL': 'Cancel',
    'SUBMIT': 'Submit',
    'LOADING': 'Loading...',
    'LOGIN_REQUIRED': 'Login required',
    'LOGIN_REQUIRED_CONTENT': 'Please log in first to use this function.',
    'LOGIN_FAILED': 'Login failed',
    'LOGIN_FAILED_CONTENT': 'Username or password not correct.',
    'LOGIN_INCORRECT': 'Invalid combination of username and password.',
    'UPLOAD_SUCCESS_HEADING': 'Upload finished',
    'UPLOAD_SUCCESS_CONTENT': 'The upload has finished successfully.',
    'UPLOAD_FAILURE_HEADING': 'Upload canceled',
    'UPLOAD_FAILURE_CONTENT': 'The upload couldn\'t be finished. Please check your connection or try again later.',
    'UPLOAD_IN_PROGRESS_HEADING': 'Upload...',
    'UPLOAD_IN_PROGRESS_CONTENT': 'Picture is being uploaded...',
    'DISCLAIMER_TITLE': 'Disclaimer',
    'SETTINGS_DISCLAIMER': 'Disclaimer',
    'IMPRESS': 'Impress',
    'LANGUAGE': 'Language',
    'ADDITIONAL_INFORMATION': 'Additional information',
    'OFFLINE': 'An error occured while loading.<br /> Please check your Internet connection and try again.',
    'SEARCH_OWN_NO_ITEMS': 'You haven\'t uploaded any images yet. Click on the camrea below and start right now!',
    'PRIVACY_VISIBILITY_TEXT': 'Hier kannst Du einstellen, wer Deine Bilder sehen darf.',
    'PRIVACY_RIGHTS_LABEL': 'Rights',
    'PRIVACY_RIGHTS_TEXT': 'Welche Rechte liegen auf deinen Bildern?',
    'PRIVACY_ALL_RIGHTS_RESERVED': 'All rights reserved',
    'PRIVACY_CREATIVE_COMMONS': 'Creative Commons',
    'PRIVACY_CC_ATTR': 'Attribution',
    'PRIVACY_CC_ATTR_NODER': 'Attribution-NoDerivs',
    'PRIVACY_CC_ATTR_SHARE': 'Attribution-ShareAlike',
    'PRIVACY_CC_ATTR_NONCOMM': 'Attribution-NonCommercial',
    'PRIVACY_CC_ATTR_NONCOMM_NODER': 'Attribution-NonCommercial-NoDerivs',
    'PRIVACY_CC_ATTR_NONCOMM_SHARE': 'Attribution-NonCommercial-ShareAlike',
    'PRIVACY_PUBLIC_DOMAIN': 'Public Domain Dedication',
    'OVERLAY_TAKE_PHOTO': 'Take photo',
    'OVERLAY_OPEN_GALLERY': 'Pick from gallery',
    'PRIVACY_IN_FUTURE': 'Soon you will also be able to change your default rights settings here.',
    'DETAIL_INFO': 'Details',
    'LOGIN_REQUIRED_REF': 'Sign in to see more exciting pictures and to upload your own.',
    'DISCLAIMER_CONTENT': ''
  });
});
